package it.finanze.dogane.accise.metano.model; 

import it.finanze.dogane.accise.model.AbstractRecord;

import java.io.IOException;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.zip.DataFormatException;


public class DatiAddizionaleClientiAgevolati extends MetanoRecord{

	//dichiarazioni variabili
	private String  letteraIdentificativa = "";
	private String codiceCatastale = "";
	private BigInteger progessivoInternoComune = BigInteger.valueOf(0);
	private BigInteger numeroUtenze = BigInteger.valueOf(0);
//	private String segnoConsumi = "";
	private BigInteger progRecordUso = BigInteger.valueOf(0);
	private BigInteger progIdentificativoUso = BigInteger.valueOf(0);
	private BigInteger  consumi = BigInteger.valueOf(0);
	private BigDecimal  aliquotaDImposta = new BigDecimal(0);
//	private String  segnoFatturazione = "";
	private BigDecimal  rettificaFatturazione = new BigDecimal(0);
//	private String  segnoTotaleAddizionale = "";
	private BigDecimal  totaleAddizionale = new BigDecimal(0);
	
	
	//Nuovi per allegato
	private String codiceIdentificativoCliente = "";
	private String tipologiaUtilizzo="";
	
	
	private String dataInizio="";
	private String dataFine="";
	private String applicazioneAgevolazione="";
	
	private String percentuale="";
	private String numeri="";
	private String numero="";
	private String TipoQuadro="";
	private String applicazioneAgevolazioneCampo="";
	
	private String codiceApplicazioneAgevolazione ="";
	private String dataInizioFormattata="";
	private String dataFineFormattata="";
	//valorizzazioni variabili 
		            
		public static final int dimProgessivoInternoComune = 2;       
		public static final int dimNumeroUtenze = 8;                  
		public static final int dimSegnoConsumi = 1;                  
		public static final int dimConsumi = 13;                      
		public static final int dimAliquotaDImpostaIntero = 1;        
		public static final int dimAliquotaDImpostaDecimale = 7;      
		public static final int dimSegnoFatturazione = 1;             
		public static final int dimRettificaFatturazioneIntero = 11;  
		public static final int dimRettificaFatturazioneDecimale = 2; 
		public static final int dimSegnoTotaleAddizionale = 1;        
		public static final int dimTotaleAddizionaleIntero = 12;      
		public static final int dimTotaleAddizionaleDecimale = 2;     
		public  static final String CODICE_CATASTALE = "ZZZZ";     
		
		
		
	//Nuove dimensioni	   
	public static final int dimTipologiaUtilizzo = 3;         
	public static final int dimApplicazioneAgevolazione = 1;         
	
	public static final int dimLetteraIdentificativa = 1;         
	public static final int dimCodiceIdentificativoCliente = 16;
	public static final int dimTipoQuadro = 1;
	public static final int dimTipoNumeri = 2;
	public static final int dimCodiceApplicazioneAgevolazione = 1;               
	public static final int dimPercentuale = 3;               
	public static final int dimData = 8 ;
	
	
	
	
	
	
	
		                                                              

	
	
	public static DatiAddizionaleClientiAgevolati getNewObject(ProspettoConsumo prospettoConsumo) {
		
			DatiAddizionaleClientiAgevolati retvalue = new DatiAddizionaleClientiAgevolati();
			Frontespizio frontespizio = prospettoConsumo.getFrontespizio();
		
			retvalue.setAnnoDichiarazione(frontespizio.getAnnoDichiarazione());
			//retvalue.setCodiceDitta(frontespizio.getCodiceDitta());
			retvalue.setMese(frontespizio.getMese());
		
			return retvalue;
		}
	
	public void scriviOggetto(java.io.OutputStream out) throws IOException {

		super.scriviOggetto(out);
		out.write(normalizzaCampo("8", dimLetteraIdentificativa));
		if(codiceIdentificativoCliente.length()==11){
			codiceIdentificativoCliente =  "     " + codiceIdentificativoCliente;
		}
		out.write(normalizzaCampo(codiceIdentificativoCliente, dimCodiceIdentificativoCliente));
		
		out.write(normalizzaCampo(TipoQuadro, dimTipoQuadro));
		out.write(normalizzaCampo(numeri, dimTipoNumeri));
		out.write(normalizzaCampo(codiceApplicazioneAgevolazione,dimCodiceApplicazioneAgevolazione));
		String percentualeFormattata="000";
		
		if (codiceApplicazioneAgevolazione.equals("2")){
			if (percentuale.length()==2){
				percentualeFormattata = "0" + percentuale; 	
			}else if (percentuale.length()==1){
				percentualeFormattata = "00" + percentuale;
			}else
				percentualeFormattata = percentuale;
			
		}
		
		out.write(normalizzaCampo(percentualeFormattata,dimPercentuale));
		
		
		
		out.write(normalizzaCampo(dataInizioFormattata,dimData));
		out.write(normalizzaCampo(dataFineFormattata,dimData));
		
		scriviFineRiga(out);
	}
	
	
	
	
	public void leggiOggetto(java.io.InputStream in) throws IOException {

		super.leggiOggetto(in);

		letteraIdentificativa = readFieldString(in, dimLetteraIdentificativa); 
		
		
		codiceIdentificativoCliente = readFieldString(in, dimCodiceIdentificativoCliente); 
		
		
		if(codiceIdentificativoCliente.length() > 9){

		if(codiceIdentificativoCliente.substring(0,5).equals("     ")){

			codiceIdentificativoCliente = codiceIdentificativoCliente.substring(5,16);
		
		
			}
		}
		
		tipologiaUtilizzo = readFieldString(in, dimTipologiaUtilizzo);
		
		
		TipoQuadro = tipologiaUtilizzo.substring(0,1);
		
		numeri = tipologiaUtilizzo.substring(1);
		
		
		
		String primaLetteraNumero = numeri.substring(0,1);
		String secondaLetteraNumero = numeri.substring(1);
		
			
		if(primaLetteraNumero.equals("0")){
				numero = secondaLetteraNumero;
			}else numero = numeri;
					
		tipologiaUtilizzo = TipoQuadro + numero;//mi serve per metterlo nel template nel corretto formato
		
		
		//Formatto l'applicazione agevolazione
		codiceApplicazioneAgevolazione = readFieldString(in, dimApplicazioneAgevolazione);//codice nel file
		applicazioneAgevolazioneCampo = formattaApplicazioneAgevolazione(codiceApplicazioneAgevolazione);//Lo inserisco nella parte di sotto per modificarlo
		percentuale = readFieldString(in, dimPercentuale);//Mi serve inserirlo nel template e nella parte di sotto per modificarlo
	
		if (percentuale!=null){
			if(!percentuale.equals("")){
			
		
		if (percentuale.substring(0,1).equals("0") && !percentuale.substring(1,2).equals("0")){
			percentuale = percentuale.substring(1,3);
		}else if (percentuale.substring(0,2).equals("00")){
			percentuale = percentuale.substring(2,3);
				}
			}
		}	
		
		
		applicazioneAgevolazione = formattaApplicazioneAgevolazionePiuPercentuale(codiceApplicazioneAgevolazione);//campo che inserisco nel template
		
		
		
		
		
	
		//Formatto le date	
		dataInizio = readFieldString(in, dimData);	
		dataInizioFormattata = dataInizio;
		dataInizio = formattaData(dataInizio);
		dataFine = readFieldString(in, dimData);	
		dataFineFormattata = dataFine;
		dataFine = formattaData(dataFine);
	
	
	
	
		saltaFineRiga(in);
	
			
	
	}

		private String formattaData(String data){
			String dataFormattata ="";
			String anno = data.substring(0,4);
			String mese = data.substring(4,6);
			String giorno = data.substring(6,8);
			
			dataFormattata = giorno +"/" + mese + "/" + anno;
			
			
			return dataFormattata;
		}
	
	
	private String formattaApplicazioneAgevolazionePiuPercentuale(String codiceApplicazioneAgevolazione){

			
			
			
			
				if (codiceApplicazioneAgevolazione.equals("1")){
					applicazioneAgevolazione = "Totalmente non tassata (100%)";
					
				}else if (codiceApplicazioneAgevolazione.equals("2")){
					if (percentuale.length() >= 1){
					
					applicazioneAgevolazione = "a forfait" + "(" + percentuale + "%)";
					}
				}else if (codiceApplicazioneAgevolazione.equals("3")){
					applicazioneAgevolazione = "mediante misura (a contenitore/misuratore)";
				
				}
		
		
			return applicazioneAgevolazione;
			}
	
	
	
	private String formattaApplicazioneAgevolazione(String applicazioneAgevolazione){
			String applicazioneAgevolazioneFormattata="";
			String codice = applicazioneAgevolazione;
			
			
			
			
			if (codice.equals("1")){
				applicazioneAgevolazioneCampo = "Totalmente non tassata (100%)";
				applicazioneAgevolazioneFormattata = applicazioneAgevolazioneCampo;
			}else if (codice.equals("2")){
				applicazioneAgevolazioneCampo = "a forfait";
				
			}else if (codice.equals("3")){
				applicazioneAgevolazioneCampo = "mediante misura (a contenitore/misuratore)";
				
			}
		
		
		return applicazioneAgevolazioneCampo;
		}
	
	/**
	 * @return
	 */
	public BigDecimal getAliquotaDImposta() {
		return aliquotaDImposta;
	}

	/**
	 * @return
	 */
	public String getCodiceCatastale() {
		return codiceCatastale;
	}

	/**
	 * @return
	 */
	public BigInteger getConsumi() {
		return consumi;
	}

	/**
	 * @return
	 */
	public String getLetteraIdentificativa() {
		return letteraIdentificativa;
	}

	/**
	 * @return
	 */
	public BigInteger getNumeroUtenze() {
		return numeroUtenze;
	}

	/**
	 * @return
	 */
	public BigInteger getProgessivoInternoComune() {
		return progessivoInternoComune;
	}

	/**
	 * @return
	 */
	public BigDecimal getRettificaFatturazione() {
		return rettificaFatturazione;
	}

	/**
	 * @return
	 */
	public String getSegnoConsumi() {
		String retvalue = AbstractRecord.PLUS;
		// minore di zero
		if(consumi.compareTo(BigInteger.ZERO) < 0) {
			retvalue = AbstractRecord.MINUS;
		}

		return retvalue;
	}

	/**
	 * @return
	 */
	public String getSegnoFatturazione() {
		String retvalue = AbstractRecord.PLUS;
		// minore di zero
		if(rettificaFatturazione.compareTo(BigDecimal.valueOf(0)) < 0) {
			retvalue = AbstractRecord.MINUS;
		}

		return retvalue;
	}

	/**
	 * @return
	 */
	public String getSegnoTotaleAddizionale() {
		String retvalue = AbstractRecord.PLUS;
		// minore di zero
		if(totaleAddizionale.compareTo(BigDecimal.valueOf(0)) < 0) {
			retvalue = AbstractRecord.MINUS;
		}

		return retvalue;
	}


	/**
	 * @return
	 */
	public BigDecimal getTotaleAddizionale() {
		return totaleAddizionale;
	}

	/**
	 * @param d
	 */
	public void setAliquotaDImposta(BigDecimal d) {
		aliquotaDImposta = d;
	}

	/**
	 * @param string
	 */
	public void setCodiceCatastale(String string) {
		codiceCatastale = string;
	}

	/**
	 * @param i
	 */
	public void setConsumi(BigInteger i) {
		consumi = i;
	}

	/**
	 * @param string
	 */
	public void setLetteraIdentificativa(String string) {
		letteraIdentificativa = string;
	}

	/**
	 * @param i
	 */
	public void setNumeroUtenze(BigInteger i) {
		numeroUtenze = i;
	}

	/**
	 * @param i
	 */
	public void setProgessivoInternoComune(BigInteger i) {
		progessivoInternoComune = i;
	}

	/**
	 * @param d
	 */
	public void setRettificaFatturazione(BigDecimal d) {
		rettificaFatturazione = d;
	}



	/**
	 * @param d
	 */
	public void setTotaleAddizionale(BigDecimal d) {
		totaleAddizionale = d;
	}
	
	/**
	 * Ridefinisco il metodo per impostare la lettera identificativa del quadro
	 */
	public void setTipoRecord(BigInteger i) {
		super.setTipoRecord(i);
		
		if(i.equals(BigInteger.valueOf(71))) {
			setLetteraIdentificativa("V");
		} else if(i.equals(BigInteger.valueOf(72))) {
			setLetteraIdentificativa("W");
		} else if(i.equals(BigInteger.valueOf(73))) {
			setLetteraIdentificativa("Z");
		}else if(i.equals(BigInteger.valueOf(80))) {
		setLetteraIdentificativa("Allegato");
		} 
	}

	
	public Object clone() throws CloneNotSupportedException {
		DatiAddizionaleClientiAgevolati clonato = new DatiAddizionaleClientiAgevolati();
		
		clonato.setAnnoDichiarazione(this.getAnnoDichiarazione());
		//clonato.setCampoDisponibile(this.getCampoDisponibile());
		//clonato.setCodiceDitta(this.getCodiceDitta());
		clonato.setLetteraIdentificativa(this.getLetteraIdentificativa());
		clonato.setMese(this.getMese());
		
		clonato.setApplicazioneAgevolazione(this.getApplicazioneAgevolazione());
		
		clonato.setApplicazioneAgevolazioneCampo(this.getApplicazioneAgevolazioneCampo());
		clonato.setCodiceIdentificativoCliente(this.getCodiceIdentificativoCliente());
		clonato.setDataFine(this.getDataFine());
		clonato.setDataInizio(this.getDataInizio());
		clonato.setTipologiaUtilizzo(this.getTipologiaUtilizzo());
		
		
		clonato.setTipoRecord(this.getTipoRecord());
		
		clonato.setNumeri(this.getNumeri());
		clonato.setTipoQuadro(this.getTipoQuadro());
		clonato.setPercentuale(this.getPercentuale());
		clonato.codiceApplicazioneAgevolazione = this.codiceApplicazioneAgevolazione;
		clonato.dataInizioFormattata = this.dataInizioFormattata;
		clonato.dataFineFormattata = this.dataFineFormattata;
		clonato.applicazioneAgevolazioneCampo = this.applicazioneAgevolazioneCampo;
		clonato.dataInizio = this.dataInizio;
		clonato.dataFine = this.dataFine;
		clonato.numero = numero;
		clonato.setProvincia(this.getProvincia());
		
		return clonato;
	}


	/**
	 * @return
	 */
	public String getCodiceIdentificativoCliente() {
		return codiceIdentificativoCliente;
	}

	/**
	 * @return
	 */
	
	/**
	 * @return
	 */
	public String getDataFine() {
		return dataFine;
	}

	/**
	 * @return
	 */
	public String getDataInizio() {
		return dataInizio;
	}

	

	/**
	 * @param string
	 */
	public void setDataFine(String dataFine) {
		
		
		String giorno = dataFine.substring(0,2);
		String barraUno = dataFine.substring(2,3);
		String mese = dataFine.substring(3,5);
		String barraDue = dataFine.substring(5,6);
		String anno = dataFine.substring(6);
		
		dataFineFormattata = anno + mese + giorno;
		
		this.dataFine = dataFine;
	}

	/**
	 * @param string
	 */
	public void setDataInizio(String dataInizio) {
		
		
		String giorno = dataInizio.substring(0,2);
				String barraUno = dataInizio.substring(2,3);
				String mese = dataInizio.substring(3,5);
		
				String barraDue = dataInizio.substring(5,6);
				String anno = dataInizio.substring(6);
				
		
		
		dataInizioFormattata= anno + mese + giorno;
		
		this.dataInizio = dataInizio;
	}

	
	
	
	/**
	 * @param string
	 */
	public void setCodiceIdentificativoCliente(String string) {
		codiceIdentificativoCliente = string;
	}
	
	
	
	/**
	 * @return
	 */

	/**
	 * @return
	 */
	public String getApplicazioneAgevolazione() {
		return applicazioneAgevolazione;
	}

	/**
	 * @return
	 */
	public String getTipologiaUtilizzo() {
		return tipologiaUtilizzo;
	}

	/**
	 * @param string
	 */
	public void setApplicazioneAgevolazione(String string) {
		applicazioneAgevolazione = string;
	}

	/**
	 * @param string
	 */
	public void setTipologiaUtilizzo(String string) {
		tipologiaUtilizzo = string;
	}

	/**
	 * @return
	 */
	public String getApplicazioneAgevolazioneCampo() {
		return applicazioneAgevolazioneCampo;
	}

	/**
	 * @return
	 */
	public String getNumeri() {
		return numeri;
	}

	/**
	 * @return
	 */
	public String getPercentuale() {
		return percentuale;
	}

	/**
	 * @return
	 */
	public String getTipoQuadro() {
		return TipoQuadro;
	}



	
	/**
	 * @param string
	 */
	public void setApplicazioneAgevolazioneCampo(String string) {
		if (string.equals("Totalmente non tassata (100%)")){
			
		codiceApplicazioneAgevolazione= "1";	
			
		}else if (string.equals("a forfait")){
			
		codiceApplicazioneAgevolazione= "2";	
			
		}else if(string.equals("mediante misura (a contenitore/misuratore)")){
	                    
		codiceApplicazioneAgevolazione= "3";	
			
		}
		
		
		
		applicazioneAgevolazioneCampo = string;
		
		
		
	}

	/**
	 * @param string
	 */
	public void setNumeri(String string) {
		numeri = string;
	}

	/**
	 * @param string
	 */
	public void setPercentuale(String string) {
		percentuale = string;
	}

	/**
	 * @param string
	 */
	public void setTipoQuadro(String string) {
		TipoQuadro = string;
	}

/**
 * @return
 */
public BigInteger getProgRecordUso() {
	return progRecordUso;
}

/**
 * @param integer
 */
public void setProgRecordUso(BigInteger integer) {
	progRecordUso = integer;
}

	/**
	 * @return
	 */
	public BigInteger getProgIdentificativoUso() {
		return progIdentificativoUso;
	}

	/**
	 * @param integer
	 */
	public void setProgIdentificativoUso(BigInteger integer) {
		progIdentificativoUso = integer;
	}

}
