package it.finanze.dogane.accise.metano.model;

import java.io.IOException;
import java.math.BigInteger;


public class Frontespizio extends MetanoRecord {
	
	private String tipologiaDichiarante = "";
	private String campoRiservato = " ";	
	private String denominazioneDitta = "";
	private String comuneSedeDepositoFiscale = "";
	private String provinciaDepositoFiscale = "";
	private String indirizzoDepositoFiscale = "";
	private String comuneSedeUfficioAmm = "";
	private String provinciaSedeUfficioAmm = "";
	private String indirizzoSedeUfficioAmm = "";
	private BigInteger numeroRecordTipo10 = BigInteger.valueOf(0);
	private BigInteger numeroRecordTipo11 = BigInteger.valueOf(0);
	private BigInteger numeroRecordTipo15 = BigInteger.valueOf(0);
	private BigInteger numeroRecordTipo16 = BigInteger.valueOf(0);
	private BigInteger numeroRecordTipo20 = BigInteger.valueOf(0);
	private BigInteger numeroRecordTipo31 = BigInteger.valueOf(0);
	private BigInteger numeroRecordTipo32 = BigInteger.valueOf(0);
	private BigInteger numeroRecordTipo40 = BigInteger.valueOf(0);
	private BigInteger numeroRecordTipo50 = BigInteger.valueOf(0);
	private BigInteger numeroRecordTipo55 = BigInteger.valueOf(0);
	private BigInteger numeroRecordTipo60 = BigInteger.valueOf(0);
	private BigInteger numeroRecordTipo65 = BigInteger.valueOf(0);
	private BigInteger numeroRecordTipo70 = BigInteger.valueOf(0);
	private BigInteger numeroRecordTipo75 = BigInteger.valueOf(0);
	private BigInteger totaleRecordInFile = BigInteger.valueOf(0);
	private BigInteger numeroTotaleRecord = BigInteger.valueOf(0);
	private BigInteger numeroSupporti =BigInteger.valueOf(0);
	/** MODIFICA 07-11-2007 **/
	private BigInteger numeroRecordTipo80 = BigInteger.valueOf(0);
	/** FINE MODIFICA **/
	
	public static final int dimTipologiaDichiarante = 1;
	public static final int dimCampoRiservato = 1;	
	public static final int dimDenominazioneDitta = 60;
	public static final int dimComuneSedeDepositoFiscale = 45;	
	public static final int dimProvinciaDepositoFiscale = 2;
	public static final int dimIndirizzoDepositoFiscale = 50;
	public static final int dimComuneSedeUfficioAmm = 45;	
	public static final int dimProvinciaSedeUfficioAmm = 2;
	public static final int dimIndirizzoSedeUfficioAmm = 50;
	public static final int dimNumeroRecordTipo10 = 5;
	public static final int dimNumeroRecordTipo11 = 5;
	public static final int dimNumeroRecordTipo15 = 5;
	public static final int dimNumeroRecordTipo16 = 5;
	public static final int dimNumeroRecordTipo20 = 5;
	public static final int dimNumeroRecordTipo31 = 5;
	public static final int dimNumeroRecordTipo32 = 5;
	public static final int dimNumeroRecordTipo40 = 5;
	public static final int dimNumeroRecordTipo50 = 5;
	public static final int dimNumeroRecordTipo55 = 5;
	public static final int dimNumeroRecordTipo60 = 5;
	public static final int dimNumeroRecordTipo65 = 5;
	public static final int dimNumeroRecordTipo70 = 5;
	public static final int dimNumeroRecordTipo75 = 5;
	public static final int dimTotaleRecordInFile = 6;
	public static final int dimNumeroSupporti = 2;
	/** MODIFICA 07-11-2007 **/
	public static final int dimNumeroRecordTipo80 = 5;
	/** FINE MODIFICA **/
	
	
	public void scriviOggetto(java.io.OutputStream out) throws IOException {
		
		super.scriviOggetto(out);

		out.write(normalizzaCampo(tipologiaDichiarante, dimTipologiaDichiarante));
		out.write(normalizzaCampo(campoRiservato, dimCampoRiservato));		
		out.write(normalizzaCampo(denominazioneDitta, dimDenominazioneDitta));
		out.write(normalizzaCampo(comuneSedeDepositoFiscale, dimComuneSedeDepositoFiscale));
		out.write(normalizzaCampo(provinciaDepositoFiscale, dimProvinciaDepositoFiscale));
		out.write(normalizzaCampo(indirizzoDepositoFiscale, dimIndirizzoDepositoFiscale));
		out.write(normalizzaCampo(comuneSedeUfficioAmm, dimComuneSedeUfficioAmm));
		out.write(normalizzaCampo(provinciaSedeUfficioAmm, dimProvinciaSedeUfficioAmm));
		out.write(normalizzaCampo(indirizzoSedeUfficioAmm, dimIndirizzoSedeUfficioAmm));
		out.write(normalizzaCampo(numeroRecordTipo10, dimNumeroRecordTipo10));
		out.write(normalizzaCampo(numeroRecordTipo11, dimNumeroRecordTipo11));
		out.write(normalizzaCampo(numeroRecordTipo15, dimNumeroRecordTipo15));
		out.write(normalizzaCampo(numeroRecordTipo16, dimNumeroRecordTipo16));
		out.write(normalizzaCampo(numeroRecordTipo20, dimNumeroRecordTipo20));
		out.write(normalizzaCampo(numeroRecordTipo31, dimNumeroRecordTipo31));
		out.write(normalizzaCampo(numeroRecordTipo32, dimNumeroRecordTipo32));
		out.write(normalizzaCampo(numeroRecordTipo40, dimNumeroRecordTipo40));
		out.write(normalizzaCampo(numeroRecordTipo50, dimNumeroRecordTipo50));
		out.write(normalizzaCampo(numeroRecordTipo55, dimNumeroRecordTipo55));
		out.write(normalizzaCampo(numeroRecordTipo60, dimNumeroRecordTipo60));
		out.write(normalizzaCampo(numeroRecordTipo65, dimNumeroRecordTipo65));
		out.write(normalizzaCampo(numeroRecordTipo70, dimNumeroRecordTipo70));
		out.write(normalizzaCampo(numeroRecordTipo75, dimNumeroRecordTipo75));
		out.write(normalizzaCampo(totaleRecordInFile, dimTotaleRecordInFile));
		out.write(normalizzaCampo(numeroSupporti, dimNumeroSupporti));
		out.write(normalizzaCampo(numeroRecordTipo80, dimNumeroRecordTipo80));
	
		scriviFineRiga(out);
	}

	public void leggiOggetto(java.io.InputStream in) throws IOException {
		
		super.leggiOggetto(in);
		
		tipologiaDichiarante = readFieldString(in, dimTipologiaDichiarante);		
		campoRiservato = readFieldString(in, dimCampoRiservato);		
		denominazioneDitta = readFieldString(in, dimDenominazioneDitta);
		comuneSedeDepositoFiscale =	 readFieldString(in, dimComuneSedeDepositoFiscale);		
		provinciaDepositoFiscale = readFieldString(in, dimProvinciaDepositoFiscale);
		indirizzoDepositoFiscale =	 readFieldString(in, dimIndirizzoDepositoFiscale);		
		comuneSedeUfficioAmm = readFieldString(in, dimComuneSedeUfficioAmm);
		provinciaSedeUfficioAmm =	 readFieldString(in, dimProvinciaSedeUfficioAmm);
		indirizzoSedeUfficioAmm =	 readFieldString(in, dimIndirizzoSedeUfficioAmm);			
		numeroRecordTipo10 = readFieldBigInteger(in, dimNumeroRecordTipo10);
		numeroRecordTipo11 = readFieldBigInteger(in, dimNumeroRecordTipo11);
		numeroRecordTipo15 = readFieldBigInteger(in, dimNumeroRecordTipo15);
		numeroRecordTipo16 = readFieldBigInteger(in, dimNumeroRecordTipo16);
		numeroRecordTipo20 = readFieldBigInteger(in, dimNumeroRecordTipo20);			
		numeroRecordTipo31 = readFieldBigInteger(in, dimNumeroRecordTipo31);
		numeroRecordTipo32 = readFieldBigInteger(in, dimNumeroRecordTipo32);
		numeroRecordTipo40 = readFieldBigInteger(in, dimNumeroRecordTipo40);
		numeroRecordTipo50 = readFieldBigInteger(in, dimNumeroRecordTipo50);
		numeroRecordTipo55 = readFieldBigInteger(in, dimNumeroRecordTipo55);
		numeroRecordTipo60 = readFieldBigInteger(in, dimNumeroRecordTipo60);
		numeroRecordTipo65 = readFieldBigInteger(in, dimNumeroRecordTipo65);
		numeroRecordTipo70 = readFieldBigInteger(in, dimNumeroRecordTipo70);
		numeroRecordTipo75 = readFieldBigInteger(in, dimNumeroRecordTipo75);
		totaleRecordInFile = readFieldBigInteger(in, dimTotaleRecordInFile);
		numeroSupporti = readFieldBigInteger(in, dimNumeroSupporti);
		numeroRecordTipo80 = readFieldBigInteger(in, dimNumeroRecordTipo80);
		
		saltaFineRiga(in);
	}

	/**
	 * @return
	 */
	public static int getDimCampoRiservato() {
		return dimCampoRiservato;
	}

	/**
	 * @return
	 */
	public static int getDimDenominazioneDitta() {
		return dimDenominazioneDitta;
	}

	/**
	 * @return
	 */
	public String getCampoRiservato() {
		return campoRiservato;
	}

	/**
	 * @return
	 */
	public String getDenominazioneDitta() {
		return denominazioneDitta;
	}

	/**
	 * @param string
	 */
	public void setCampoRiservato(String string) {
		campoRiservato = string;
	}

	/**
	 * @param string
	 */
	public void setDenominazioneDitta(String string) {
		denominazioneDitta = string;
	}

	/**
	 * @return
	 */
	public static int getDimComuneSedeDepositoFiscale() {
		return dimComuneSedeDepositoFiscale;
	}

	/**
	 * @return
	 */
	public static int getDimComuneSedeUfficioAmm() {
		return dimComuneSedeUfficioAmm;
	}

	/**
	 * @return
	 */
	public static int getDimIndirizzoDepositoFiscale() {
		return dimIndirizzoDepositoFiscale;
	}

	/**
	 * @return
	 */
	public static int getDimIndirizzoSedeUfficioAmm() {
		return dimIndirizzoSedeUfficioAmm;
	}

	/**
	 * @return
	 */
	public static int getDimNumeroRecordTipo10() {
		return dimNumeroRecordTipo10;
	}

	/**
	 * @return
	 */
	public static int getDimNumeroRecordTipo11() {
		return dimNumeroRecordTipo11;
	}

	/**
	 * @return
	 */
	public static int getDimNumeroRecordTipo15() {
		return dimNumeroRecordTipo15;
	}

	/**
	 * @return
	 */
	public static int getDimNumeroRecordTipo16() {
		return dimNumeroRecordTipo16;
	}

	/**
	 * @return
	 */
	public static int getDimNumeroRecordTipo20() {
		return dimNumeroRecordTipo20;
	}

	/**
	 * @return
	 */
	public static int getDimNumeroRecordTipo31() {
		return dimNumeroRecordTipo31;
	}

	/**
	 * @return
	 */
	public static int getDimNumeroRecordTipo32() {
		return dimNumeroRecordTipo32;
	}

	/**
	 * @return
	 */
	public static int getDimNumeroRecordTipo40() {
		return dimNumeroRecordTipo40;
	}

	/**
	 * @return
	 */
	public static int getDimNumeroRecordTipo50() {
		return dimNumeroRecordTipo50;
	}

	/**
	 * @return
	 */
	public static int getDimNumeroRecordTipo55() {
		return dimNumeroRecordTipo55;
	}

	/**
	 * @return
	 */
	public static int getDimNumeroRecordTipo60() {
		return dimNumeroRecordTipo60;
	}

	/**
	 * @return
	 */
	public static int getDimNumeroRecordTipo65() {
		return dimNumeroRecordTipo65;
	}

	/**
	 * @return
	 */
	public static int getDimNumeroRecordTipo70() {
		return dimNumeroRecordTipo70;
	}

	/**
	 * @return
	 */
	public static int getDimNumeroRecordTipo75() {
		return dimNumeroRecordTipo75;
	}

	/**
	 * @return
	 */
	public static int getDimNumeroSupporti() {
		return dimNumeroSupporti;
	}

	/**
	 * @return
	 */
	public static int getDimProvinciaDepositoFiscale() {
		return dimProvinciaDepositoFiscale;
	}

	/**
	 * @return
	 */
	public static int getDimProvinciaSedeUfficioAmm() {
		return dimProvinciaSedeUfficioAmm;
	}

	/**
	 * @return
	 */
	public static int getDimTipologiaDichiarante() {
		return dimTipologiaDichiarante;
	}

	/**
	 * @return
	 */
	public static int getDimTotaleRecordInFile() {
		return dimTotaleRecordInFile;
	}

	/**
	 * @return
	 */
	public String getComuneSedeDepositoFiscale() {
		return comuneSedeDepositoFiscale;
	}

	/**
	 * @return
	 */
	public String getComuneSedeUfficioAmm() {
		return comuneSedeUfficioAmm;
	}

	/**
	 * @return
	 */
	public String getIndirizzoDepositoFiscale() {
		return indirizzoDepositoFiscale;
	}

	/**
	 * @return
	 */
	public String getIndirizzoSedeUfficioAmm() {
		return indirizzoSedeUfficioAmm;
	}

	/**
	 * @return
	 */
	public BigInteger getNumeroRecordTipo10() {
		return numeroRecordTipo10;
	}

	/**
	 * @return
	 */
	public BigInteger getNumeroRecordTipo11() {
		return numeroRecordTipo11;
	}

	/**
	 * @return
	 */
	public BigInteger getNumeroRecordTipo15() {
		return numeroRecordTipo15;
	}

	/**
	 * @return
	 */
	public BigInteger getNumeroRecordTipo16() {
		return numeroRecordTipo16;
	}

	/**
	 * @return
	 */
	public BigInteger getNumeroRecordTipo20() {
		return numeroRecordTipo20;
	}

	/**
	 * @return
	 */
	public BigInteger getNumeroRecordTipo31() {
		return numeroRecordTipo31;
	}

	/**
	 * @return
	 */
	public BigInteger getNumeroRecordTipo32() {
		return numeroRecordTipo32;
	}

	/**
	 * @return
	 */
	public BigInteger getNumeroRecordTipo40() {
		return numeroRecordTipo40;
	}

	/**
	 * @return
	 */
	public BigInteger getNumeroRecordTipo50() {
		return numeroRecordTipo50;
	}

	/**
	 * @return
	 */
	public BigInteger getNumeroRecordTipo55() {
		return numeroRecordTipo55;
	}

	/**
	 * @return
	 */
	public BigInteger getNumeroRecordTipo60() {
		return numeroRecordTipo60;
	}

	/**
	 * @return
	 */
	public BigInteger getNumeroRecordTipo65() {
		return numeroRecordTipo65;
	}

	/**
	 * @return
	 */
	public BigInteger getNumeroRecordTipo70() {
		return numeroRecordTipo70;
	}

	/**
	 * @return
	 */
	public BigInteger getNumeroRecordTipo75() {
		return numeroRecordTipo75;
	}

	/**
	 * @return
	 */
	public BigInteger getNumeroSupporti() {
		return numeroSupporti;
	}

	/**
	 * @return
	 */
	public String getProvinciaDepositoFiscale() {
		return provinciaDepositoFiscale;
	}

	/**
	 * @return
	 */
	public String getProvinciaSedeUfficioAmm() {
		return provinciaSedeUfficioAmm;
	}

	/**
	 * @return
	 */
	public String getTipologiaDichiarante() {
		return tipologiaDichiarante;
	}

	/**
	 * @return
	 */
	public BigInteger getTotaleRecordInFile() {
		return totaleRecordInFile;
	}

	/**
	 * @param string
	 */
	public void setComuneSedeDepositoFiscale(String string) {
		comuneSedeDepositoFiscale = string;
	}

	/**
	 * @param string
	 */
	public void setComuneSedeUfficioAmm(String string) {
		comuneSedeUfficioAmm = string;
	}

	/**
	 * @param string
	 */
	public void setIndirizzoDepositoFiscale(String string) {
		indirizzoDepositoFiscale = string;
	}

	/**
	 * @param string
	 */
	public void setIndirizzoSedeUfficioAmm(String string) {
		indirizzoSedeUfficioAmm = string;
	}

	/**
	 * @param i
	 */
	public void setNumeroRecordTipo10(BigInteger i) {
		numeroRecordTipo10 = i;
	}

	/**
	 * @param i
	 */
	public void setNumeroRecordTipo11(BigInteger i) {
		numeroRecordTipo11 = i;
	}

	/**
	 * @param i
	 */
	public void setNumeroRecordTipo15(BigInteger i) {
		numeroRecordTipo15 = i;
	}

	/**
	 * @param i
	 */
	public void setNumeroRecordTipo16(BigInteger i) {
		numeroRecordTipo16 = i;
	}

	/**
	 * @param i
	 */
	public void setNumeroRecordTipo20(BigInteger i) {
		numeroRecordTipo20 = i;
	}

	/**
	 * @param i
	 */
	public void setNumeroRecordTipo31(BigInteger i) {
		numeroRecordTipo31 = i;
	}

	/**
	 * @param i
	 */
	public void setNumeroRecordTipo32(BigInteger i) {
		numeroRecordTipo32 = i;
	}

	/**
	 * @param i
	 */
	public void setNumeroRecordTipo40(BigInteger i) {
		numeroRecordTipo40 = i;
	}

	/**
	 * @param i
	 */
	public void setNumeroRecordTipo50(BigInteger i) {
		numeroRecordTipo50 = i;
	}

	/**
	 * @param i
	 */
	public void setNumeroRecordTipo55(BigInteger i) {
		numeroRecordTipo55 = i;
	}

	/**
	 * @param i
	 */
	public void setNumeroRecordTipo60(BigInteger i) {
		numeroRecordTipo60 = i;
	}

	/**
	 * @param i
	 */
	public void setNumeroRecordTipo65(BigInteger i) {
		numeroRecordTipo65 = i;
	}

	/**
	 * @param i
	 */
	public void setNumeroRecordTipo70(BigInteger i) {
		numeroRecordTipo70 = i;
	}

	/**
	 * @param i
	 */
	public void setNumeroRecordTipo75(BigInteger i) {
		numeroRecordTipo75 = i;
	}

	/**
	 * @param i
	 */
	public void setNumeroSupporti(BigInteger i) {
		numeroSupporti = i;
	}

	/**
	 * @param string
	 */
	public void setProvinciaDepositoFiscale(String string) {
		provinciaDepositoFiscale = string;
	}

	/**
	 * @param string
	 */
	public void setProvinciaSedeUfficioAmm(String string) {
		provinciaSedeUfficioAmm = string;
	}

	/**
	 * @param string
	 */
	public void setTipologiaDichiarante(String string) {
		tipologiaDichiarante = string;
	}

	/**
	 * @param i
	 */
	public void setTotaleRecordInFile(BigInteger i) {
		totaleRecordInFile = i;
	}

	/**
	 * @param integer
	 */
	public void setNumeroTotaleRecord(BigInteger integer) {
		numeroTotaleRecord = integer;
	}

	/**
	 * @return
	 */
	public static int getDimNumeroRecordTipo80() {
		return dimNumeroRecordTipo80;
	}



	/**
	 * @return
	 */
	public BigInteger getNumeroRecordTipo80() {
		return numeroRecordTipo80;
	}

	/**
	 * @param integer
	 */
	public void setNumeroRecordTipo80(BigInteger integer) {
		numeroRecordTipo80 = integer;
	}

	/**
	 * @return
	 */
	public BigInteger getNumeroTotaleRecord() {
		return numeroTotaleRecord;
	}

}
