/*
 * Created on 20-set-06
 *
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package it.finanze.dogane.accise.metano.model;

import it.finanze.dogane.accise.model.AbstractRecord;
import it.finanze.dogane.accise.util.StringUtil;

import java.io.IOException;
import java.math.BigDecimal;
import java.math.BigInteger;

/**
 * @author Fiorello
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class MetanoLiquidazioneImposte extends MetanoRecord {

	//dichiarazione variabili
	private String letteraIdentificativa = "";
	private BigInteger capitoliImputazioneImposta = BigInteger.valueOf(0);
	private BigInteger campoADisposizione = BigInteger.valueOf(0);
	private BigInteger tipoRigo = BigInteger.valueOf(0);
	private String fasciaClimatica = "";
	private BigInteger progressivoIdentificativo = BigInteger.valueOf(-1);
	private BigInteger progressivoRecordRigo = BigInteger.valueOf(0);
	private String segnoConsumi = "+";
	private BigInteger consumi = BigInteger.valueOf(0);
	private BigDecimal aliquotaImposta = BigDecimal.valueOf(0);
	private String segnoImposta = "";
	private BigDecimal impostaEuro = BigDecimal.valueOf(0);
	
	//inizializzazione variabili
	public static final int DIM_LETTERA_IDENTIFICATIVA = 1;
	public static final int DIM_CAPITOLI_IMPUTAZIONE_IMPOSTA = 4;
	public static final int DIM_CAMPO_A_DISPOSIZIONE = 2;
	public static final int DIM_TIPO_RIGO = 1;
	public static final int DIM_FASCIA_CLIMATICA = 3;
	public static final int DIM_PROGRESSIVO_IDENTIFICATIVO = 2;
	public static final int DIM_PROGRESSIVO_RECORD_RIGO = 2;
	public static final int DIM_SEGNO_CONSUMI = 1;
	public static final int DIM_CONSUMI = 13;
	public static final int DIM_ALIQUOTA_IMPOSTA_INTERE = 1;
	public static final int DIM_ALIQUOTA_IMPOSTA_DECIMALI = 7;
	public static final int DIM_SEGNO_IMPOSTA = 1;
	public static final int DIM_IMPOSTA_EURO_INTERE = 12;
	public static final int DIM_IMPOSTA_EURO_DECIMALI = 2;

	public void scriviOggetto(java.io.OutputStream out) throws IOException {

		super.scriviOggetto(out);
		out.write(normalizzaCampo(this.letteraIdentificativa, DIM_LETTERA_IDENTIFICATIVA));
		out.write(normalizzaCampo(this.capitoliImputazioneImposta,DIM_CAPITOLI_IMPUTAZIONE_IMPOSTA));
		out.write(normalizzaCampo(this.campoADisposizione, DIM_CAMPO_A_DISPOSIZIONE));
		out.write(normalizzaCampo(this.tipoRigo, DIM_TIPO_RIGO));
		out.write(normalizzaCampo(this.fasciaClimatica, DIM_FASCIA_CLIMATICA));
		out.write(normalizzaCampo(this.progressivoIdentificativo,DIM_PROGRESSIVO_IDENTIFICATIVO));
		out.write(normalizzaCampo(this.progressivoRecordRigo,DIM_PROGRESSIVO_RECORD_RIGO));

		//out.write(normalizzaCampo(this.segnoConsumi, DIM_SEGNO_CONSUMI));
		out.write(normalizzaCampo(getSegnoConsumi(), DIM_SEGNO_CONSUMI));

		out.write(normalizzaCampo(this.consumi, DIM_CONSUMI));
		out.write(normalizzaCampo(aliquotaImposta,DIM_ALIQUOTA_IMPOSTA_INTERE,DIM_ALIQUOTA_IMPOSTA_DECIMALI));

		//out.write(normalizzaCampo(segnoImposta, DIM_SEGNO_IMPOSTA));
		out.write(normalizzaCampo(getSegnoImposta(), DIM_SEGNO_IMPOSTA));

		out.write(normalizzaCampo(this.impostaEuro,DIM_IMPOSTA_EURO_INTERE,DIM_IMPOSTA_EURO_DECIMALI));

		scriviFineRiga(out);
	}

	public void leggiOggetto(java.io.InputStream in) throws IOException {

		super.leggiOggetto(in);

		this.letteraIdentificativa = readFieldString(in, DIM_LETTERA_IDENTIFICATIVA);
		capitoliImputazioneImposta = readFieldBigInteger(in, DIM_CAPITOLI_IMPUTAZIONE_IMPOSTA);
		campoADisposizione = readFieldBigInteger(in, DIM_CAMPO_A_DISPOSIZIONE);
		tipoRigo = readFieldBigInteger(in, DIM_TIPO_RIGO);
		fasciaClimatica = readFieldString(in, DIM_FASCIA_CLIMATICA);
		progressivoIdentificativo = readFieldBigInteger(in, DIM_PROGRESSIVO_IDENTIFICATIVO);
		progressivoRecordRigo = readFieldBigInteger(in, DIM_PROGRESSIVO_RECORD_RIGO);
		
		segnoConsumi = readFieldString(in, DIM_SEGNO_CONSUMI);
		consumi = readFieldBigInteger(in, DIM_CONSUMI);
		if(AbstractRecord.MINUS.equals(segnoConsumi)) {
			BigInteger consumiNew = consumi.multiply(BigInteger.valueOf(-1));
			consumi=consumiNew;
		}

		aliquotaImposta = readFieldBigDecimal(in,DIM_ALIQUOTA_IMPOSTA_INTERE,DIM_ALIQUOTA_IMPOSTA_DECIMALI);

		segnoImposta = readFieldString(in, DIM_SEGNO_IMPOSTA);
		impostaEuro = readFieldBigDecimal(in,DIM_IMPOSTA_EURO_INTERE,DIM_IMPOSTA_EURO_DECIMALI);
		if(AbstractRecord.MINUS.equals(segnoImposta)) {
			BigDecimal impostaEuroNew = impostaEuro.multiply(BigDecimal.valueOf(-1));
			impostaEuro=impostaEuroNew;
		}

		saltaFineRiga(in);
		setTipoRigo();
	}
	
	/**
	 * Restituisce una stringa composta di capitolo articolo prendendo i valori iniziali dai metodi
	 * getCapitoliImputazioneImposta e getArticoloProgressivoImposta
	 * @return
	 */
	/***
	public String getCapitoloArticolo() {
		String capitolo = null;
		String articolo = null;
			
		capitolo = String.valueOf(getCapitoliImputazioneImposta());
		articolo = String.valueOf(getArticoloProgressivoImposta());

		while(articolo.length() < 2) { // gli articoli sono sempre di 2 caratteri
			articolo = "0" + articolo;			
		}

		String capitoloArticolo = capitolo + articolo; // Non ci dovrebbero essere capitoli inferiori a 1000 e superiori a 9999
		return capitoloArticolo;
	}
	***/

	/**
	 * @return aliquotaImposta
	 */
	public BigDecimal getAliquotaImposta() {
		return this.aliquotaImposta;
	}

	/**
	 * @return campoADisposizione
	 */
	public BigInteger getCampoADisposizione() {
		return this.campoADisposizione;
	}

	/**
	 * @return capitoliImputazioneImposta
	 */
	public BigInteger getCapitoliImputazioneImposta() {
		return this.capitoliImputazioneImposta;
	}

	/**
	 * @return consumi
	 */
	public BigInteger getConsumi() {
		return this.consumi;
	}

	/**
	 * @return fasciaClimatica
	 */
	public String getFasciaClimatica() {
		return this.fasciaClimatica;
	}

	/**
	 * @return impostaEuro
	 */
	public BigDecimal getImpostaEuro() {
		return this.impostaEuro;
	}

	/**
	 * @return letteraIdentificativa
	 */
	public String getLetteraIdentificativa() {
		return this.letteraIdentificativa;
	}

	/**
	 * @return progressivoIdentificativo
	 */
	public BigInteger getProgressivoIdentificativo() {
		return this.progressivoIdentificativo;
	}

	/**
	 * @return progressivoRecordRigo
	 */
	public BigInteger getProgressivoRecordRigo() {
		return this.progressivoRecordRigo;
	}

	/**
	 * @return segnoConsumi
	 */
	public String getSegnoConsumi() {
		//return this.segnoConsumi;
		String retvalue = AbstractRecord.PLUS;
		// se l'importo  minore di zero
		if(consumi.compareTo(BigInteger.valueOf(0))==-1) {
			retvalue = AbstractRecord.MINUS;
		}
		return retvalue;
	}

	/**
	 * @return segnoImposta
	 */
	public String getSegnoImposta() {
		//return this.segnoImposta;
		String retvalue = AbstractRecord.PLUS;
		// se l'importo  minore di zero
		if(impostaEuro.compareTo(BigDecimal.valueOf(0))==-1) {
			retvalue = AbstractRecord.MINUS;
		}
		return retvalue;
	}

	/**
	 * @return tipoRigo
	 */
	public BigInteger getTipoRigo() {
		return this.tipoRigo;
	}

	/**
	 * @param aliquotaImposta
	 */
	public void setAliquotaImposta(BigDecimal aliquotaImposta) {
		this.aliquotaImposta = aliquotaImposta;
	}

	/**
	 * @param campoADisposizione
	 */
	public void setCampoADisposizione(BigInteger campoADisposizione) {
		this.campoADisposizione = campoADisposizione;
	}

	/**
	 * @param capitoliImputazioneImposta
	 */
	public void setCapitoliImputazioneImposta(BigInteger capitoliImputazioneImposta) {
		this.capitoliImputazioneImposta = capitoliImputazioneImposta;
	}

	/**
	 * @param consumi
	 */
	public void setConsumi(BigInteger consumi) {
		this.consumi = consumi;
	}

	/**
	 * @param fasciaClimatica
	 */
	public void setFasciaClimatica(String fasciaClimatica) {
		this.fasciaClimatica = fasciaClimatica;
	}

	/**
	 * @param impostaEuro
	 */
	public void setImpostaEuro(BigDecimal impostaEuro) {
		this.impostaEuro = impostaEuro;
	}

	/**
	 * @param letteraIdentificativa
	 */
	public void setLetteraIdentificativa(String lettIdentificativa) {
		this.letteraIdentificativa = lettIdentificativa;
		setTipoRigo();
	}

	/**
	 * @param progressivoIdentificativo
	 */
	public void setProgressivoIdentificativo(BigInteger progressivoIdentificativo) {
		this.progressivoIdentificativo = progressivoIdentificativo;
		setTipoRigo();
	}

	/**
	 * @param progressivoRecordRigo
	 */
	public void setProgressivoRecordRigo(BigInteger progressivoRecordRigo) {
		this.progressivoRecordRigo = progressivoRecordRigo;
	}

	/**
	 * @param segnoConsumi
	 */
	public void setSegnoConsumi(String segnoConsumi) {
		this.segnoConsumi = segnoConsumi;
	}

	/**
	 * @param segnoImposta
	 */
	public void setSegnoImposta(String segnoImposta) {
		this.segnoImposta = segnoImposta;
	}

	/**
	 * @param tipoRigo
	 */
	public void setTipoRigo(BigInteger tipoRigo) {
		this.tipoRigo = tipoRigo;
	}

	/**
	 * Ridefinisco il metodo per impostare la lettera identificativa del quadro
	 */
	public void setTipoRecord(BigInteger i) {
		super.setTipoRecord(i);
		if (i.equals(BigInteger.valueOf(50))) {
			setLetteraIdentificativa("I");
		}
		else if (i.equals(BigInteger.valueOf(60))) {
			setLetteraIdentificativa("M");
		}
		else if (i.equals(BigInteger.valueOf(70))) {
			setLetteraIdentificativa("O");
		}
	}

	/**
	 * Imposta correttamente il Tipo Rigo se la lettera identificativa e il progressivo sono correttamente impostate 
	 */
	public void setTipoRigo() {
		if(StringUtil.nullify(letteraIdentificativa) != null && !progressivoIdentificativo.equals(BigInteger.valueOf(-1))) {
			if(letteraIdentificativa.equalsIgnoreCase("I")) {
				setTipoRigoForI();
			} else if(letteraIdentificativa.equalsIgnoreCase("M")) {
				setTipoRigoForM();
			} else if(letteraIdentificativa.equalsIgnoreCase("O")) {
				setTipoRigoForO();
			}
		}
	}

	/**
	 * 
	 */
	/** MODIFICA 25-10-2007 **/
	private void setTipoRigoForI() {
		int progressivo = progressivoIdentificativo.intValue();
		if(
			(progressivo == 1) ||
			(progressivo >= 4 && progressivo <= 13)) { // vecchio valore progressivo <= 12
		
			setTipoRigo(BigInteger.ZERO);
		
		} else if(
			(progressivo == 2) ||
			(progressivo == 14)) { // vecchio valore progressivo == 13
				
			setTipoRigo(BigInteger.ONE);
			
		} else if(
			(progressivo == 3) ||
			(progressivo == 15)) { // vecchio valore progressivo == 14
					
			setTipoRigo(BigInteger.valueOf(9));
		} else {
			// NON DOVREBBE MAI CAPITARE
			throw new IllegalStateException("Stato del bean non valido....");
		}
	}
	/** FINE MODIFICA **/
	/**
	 * 
	 */
	private void setTipoRigoForM() {
		int progressivo = progressivoIdentificativo.intValue();
		if(
			(progressivo >= 1 && progressivo <= 6)) {
		
			setTipoRigo(BigInteger.ZERO);
		
		} else if(
			(progressivo == 7)) {
				
			setTipoRigo(BigInteger.ONE);
			
		} else if(
			(progressivo == 8)) {
					
			setTipoRigo(BigInteger.valueOf(9));
		} else {
			// NON DOVREBBE MAI CAPITARE
			throw new IllegalStateException("Stato del bean non valido....");
		}
	}

	/**
	 * 
	 */
	private void setTipoRigoForO() {
		int progressivo = progressivoIdentificativo.intValue();
		if(
			(progressivo >= 1 && progressivo <= 7)) {
		
			setTipoRigo(BigInteger.ZERO);
		
		} else if(
			(progressivo == 8)) {
				
			setTipoRigo(BigInteger.ONE);
			
		} else if(
			(progressivo == 9)) {
					
			setTipoRigo(BigInteger.valueOf(9));
		} else {
			// NON DOVREBBE MAI CAPITARE
			throw new IllegalStateException("Stato del bean non valido....");
		}
	}

	public Object clone() throws CloneNotSupportedException {
		MetanoLiquidazioneImposte clonato = new MetanoLiquidazioneImposte();

		clonato.setAliquotaImposta(this.getAliquotaImposta());
		clonato.setAnnoDichiarazione(this.getAnnoDichiarazione());
		clonato.setCampoADisposizione(this.getCampoADisposizione());
		clonato.setCapitoliImputazioneImposta(this.getCapitoliImputazioneImposta());
		clonato.setConsumi(this.getConsumi());
		clonato.setImpostaEuro(this.getImpostaEuro());
		clonato.setLetteraIdentificativa(this.getLetteraIdentificativa());
		clonato.setMese(this.getMese());
		clonato.setProgressivoIdentificativo(this.getProgressivoIdentificativo());
		clonato.setProgressivoRecordRigo(this.getProgressivoRecordRigo());
	    clonato.setSegnoConsumi(this.getSegnoConsumi());
		clonato.setSegnoImposta(this.getSegnoImposta());
		clonato.setTipoRecord(this.getTipoRecord());
		clonato.setTipoRigo(this.getTipoRigo());
		clonato.setFasciaClimatica(this.getFasciaClimatica());
		clonato.setCodiceAccisa(this.getCodiceAccisa());
		clonato.setProvincia(this.getProvincia());

		return clonato;
	}

	public static MetanoLiquidazioneImposte getNewObject(ProspettoConsumo prospettoConsumo) {
		MetanoLiquidazioneImposte retvalue = new MetanoLiquidazioneImposte();
		Frontespizio frontespizio = prospettoConsumo.getFrontespizio();
		retvalue.setAnnoDichiarazione(frontespizio.getAnnoDichiarazione());
		retvalue.setCodiceAccisa(frontespizio.getCodiceAccisa());
		return retvalue;
	}
}
