/*
 * Created on 26-set-06
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package it.finanze.dogane.accise.metano.model;

import it.finanze.dogane.accise.model.AbstractRecord;

import java.io.IOException;
import java.math.BigDecimal;
import java.math.BigInteger;

/**
 * @author Fiorello
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class MetanoRettificheFatturazione extends MetanoRecord {

	//dichiarazioni variabili
	private String letteraIdentificativa = "";
	private BigInteger progIdentificativoUso = BigInteger.valueOf(0);
	private BigInteger progRecordUso = BigInteger.valueOf(0);
	private String locUtenzeCivili = "";
	private BigDecimal importoEuro = BigDecimal.valueOf(0);
	private BigInteger quantita = BigInteger.valueOf(0);
	private BigDecimal aliquotaImposta = BigDecimal.valueOf(000000);
	private String segno;
	//valorizzazioni delle variabili
	public static final int dimLetteraIdentificativa = 1;
	public static final int dimProgIdentificativoUso = 2;
	public static final int dimProgRecordUso = 3;
	public static final int dimLocUtenzeCivili = 1;
	public static final int dimSegno = 1;
	public static final int dimImportoEuroIntere = 12;
	public static final int dimImportoEuroDecimale = 2;
	public static final int dimQuantita = 13;
	public static final int dimAliquotaImpostaIntere = 1;
	public static final int dimAliquotaImpostaDecimale = 7;

	public void scriviOggetto(java.io.OutputStream out) throws IOException {

		super.scriviOggetto(out);
		out.write(normalizzaCampo(letteraIdentificativa, dimLetteraIdentificativa));
		out.write(normalizzaCampo(progIdentificativoUso, dimProgIdentificativoUso));
		out.write(normalizzaCampo(progRecordUso, dimProgRecordUso));
		out.write(normalizzaCampo(locUtenzeCivili, dimLocUtenzeCivili));
		out.write(normalizzaCampo(getSegno(), dimSegno));
		out.write(normalizzaCampo(importoEuro, dimImportoEuroIntere, dimImportoEuroDecimale));
		out.write(normalizzaCampo(quantita, dimQuantita));
		out.write(normalizzaCampo(aliquotaImposta,dimAliquotaImpostaIntere,dimAliquotaImpostaDecimale));
		scriviFineRiga(out);
	}

	public void leggiOggetto(java.io.InputStream in) throws IOException {

		super.leggiOggetto(in);

		letteraIdentificativa = readFieldString(in, dimLetteraIdentificativa);
		progIdentificativoUso =	readFieldBigInteger(in, dimProgIdentificativoUso);
		progRecordUso = readFieldBigInteger(in, dimProgRecordUso);
		locUtenzeCivili = readFieldString(in, dimLocUtenzeCivili);

		String segnoImporto = readFieldString(in, dimSegno);
		importoEuro = readFieldBigDecimal(in,dimImportoEuroIntere,dimImportoEuroDecimale);
		if (AbstractRecord.MINUS.equals(segnoImporto) /* && progRecordUso.equals(BigInteger.valueOf(999)) */) {
			importoEuro = importoEuro.negate();
			// importoEuro = importoEuro.multiply(BigDecimal.valueOf(-1));
		}
		quantita = readFieldBigInteger(in, dimQuantita);
		aliquotaImposta =readFieldBigDecimal(in,dimAliquotaImpostaIntere,dimAliquotaImpostaDecimale);

		saltaFineRiga(in);
	}

	/*public void setSegno(String segno) {
		
		this.segno = segno;
	
	}*/
	
	public String getSegno() {
		
		String retvalue = AbstractRecord.PLUS;
		
		// minore di zero
		if(importoEuro.compareTo(BigDecimal.valueOf(0))==-1) {
			retvalue = AbstractRecord.MINUS;
		}
		this.segno = retvalue;
		
		return this.segno;
	}

	/**
	 * @return
	 */
	public BigDecimal getAliquotaImposta() {
		return aliquotaImposta;
	}

	/**
	 * @return
	 */
	public BigDecimal getImportoEuro() {
		return importoEuro;
	}

	/**
	 * @return
	 */
	public String getLetteraIdentificativa() {
		return letteraIdentificativa;
	}

	/**
	 * @return
	 */
	public String getLocUtenzeCivili() {
		return locUtenzeCivili;
	}

	/**
	 * @return
	 */
	public BigInteger getProgIdentificativoUso() {
		return progIdentificativoUso;
	}

	/**
	 * @return
	 */
	public BigInteger getProgRecordUso() {
		return progRecordUso;
	}

	/**
	 * @return
	 */
	public BigInteger getQuantita() {
		return quantita;
	}

	/**
	 * @param integer
	 */
	public void setAliquotaImposta(BigDecimal integer) {
		aliquotaImposta = integer;
	}

	/**
	 * @param decimal
	 */
	public void setImportoEuro(BigDecimal decimal) {
		importoEuro = decimal;
	}

	/**
	 * @param string
	 */
	public void setLetteraIdentificativa(String string) {
		letteraIdentificativa = string;
	}

	/**
	 * @param string
	 */
	public void setLocUtenzeCivili(String string) {
		locUtenzeCivili = string;
	}

	/**
	 * @param integer
	 */
	public void setProgIdentificativoUso(BigInteger integer) {
		progIdentificativoUso = integer;
	}

	/**
	 * @param integer
	 */
	public void setProgRecordUso(BigInteger integer) {
		progRecordUso = integer;
	}

	/**
	 * @param integer
	 */
	public void setQuantita(BigInteger integer) {
		quantita = integer;
	}

	/**
	 * Ridefinisco il metodo per impostare la lettera identificativa del quadro
	 */
	public void setTipoRecord(BigInteger i) {
		super.setTipoRecord(i);
		setLetteraIdentificativa("H");
	}

	public Object clone() throws CloneNotSupportedException {
		MetanoRettificheFatturazione clonato =
			new MetanoRettificheFatturazione();
		clonato.setCodiceAccisa(this.getCodiceAccisa());
		clonato.setAnnoDichiarazione(this.getAnnoDichiarazione());	
		clonato.setTipoRecord(this.getTipoRecord());
		clonato.setProvincia(this.getProvincia());
		clonato.setMese(this.getMese());
		clonato.setLetteraIdentificativa(this.getLetteraIdentificativa());
		clonato.setProgIdentificativoUso(this.getProgIdentificativoUso());
		clonato.setProgRecordUso(this.getProgRecordUso());
		clonato.setLocUtenzeCivili(this.getLocUtenzeCivili());
		clonato.setImportoEuro(this.getImportoEuro());
		clonato.setQuantita(this.getQuantita());
		clonato.setAliquotaImposta(this.getAliquotaImposta());

		return clonato;
	}

	public static MetanoRettificheFatturazione getNewObject(ProspettoConsumo prospettoConsumo) {
		MetanoRettificheFatturazione retvalue =	new MetanoRettificheFatturazione();
		Frontespizio frontespizio = prospettoConsumo.getFrontespizio();

		retvalue.setAnnoDichiarazione(frontespizio.getAnnoDichiarazione());
		retvalue.setCodiceAccisa(frontespizio.getCodiceAccisa());

		return retvalue;
	}
}
