/*
 * Created on 22-set-06
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 * 
 * 
 */
package it.finanze.dogane.accise.metano.model;

import it.finanze.dogane.accise.model.AbstractRecord;

import java.io.IOException;
import java.math.BigDecimal;
import java.math.BigInteger;

/**
 * @author Fiorello
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class MetanoRiepilogoSaldoImposte extends MetanoRecord {
	
		//dichiarazioni variabili
		private String letteraIdentificativa = "";
		private BigInteger capitoliImputazioneImposta = BigInteger.valueOf(0);
		private BigInteger campoDisponibile = BigInteger.valueOf(0);
		private BigInteger progressivoIdentificativo = BigInteger.valueOf(0);
		private String segnoLiquidataAddLiq = "";
		private BigDecimal importoEuro = BigDecimal.valueOf(0);
	
		//valorizzazioni delle variabili
		public static final int dimLetteraIdentificativa =1 ;
		public static final int dimCapitoliImputazioneImposta = 4;
		public static final int dimCampoDisponibile = 2;
		public static final int dimProgrIdentificativoRigoDescrizione =3 ;
		public static final int dimSegnoLiquidataAddLiq =1 ;
		public static final int dimImportoEuroIntere = 12;
		public static final int dimImportoEuroDecimale = 2;

		public void scriviOggetto(java.io.OutputStream out) throws IOException {

			super.scriviOggetto(out);
			out.write(normalizzaCampo(letteraIdentificativa, dimLetteraIdentificativa));
			out.write(normalizzaCampo(capitoliImputazioneImposta, dimCapitoliImputazioneImposta));
			out.write(normalizzaCampo(campoDisponibile, dimCampoDisponibile));
			out.write(normalizzaCampo(progressivoIdentificativo, dimProgrIdentificativoRigoDescrizione));
			out.write(normalizzaCampo(getSegnoLiquidataAddLiq(), dimSegnoLiquidataAddLiq));
			out.write(normalizzaCampo(importoEuro, dimImportoEuroIntere, dimImportoEuroDecimale));
		
			scriviFineRiga(out);
		}
	
		public void leggiOggetto(java.io.InputStream in) throws IOException {

			super.leggiOggetto(in);

			letteraIdentificativa = readFieldString(in, dimLetteraIdentificativa); 
			capitoliImputazioneImposta = readFieldBigInteger(in, dimCapitoliImputazioneImposta); 
			campoDisponibile = readFieldBigInteger(in, dimCampoDisponibile); 
			progressivoIdentificativo = readFieldBigInteger(in, dimProgrIdentificativoRigoDescrizione); 
			String segno = readFieldString(in, dimSegnoLiquidataAddLiq); 
			importoEuro = readFieldBigDecimal(in, dimImportoEuroIntere, dimImportoEuroDecimale);
			if(AbstractRecord.MINUS.equals(segno)) {
				//importoEuro *= -1; 
				BigDecimal importoEuroNew = importoEuro.multiply(BigDecimal.valueOf(-1));
				importoEuro=importoEuroNew;
			}

			saltaFineRiga(in);
		}

		/**
		 * @return
		 */
		public BigInteger getCampoDisponibile() {
			return campoDisponibile;
		}

		/**
		 * @return
		 */
		public BigInteger getCapitoliImputazioneImposta() {
			return capitoliImputazioneImposta;
		}

		/**
		 * @return
		 */
		public BigDecimal getImportoEuro() {
			return importoEuro;
		}

		/**
		 * @return
		 */
		public String getLetteraIdentificativa() {
			return letteraIdentificativa;
		}

		/**
		 * @return
		 */
		public BigInteger getProgressivoIdentificativo() {
			return progressivoIdentificativo;
		}

		/**
		 * @return
		 */
		public String getSegnoLiquidataAddLiq() {
			String retvalue = AbstractRecord.PLUS;
			// se l'importo  minore di zero
			if(importoEuro.compareTo(BigDecimal.valueOf(0))==-1) {
				retvalue = AbstractRecord.MINUS;
			}

			return retvalue;
		}

		/**
		 * @param i
		 */
		public void setCampoDisponibile(BigInteger i) {
			campoDisponibile = i;
		}

		/**
		 * @param i
		 */
		public void setCapitoliImputazioneImposta(BigInteger i) {
			capitoliImputazioneImposta = i;
		}

		/**
		 * @param d
		 */
		public void setImportoEuro(BigDecimal d) {
			importoEuro = d;
		}

		/**
		 * @param string
		 */
		public void setLetteraIdentificativa(String string) {
			letteraIdentificativa = string;
		}

		/**
		 * @param i
		 */
		public void setProgressivoIdentificativo(BigInteger i) {
			progressivoIdentificativo = i;
		}
	
		/**
		 * Ridefinisco il metodo per impostare la lettera identificativa del quadro
		 */
		public void setTipoRecord(BigInteger i) {
			super.setTipoRecord(i);
		
			if(i.equals(BigInteger.valueOf(55))) {
				setLetteraIdentificativa("L");
			} else if(i.equals(BigInteger.valueOf(65))) {
				setLetteraIdentificativa("N");
			} else if(i.equals(BigInteger.valueOf(75))) {
				setLetteraIdentificativa("P");
			} 
		}

		public Object clone() throws CloneNotSupportedException {
			MetanoRiepilogoSaldoImposte clonato = new MetanoRiepilogoSaldoImposte();
		
			clonato.setAnnoDichiarazione(this.getAnnoDichiarazione());
			clonato.setCampoDisponibile(this.getCampoDisponibile());
			clonato.setCapitoliImputazioneImposta(this.getCapitoliImputazioneImposta());
			clonato.setCodiceAccisa(this.getCodiceAccisa());
			clonato.setImportoEuro(this.getImportoEuro());
			clonato.setLetteraIdentificativa(this.getLetteraIdentificativa());
			clonato.setMese(this.getMese());
			clonato.setProgressivoIdentificativo(this.getProgressivoIdentificativo());
			clonato.setTipoRecord(this.getTipoRecord());
			clonato.setProvincia(this.getProvincia());
		
			return clonato;
		}

		public static MetanoRiepilogoSaldoImposte getNewObject(ProspettoConsumo prospettoConsumo) {
			MetanoRiepilogoSaldoImposte retvalue = new MetanoRiepilogoSaldoImposte();
			Frontespizio frontespizio = prospettoConsumo.getFrontespizio();
		
			retvalue.setAnnoDichiarazione(frontespizio.getAnnoDichiarazione());
			retvalue.setCodiceAccisa(frontespizio.getCodiceAccisa());
		
			return retvalue;
		}

	}
