package it.finanze.dogane.accise.metano.model;



import it.finanze.dogane.accise.model.DicInterface;
import it.finanze.dogane.accise.model.Prospect;
import it.finanze.dogane.accise.util.ComparatorListModel;
import it.finanze.dogane.accise.util.QuadroUtil;
import it.finanze.dogane.accise.util.ResourceAccess;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.Serializable;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

public class ProspettoConsumo implements Serializable, Prospect {

	private ResourceAccess resourceAccess = new ResourceAccess(this);
	private Frontespizio frontespizio = new Frontespizio();
	private List listaRecord = new LinkedList();

	public void scriviOggetto(java.io.OutputStream out) throws IOException {
		
		updateRecordNumbers();
		frontespizio.scriviOggetto(out);
		Collections.sort(listaRecord, new ComparatorListModel());
		
		Iterator it = listaRecord.iterator();
		
		/** MODIFICA 14-11-2007 **/
		String prev = "";
		String prev1 = "";
		while (it.hasNext()) {
			MetanoRecord record = (MetanoRecord) it.next();
			if(record.getTipoRecord().toString().equals("60")) {
				MetanoLiquidazioneImposte mRecord = (MetanoLiquidazioneImposte) record;
				
				if(mRecord.getProgressivoIdentificativo().toString().equals("7")) {
				   	String curr = mRecord.getProvincia()+""+mRecord.getProgressivoIdentificativo();  
					if(!curr.equals(prev)){
						record.impostaCampiComuni(frontespizio);
						record.scriviOggetto(out);
						prev = curr;
					}
					else
						prev = curr;
				   	}
					else if(mRecord.getProgressivoIdentificativo().toString().equals("8")) {
						String curr = mRecord.getProvincia()+""+mRecord.getProgressivoIdentificativo();  
						if(!curr.equals(prev1)){
							record.impostaCampiComuni(frontespizio);
							record.scriviOggetto(out);
							prev1 = curr;
						}
						else
							prev1 = curr;
						}	
				   
				   
				else {
						record.impostaCampiComuni(frontespizio);
						record.scriviOggetto(out);
				}
					
			}
			else {
				record.impostaCampiComuni(frontespizio);
				record.scriviOggetto(out);
			}
			/** FINE MODIFICA **/
		}
	}
	
	protected void updateRecordNumbers() {
		
		frontespizio.setNumeroRecordTipo10(QuadroUtil.countRecord(listaRecord, BigInteger.valueOf(10)));
		frontespizio.setNumeroRecordTipo11(QuadroUtil.countRecord(listaRecord, BigInteger.valueOf(11)));
		frontespizio.setNumeroRecordTipo15(QuadroUtil.countRecord(listaRecord, BigInteger.valueOf(15)));
		frontespizio.setNumeroRecordTipo16(QuadroUtil.countRecord(listaRecord, BigInteger.valueOf(16)));
		frontespizio.setNumeroRecordTipo20(QuadroUtil.countRecord(listaRecord, BigInteger.valueOf(20)));
		frontespizio.setNumeroRecordTipo31(QuadroUtil.countRecord(listaRecord, BigInteger.valueOf(31)));
		frontespizio.setNumeroRecordTipo32(QuadroUtil.countRecord(listaRecord, BigInteger.valueOf(32)));
		frontespizio.setNumeroRecordTipo40(QuadroUtil.countRecord(listaRecord, BigInteger.valueOf(40)));
		frontespizio.setNumeroRecordTipo50(QuadroUtil.countRecord(listaRecord, BigInteger.valueOf(50)));
		frontespizio.setNumeroRecordTipo55(QuadroUtil.countRecord(listaRecord, BigInteger.valueOf(55)));
		frontespizio.setNumeroRecordTipo60(QuadroUtil.countRecord(listaRecord, BigInteger.valueOf(60)));
		frontespizio.setNumeroRecordTipo65(QuadroUtil.countRecord(listaRecord, BigInteger.valueOf(65)));
		frontespizio.setNumeroRecordTipo70(QuadroUtil.countRecord(listaRecord, BigInteger.valueOf(70)));
		frontespizio.setNumeroRecordTipo75(QuadroUtil.countRecord(listaRecord, BigInteger.valueOf(75)));
		frontespizio.setNumeroRecordTipo80(QuadroUtil.countRecord(listaRecord, BigInteger.valueOf(80)));
		frontespizio.setTotaleRecordInFile(BigInteger.valueOf(listaRecord.size() + 1));
		}
	
	

	public void leggiOggetto(java.io.InputStream in) throws IOException {

		frontespizio = new Frontespizio();
		listaRecord.clear();

		frontespizio.leggiOggetto(in);
		BufferedReader reader = new BufferedReader(new InputStreamReader(in));
		
		MetanoRecord record = RecordFactory.readNextRecord(reader);
		while(record != null) {
			listaRecord.add(record);
			record = RecordFactory.readNextRecord(reader);
		}
		reader.close();
	}

	/**
	 * @return
	 */
	public Frontespizio getFrontespizio() {
		return frontespizio;
	}

	/**
	 * @param frontespizio
	 */
	public void setFrontespizio(Frontespizio frontespizio) {
		this.frontespizio = frontespizio;
	}
	//Questo metodo restituisce la lista con i diversi quadri in base alla provincia selezioinata
	public List getListaQuadro(int[] tipologieQuadro) {
		return QuadroUtil.getListaQuadro(listaRecord, tipologieQuadro);
	}

	public void setListaQuadro(List listaQuadro, int[] tipologieQuadro) {

		QuadroUtil.removeListaQuadro(listaRecord, tipologieQuadro);
		QuadroUtil.addListaQuadro(listaRecord, listaQuadro);
	}
	



	public ResourceAccess getResourceAccess() {
		return resourceAccess;
	}

	public void setResourceAccess(ResourceAccess access) {
		resourceAccess = access;
	}

	public Object scriviOggettoInterchange() throws IOException {
		throw new UnsupportedOperationException();
	}
	public void setListaRecord(List listaRec){
		this.listaRecord=listaRec;
	}
	public List getListaRecord(){
		return this.listaRecord;
	}

}
