package it.finanze.dogane.accise.metano.pdf;

import it.finanze.dogane.accise.combo.ComboDataSource;
import it.finanze.dogane.accise.combo.TipoProvincia;
import it.finanze.dogane.accise.metano.model.Frontespizio;
import it.finanze.dogane.accise.metano.model.MetanoRecord;
import it.finanze.dogane.accise.metano.model.ProspettoConsumo;
import it.finanze.dogane.accise.pdf.AbstractPdfProspectWriter;
import it.finanze.dogane.accise.pdf.PdfBuilder;

public class PdfProspectWriter extends AbstractPdfProspectWriter {

	protected void printFrontespizio(PdfBuilder pdfBuilder) {
		
		ProspettoConsumo prospetto = (ProspettoConsumo)getProspect();
		Frontespizio frontespizio = prospetto.getFrontespizio();
		
		pdfBuilder.newPage();
		pdfBuilder.moveYPen(50);
		pdfBuilder.writeCenteredLabel("AGENZIA DELLE DOGANE", 18);
		pdfBuilder.moveYPen(20);
		//pdfBuilder.writeCenteredLabel("Ufficio delle Dogane di "+frontespizio.getComuneSedeUfficioAmm(), 14);
		pdfBuilder.writeCenteredLabel("Ufficio di ________________________", 10);
		pdfBuilder.moveYPen(30);
		
		String autorizzato = frontespizio.getTipologiaDichiarante();
		
		if(autorizzato.equals("S"))
		{
			pdfBuilder.writeCenteredLabel("[X] "+" Soggetto obbligato " + "                " + "[  ] " +" Altro soggetto ",12);	
		}
		else{
			pdfBuilder.writeCenteredLabel("[  ] "+" Soggetto obbligato " + "                " + "[X] "+" Altro soggetto ",12);
		}
		
		pdfBuilder.moveYPen(20);
		pdfBuilder.moveXPen(80);
		pdfBuilder.writeLeftLabel("Codice Accisa/Ditta  " + "IT00"+frontespizio.getCodiceAccisa().toUpperCase() ,12);
		pdfBuilder.writeLeftLabel("Denominazione  "+ frontespizio.getDenominazioneDitta() ,12);
		pdfBuilder.writeLeftLabel("Comune  "+ frontespizio.getComuneSedeDepositoFiscale()+" ("+ frontespizio.getProvinciaDepositoFiscale() + ")" ,12);
		pdfBuilder.writeLeftLabel("Indirizzo  "+ frontespizio.getIndirizzoDepositoFiscale() ,12);
		pdfBuilder.moveYPen(30);
		pdfBuilder.writeCenteredLabel("IMPOSTE SUL GAS NATURALE", 18);
		pdfBuilder.moveYPen(30);
		pdfBuilder.writeCenteredLabel("Dichiarazione di consumo", 16);
		pdfBuilder.moveYPen(5);
		pdfBuilder.writeCenteredLabel("Periodo anno:  "+frontespizio.getAnnoDichiarazione(),12 );
		//SALVATORE
		//pdfBuilder.moveYPen(10);
		//TipoProvincia provincia = ComboDataSource.getInstance().getProvincia(frontespizio.getProvinciaDepositoFiscale());
		//pdfBuilder.writeCenteredLabel("Provincia:  "+ provincia.getDescrizione(), 12);
		//
		pdfBuilder.moveYPen(20);
		pdfBuilder.moveXPen(80);
		pdfBuilder.writeCenteredLabel("Ufficio Amministrativo presso il quale sono conservate le contabilita': ", 12);
		pdfBuilder.moveYPen(5);
		pdfBuilder.setXPen(112);
		pdfBuilder.writeLeftLabel("Comune  "+frontespizio.getComuneSedeUfficioAmm()+" ("+ frontespizio.getProvinciaSedeUfficioAmm()+")", 12);
		pdfBuilder.writeLeftLabel("Indirizzo  "+frontespizio.getIndirizzoSedeUfficioAmm(), 12);
		/*pdfBuilder.moveYPen(30);
		pdfBuilder.writeCenteredLabel("ESTREMI REGISTRAZIONE E DATA DI ARRIVO " ,18);
		pdfBuilder.moveYPen(20);
		pdfBuilder.writeCenteredLabel("Estremi registrazione 6-a/2006" ,10);
		pdfBuilder.writeCenteredLabel("Data 21/09/2006" ,10);*/
	}
}
