package it.finanze.dogane.accise.metano.ui;

import it.finanze.dogane.accise.metano.model.ProspettoConsumo;
import it.finanze.dogane.accise.ui.GestoreEventiGenerale;
import it.finanze.dogane.accise.ui.actions.AboutAction;
import it.finanze.dogane.accise.ui.actions.InterchangeAction;
import it.finanze.dogane.accise.metano.model.ProspettoInterchange;

import java.awt.Component;

import javax.swing.JOptionPane;

public class GestoreEventi {

	public static ProspettoConsumo newProspect() {
		return new ProspettoConsumo();
	}

	/**
	 * Ritorna un oggetto ProspettoConsumo se selezionato un file .dic null altrimenti
	 * @param component
	 * @return ProspettoConsumo
	 */
	public static ProspettoConsumo openProspect(Component component) {
		ProspettoConsumo retvalue = new ProspettoConsumo();

		// cerco di capire se ho selezionato il bottone invia file
		boolean sendFileMode=false;
		if (component instanceof MetanoFrame){
			sendFileMode=((MetanoFrame)component).isSendActionMode();
		} else if (component instanceof MetanoInterchangeDialog){
			sendFileMode=true;
		}

		try {
			boolean loadAppened = retvalue.getResourceAccess().loadProspect(component);
			if(loadAppened) {
				if(!sendFileMode) {
					JOptionPane.showMessageDialog(component, 
						"Caricamento file completato",
						"Ok",
						JOptionPane.INFORMATION_MESSAGE);
				}
			} else {
				retvalue = null;
			}
		} catch (Exception e) {
			e.printStackTrace();
			retvalue = null; // Se si commenta questo si potrebbe visualizzare il prospetto fino a questo momento caricato
			JOptionPane.showMessageDialog(component, 
				"Errore durante il caricamento del file: \n" + e.getMessage(),
				"Errore",
				JOptionPane.ERROR_MESSAGE);
		}

		
		return retvalue;
	}
	

		
	
	/*	finally {
			try {
				is.close();
			} catch (IOException eclose) {
				eclose.printStackTrace();
			}
		}*/

	//	return retvalue;
	public static boolean saveAsProspect(Component component, ProspettoConsumo prospettoConsumo,String fileName) {
		boolean retvalue = false;
		try {
			retvalue = prospettoConsumo.getResourceAccess().saveAsFile(component,fileName);
			if(retvalue == true) {
				JOptionPane.showMessageDialog(component, 
					"Invio effettuato.",
					"Ok",
					JOptionPane.INFORMATION_MESSAGE);
			}
		} catch (Exception e) {
			e.printStackTrace();
			JOptionPane.showMessageDialog(component, 
				"Errore durante l'invio del file: \n" + e.getMessage(),
				"Errore",
				JOptionPane.ERROR_MESSAGE);
		}
		return retvalue;
	}

	public static boolean saveAsProspect(
		Component component,
		ProspettoConsumo prospettoConsumo) {
		return GestoreEventiGenerale.saveAsProspect(
			component,
			prospettoConsumo);
	}

	public static boolean saveProspect(Component component, ProspettoConsumo prospettoConsumo) {
		return GestoreEventiGenerale.saveProspect(component, prospettoConsumo);
	}
	
	
	public static void exitApplication() {
		GestoreEventiGenerale.exitApplication();
	}

	public static void showHelp(Component component, AboutAction aboutAction) {
		GestoreEventiGenerale.showHelp(component, aboutAction);
	}
	
	public static boolean saveProspectInterchange(Component component, ProspettoInterchange prospettoInter) {
		return GestoreEventiGenerale.saveProspectInterchange(component, prospettoInter,prospettoInter.getInterchangeRecordTestata().getNomeFlusso());
	}
}
