
package it.finanze.dogane.accise.metano.ui;

import it.finanze.dogane.accise.combo.TipoMese;
import it.finanze.dogane.accise.metano.model.Frontespizio;
import it.finanze.dogane.accise.metano.model.MetanoAcquistatoDaSoggettiSenzaImpianti;
import it.finanze.dogane.accise.metano.model.ProspettoConsumo;
import it.finanze.dogane.accise.metano.ui.quadri.Parametri;
import it.finanze.dogane.accise.metano.ui.quadri.Quadro;
import it.finanze.dogane.accise.metano.ui.tablemodel.MetanoAcquistatoDaSoggettiSenzaImpiantiTM;
import it.finanze.dogane.accise.model.Prospect;
import it.finanze.dogane.accise.pdf.PdfBuilder;
import it.finanze.dogane.accise.pdf.PdfPrintable;
import it.finanze.dogane.accise.ui.FullScreenLayoutManager;
import it.finanze.dogane.accise.ui.RealDim;
import it.finanze.dogane.accise.ui.TableUtil;
import it.finanze.dogane.accise.ui.quadri.GestoreQuadro;
import it.finanze.dogane.accise.ui.quadri.dialog.QuadroDialog;
import it.finanze.dogane.accise.ui.validation.BigIntegerDocument;
import it.finanze.dogane.accise.ui.validation.StringDocument;
import it.finanze.dogane.accise.ui.validation.Validator;
import it.finanze.dogane.accise.util.StringUtil;

import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.math.BigInteger;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

public class MetanoAcquistatoDaSoggettiSenzaImpiantiDialog
	extends JDialog
	implements ActionListener, ListSelectionListener, FocusListener, QuadroDialog, PdfPrintable {
		private javax.swing.JPanel jContentPane = null;
		private javax.swing.JPanel jPanelIntestazione = null;
		private javax.swing.JLabel jLabelMese = null;
		private javax.swing.JLabel jLabelNomeQuadro = null;
		private javax.swing.JLabel jLabelTitoloQuadro = null;
		private javax.swing.JPanel jPanelQuantita = null;
		private javax.swing.JTextField jTextFieldMetanoProprio = null;
		private javax.swing.JTextField jTextFieldCodAccisaNaz = null;
		private javax.swing.JTextField jTextFieldMetanoNaz = null;
		private javax.swing.JTextField jTextFieldCodAccisaUE = null;
		private javax.swing.JTextField jTextFieldMetanoUE = null;
		private javax.swing.JTextField jTextFieldMetanoExtraUE = null;
		private javax.swing.JTextField jTextFieldTotale = null;
		private javax.swing.JButton jButtonElimina = null;
		private javax.swing.JButton jButtonModifica = null;
		private javax.swing.JButton jButtonInserisci = null;
		private javax.swing.JPanel jPanelTotali = null;
		private javax.swing.JTextField jTextFieldTotMetanoProprio = null;
		private javax.swing.JTextField jTextFieldTotMetanoNaz = null;
		private javax.swing.JTextField jTextFieldTotMetanoUE = null;
		private javax.swing.JTextField jTextFieldTotMetanoExtraUE = null;
		private javax.swing.JTextField jTextFieldTotTotale = null;
		private javax.swing.JButton jButtonConferma = null;
		private javax.swing.JButton jButtonChiudi = null;
		private javax.swing.JLabel jLabel7 = null;
		private javax.swing.JLabel jLabel8 = null;
		private javax.swing.JLabel jLabel9 = null;
		private javax.swing.JLabel jLabel = null;
		private javax.swing.JLabel jLabel4 = null;
		private javax.swing.JLabel jLabel11 = null;
		private javax.swing.JLabel jLabel12 = null;
		private javax.swing.JLabel jLabel13 = null;
		private javax.swing.JLabel jLabel14 = null;
		private javax.swing.JLabel jLabel15 = null;
		private javax.swing.JLabel jLabel16 = null;
		private javax.swing.JScrollPane jScrollPane = null;
		private javax.swing.JTable jTableDettaglio = null;
		private javax.swing.JLabel jLabel6 = null;
		private javax.swing.JTextField jTextFieldStatoEstero = null;
		private javax.swing.JLabel jLabel1 = null;


		private boolean flagModifica = false;
		private ProspettoConsumo prospettoConsumo = null;
		private Quadro quadro = null;	
		private TipoMese tipoMese = null;
		private MetanoAcquistatoDaSoggettiSenzaImpianti totaleRecord = null;
		// private MetanoAcquistatoDaSoggettiSenzaImpianti firstRecordTipoRigoZero = null;

		/**
		 * This is the default constructor
		 */
		public MetanoAcquistatoDaSoggettiSenzaImpiantiDialog(Frame frame, String description, String secondDescription) {
			super(frame, "Prospetto mensile del gas naturale commercializzato", true);
			getJLabelTitoloQuadro().setText(description);
			getJLabelNomeQuadro().setText(secondDescription);
			initialize();
		}

		/**
		 * This method initializes this
		 * 
		 * @return void
		 */
		private void initialize() {
			//this.setSize(800, 600);
			this.setSize(RealDim.getAbsoluteXValue(800), RealDim.getAbsoluteYValue(600));
			this.setContentPane(getJContentPane());
			this.setLocation(0, 0);
			this.setResizable(false);
			this.setModal(true);
			this.setDefaultCloseOperation(
				javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
			
			
			getJTextFieldCodAccisaNaz().addFocusListener(this);
			getJTextFieldCodAccisaUE().addFocusListener(this);
			getJTextFieldMetanoExtraUE().addFocusListener(this);
			getJTextFieldMetanoNaz().addFocusListener(this);
			getJTextFieldMetanoProprio().addFocusListener(this);
			getJTextFieldMetanoUE().addFocusListener(this);
		}

		public void prepareValues(Prospect prospect, GestoreQuadro gestoreQuadro) {

			prospettoConsumo = (ProspettoConsumo) prospect;
			Frontespizio frontespizio = prospettoConsumo.getFrontespizio();

			this.quadro = (Quadro) gestoreQuadro;
			List lista = prospettoConsumo.getListaQuadro(quadro.getTipiRecord());

			tipoMese = ((Parametri)quadro.getParameter()).getMese();

			boolean isAnnuale = false;
			if(Integer.parseInt(tipoMese.getCodice()) == 0) { // Annuale!
				super.setTitle("Prospetto annuale del gas naturale commercializzato");
				getJLabelMese().setText("Prospetto Annuale del gas naturale commercializzato");
				isAnnuale = true;
			} else {
				getJLabelMese().setText("Mese di " + tipoMese.getDescrizione());
			}
			int mese = Integer.parseInt(tipoMese.getCodice());
			List listaXMese = Quadro.getListaRecordPerMese(lista, mese);
		
			preparaTotale(listaXMese, isAnnuale);

			if(listaXMese.size() == 0 && isAnnuale) { // Allora devo inizializzare l'annuale
			
				MetanoAcquistatoDaSoggettiSenzaImpiantiTM model = new MetanoAcquistatoDaSoggettiSenzaImpiantiTM(lista, true);
				jTableDettaglio.setModel(model);
				TableUtil.redimTable(jTableDettaglio, jScrollPane);	
			
			} else {
				MetanoAcquistatoDaSoggettiSenzaImpiantiTM model = new MetanoAcquistatoDaSoggettiSenzaImpiantiTM(listaXMese, false);
				jTableDettaglio.setModel(model);
				TableUtil.redimTable(jTableDettaglio, jScrollPane);	
			}
		
		}

//	public void prepareValues(Prospect prospect, GestoreQuadro gestoreQuadro) {
//
//		prospettoConsumo = (ProspettoConsumo) prospect;
//		Frontespizio frontespizio = prospettoConsumo.getFrontespizio();
//
//		this.quadro = (Quadro) gestoreQuadro;
//		List lista = prospettoConsumo.getListaQuadro(quadro.getTipiRecord());
//
//		tipoMese = ((Parametri)quadro.getParameter()).getMese();
//		int mese = Integer.parseInt(tipoMese.getCodice());
//		List listaXMese = Quadro.getListaRecordPerMese(lista, mese);
//
//		if (mese==0 && listaXMese.size()==0 && (tipoMese.getCodice().trim().equals("0")||tipoMese.getCodice().trim().equals("00"))){
//			// se il mese selezionato  annuale e non esiste tale record sul file
//			// devo calcolare l'annuale per la pronvincia specificata
//			listaXMese = calcoloAnnuale();
//		}
//
//		boolean isAnnuale = false;
//		if(Integer.parseInt(tipoMese.getCodice()) == 0) { // Annuale!
//			getJLabelMese().setText("Prospetto Annuale");
//			isAnnuale = true;
//		} else {
//			getJLabelMese().setText("Mese di " + tipoMese.getDescrizione());
//		}
//		
//		preparaTotale(listaXMese, isAnnuale);
//
//		MetanoAcquistatoDaSoggettiSenzaImpiantiTM model = new MetanoAcquistatoDaSoggettiSenzaImpiantiTM(listaXMese);
//
//		jTableDettaglio.setModel(model);
//		TableUtil.redimTable(jTableDettaglio, jScrollPane);
//	}

	/**
	 * @return
	 */
//	private void procSummary(List annualeList) {
//		boolean isfirst=true;
//		// List annualeList = new LinkedList();
//		LinkedList listAll = (LinkedList)prospettoConsumo.getListaQuadro(quadro.getTipiRecord());
//
//		List fornitoriNazionali=null;
//		List fornitoriUE=null;
//		List fornitoriExtraUE=null;
//
//		// clono la lista per i tre tipi di fornitori
//		
//		fornitoriNazionali=clone(listAll);
//		fornitoriUE=clone(listAll);
//		fornitoriExtraUE=clone(listAll);
//
//		// rimuovo i totali
//		cleanFromTot(fornitoriNazionali);
//		cleanFromTot(fornitoriUE);
//		cleanFromTot(fornitoriExtraUE);
//		// rimuovo dai record i dati in eccesso e i totali
//		resetFornitoriNazionali(fornitoriNazionali);
//		resetFornitoriUE(fornitoriUE);
//		resetFornitoriExtraUE(fornitoriExtraUE);
//
//		// a questo punto faccio le sommarizzazioni in ogni singola lista
//		List fornitoriNazionaliSum = execSummaryFornitoriNazionali(fornitoriNazionali);
//		List fornitoriUESum        = execSummaryFornitoriUE(fornitoriUE);
//		List fornitoriExtraUESum   = execSummaryFornitoriExtraUE(fornitoriExtraUE);
//
//		// altero la lista annuale aggiornando i dati con i valori sommarizzati
//		int i = 0;
//		Iterator itListaProspetto = annualeList.iterator();
//		while (itListaProspetto.hasNext()){
//			MetanoAcquistatoDaSoggettiSenzaImpianti record = (MetanoAcquistatoDaSoggettiSenzaImpianti) itListaProspetto.next();
//			MetanoAcquistatoDaSoggettiSenzaImpianti recordFornitoreNazionale=null;
//			if (!record.getTipoRigo().equals(BigInteger.valueOf(9))) {
//				if (fornitoriNazionaliSum.size()>i) {			
//					// recupero l'i-esimo record dalla lista dei fornitori nazionali (se presente) e setto i valori per i fornitori nazionali
//					recordFornitoreNazionale = (MetanoAcquistatoDaSoggettiSenzaImpianti)fornitoriNazionaliSum.get(i);
//					record.setCodiceAccisaFornitoreNazionale(recordFornitoreNazionale.getCodiceAccisaFornitoreNazionale());
//					record.setMetanoFornitoreNazionale(recordFornitoreNazionale.getMetanoFornitoreNazionale());
//				} else {
//					// azzero i valori corrispondenti				
//					record.setCodiceAccisaFornitoreNazionale("");
//					record.setMetanoFornitoreNazionale(BigInteger.ZERO);
//				}
//				MetanoAcquistatoDaSoggettiSenzaImpianti recordFornitoreUE=null;
//				if (fornitoriUESum.size()>i) {			
//					// recupero l'i-esimo record dalla lista dei fornitori nazionali (se presente) e setto i valori per i fornitori UE
//					recordFornitoreUE = (MetanoAcquistatoDaSoggettiSenzaImpianti)fornitoriUESum.get(i);
//					record.setCodiceAccisaFornitoreUE(recordFornitoreUE.getCodiceAccisaFornitoreUE());
//					record.setMetanoFornitoreUE(recordFornitoreUE.getMetanoFornitoreUE());
//				} else {
//					// azzero i valori corrispondenti				
//					record.setCodiceAccisaFornitoreUE("");
//					record.setMetanoFornitoreUE(BigInteger.ZERO);
//				}
//				MetanoAcquistatoDaSoggettiSenzaImpianti recordFornitoreEXTRA=null;
//				if (fornitoriExtraUESum.size()>i) {			
//					// recupero l'i-esimo record dalla lista dei fornitori nazionali (se presente) e setto i valori per i fornitori EXTRA UE
//					recordFornitoreEXTRA = (MetanoAcquistatoDaSoggettiSenzaImpianti)fornitoriExtraUESum.get(i);
//					record.setStatoEsteroMetanoFornitoreExtraUE(recordFornitoreEXTRA.getStatoEsteroMetanoFornitoreExtraUE());
//					record.setMetanoFornitoreExtraUE(recordFornitoreEXTRA.getMetanoFornitoreExtraUE());
//				} else {
//					// azzero i valori corrispondenti				
//					record.setStatoEsteroMetanoFornitoreExtraUE("");
//					record.setMetanoFornitoreExtraUE(BigInteger.ZERO);
//				}
//				i++;
//			}
//		}
//	}
//
//	/**
//	 * @param fornitoriNazionali
//	 */
//	private void cleanFromTot(List fornitori) {
//		Iterator it=fornitori.iterator();
//		while (it.hasNext()) {
//			MetanoAcquistatoDaSoggettiSenzaImpianti record = (MetanoAcquistatoDaSoggettiSenzaImpianti) it.next();
//			if (record.getTipoRigo().equals(BigInteger.valueOf(9))){
//				it.remove();
//			}
//		}
//	}
//
//	/**
//	 * @param listAll
//	 * @return
//	 */
//	private List clone(LinkedList listAll) {
//		List newList=new LinkedList();
//		Iterator it=listAll.iterator();
//		while (it.hasNext()) {
//			MetanoAcquistatoDaSoggettiSenzaImpianti record = (MetanoAcquistatoDaSoggettiSenzaImpianti) it.next();
//			try {
//				newList.add(record.clone());
//			} catch (CloneNotSupportedException e) {
//				e.printStackTrace();
//			}
//		}
//		return newList;
//	}
//
//	/**
//	 * @param fornitoriExtraUE
//	 * @return
//	 */
//	private List execSummaryFornitoriExtraUE(List fornitoriExtraUE) {
//		List fornitoriExtraUE_Sum = new LinkedList();
//		// Per ogni record, controllo se  gia' contenuto nella lista "xxx_Sum", se non c' lo metto in lista, altrimenti lo sommo a quello esistente
//		Iterator it = fornitoriExtraUE.iterator();
//		while (it.hasNext()) {
//			MetanoAcquistatoDaSoggettiSenzaImpianti record = (MetanoAcquistatoDaSoggettiSenzaImpianti) it.next();
//
//			MetanoAcquistatoDaSoggettiSenzaImpianti item=containsItem(record,fornitoriExtraUE_Sum,"EXTRA");
//			if (item==null){ // se l'elemento non  ancora in lista lo aggiungo
//				record.setMese(BigInteger.valueOf(0));
//				fornitoriExtraUE_Sum.add(record);
//			} else { // se l'elemento  gi in lista sommo i metri cubi
//				item.setMetanoFornitoreNazionale(item.getMetanoFornitoreNazionale().add(record.getMetanoFornitoreNazionale()));
//				// item.setMetanoDiProprieta(item.getMetanoDiProprieta().add(record.getMetanoDiProprieta()));
//				// item.setTotale(item.getTotale().add(record.getTotale()));
//			}
//		}
//		return sortList(fornitoriExtraUE_Sum, "EXTRA");
//	}
//
//	/**
//	 * @param fornitoriUE
//	 * @return
//	 */
//	private List execSummaryFornitoriUE(List fornitoriUE) {
//		List fornitoriUE_Sum = new LinkedList();
//		// Per ogni record, controllo se  gia' contenuto nella lista "xxx_Sum", se non c' lo metto in lista, altrimenti lo sommo a quello esistente
//		Iterator it = fornitoriUE.iterator();
//		while (it.hasNext()) {
//			MetanoAcquistatoDaSoggettiSenzaImpianti record = (MetanoAcquistatoDaSoggettiSenzaImpianti) it.next();
//
//			MetanoAcquistatoDaSoggettiSenzaImpianti item=containsItem(record,fornitoriUE_Sum,"UE");
//			if (item==null){ // se l'elemento non  ancora in lista lo aggiungo
//				record.setMese(BigInteger.valueOf(0));
//				fornitoriUE_Sum.add(record);
//			} else { // se l'elemento  gi in lista sommo i metri cubi
//				item.setMetanoFornitoreNazionale(item.getMetanoFornitoreNazionale().add(record.getMetanoFornitoreNazionale()));
//				// item.setMetanoDiProprieta(item.getMetanoDiProprieta().add(record.getMetanoDiProprieta()));
//				// item.setTotale(item.getTotale().add(record.getTotale()));
//			}
//		}
//		return sortList(fornitoriUE_Sum, "EU");
//	}
//
//	/**
//	 * @param fornitoriNazionali
//	 * @return
//	 */
//	private List execSummaryFornitoriNazionali(List fornitoriNazionali) {
//
//		List fornitoriNazionali_Sum = new LinkedList();
//		// Per ogni record, controllo se  gia' contenuto nella lista "xxx_Sum", se non c' lo metto in lista, altrimenti lo sommo a quello esistente
//		Iterator it = fornitoriNazionali.iterator();
//		while (it.hasNext()) {
//			MetanoAcquistatoDaSoggettiSenzaImpianti record = (MetanoAcquistatoDaSoggettiSenzaImpianti) it.next();
//
//			MetanoAcquistatoDaSoggettiSenzaImpianti item=containsItem(record,fornitoriNazionali_Sum,"IT");
//			if (item==null){ // se l'elemento non  ancora in lista lo aggiungo
//				record.setMese(BigInteger.valueOf(0));
//				fornitoriNazionali_Sum.add(record);
//			} else { // se l'elemento  gi in lista sommo i metri cubi
//				item.setMetanoFornitoreNazionale(item.getMetanoFornitoreNazionale().add(record.getMetanoFornitoreNazionale()));
//				// item.setMetanoDiProprieta(item.getMetanoDiProprieta().add(record.getMetanoDiProprieta()));
//				// item.setTotale(item.getTotale().add(record.getTotale()));
//			}
//		}
//		return sortList(fornitoriNazionali_Sum, "IT");
//	}
//
//	/**
//	 * @param fornitoriExtraUE
//	 */
//	private void resetFornitoriExtraUE(List fornitoriExtraUE) {
//		// Per ogni record cancello i dati relativi agli altri fornitori
//		Iterator it = fornitoriExtraUE.iterator();
//		while (it.hasNext()) {
//			MetanoAcquistatoDaSoggettiSenzaImpianti record =(MetanoAcquistatoDaSoggettiSenzaImpianti) it.next();
//
//			record.setMetanoFornitoreNazionale(BigInteger.ZERO);
//			record.setCodiceAccisaFornitoreNazionale("");
//
//			record.setMetanoFornitoreUE(BigInteger.ZERO);
//			record.setCodiceAccisaFornitoreUE("");
//
//		}
//	}
//
//	/**
//	 * @param fornitoriUE
//	 */
//	private void resetFornitoriUE(List fornitoriUE) {
//		// Per ogni record cancello i dati relativi agli altri fornitori
//		Iterator it = fornitoriUE.iterator();
//		while (it.hasNext()) {
//			MetanoAcquistatoDaSoggettiSenzaImpianti record =(MetanoAcquistatoDaSoggettiSenzaImpianti) it.next();
//
//			record.setMetanoFornitoreNazionale(BigInteger.ZERO);
//			record.setCodiceAccisaFornitoreNazionale("");
//
//			record.setMetanoFornitoreExtraUE(BigInteger.ZERO);
//			record.setStatoEsteroMetanoFornitoreExtraUE("");
//
//		}
//		
//	}
//
//	/**
//	 * @param fornitoriNazionali
//	 */
//	private void resetFornitoriNazionali(List fornitoriNazionali) {
//		// Per ogni record cancello i dati relativi agli altri fornitori
//		
//		Iterator it = fornitoriNazionali.iterator();
//		while (it.hasNext()) {
//			MetanoAcquistatoDaSoggettiSenzaImpianti record =(MetanoAcquistatoDaSoggettiSenzaImpianti) it.next();
//
//			record.setMetanoFornitoreExtraUE(BigInteger.ZERO);
//			record.setStatoEsteroMetanoFornitoreExtraUE("");
//
//			record.setMetanoFornitoreUE(BigInteger.ZERO);
//			record.setCodiceAccisaFornitoreUE("");
//		}
//	}
//
//	private List sortList(List listaFornitori, String tipoFornitori){
//		// sposto gli elementi con valori nulla in coda alla lista
//		List listaFornitoriSorted = new LinkedList();
//		List listaFornitoriEmpty = new LinkedList();
//		Iterator it=listaFornitori.iterator();
//		while (it.hasNext()){
//			MetanoAcquistatoDaSoggettiSenzaImpianti record = (MetanoAcquistatoDaSoggettiSenzaImpianti)it.next();
//			if (tipoFornitori.equals("IT")){
//				if (StringUtil.nullify(record.getCodiceAccisaFornitoreNazionale())==null && record.getMetanoFornitoreNazionale().equals(BigInteger.ZERO)){
//					listaFornitoriEmpty.add(record);
//				} else {
//					listaFornitoriSorted.add(record);
//				}
//			} else if (tipoFornitori.equals("EU")){
//				if (StringUtil.nullify(record.getCodiceAccisaFornitoreUE())==null && record.getMetanoFornitoreUE().equals(BigInteger.ZERO)){
//					listaFornitoriEmpty.add(record);
//				} else {
//					listaFornitoriSorted.add(record);
//				}
//			} else if (tipoFornitori.equals("EXTRA")){
//				if (StringUtil.nullify(record.getStatoEsteroMetanoFornitoreExtraUE())==null && record.getMetanoFornitoreExtraUE().equals(BigInteger.ZERO)){
//					listaFornitoriEmpty.add(record);
//				} else {
//					listaFornitoriSorted.add(record);
//				}
//			}
//		}
//		listaFornitoriSorted.addAll(listaFornitoriEmpty);
//		return listaFornitoriSorted;
//	}
//
//	private List calcoloAnnuale() {
//		boolean isfirst=true;
//		List annualeList = new LinkedList();
//		List listAll = prospettoConsumo.getListaQuadro(quadro.getTipiRecord());
//
//		// Per ogni record, controllo se  gia' contenuto nella lista "annualeList", se non c' lo metto in lista, altrimenti lo sommo a quello nella lista annuale
//		Iterator it = listAll.iterator();
//		while (it.hasNext()) {
//			MetanoAcquistatoDaSoggettiSenzaImpianti recordAnnuale =(MetanoAcquistatoDaSoggettiSenzaImpianti) it.next();
//
//			if (recordAnnuale.getTipoRigo().equals(BigInteger.ZERO) && isfirst) {
//				// memorizzo in una variabile il primo oggetto con tipo rigo = 0 in modo da poter aggiornare i totali successivamente
//				firstRecordTipoRigoZero=recordAnnuale;
//				isfirst=false;
//			}
//
//			MetanoAcquistatoDaSoggettiSenzaImpianti item=containsItem(recordAnnuale,annualeList);
//			if (item==null){ // se l'elemento non  ancora in lista
//				recordAnnuale.setMese(BigInteger.valueOf(0));
//				annualeList.add(recordAnnuale);
//			} else { // se l'elemento  gi in lista sommo i metri cubi
//				item.setMetanoDiProprieta(item.getMetanoDiProprieta().add(recordAnnuale.getMetanoDiProprieta()));
//				item.setMetanoFornitoreNazionale(item.getMetanoFornitoreNazionale().add(recordAnnuale.getMetanoFornitoreNazionale()));
//				item.setMetanoFornitoreUE(item.getMetanoFornitoreUE().add(recordAnnuale.getMetanoFornitoreUE()));
//				item.setMetanoFornitoreExtraUE(item.getMetanoFornitoreExtraUE().add(recordAnnuale.getMetanoFornitoreExtraUE()));
//				item.setTotale(item.getTotale().add(recordAnnuale.getTotale()));
//			}
//		}
//		this.procSummary(annualeList);
//		return annualeList;
//	}
//
//	/**
//	 * @param record da ricercare
//	 * @param lista in cui controllare l'esistenza
//	 * @param tipoFornitore
//	 * @return elemento trovato
//	 */
//	private MetanoAcquistatoDaSoggettiSenzaImpianti containsItem(MetanoAcquistatoDaSoggettiSenzaImpianti record, List annualeList, String tipoFornitore) {
//		MetanoAcquistatoDaSoggettiSenzaImpianti item = null;
//
//		String codiceAccisaFornitoreUE = "";
//		String codiceAccisaFornitoreNazionale = "";
//		String statoFornitoreExtraUE = "";
//		boolean ifFornitoreCondition=false;
//		
//		if (tipoFornitore.toUpperCase().trim().equals("IT")) {
//			codiceAccisaFornitoreNazionale = record.getCodiceAccisaFornitoreNazionale();
//		} else if (tipoFornitore.toUpperCase().trim().equals("UE")) {
//			codiceAccisaFornitoreUE = record.getCodiceAccisaFornitoreUE();
//		} else if (tipoFornitore.toUpperCase().trim().equals("EXTRA")) {
//			statoFornitoreExtraUE = record.getStatoEsteroMetanoFornitoreExtraUE();
//		}
//
//		BigInteger tipoRigo=record.getTipoRigo();
//
//		Iterator iter=annualeList.iterator();
//		while (iter.hasNext()){
//			MetanoAcquistatoDaSoggettiSenzaImpianti itemTmp=(MetanoAcquistatoDaSoggettiSenzaImpianti)iter.next();
//
//			if (tipoFornitore.toUpperCase().trim().equals("IT")) {
//				ifFornitoreCondition=StringUtil.nullify(itemTmp.getCodiceAccisaFornitoreNazionale()) != null && codiceAccisaFornitoreNazionale!=null && itemTmp.getCodiceAccisaFornitoreNazionale().trim().equals(codiceAccisaFornitoreNazionale.trim());
//			} else if (tipoFornitore.toUpperCase().trim().equals("UE")) {
//				ifFornitoreCondition=StringUtil.nullify(itemTmp.getCodiceAccisaFornitoreUE()) != null && codiceAccisaFornitoreUE!=null && itemTmp.getCodiceAccisaFornitoreUE().trim().equals(codiceAccisaFornitoreUE.trim());
//			} else if (tipoFornitore.toUpperCase().trim().equals("EXTRA")) {
//				ifFornitoreCondition=StringUtil.nullify(itemTmp.getStatoEsteroMetanoFornitoreExtraUE()) != null && statoFornitoreExtraUE!=null && itemTmp.getStatoEsteroMetanoFornitoreExtraUE().trim().equals(statoFornitoreExtraUE.trim());
//			}
//
//			if (!itemTmp.getTipoRigo().equals(BigInteger.valueOf(9)) && ifFornitoreCondition) {
//				item=itemTmp;
//			}
//		}
//		return item;
//	}
//
//	/**
//	 * @param recordAnnuale
//	 * @param annualeList
//	 * @return
//	 */
//	private MetanoAcquistatoDaSoggettiSenzaImpianti containsItem(MetanoAcquistatoDaSoggettiSenzaImpianti recordAnnuale, List annualeList) {
//		MetanoAcquistatoDaSoggettiSenzaImpianti item = null;
//		String codiceAccisa = recordAnnuale.getCodiceAccisa();
//		String codiceAccisaFornitoreNazionale = recordAnnuale.getCodiceAccisaFornitoreNazionale();
//		String codiceAccisaFornitoreUE = recordAnnuale.getCodiceAccisaFornitoreUE();
//
//		BigInteger tipoRigo=recordAnnuale.getTipoRigo();
//
//		Iterator iter=annualeList.iterator();
//		while (iter.hasNext()){
//			MetanoAcquistatoDaSoggettiSenzaImpianti itemTmp=(MetanoAcquistatoDaSoggettiSenzaImpianti)iter.next();
//			if (itemTmp.getTipoRigo().equals(BigInteger.valueOf(9)) && recordAnnuale.getTipoRigo().equals(BigInteger.valueOf(9))) {
//				item=itemTmp;
//			} else if (!itemTmp.getTipoRigo().equals(BigInteger.valueOf(9)) && StringUtil.nullify(itemTmp.getCodiceAccisa()) != null && codiceAccisa!=null && itemTmp.getCodiceAccisa().trim().equals(codiceAccisa.trim()) &&
//				StringUtil.nullify(itemTmp.getCodiceAccisaFornitoreNazionale()) != null && codiceAccisaFornitoreNazionale!=null && itemTmp.getCodiceAccisaFornitoreNazionale().trim().equals(codiceAccisaFornitoreNazionale.trim()) &&
//				StringUtil.nullify(itemTmp.getCodiceAccisaFornitoreUE()) != null && codiceAccisaFornitoreUE!=null && itemTmp.getCodiceAccisaFornitoreUE().trim().equals(codiceAccisaFornitoreUE.trim())
//			) {
//				item=itemTmp;
//			}
//		}
//		return item;
//	}

//	private void preparaTotale(List list, boolean isAnnuale) {
//		BigInteger totaleAnnualeMetanoFornitoreExtraUE = BigInteger.ZERO;
//		BigInteger totaleAnnualeMetanoFornitoreNazionale = BigInteger.ZERO;
//		BigInteger totaleAnnualeMetanoDiProprieta = BigInteger.ZERO;
//		BigInteger totaleAnnualeMetanoFornitoreUE = BigInteger.ZERO;
//		
//		if (list != null) {
//			Iterator it = list.iterator();
//			boolean found = false;
//			while (it.hasNext() && !found) {
//				MetanoAcquistatoDaSoggettiSenzaImpianti record =(MetanoAcquistatoDaSoggettiSenzaImpianti) it.next();
//				if (record.getTipoRigo().equals(BigInteger.valueOf(9))) {
//					totaleRecord = record;
//					totaleAnnualeMetanoFornitoreExtraUE=totaleAnnualeMetanoFornitoreExtraUE.add(totaleRecord.getMetanoFornitoreExtraUE());
//					totaleAnnualeMetanoFornitoreNazionale=totaleAnnualeMetanoFornitoreNazionale.add(totaleRecord.getMetanoFornitoreNazionale());
//					totaleAnnualeMetanoDiProprieta=totaleAnnualeMetanoDiProprieta.add(totaleRecord.getMetanoDiProprieta());
//					totaleAnnualeMetanoFornitoreUE=totaleAnnualeMetanoFornitoreUE.add(totaleRecord.getMetanoFornitoreUE());
//					found = true;
//					it.remove();
//				}
//			}
//			if(!found) {
//				totaleRecord = MetanoAcquistatoDaSoggettiSenzaImpianti.getNewObject(prospettoConsumo);
//				totaleRecord.setTipoRigo(BigInteger.valueOf(9));
//				totaleRecord.setTipoRecord(BigInteger.valueOf(quadro.getTipiRecord()[0]));
//				totaleRecord.setMese(new BigInteger(tipoMese.getCodice()));
//			}
//		}
//		
//		if (isAnnuale && firstRecordTipoRigoZero!=null) {
//			firstRecordTipoRigoZero.setTotale(totaleRecord.getTotale());
//			firstRecordTipoRigoZero.setMetanoDiProprieta(totaleRecord.getMetanoDiProprieta());
//		}
//
//		jTextFieldTotMetanoExtraUE.setText(totaleRecord.getMetanoFornitoreExtraUE().toString());
//		jTextFieldTotMetanoNaz.setText(totaleRecord.getMetanoFornitoreNazionale().toString());
//		jTextFieldTotMetanoProprio.setText(totaleRecord.getMetanoDiProprieta().toString());
//		jTextFieldTotMetanoUE.setText(totaleRecord.getMetanoFornitoreUE().toString());
//		jTextFieldTotTotale.setText(totaleRecord.getTotale().toString());
//	}

	private void preparaTotale(List list, boolean isAnnuale) {
		if (list != null) {
			Iterator it = list.iterator();
			boolean found = false;
			while (it.hasNext() && !found) {
				MetanoAcquistatoDaSoggettiSenzaImpianti record =(MetanoAcquistatoDaSoggettiSenzaImpianti) it.next();

				if (record.getTipoRigo().equals(BigInteger.valueOf(9))) {
					totaleRecord = record;
					found = true;
					it.remove();
				}
			}
			if(!found) {
				totaleRecord = MetanoAcquistatoDaSoggettiSenzaImpianti.getNewObject(prospettoConsumo);
				totaleRecord.setTipoRigo(BigInteger.valueOf(9));
				totaleRecord.setTipoRecord(BigInteger.valueOf(quadro.getTipiRecord()[0]));
				totaleRecord.setMese(new BigInteger(tipoMese.getCodice()));
				
				if(isAnnuale) {
					preparaTotaleAnnuale();
				}
			}
			
			jTextFieldTotMetanoExtraUE.setText(totaleRecord.getMetanoFornitoreExtraUE().toString());
			jTextFieldTotMetanoNaz.setText(totaleRecord.getMetanoFornitoreNazionale().toString());
			jTextFieldTotMetanoProprio.setText(totaleRecord.getMetanoDiProprieta().toString());
			jTextFieldTotMetanoUE.setText(totaleRecord.getMetanoFornitoreUE().toString());
			jTextFieldTotTotale.setText(totaleRecord.getTotale().toString());
		}
	}

	private void preparaTotaleAnnuale() {
		List list = prospettoConsumo.getListaQuadro(quadro.getTipiRecord());
		Iterator it = list.iterator();
		while (it.hasNext()) {
			MetanoAcquistatoDaSoggettiSenzaImpianti record =(MetanoAcquistatoDaSoggettiSenzaImpianti) it.next();

			if (record.getTipoRigo().equals(BigInteger.valueOf(9))) {
				// Si tratta di un totale ==> nulla da fare
			} else {
				// Devo sommare i valori
				totaleRecord.setMetanoFornitoreExtraUE(totaleRecord.getMetanoFornitoreExtraUE().add(record.getMetanoFornitoreExtraUE()));
				totaleRecord.setMetanoFornitoreNazionale(totaleRecord.getMetanoFornitoreNazionale().add(record.getMetanoFornitoreNazionale()));
				totaleRecord.setMetanoFornitoreUE(totaleRecord.getMetanoFornitoreUE().add(record.getMetanoFornitoreUE()));
				totaleRecord.setMetanoDiProprieta(totaleRecord.getMetanoDiProprieta().add(record.getMetanoDiProprieta()));
				
				totaleRecord.setTotale(totaleRecord.getMetanoFornitoreExtraUE());
				totaleRecord.setTotale(totaleRecord.getTotale().add(totaleRecord.getMetanoFornitoreNazionale()));
				totaleRecord.setTotale(totaleRecord.getTotale().add(totaleRecord.getMetanoFornitoreUE()));
				totaleRecord.setTotale(totaleRecord.getTotale().add(totaleRecord.getMetanoDiProprieta()));
			}
		}
		
	}

	public void plot(PdfBuilder pdfBuilder) {
		pdfBuilder.startCommandBlock();
		pdfBuilder.writeCenteredLabel(this.getTitle(), 14);
		pdfBuilder.moveYPen(50);
		
		//SALVATORE
		pdfBuilder.endCommandBlock();
		pdfBuilder.startDefineTableHeader();		
		//

		pdfBuilder.moveXPen(PdfBuilder.MARGINE);
		pdfBuilder.writeRightLabel(jLabelMese.getText(), 12);
		pdfBuilder.writeLeftLabel(jLabelNomeQuadro.getText(), 12);
		pdfBuilder.moveYPen(-14);
		pdfBuilder.writeRightLabel(jLabelTitoloQuadro.getText(), 12);
		
		//pdfBuilder.moveYPen(50);
		//pdfBuilder.writeCenteredLabel(jLabelNomeQuadro.getText() + "  " + jLabelTitoloQuadro.getText(), 12);
		pdfBuilder.moveYPen(10);
		
		//SALVATORE
		//pdfBuilder.endCommandBlock();
		pdfBuilder.endDefineTableHeader();		
		//

		pdfBuilder.writeTable(this, jTableDettaglio, jScrollPane);
		pdfBuilder.moveYPen(10);
		
		pdfBuilder.startCommandBlock();
		pdfBuilder.moveXPen(230);
		pdfBuilder.writeLeftLabel("Totali", 10);
		pdfBuilder.moveXPen(20);
		float y = pdfBuilder.getYPen();
		pdfBuilder.writeLeftLabel("Di propriet: ", 10);
		pdfBuilder.writeLeftLabel("Proveniente da Fornitori Nazionali: ", 10);
		pdfBuilder.writeLeftLabel("Proveniente da Fornitori UE: ", 10);
		pdfBuilder.writeLeftLabel("Proveniente da Fornitori Extra UE: ", 10);
		pdfBuilder.writeLeftLabel("Totale: ", 10);
		pdfBuilder.setXPen(PdfBuilder.MARGINE);

		float y2 = pdfBuilder.getYPen();
		// Mi rimetto all'inizio e comincio a scrivere i valori
		pdfBuilder.moveYPen(y - y2); // All'interno di un blocco non si pu utilizzare una setYPen		
		pdfBuilder.writeRightLabel(totaleRecord.getMetanoDiProprieta().toString(), 10);
		pdfBuilder.writeRightLabel(totaleRecord.getMetanoFornitoreNazionale().toString(), 10);
		pdfBuilder.writeRightLabel(totaleRecord.getMetanoFornitoreUE().toString(), 10);
		pdfBuilder.writeRightLabel(totaleRecord.getMetanoFornitoreExtraUE().toString(), 10);
		pdfBuilder.writeRightLabel(totaleRecord.getTotale().toString(), 10);
		pdfBuilder.endCommandBlock();
		pdfBuilder.moveYPen(20);
	}


	/*************************************************************************
	 * INIZIO GESTIONE EVENTI
	 *************************************************************************/
	 
	public void actionPerformed(ActionEvent event) {

		try {
			if (event.getSource() == jButtonChiudi) {
				doClose();
			} else if (event.getSource() == jButtonConferma) {
				doConfirm();
			} else if (event.getSource() == jButtonElimina) {
				doDelete();
			} else if (event.getSource() == jButtonInserisci) {
				doInsert();
			} else if (event.getSource() == jButtonModifica) {
				doUpdate();
			}
		}
		catch(Exception e) {
			e.printStackTrace();
			JOptionPane.showMessageDialog(this, e.getMessage(), "Errore", JOptionPane.WARNING_MESSAGE);
		}
	}

	public void valueChanged(ListSelectionEvent event) {
		try {
			if (event.getSource() == jTableDettaglio.getSelectionModel()) {
				loadUIFromRecord();
			}
		}
		catch(Exception e) {
			e.printStackTrace();
			JOptionPane.showMessageDialog(this, e.getMessage(), "Errore sulla lista", JOptionPane.WARNING_MESSAGE);
		}
	}

	public void focusGained(FocusEvent event) {}

	public void focusLost(FocusEvent event) {
		if(
				event.getSource()==getJTextFieldCodAccisaNaz() ||
				event.getSource()==getJTextFieldCodAccisaUE() ||
				event.getSource()==getJTextFieldMetanoExtraUE() ||
				event.getSource()==getJTextFieldMetanoNaz() ||
				event.getSource()==getJTextFieldMetanoProprio() ||
				event.getSource()==getJTextFieldMetanoUE()
			){
			updateRecordTot();
		}
	}

	private void doInsert() {
		if(validateInsert()) {
			MetanoAcquistatoDaSoggettiSenzaImpianti record = null;
			record = MetanoAcquistatoDaSoggettiSenzaImpianti.getNewObject(prospettoConsumo);

			record.setMese(new BigInteger(tipoMese.getCodice()));
			record.setTipoRecord(BigInteger.valueOf(quadro.getTipiRecord()[0]));

			int rowCount = jTableDettaglio.getRowCount();
			if(rowCount == 0) {
				loadRecordFromUI(record);
				record.setTipoRigo(BigInteger.ZERO);
			} else {
				//loadRecordFromUI(record);
				loadRecordFromUIRistretto(record);
				record.setTipoRigo(BigInteger.ONE);
			}

			MetanoAcquistatoDaSoggettiSenzaImpiantiTM model = (MetanoAcquistatoDaSoggettiSenzaImpiantiTM)jTableDettaglio.getModel();
			model.insertRecord(record);

			updateTot();
			flagModifica = true;
			clearFields();
			jTableDettaglio.clearSelection();
			showHideFields(1);

		}
	}
	private void doDelete() {
		MetanoAcquistatoDaSoggettiSenzaImpiantiTM model = (MetanoAcquistatoDaSoggettiSenzaImpiantiTM)jTableDettaglio.getModel();
		int selectedRow = jTableDettaglio.getSelectedRow();
		if(selectedRow != -1) {
			model.removeRecord(selectedRow);
			updateTot();
			flagModifica=true;
		} else {
			JOptionPane.showMessageDialog(
							this,
							"Selezionare un elemento dalla lista",
							"Attenzione",
							JOptionPane.WARNING_MESSAGE);
		}
	}

	private void doUpdate() {
		if(validateUpdate()) {
			MetanoAcquistatoDaSoggettiSenzaImpiantiTM model = (MetanoAcquistatoDaSoggettiSenzaImpiantiTM)jTableDettaglio.getModel();
			int selectedRow = jTableDettaglio.getSelectedRow();
			if(selectedRow != -1) {
				MetanoAcquistatoDaSoggettiSenzaImpianti record = model.getRecord(selectedRow);
			
				if(record == null) {
					throw new RuntimeException("Operazione non valida");
				}
				
				if(selectedRow == 0) {
					loadRecordFromUI(record);
				} else {
					loadRecordFromUIRistretto(record);
				}
		
				model.setRecord(selectedRow, record);
				updateTot();
				flagModifica = true;
			} else {
				JOptionPane.showMessageDialog(
								this,
								"Selezionare un elemento dalla lista",
								"Attenzione",
								JOptionPane.WARNING_MESSAGE);
			}
		}
	}
	
	private void updateRecordTot() {
		BigInteger sum = BigInteger.ZERO;
		BigInteger i =  BigInteger.ZERO;
		String valore = null;

		valore = StringUtil.nullify(jTextFieldMetanoExtraUE.getText()); 
		try {
			i = new BigInteger(valore);
		}
		catch(Exception e) {
			i =  BigInteger.ZERO;
		}
		sum = sum.add(i);

		valore = StringUtil.nullify(jTextFieldMetanoNaz.getText()); 
		try {
			i = new BigInteger(valore);
		}
		catch(Exception e) {
			i =  BigInteger.ZERO;
		}
		sum = sum.add(i);

		valore = StringUtil.nullify(jTextFieldMetanoProprio.getText()); 
		try {
			i = new BigInteger(valore);
		}
		catch(Exception e) {
			i =  BigInteger.ZERO;
		}
		sum = sum.add(i);

		valore = StringUtil.nullify(jTextFieldMetanoUE.getText()); 
		try {
			i = new BigInteger(valore);
		}
		catch(Exception e) {
			i =  BigInteger.ZERO;
		}
		sum = sum.add(i);

		jTextFieldTotale.setText(sum.toString());
		
	}
		
	private void updateTot() {
		MetanoAcquistatoDaSoggettiSenzaImpiantiTM model = (MetanoAcquistatoDaSoggettiSenzaImpiantiTM)jTableDettaglio.getModel();
		
		totaleRecord.setTotale(BigInteger.ZERO);
		totaleRecord.setMetanoFornitoreExtraUE(BigInteger.ZERO);
		totaleRecord.setMetanoFornitoreNazionale(BigInteger.ZERO);
		totaleRecord.setMetanoFornitoreUE(BigInteger.ZERO);
		totaleRecord.setMetanoDiProprieta(BigInteger.ZERO);

		List lista = model.getRecords();
		if(lista != null && lista.size() > 0) {
			Iterator it = lista.iterator();
			while(it.hasNext()) {
				MetanoAcquistatoDaSoggettiSenzaImpianti item = (MetanoAcquistatoDaSoggettiSenzaImpianti)it.next();

				totaleRecord.setTotale(totaleRecord.getTotale().add(item.getTotale()));
				totaleRecord.setMetanoFornitoreExtraUE(totaleRecord.getMetanoFornitoreExtraUE().add(item.getMetanoFornitoreExtraUE()));
				totaleRecord.setMetanoFornitoreNazionale(totaleRecord.getMetanoFornitoreNazionale().add(item.getMetanoFornitoreNazionale()));
				totaleRecord.setMetanoFornitoreUE(totaleRecord.getMetanoFornitoreUE().add(item.getMetanoFornitoreUE()));
				totaleRecord.setMetanoDiProprieta(totaleRecord.getMetanoDiProprieta().add(item.getMetanoDiProprieta()));
			}
		}

		loadUIFromRecordTotale();
	}
	

	private void doClose() {
		int val = validateExitText();
			if(val == JOptionPane.YES_OPTION) {
				doConfirm();
			} else if(val == JOptionPane.NO_OPTION) {
				this.setVisible(false);
			} else if(val == JOptionPane.CANCEL_OPTION) {
			}
	}

	private void doConfirm() {
		MetanoAcquistatoDaSoggettiSenzaImpiantiTM model = (MetanoAcquistatoDaSoggettiSenzaImpiantiTM)jTableDettaglio.getModel();
		List nuovaLista = model.getRecords();
		
		/** MODIFICA 24-10-2007 **/
			if(nuovaLista.size() >0) {
				quadro.setEmpty(false);
			}
			else
				quadro.setEmpty(true);
		
		if(nuovaLista == null) {
			nuovaLista = new LinkedList();
		}
		if(nuovaLista.size() > 0) {
			loadRecordTotaleFromUI();
			nuovaLista.add(totaleRecord);
		}

		List listaQuadroCompleta = prospettoConsumo.getListaQuadro(quadro.getTipiRecord());
		// Elimino i vecchi record con il mese in modifica
		Iterator it = listaQuadroCompleta.iterator();
		while(it.hasNext()) {
			MetanoAcquistatoDaSoggettiSenzaImpianti record = (MetanoAcquistatoDaSoggettiSenzaImpianti)it.next();
			if(record.getMese().equals(new BigInteger(tipoMese.getCodice()))) {
				it.remove();
			}
		}

		// Aggiungo i nuovi record per il mese in modifica
		listaQuadroCompleta.addAll(nuovaLista);
		
		// Imposto tutto sul modello! Finally!!!!!
		prospettoConsumo.setListaQuadro(listaQuadroCompleta, quadro.getTipiRecord());
		
		this.setVisible(false);
	}

	private void loadUIFromRecordTotale() {
		jTextFieldTotTotale.setText(totaleRecord.getTotale().toString());		
		jTextFieldTotMetanoExtraUE.setText(totaleRecord.getMetanoFornitoreExtraUE().toString());			
		jTextFieldTotMetanoNaz.setText(totaleRecord.getMetanoFornitoreNazionale().toString());
		jTextFieldTotMetanoUE.setText(totaleRecord.getMetanoFornitoreUE().toString());
		jTextFieldTotMetanoProprio.setText(totaleRecord.getMetanoDiProprieta().toString());
	}

	private void loadRecordTotaleFromUI() {
		String stringTotale = null;
		
		stringTotale = StringUtil.nullify(jTextFieldTotMetanoExtraUE.getText()); 
		if(stringTotale != null) {
			try {
				BigInteger i = new BigInteger(stringTotale);
				totaleRecord.setMetanoFornitoreExtraUE(i);
			}
			catch(NumberFormatException e) {
				totaleRecord.setMetanoFornitoreExtraUE(BigInteger.valueOf(0));
			}
		}

		stringTotale = StringUtil.nullify(jTextFieldTotMetanoNaz.getText()); 
		if(stringTotale != null) {
			try {
				BigInteger i = new BigInteger(stringTotale);
				totaleRecord.setMetanoFornitoreNazionale(i);
			}
			catch(NumberFormatException e) {
				totaleRecord.setMetanoFornitoreNazionale(BigInteger.valueOf(0));
			}
		}
		
		stringTotale = StringUtil.nullify(jTextFieldTotMetanoProprio.getText()); 
		if(stringTotale != null) {
			try {
				BigInteger i = new BigInteger(stringTotale);
				totaleRecord.setMetanoDiProprieta(i);
			}
			catch(NumberFormatException e) {
				totaleRecord.setMetanoDiProprieta(BigInteger.valueOf(0));
			}
		}
		
		stringTotale = StringUtil.nullify(jTextFieldTotMetanoUE.getText()); 
		if(stringTotale != null) {
			try {
				BigInteger i = new BigInteger(stringTotale);
				totaleRecord.setMetanoFornitoreUE(i);
			}
			catch(NumberFormatException e) {
				totaleRecord.setMetanoFornitoreUE(BigInteger.valueOf(0));
			}
		}

		stringTotale = StringUtil.nullify(jTextFieldTotTotale.getText());
		if(stringTotale != null) {
			try {
				BigInteger i = new BigInteger(stringTotale);
				totaleRecord.setTotale(i);
			}
			catch(NumberFormatException e) {
				totaleRecord.setTotale(BigInteger.valueOf(0));
			}
		}
	}

	private void loadUIFromRecord(MetanoAcquistatoDaSoggettiSenzaImpianti record) {
		if(record.getMetanoDiProprieta().equals(BigInteger.valueOf(0))){
			jTextFieldMetanoProprio.setText("");
		}else{
			jTextFieldMetanoProprio.setText(String.valueOf(record.getMetanoDiProprieta()));
		}

		jTextFieldCodAccisaNaz.setText(record.getCodiceAccisaFornitoreNazionale());

		if(record.getMetanoFornitoreNazionale().equals(BigInteger.valueOf(0)))	{
			jTextFieldMetanoNaz.setText("");
		}else{
			jTextFieldMetanoNaz.setText(String.valueOf(record.getMetanoFornitoreNazionale()));
		}

		jTextFieldCodAccisaUE.setText(record.getCodiceAccisaFornitoreUE());
		jTextFieldStatoEstero.setText(record.getStatoEsteroMetanoFornitoreExtraUE());

		if(record.getMetanoFornitoreUE().equals(BigInteger.valueOf(0))){
			jTextFieldMetanoUE.setText("");
		}else{
			jTextFieldMetanoUE.setText(String.valueOf(record.getMetanoFornitoreUE()));
		}

		if(record.getMetanoFornitoreExtraUE().equals(BigInteger.valueOf(0))){
			jTextFieldMetanoExtraUE.setText("");
		}else{
			jTextFieldMetanoExtraUE.setText(String.valueOf(record.getMetanoFornitoreExtraUE()));
		}

		if(record.getTotale().equals(BigInteger.valueOf(0))){
			jTextFieldTotale.setText("");
		}else{
			jTextFieldTotale.setText(String.valueOf(record.getTotale()));
		}

		showHideFields(0);
	}
	
	private void loadUIFromRecord() {
		MetanoAcquistatoDaSoggettiSenzaImpiantiTM model =(MetanoAcquistatoDaSoggettiSenzaImpiantiTM) jTableDettaglio.getModel();

		int selectedRow = jTableDettaglio.getSelectedRow();
		int numOfElems = model.getRowCount();
		if (selectedRow == -1 || numOfElems < 1) {
			clearFields();
		} else {
			MetanoAcquistatoDaSoggettiSenzaImpianti record =(MetanoAcquistatoDaSoggettiSenzaImpianti) model.getRecord(selectedRow);
			loadUIFromRecord(record);
		}
		showHideFields(selectedRow);
	}

	/**
	 * @param record
	 */
	private void loadRecordFromUI(MetanoAcquistatoDaSoggettiSenzaImpianti record) {
		
		
		String value = null;
		BigInteger intValue = null;
		
		try {
			value = jTextFieldMetanoProprio.getText();
			intValue = new BigInteger(value);			
		}
		catch(NumberFormatException e) {
			intValue = BigInteger.ZERO;			
		}
		record.setMetanoDiProprieta(intValue);
		
		try {
			value = jTextFieldTotale.getText();
			intValue = new BigInteger(value);			
		}
		catch(NumberFormatException e) {
			intValue = BigInteger.ZERO;			
		}
		record.setTotale(intValue);
		
		loadRecordFromUIRistretto(record);
	}

	private void loadRecordFromUIRistretto(MetanoAcquistatoDaSoggettiSenzaImpianti record) {
		String value = null;
		BigInteger intValue = null;

		try {
			value = jTextFieldMetanoNaz.getText();
			intValue = new BigInteger(value);			
		}
		catch(NumberFormatException e) {
			intValue = BigInteger.ZERO;			
		}
		record.setMetanoFornitoreNazionale(intValue);
		
		try {
			value = jTextFieldMetanoUE.getText();
			intValue = new BigInteger(value);			
		}
		catch(NumberFormatException e) {
			intValue = BigInteger.ZERO;			
		}
		record.setMetanoFornitoreUE(intValue);

		try {
			value = jTextFieldMetanoExtraUE.getText();
			intValue = new BigInteger(value);			
		}
		catch(NumberFormatException e) {
			intValue = BigInteger.ZERO;			
		}
		record.setMetanoFornitoreExtraUE(intValue);
		
		value = jTextFieldCodAccisaNaz.getText();
		record.setCodiceAccisaFornitoreNazionale(value);
		
		value = jTextFieldCodAccisaUE.getText();
		record.setCodiceAccisaFornitoreUE(value);

		value = jTextFieldStatoEstero.getText();
		record.setStatoEsteroMetanoFornitoreExtraUE(value);
	}

	
	private void clearFields() {
		jTextFieldMetanoProprio.setText("");
		jTextFieldStatoEstero.setText("");
		jTextFieldCodAccisaNaz.setText("");
		jTextFieldMetanoNaz.setText("");
		jTextFieldCodAccisaUE.setText("");
		jTextFieldMetanoUE.setText("");
		jTextFieldMetanoExtraUE.setText("");
		jTextFieldTotale.setText("");
		
		showHideFields(0);
	}

	private void showHideFields(int selectedRow) {
		if (selectedRow == 0) {
			jTextFieldMetanoProprio.setEnabled(true);
			//jTextFieldMetanoProprio.setVisible(true);

			jTextFieldTotale.setEnabled(true);
			//jTextFieldTotale.setVisible(true);
			
		} else {
			jTextFieldMetanoProprio.setEnabled(false);
			//jTextFieldMetanoProprio.setVisible(false);

			jTextFieldTotale.setEnabled(false);
			// jTextFieldTotale.setVisible(false);
		}
	}

	private boolean validateUpdate() {
		return validateInsert();
	}

	private boolean validateInsert() {
//		if(true)return true;
		
		boolean isOk=true;
		
		String codice = StringUtil.nullify(jTextFieldCodAccisaNaz.getText());
		String valore = null;
		if(codice != null) {
			isOk = validateCodAccisaNaz();
			//SALVATORE
			isOk = true;
			//
		}
		if(isOk) {
			valore = StringUtil.nullify(jTextFieldMetanoNaz.getText());
			if(codice == null ^ valore == null) {
				JOptionPane.showMessageDialog(
					this,
					"Il codice accisa nazionale ed i consumi relativi devono essere entrambi presenti o assenti",
					"Attenzione",
					JOptionPane.WARNING_MESSAGE);
				isOk = false;
			}
		}
		if(isOk) {
			isOk = compareAccisaDic();
		}
		if(isOk) {
			codice = StringUtil.nullify(jTextFieldCodAccisaUE.getText());
			if(codice != null) {
				isOk = validateCodAccisaUE();
			}
		}
		if(isOk) {
			valore = StringUtil.nullify(jTextFieldMetanoUE.getText());
			if(codice == null ^ valore == null) {
				JOptionPane.showMessageDialog(
					this,
					"Il codice accisa UE ed i consumi relativi devono essere entrambi presenti o assenti",
					"Attenzione",
					JOptionPane.WARNING_MESSAGE);
				isOk = false;
			}
		}
		
		return isOk;
	}


	private boolean validateCodAccisaUE() {
		boolean isOk=true;
		int valore = jTextFieldCodAccisaUE.getText().length();
		/*
		if(valore<20){
			JOptionPane.showMessageDialog(
				this,
				"Il codice accisa UE deve essere 20 caratteri",
				"Attenzione",
				JOptionPane.WARNING_MESSAGE);
			isOk=false;
		}
		*/
		return isOk;
	}

	private boolean compareAccisaDic() {
		boolean isOk=true;
		Frontespizio frontespizio = prospettoConsumo.getFrontespizio();
		if (frontespizio.getCodiceAccisa().equals(jTextFieldCodAccisaNaz.getText())){
			JOptionPane.showMessageDialog(
					this,
					"I codici accisa deve essere diverso da quello corrente",
					"Attenzione",
					JOptionPane.WARNING_MESSAGE);  
			isOk=false;
		}
		return isOk;
	}

	private boolean validateCodAccisaNaz() {
		boolean isOk=true;
		String codice = jTextFieldCodAccisaNaz.getText();
		int valore = codice.length();
		if(valore<9){
			JOptionPane.showMessageDialog(
				this,
				"Il codice accisa Nazionale deve essere 9 caratteri\n",
				"Attenzione",
				JOptionPane.WARNING_MESSAGE);
			isOk=false;
		}
		if(isOk) {
			if(!Validator.isCodiceDittaForMetano(codice)) {
				JOptionPane.showMessageDialog(
					this,
					"Il codice accisa non  valido",
					"Attenzione",
					JOptionPane.WARNING_MESSAGE);
				isOk=false;
			}
		}
		
		return isOk;
	}
		
	/*************************************************************************
	 * FINE GESTIONE EVENTI
	 *************************************************************************/




	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(null);
			jContentPane.setLayout(FullScreenLayoutManager.getInstance());
			jContentPane.add(getJPanelIntestazione(), null);
			jContentPane.add(getJPanelQuantita(), null);
			jContentPane.add(getJPanelTotali(), null);
			jContentPane.add(getJButtonConferma(), null);
			jContentPane.add(getJButtonChiudi(), null);
			jContentPane.setBackground(java.awt.Color.lightGray);
		}
		return jContentPane;
	}
	/**;
	 * This method initializes jPanelIntestazione
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanelIntestazione() {
		if(jPanelIntestazione == null) {
			jPanelIntestazione = new javax.swing.JPanel();
			jPanelIntestazione.setLayout(FullScreenLayoutManager.getInstance());
			jPanelIntestazione.setLayout(null);
			jPanelIntestazione.add(getJLabelMese(), null);
			jPanelIntestazione.add(getJLabelNomeQuadro(), null);
			jPanelIntestazione.add(getJLabelTitoloQuadro(), null);
			jPanelIntestazione.setBounds(0, 2, 793, 49);
			jPanelIntestazione.setBackground(java.awt.Color.lightGray);
			jPanelIntestazione.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.black,0));
		}
		return jPanelIntestazione;
	}
	/**
	 * This method initializes jLabelMese
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelMese() {
		if(jLabelMese == null) {
			jLabelMese = new javax.swing.JLabel();
			jLabelMese.setBounds(544, 4, 246, 20);
			jLabelMese.setText("");
			jLabelMese.setBackground(java.awt.Color.lightGray);
			jLabelMese.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
		}
		return jLabelMese;
	}
	/**
	 * This method initializes jLabelNomeQuadro
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelNomeQuadro() {
		if(jLabelNomeQuadro == null) {
			jLabelNomeQuadro = new javax.swing.JLabel();
			jLabelNomeQuadro.setBounds(544, 23, 248, 24);
			jLabelNomeQuadro.setText("");
			jLabelNomeQuadro.setBackground(java.awt.Color.lightGray);
			jLabelNomeQuadro.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
			jLabelNomeQuadro.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
		}
		return jLabelNomeQuadro;
	}
	/**
	 * This method initializes jLabelTitoloQuadro
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelTitoloQuadro() {
		if(jLabelTitoloQuadro == null) {
			jLabelTitoloQuadro = new javax.swing.JLabel();
			jLabelTitoloQuadro.setBounds(0, 29, 126, 19);
			jLabelTitoloQuadro.setText("");
			jLabelTitoloQuadro.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
			jLabelTitoloQuadro.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 18));
		}
		return jLabelTitoloQuadro;
	}
	/**
	 * This method initializes jPanelQuantita
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanelQuantita() {
		if(jPanelQuantita == null) {
			jPanelQuantita = new javax.swing.JPanel();
			jPanelQuantita.setLayout(null);
			jPanelQuantita.setLayout(FullScreenLayoutManager.getInstance());
			jPanelQuantita.add(getJTextFieldMetanoProprio(), null);
			jPanelQuantita.add(getJTextFieldCodAccisaNaz(), null);
			jPanelQuantita.add(getJTextFieldMetanoNaz(), null);
			jPanelQuantita.add(getJTextFieldCodAccisaUE(), null);
			jPanelQuantita.add(getJTextFieldMetanoUE(), null);
			jPanelQuantita.add(getJTextFieldMetanoExtraUE(), null);
			jPanelQuantita.add(getJTextFieldTotale(), null);
			jPanelQuantita.add(getJButtonElimina(), null);
			jPanelQuantita.add(getJButtonModifica(), null);
			jPanelQuantita.add(getJButtonInserisci(), null);
			jPanelQuantita.add(getJLabel7(), null);
			jPanelQuantita.add(getJLabel8(), null);
			jPanelQuantita.add(getJLabel9(), null);
			jPanelQuantita.add(getJLabel(), null);
			jPanelQuantita.add(getJLabel4(), null);
			jPanelQuantita.add(getJLabel11(), null);
			jPanelQuantita.add(getJLabel12(), null);
			jPanelQuantita.add(getJLabel13(), null);
			jPanelQuantita.add(getJLabel14(), null);
			jPanelQuantita.add(getJLabel15(), null);
			jPanelQuantita.add(getJLabel16(), null);
			jPanelQuantita.add(getJScrollPane(), null);
			jPanelQuantita.add(getJLabel6(), null);
			jPanelQuantita.add(getJTextFieldStatoEstero(), null);
			jPanelQuantita.add(getJLabel1(), null);
			jPanelQuantita.setBounds(1, 68, 791, 338);
			jPanelQuantita.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Quantit", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
		}
		return jPanelQuantita;
	}
	/**
	 * This method initializes jTextFieldMetanoProprio
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldMetanoProprio() {
		if(jTextFieldMetanoProprio == null) {
			jTextFieldMetanoProprio = new javax.swing.JTextField();
			jTextFieldMetanoProprio.setBounds(new java.awt.Rectangle(3,242,99,19));

			jTextFieldMetanoProprio.setDocument(new BigIntegerDocument(MetanoAcquistatoDaSoggettiSenzaImpianti.dimMetanoDiProprieta));
		}
		return jTextFieldMetanoProprio;
	}
	/**
	 * This method initializes jTextFieldCodAccisaNaz
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldCodAccisaNaz() {
		if(jTextFieldCodAccisaNaz == null) {
			jTextFieldCodAccisaNaz = new javax.swing.JTextField();
			jTextFieldCodAccisaNaz.setBounds(102, 242, 98, 19);
			// jTextFieldCodAccisaNaz.addFocusListener(this);
		
			jTextFieldCodAccisaNaz.setDocument(new StringDocument(MetanoAcquistatoDaSoggettiSenzaImpianti.dimCodiceAccisaFornitoreNazionale));
		}
		return jTextFieldCodAccisaNaz;
	}
	/**
	 * This method initializes jTextFieldMatanoNaz
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldMetanoNaz() {
		if(jTextFieldMetanoNaz == null) {
			jTextFieldMetanoNaz = new javax.swing.JTextField();
			jTextFieldMetanoNaz.setBounds(201, 242, 98, 19);

			jTextFieldMetanoNaz.setDocument(new BigIntegerDocument(MetanoAcquistatoDaSoggettiSenzaImpianti.dimMetanoFornitoreNazionale));
		}
		return jTextFieldMetanoNaz;
	}
	/**
	 * This method initializes jTextFieldCodAccisaUE
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldCodAccisaUE() {
		if(jTextFieldCodAccisaUE == null) {
			jTextFieldCodAccisaUE = new javax.swing.JTextField();
			jTextFieldCodAccisaUE.setBounds(300, 242, 98, 19);
			jTextFieldCodAccisaUE.setDocument(new StringDocument(MetanoAcquistatoDaSoggettiSenzaImpianti.dimCodiceAccisaFornitoreUE));
			// jTextFieldCodAccisaUE.addFocusListener(this);
		}
		return jTextFieldCodAccisaUE;
	}
	/**
	 * This method initializes jTextFieldMetanoUE
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldMetanoUE() {
		if(jTextFieldMetanoUE == null) {
			jTextFieldMetanoUE = new javax.swing.JTextField();
			jTextFieldMetanoUE.setBounds(399, 242, 98, 19);

			jTextFieldMetanoUE.setDocument(new BigIntegerDocument(MetanoAcquistatoDaSoggettiSenzaImpianti.dimMetanoFornitoreUE));
		}
		return jTextFieldMetanoUE;
	}
	/**
	 * This method initializes jTextFieldMetanoExtraUE
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldMetanoExtraUE() {
		if(jTextFieldMetanoExtraUE == null) {
			jTextFieldMetanoExtraUE = new javax.swing.JTextField();
			jTextFieldMetanoExtraUE.setBounds(580, 242, 99, 19);

			jTextFieldMetanoExtraUE.setDocument(new BigIntegerDocument(MetanoAcquistatoDaSoggettiSenzaImpianti.dimMetanoFornitoreExtraUE));
		}
		return jTextFieldMetanoExtraUE;
	}
	/**
	 * This method initializes jTextFieldTotale
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldTotale() {
		if(jTextFieldTotale == null) {
			jTextFieldTotale = new javax.swing.JTextField();
			jTextFieldTotale.setBounds(680, 242, 98, 19);

			jTextFieldTotale.setDocument(new BigIntegerDocument(MetanoAcquistatoDaSoggettiSenzaImpianti.dimTotale));
		}
		return jTextFieldTotale;
	}
	/**
	 * This method initializes jButtonElimina
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonElimina() {
		if(jButtonElimina == null) {
			jButtonElimina = new javax.swing.JButton();
			jButtonElimina.setBounds(687, 267, 90, 27);
			jButtonElimina.setText("Elimina");
			
			jButtonElimina.addActionListener(this);
			// jButtonElimina.setEnabled(false);
		}
		return jButtonElimina;
	}
	/**
	 * This method initializes jButtonModifica
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonModifica() {
		if(jButtonModifica == null) {
			jButtonModifica = new javax.swing.JButton();
			jButtonModifica.setBounds(593, 267, 90, 27);
			jButtonModifica.setText("Modifica");

			jButtonModifica.addActionListener(this);
			// jButtonModifica.setEnabled(false);
		}
		return jButtonModifica;
	}
	/**
	 * This method initializes jButtonInserisci
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonInserisci() {
		if(jButtonInserisci == null) {
			jButtonInserisci = new javax.swing.JButton();
			jButtonInserisci.setBounds(498, 267, 90, 27);
			jButtonInserisci.setText("Inserisci");
			
			jButtonInserisci.addActionListener(this);
			// jButtonInserisci.setEnabled(false);
		}
		return jButtonInserisci;
	}
	/**
	 * This method initializes jPanelTotali
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanelTotali() {
		if(jPanelTotali == null) {
			jPanelTotali = new javax.swing.JPanel();
			jPanelTotali.setLayout(null);
			jPanelTotali.setLayout(FullScreenLayoutManager.getInstance());
			jPanelTotali.add(getJTextFieldTotMetanoProprio(), null);
			jPanelTotali.add(getJTextFieldTotMetanoNaz(), null);
			jPanelTotali.add(getJTextFieldTotMetanoUE(), null);
			jPanelTotali.add(getJTextFieldTotMetanoExtraUE(), null);
			jPanelTotali.add(getJTextFieldTotTotale(), null);
			jPanelTotali.setBounds(2, 412, 792, 54);
			jPanelTotali.setBackground(java.awt.Color.lightGray);
			jPanelTotali.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Totali", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
		}
		return jPanelTotali;
	}
	/**
	 * This method initializes jTextFieldTotMetanoProprio
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldTotMetanoProprio() {
		if(jTextFieldTotMetanoProprio == null) {
			jTextFieldTotMetanoProprio = new javax.swing.JTextField();
			jTextFieldTotMetanoProprio.setBounds(3, 17, 99, 19);
			
			jTextFieldTotMetanoProprio.setDocument(new BigIntegerDocument(MetanoAcquistatoDaSoggettiSenzaImpianti.dimMetanoDiProprieta));
		}
		return jTextFieldTotMetanoProprio;
	}
	/**
	 * This method initializes jTextFieldTotMetanoNaz
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldTotMetanoNaz() {
		if(jTextFieldTotMetanoNaz == null) {
			jTextFieldTotMetanoNaz = new javax.swing.JTextField();
			jTextFieldTotMetanoNaz.setBounds(201, 17, 98, 19);

			jTextFieldTotMetanoNaz.setDocument(new BigIntegerDocument(MetanoAcquistatoDaSoggettiSenzaImpianti.dimMetanoFornitoreNazionale));

		}
		return jTextFieldTotMetanoNaz;
	}
	/**
	 * This method initializes jTextFieldTotMetanoUE
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldTotMetanoUE() {
		if(jTextFieldTotMetanoUE == null) {
			jTextFieldTotMetanoUE = new javax.swing.JTextField();
			jTextFieldTotMetanoUE.setBounds(399, 17, 98, 19);

			jTextFieldTotMetanoUE.setDocument(new BigIntegerDocument(MetanoAcquistatoDaSoggettiSenzaImpianti.dimMetanoFornitoreUE));
		}
		return jTextFieldTotMetanoUE;
	}
	/**
	 * This method initializes jTextFieldTotMetanoExtraUE
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldTotMetanoExtraUE() {
		if(jTextFieldTotMetanoExtraUE == null) {
			jTextFieldTotMetanoExtraUE = new javax.swing.JTextField();
			jTextFieldTotMetanoExtraUE.setBounds(580, 17, 99, 19);

			jTextFieldTotMetanoExtraUE.setDocument(new BigIntegerDocument(MetanoAcquistatoDaSoggettiSenzaImpianti.dimMetanoFornitoreExtraUE));
		}
		return jTextFieldTotMetanoExtraUE;
	}
	/**
	 * This method initializes jTextFieldTotTotale
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldTotTotale() {
		if(jTextFieldTotTotale == null) {
			jTextFieldTotTotale = new javax.swing.JTextField();
			jTextFieldTotTotale.setBounds(680, 17, 98, 19);

			jTextFieldTotTotale.setDocument(new BigIntegerDocument(MetanoAcquistatoDaSoggettiSenzaImpianti.dimTotale));
		}
		return jTextFieldTotTotale;
	}
	/**
	 * This method initializes jButtonConferma
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonConferma() {
		if(jButtonConferma == null) {
			jButtonConferma = new javax.swing.JButton();
			jButtonConferma.setBounds(10, 484, 90, 26);
			jButtonConferma.setText("Conferma");

			jButtonConferma.addActionListener(this);
		}
		return jButtonConferma;
	}
	/**
	 * This method initializes jButtonChiudi
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonChiudi() {
		if(jButtonChiudi == null) {
			jButtonChiudi = new javax.swing.JButton();
			jButtonChiudi.setBounds(107, 484, 90, 26);
			jButtonChiudi.setText("Chiudi");
			jButtonChiudi.addActionListener(this);
		}
		return jButtonChiudi;
	}
	/**
	 * This method initializes jLabel7
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel7() {
		if(jLabel7 == null) {
			jLabel7 = new javax.swing.JLabel();
			jLabel7.setBounds(103, 204, 195, 18);
			jLabel7.setText("NAZIONALI");
			jLabel7.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			jLabel7.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1));
			jLabel7.setVerticalAlignment(javax.swing.SwingConstants.TOP);
		}
		return jLabel7;
	}
	/**
	 * This method initializes jLabel8
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel8() {
		if(jLabel8 == null) {
			jLabel8 = new javax.swing.JLabel();
			jLabel8.setBounds(300, 204, 196, 18);
			jLabel8.setText("UE");
			jLabel8.setVerticalAlignment(javax.swing.SwingConstants.TOP);
			jLabel8.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			jLabel8.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1));
		}
		return jLabel8;
	}
	/**
	 * This method initializes jLabel9
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel9() {
		if(jLabel9 == null) {
			jLabel9 = new javax.swing.JLabel();
			jLabel9.setBounds(498, 204, 180, 18);
			jLabel9.setText("EXTRA UE");
			jLabel9.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1));
			jLabel9.setVerticalAlignment(javax.swing.SwingConstants.TOP);
			jLabel9.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}
		return jLabel9;
	}
	
	private javax.swing.JLabel getJLabel() {
		if(jLabel == null) {
			jLabel = new javax.swing.JLabel();
			jLabel.setBounds(3, 216, 99, 10);
			jLabel.setText(" ");
			jLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}
		return jLabel;
	}
	/**
	 * This method initializes jLabel4
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel4() {
		if(jLabel4 == null) {
			jLabel4 = new javax.swing.JLabel();
			jLabel4.setBounds(3, 228, 99, 10);
			jLabel4.setText("Di propriet");
			jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}
		return jLabel4;
	}
	/**
	 * This method initializes jLabel11
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel11() {
		if(jLabel11 == null) {
			jLabel11 = new javax.swing.JLabel();
			jLabel11.setBounds(103, 183, 575, 20);
			jLabel11.setText("PROVENIENTE DA ALTRI FORNITORI");
			jLabel11.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			jLabel11.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1));
			jLabel11.setVerticalAlignment(javax.swing.SwingConstants.TOP);
		}
		return jLabel11;
	}
	/**
	 * This method initializes jLabel12
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel12() {
		if(jLabel12 == null) {
			jLabel12 = new javax.swing.JLabel();
			jLabel12.setBounds(102, 228, 98, 10);
			jLabel12.setText("Codice identificativo");
			jLabel12.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

		}
		return jLabel12;
	}
	/**
	 * This method initializes jLabel13
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel13() {
		if(jLabel13 == null) {
			jLabel13 = new javax.swing.JLabel();
			jLabel13.setBounds(201, 228, 98, 10);
			jLabel13.setText("Metri cubi");
			jLabel13.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}
		return jLabel13;
	}
	/**
	 * This method initializes jLabel14
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel14() {
		if(jLabel14 == null) {
			jLabel14 = new javax.swing.JLabel();
			jLabel14.setBounds(300, 228, 98, 10);
			jLabel14.setText("Codice identificativo");
			jLabel14.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}
		return jLabel14;
	}
	/**
	 * This method initializes jLabel15
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel15() {
		if(jLabel15 == null) {
			jLabel15 = new javax.swing.JLabel();
			jLabel15.setBounds(399, 228, 98, 10);
			jLabel15.setText("Metri cubi");
			jLabel15.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}
		return jLabel15;
	}
	/**
	 * This method initializes jLabel16
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel16() {
		if(jLabel16 == null) {
			jLabel16 = new javax.swing.JLabel();
			jLabel16.setBounds(580, 228, 99, 10);
			jLabel16.setText("Metri cubi");
			jLabel16.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}
		return jLabel16;
	}
	
	
			
	private int validateExitText() {
			int retvalue = JOptionPane.NO_OPTION;
			if(flagModifica==true) {
				retvalue = JOptionPane.showConfirmDialog(this, "Le modifiche effettutate verranno perse. Vuoi salvare le modifiche?", "", JOptionPane.YES_NO_CANCEL_OPTION);
			}
			return retvalue;
		}			
	

	/**
	 * This method initializes jTableDettaglio
	 * 
	 * @return javax.swing.JTable
	 */
	private javax.swing.JTable getJTableDettaglio() {
		if(jTableDettaglio == null) {
			jTableDettaglio = new javax.swing.JTable();
			jTableDettaglio.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
			jTableDettaglio.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
			jTableDettaglio.getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			jTableDettaglio.getSelectionModel().addListSelectionListener(this);
		}
		return jTableDettaglio;
	}
	/**
	 * This method initializes jScrollPane1
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private javax.swing.JScrollPane getJScrollPane() {
		if(jScrollPane == null) {
			jScrollPane = new javax.swing.JScrollPane();
			jScrollPane.setBounds(7, 17, 777, 158);
			jScrollPane.setViewportView(getJTableDettaglio());
		}
		return jScrollPane;
	}
	/* (non-Javadoc)
	 * @see java.awt.event.MouseListener#mouseClicked(java.awt.event.MouseEvent)
	

	/**
	 * This method initializes jLabel6
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel6() {
		if(jLabel6 == null) {
			jLabel6 = new javax.swing.JLabel();
			jLabel6.setBounds(680, 228, 98, 10);
			jLabel6.setText("TOTALE");
			jLabel6.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}
		return jLabel6;
	}
	/**
	 * This method initializes jTextField
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldStatoEstero() {
		if(jTextFieldStatoEstero == null) {
			jTextFieldStatoEstero = new javax.swing.JTextField();
			jTextFieldStatoEstero.setBounds(498, 242, 82, 19);

			jTextFieldStatoEstero.setDocument(new StringDocument(MetanoAcquistatoDaSoggettiSenzaImpianti.dimMetanoFornitoreUE));
		}
		return jTextFieldStatoEstero;
	}
	/**
	 * This method initializes jLabel1
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel1() {
		if(jLabel1 == null) {
			jLabel1 = new javax.swing.JLabel();
			jLabel1.setBounds(498, 228, 82, 10);
			jLabel1.setText("Stato estero");
			jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

		}
		return jLabel1;
	}

}  //  @jve:visual-info  decl-index=0 visual-constraint="108,25"
