
package it.finanze.dogane.accise.metano.ui;


import it.finanze.dogane.accise.combo.AbstractTipo;
import it.finanze.dogane.accise.combo.ComboDataSource;
import it.finanze.dogane.accise.combo.ComboUtil;
import it.finanze.dogane.accise.combo.TipoComune;
import it.finanze.dogane.accise.combo.TipoEstrazioneVendita;
import it.finanze.dogane.accise.combo.TipoMese;
import it.finanze.dogane.accise.metano.model.Frontespizio;
import it.finanze.dogane.accise.metano.model.MetanoEstrattoVenduto;
import it.finanze.dogane.accise.metano.model.ProspettoConsumo;
import it.finanze.dogane.accise.metano.ui.quadri.Parametri;
import it.finanze.dogane.accise.metano.ui.quadri.Quadro;
import it.finanze.dogane.accise.metano.ui.tablemodel.MetanoEstrattoVendutoTM;
import it.finanze.dogane.accise.model.Prospect;
import it.finanze.dogane.accise.pdf.PdfBuilder;
import it.finanze.dogane.accise.pdf.PdfPrintable;
import it.finanze.dogane.accise.ui.FullScreenLayoutManager;
import it.finanze.dogane.accise.ui.RealDim;
import it.finanze.dogane.accise.ui.TableUtil;
import it.finanze.dogane.accise.ui.quadri.GestoreQuadro;
import it.finanze.dogane.accise.ui.quadri.dialog.QuadroDialog;
import it.finanze.dogane.accise.ui.validation.BigIntegerDocument;
import it.finanze.dogane.accise.ui.validation.StringDocument;
import it.finanze.dogane.accise.ui.validation.Validator;
import it.finanze.dogane.accise.util.StringUtil;

import java.awt.Component;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.math.BigInteger;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import javax.swing.DefaultComboBoxModel;
import javax.swing.DefaultListCellRenderer;
import javax.swing.JDialog;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

public class MetanoEstrattoVendutoDialog
	extends JDialog
	implements ActionListener, ListSelectionListener, FocusListener, QuadroDialog, PdfPrintable {

	private TipoMese tipoMese;

	private javax.swing.JPanel jContentPane = null;
	private javax.swing.JPanel jPanel = null;
	private javax.swing.JLabel jLabelMese = null;
	private javax.swing.JLabel jLabelTitoloQuadro = null;
	private javax.swing.JLabel jLabelNomeQuadro = null;
	private javax.swing.JPanel jPanel1 = null;
	private javax.swing.JScrollPane jScrollPane = null;
	private javax.swing.JTable jTable = null;
	private javax.swing.JTextField jTextFieldTotale = null;
	private javax.swing.JLabel jLabel4 = null;
	private javax.swing.JTextField jTextFieldMetriCubi = null;
	private javax.swing.JTextField jTextFieldCodAccisa = null;
	private javax.swing.JComboBox jComboBoxTipologiaEstrazione = null;
	private javax.swing.JButton jButtonElimina = null;
	private javax.swing.JButton jButtonModifica = null;
	private javax.swing.JButton jButtonInserisci = null;
	private javax.swing.JButton jButtonConferma = null;
	private javax.swing.JButton jButtonChiudi = null;
	private javax.swing.JLabel jLabel1 = null;
	private javax.swing.JLabel jLabel2 = null;
	private javax.swing.JLabel jLabel5 = null;
	private boolean flagModifica=false;
	private ProspettoConsumo prospettoConsumo = null;
	private Quadro quadro = null;
	private MetanoEstrattoVenduto totaleRecord = null;

	/**
	 * This is the default constructor
	 */
	public MetanoEstrattoVendutoDialog(Frame frame,String description,String secondDescription) {
		
		super(frame, "Prospetto mensile del gas naturale movimentato", true);
		
		
		initialize();
		getJLabelTitoloQuadro().setText(description);
		getJLabelNomeQuadro().setText(secondDescription);
		
		
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		//this.setSize(800, 600);
		this.setSize(RealDim.getAbsoluteXValue(800), RealDim.getAbsoluteYValue(600));
		this.setContentPane(getJContentPane());
		this.setLocation(0, 0);
		this.setResizable(false);
		this.setModal(true);
		this.setDefaultCloseOperation(
			javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);

	}

	public void prepareValues(Prospect prospect, GestoreQuadro gestoreQuadro) {

		prospettoConsumo = (ProspettoConsumo) prospect;
		Frontespizio frontespizio = prospettoConsumo.getFrontespizio();

		this.quadro = (Quadro) gestoreQuadro;
		tipoMese = ((Parametri)quadro.getParameter()).getMese();

		List lista = prospettoConsumo.getListaQuadro(quadro.getTipiRecord());

		Parametri parametriSelezionati = new Parametri();
		parametriSelezionati.setMese(tipoMese);
		lista =	Quadro.getListaRecordParametrizzato(lista,parametriSelezionati,quadro);
		
		if(quadro.getLettera().equals("B")){
							super.setTitle("Prospetto mensile del gas naturale movimentato");
							}else if (quadro.getLettera().equals("D")){
							super.setTitle("Prospetto mensile del gas naturale commercializzato");
								}
				
		
		boolean isAnnuale = false;
		if (!tipoMese.getCodice().trim().equals("0") && !tipoMese.getCodice().trim().equals("00")) {
			getJLabelMese().setText("Mese di " + tipoMese.getDescrizione());
		} else {
			getJLabelMese().setText("Prospetto "+ tipoMese.getDescrizione());
			isAnnuale = true;
		}
		/** MODIFICA 13-11-2007 **/
		if (isAnnuale && lista.size()==0){  // Modifica annullata 17/01/2008 if (isAnnuale) { //&& lista.size()==0){ 
			if(quadro.getLettera().equals("B")){
			super.setTitle("Prospetto annuale del gas naturale movimentato");
			}else if (quadro.getLettera().equals("D")){
			super.setTitle("Prospetto annuale del gas naturale commercializzato");
				}
			
			// se  annuale e non esiste la lista associata allora la devo inizializzare
			lista = calcoloAnnuale();
		}

		//int mese = Integer.parseInt(tipoMese.getCodice());
		//lista =	Quadro.getListaRecordPerMese(lista,mese);

		ComboUtil.setValues(jComboBoxTipologiaEstrazione,ComboDataSource.getInstance().getTipologieEstrazioneVendita(quadro.getLettera()));
		jComboBoxTipologiaEstrazione.setSelectedIndex(-1);
      
		initTotale(lista);

		MetanoEstrattoVendutoTM model = new MetanoEstrattoVendutoTM(lista,quadro.getLettera());
		jTable.setModel(model);
		TableUtil.redimTable(jTable, jScrollPane);
		
		if(quadro.getLettera().equalsIgnoreCase("B")) {
			jLabel2.setText("Codice accisa/ditta destinatario");			
		} else {
			jLabel2.setText("Codice identificativo acquirente/distributore");			
		}
		
	}

	/**
	 * @return
	 */
	private List calcoloAnnuale() {
		List annualeList = new LinkedList();
		List listAll = prospettoConsumo.getListaQuadro(quadro.getTipiRecord());

		// Per ogni record, controllo se  gia' contenuto nella lista "annualeList", se non c' lo metto in lista, altrimenti lo sommo a quello nella lista annuale
		Iterator it = listAll.iterator();
		while (it.hasNext()) {
			MetanoEstrattoVenduto record = (MetanoEstrattoVenduto)it.next();
			if(!record.getTipoRigo().equals(BigInteger.valueOf(9))) { // Se non si tratta di un totale!
				Iterator itAll = listAll.iterator();

				MetanoEstrattoVenduto item = containsItem(record, annualeList);
				if (item == null){ // se l'elemento non  ancora in lista
					record.setMese(BigInteger.valueOf(0));
					annualeList.add(record);
				} else { // se l'elemento  gi in lista sommo i metri cubi
					item.setMetriCubi(item.getMetriCubi().add(record.getMetriCubi()));
				}
			}
		}
		return annualeList;
	}

	/**
	 * @param recordAnnuale
	 * @param annualeList
	 * @return
	 */
	private MetanoEstrattoVenduto containsItem(MetanoEstrattoVenduto recordAnnuale, List annualeList) {
		MetanoEstrattoVenduto retvalue = null;

		String tipologiaVendita=StringUtil.denullify(recordAnnuale.getTipEstrazioneVendita());
		String codiceAccisa=StringUtil.denullify(recordAnnuale.getCodiceAcc());

		Iterator iter = annualeList.iterator();
		while (iter.hasNext() && retvalue == null){
			MetanoEstrattoVenduto itemTmp = (MetanoEstrattoVenduto)iter.next();
			String tipologiaVenditaTmp = StringUtil.denullify(itemTmp.getTipEstrazioneVendita());
			String codiceAccisaTmp = StringUtil.denullify(itemTmp.getCodiceAcc());

			if (tipologiaVendita.equals(tipologiaVenditaTmp) && codiceAccisa.equals(codiceAccisaTmp)) {
				retvalue = itemTmp;
			}
		}
		return retvalue;
	}

	private void initTotale(List list) {
		BigInteger totaleTemporaneo = BigInteger.ZERO;
		
		
		if (list != null) {
			Iterator it = list.iterator();
			boolean found = false;
			while (it.hasNext()&& found!=true ) {
				MetanoEstrattoVenduto record =(MetanoEstrattoVenduto) it.next();
				totaleTemporaneo = totaleTemporaneo.add(record.getMetriCubi());
				if (record.getTipoRigo().equals(BigInteger.valueOf(9))) {					
					totaleRecord = record;	
					it.remove();
					found = true;
				}
			
			}
			if (!found) {
				totaleRecord =MetanoEstrattoVenduto.getNewObject(prospettoConsumo);	
				totaleRecord.setTipoRigo(BigInteger.valueOf(9));
				totaleRecord.setMese(new BigInteger(tipoMese.getCodice()));
				totaleRecord.setLetteraIdQuadro(quadro.getLettera());		
				totaleRecord.setTipoRecord(BigInteger.valueOf(quadro.getTipiRecord()[0]));
				totaleRecord.setMetriCubi(totaleTemporaneo);
			}
		} else {
			totaleRecord = MetanoEstrattoVenduto.getNewObject(prospettoConsumo);
			totaleRecord.setTipoRigo(BigInteger.valueOf(9));
			totaleRecord.setMese(new BigInteger(tipoMese.getCodice()))	;
			totaleRecord.setLetteraIdQuadro(quadro.getLettera());	
			totaleRecord.setTipoRecord(BigInteger.valueOf(quadro.getTipiRecord()[0]));
		}
		jTextFieldTotale.setText(String.valueOf(totaleRecord.getMetriCubi()));
	}
	
	private void initTotaleAnnuale(List list)  {
		
			BigInteger totale = BigInteger.valueOf(0);
		    MetanoEstrattoVenduto clonato = new MetanoEstrattoVenduto();
		     
			if (list != null) {
				Iterator it = list.iterator();
				boolean found = false;
				while (it.hasNext()) {
					MetanoEstrattoVenduto record =(MetanoEstrattoVenduto) it.next();
					
					if (record.getTipoRigo().equals(BigInteger.valueOf(9))) {					
						totaleRecord = record;
						totale =totale.add(totaleRecord.getMetriCubi())	;						
						it.remove();						
					}
			
				}
				jTextFieldTotale.setText(String.valueOf(totale));;
				
			}
		}

		public void plot(PdfBuilder pdfBuilder) {
			
			pdfBuilder.startCommandBlock();
			pdfBuilder.writeCenteredLabel(this.getTitle(), 14);
			pdfBuilder.moveYPen(50);
			//SALVATORE
			pdfBuilder.endCommandBlock();
			pdfBuilder.startDefineTableHeader();		
			//
			
			pdfBuilder.moveXPen(50);
			pdfBuilder.writeRightLabel(jLabelMese.getText(), 12);
			pdfBuilder.setXPen(PdfBuilder.MARGINE);
			pdfBuilder.writeLeftLabel(jLabelTitoloQuadro.getText(), 12);
			pdfBuilder.moveYPen(-14);
			pdfBuilder.writeRightLabel(jLabelNomeQuadro.getText(), 12);
			pdfBuilder.moveYPen(10);
			//SALVATORE
			//pdfBuilder.endCommandBlock();
			pdfBuilder.endDefineTableHeader();		
			//
			
			pdfBuilder.writeTable(this, jTable, jScrollPane);
			pdfBuilder.moveYPen(10);
			pdfBuilder.startCommandBlock();
			pdfBuilder.writeRightLabel("Totale mc: "+  "           "+getJTextFieldTotale().getText() ,10);
			
			pdfBuilder.moveYPen(22);
			pdfBuilder.writeLeftLabel("Tipologia di vendita: ", 8);
			pdfBuilder.moveXPen(150);
						
			DefaultComboBoxModel model = (DefaultComboBoxModel)jComboBoxTipologiaEstrazione.getModel();
			int size = model.getSize();
			for(int i = 0, k = 0; i < size; i++) {
				AbstractTipo tipo = (AbstractTipo)model.getElementAt(i);
			
				pdfBuilder.writeLeftLabel(tipo.getDescrizioneEstesa(), 8);
			}
			pdfBuilder.setXPen(PdfBuilder.MARGINE);
			pdfBuilder.endCommandBlock();
			pdfBuilder.moveYPen(20);
		}

	public void actionPerformed(ActionEvent event) {

		if (event.getSource() == jButtonChiudi) {
		     doClose();
		} else if (event.getSource() == jButtonConferma) {
			doConfirm();
		} else if (event.getSource() == jButtonElimina) {
			doDelete();
		} else if (event.getSource() == jButtonInserisci) {
			doInsert();
		} else if (event.getSource() == jButtonModifica) {
			doUpdate();
		}
	}

	/**
	 * 
	 */
	
	public void focusGained(FocusEvent event) {
	}

	public void focusLost(FocusEvent event) {
		
		if(event.getSource() == jTextFieldMetriCubi) {
			validateMetriCubi();
		}//else if(event.getSource()==jTextFieldCodAccisa)
		//validateCodAccisa();
	}
	/**
	 * 
	 */
	private void validateMetriCubi() {

	}
	protected void doClose() {
		int val = validateExitText();
			if(val == JOptionPane.YES_OPTION) {
				doConfirm();
			} else if(val == JOptionPane.NO_OPTION) {
				this.setVisible(false);
			} else if(val == JOptionPane.CANCEL_OPTION) {
			}
	}

	private void doConfirm() {
		MetanoEstrattoVendutoTM model =(MetanoEstrattoVendutoTM) jTable.getModel();
		List listaQuadroXMese = model.getRecords();
				
		/** MODIFICA 24-10-2007 **/
		if(listaQuadroXMese.size() >0) {
			quadro.setEmpty(false);
		}
		else
			quadro.setEmpty(true);
		
		String stringTotale = StringUtil.nullify(jTextFieldTotale.getText());
		if(stringTotale != null) {
		try {
			totaleRecord.setMetriCubi(new BigInteger(stringTotale));
		}catch(NumberFormatException e) {
		  totaleRecord.setMetriCubi(BigInteger.valueOf(0));
	    }
		}
		
		
		List listaQuadroCompleta = prospettoConsumo.getListaQuadro(quadro.getTipiRecord());
		
		// Elimino i vecchi record con il mese in modifica
		Iterator it = listaQuadroCompleta.iterator();
		while(it.hasNext()) {
			MetanoEstrattoVenduto record = (MetanoEstrattoVenduto)it.next();
			if(record.getMese().equals(new BigInteger(tipoMese.getCodice()))) {
				it.remove();
			}
		}
		// Aggiungo i nuovi record per il mese in modifica
		listaQuadroCompleta.addAll(listaQuadroXMese);
		// Aggiungo il totale
		if(listaQuadroXMese.size()!=0)	{	
		
		listaQuadroCompleta.add(totaleRecord);
		}
		// Imposto tutto sul modello! Finally!!!!!
		prospettoConsumo.setListaQuadro(listaQuadroCompleta, quadro.getTipiRecord());
		this.setVisible(false);
	}

	private void doUpdate() {
		 if (validaCodiceAccisa()) {
			MetanoEstrattoVendutoTM model =
				(MetanoEstrattoVendutoTM) jTable.getModel();
			int selectedRow = jTable.getSelectedRow();
			if (selectedRow != -1) {
				MetanoEstrattoVenduto record =
					(MetanoEstrattoVenduto) model.getRecord(selectedRow);
				try {
					loadRecordFromUI(record);
					model.setRecord(selectedRow, new MetanoEstrattoVenduto());
					flagModifica = true;
				} catch (Exception e) {
					JOptionPane.showMessageDialog(
						this,
						e.getMessage(),
						"Errore",
						JOptionPane.ERROR_MESSAGE);
				}
				updateTot();
			} else {
				JOptionPane.showMessageDialog(
					this,
					"Selezionare un elemento dalla lista",
					"Attenzione",
					JOptionPane.WARNING_MESSAGE);
			}
		}
	}

	private void doInsert() {
			
			if(validaCodiceAccisa()){
		
			MetanoEstrattoVendutoTM model = (MetanoEstrattoVendutoTM)jTable.getModel();
			MetanoEstrattoVenduto record = MetanoEstrattoVenduto.getNewObject(prospettoConsumo);
			record.setTipoRecord(BigInteger.valueOf(quadro.getTipiRecord()[0]));
			loadRecordFromUI(record);
			model.insertRecord(record);
			flagModifica=true;
			updateTot();
			clearFieldsForEditing();
		
		}
	}
	private void loadRecordFromUI(MetanoEstrattoVenduto record) {
         
		Object selectedObj = jComboBoxTipologiaEstrazione.getSelectedItem();
		
		
		TipoEstrazioneVendita tipoEstrazioneVendita = null;
		if (selectedObj instanceof TipoEstrazioneVendita) {
			tipoEstrazioneVendita = (TipoEstrazioneVendita) selectedObj;
		} else if (selectedObj instanceof String) {
			String codiceTipologia = (String) selectedObj;
			tipoEstrazioneVendita =	ComboDataSource.getInstance().getTipologiaEstrazioneVendita(quadro.getLettera(),codiceTipologia);
			if (tipoEstrazioneVendita == null) {
				throw new RuntimeException("Codice  non valido.");
			}
		} else {
			throw new RuntimeException("Codice  non valido.");
		}
		record.setTipEstrazioneVendita(tipoEstrazioneVendita.getCodice());
		record.setMese(new BigInteger(tipoMese.getCodice()));
		record.setCodiceAcc(this.jTextFieldCodAccisa.getText().trim());
		record.setLetteraIdQuadro(quadro.getLettera());
        String str = null;
		try {
			str = jTextFieldCodAccisa.getText();
			record.setCodiceAcc(str);
		} catch (NullPointerException e) {
			record.setCodiceAcc("");
		}
		try {
			str = jTextFieldMetriCubi.getText();
			record.setMetriCubi(new BigInteger(str));
		} catch (NumberFormatException e) {
			record.setMetriCubi(BigInteger.valueOf(0));
		}
		
	}

	private void doDelete() {

		MetanoEstrattoVendutoTM model =	(MetanoEstrattoVendutoTM) jTable.getModel();
		int selectedRow = jTable.getSelectedRow();
		if (selectedRow != -1) {
			model.removeRecord(selectedRow);
			clearFieldsForEditing();
			updateTot();
		    flagModifica = true;
		}else {
		JOptionPane.showMessageDialog(
						this,
						"Selezionare un elemento dalla lista",
						"Attenzione",
						JOptionPane.WARNING_MESSAGE);
	}
		
		
		

	}

	private void updateTot() {

		MetanoEstrattoVendutoTM model =	(MetanoEstrattoVendutoTM) jTable.getModel();

		Iterator it = model.getRecords().iterator();
		BigInteger totale = BigInteger.valueOf(0);
		while (it.hasNext()) {
			MetanoEstrattoVenduto record = (MetanoEstrattoVenduto) it.next();
			totale = totale.add(record.getMetriCubi());
		}
		
		totaleRecord.setMetriCubi(totale);
	   
		jTextFieldTotale.setText(String.valueOf(totale));
		
	}

	public void valueChanged(ListSelectionEvent event) {
		if (event.getSource() == jTable.getSelectionModel()) {
			loadFieldsForEditing();
		}
	}

	private void loadFieldsForEditing() {
		MetanoEstrattoVendutoTM model =
			(MetanoEstrattoVendutoTM) jTable.getModel();
		int selectedRow = jTable.getSelectedRow();
		if (selectedRow == -1) {
		} else {
			MetanoEstrattoVenduto record =
				(MetanoEstrattoVenduto) model.getRecord(selectedRow);
			jTextFieldCodAccisa.setText(
				String.valueOf(record.getCodiceAcc()));
			jTextFieldMetriCubi.setText(String.valueOf(record.getMetriCubi()));
			jComboBoxTipologiaEstrazione.setSelectedItem(
				ComboDataSource.getInstance().getTipologiaEstrazioneVendita(
					quadro.getLettera(),
					record.getTipEstrazioneVendita()));

		}
	}

	private void clearFieldsForEditing() {
		jTextFieldCodAccisa.setText(null);
		jTextFieldMetriCubi.setText(null);
		jComboBoxTipologiaEstrazione.setSelectedItem(null);
	}

	private javax.swing.JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(null);
			jContentPane.setLayout(FullScreenLayoutManager.getInstance());
			jContentPane.add(getJPanel(), null);
			jContentPane.add(getJPanel1(), null);
			jContentPane.add(getJButtonConferma(), null);
			jContentPane.add(getJButtonChiudi(), null);
		}
		return jContentPane;
	}
	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel() {
		if (jPanel == null) {
			jPanel = new javax.swing.JPanel();
			jPanel.setLayout(null);
			jPanel.setLayout(FullScreenLayoutManager.getInstance());
			jPanel.add(getJLabelMese(), null);
			jPanel.add(getJLabelTitoloQuadro(), null);
			jPanel.add(getJLabelNomeQuadro(), null);
			jPanel.setBounds(25, 5, 741, 42);
			jPanel.setBackground(java.awt.Color.lightGray);
			jPanel.setBorder(
				javax.swing.BorderFactory.createLineBorder(
					java.awt.Color.gray,
					1));
		}
		return jPanel;
	}
	/**
	 * This method initializes jLabelMese
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelMese() {
		if (jLabelMese == null) {
			jLabelMese = new javax.swing.JLabel();
			jLabelMese.setBounds(629, 2, 111, 19);
			jLabelMese.setText("");
			jLabelMese.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
		}
		return jLabelMese;
	}
	/**
	 * This method initializes jLabelTitoloQuadro
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelTitoloQuadro() {
		if (jLabelTitoloQuadro == null) {
			jLabelTitoloQuadro = new javax.swing.JLabel();
			jLabelTitoloQuadro.setBounds(1, 20, 140, 19);
			jLabelTitoloQuadro.setText("");
			jLabelTitoloQuadro.setHorizontalAlignment(
				javax.swing.SwingConstants.LEFT);
			jLabelTitoloQuadro.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
			jLabelTitoloQuadro.setFont(
				new java.awt.Font("Dialog", java.awt.Font.BOLD, 18));
		}
		return jLabelTitoloQuadro;
	}
	/**
	 * This method initializes jLabelNomeQuadro
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelNomeQuadro() {
		if (jLabelNomeQuadro == null) {
			jLabelNomeQuadro = new javax.swing.JLabel();
			jLabelNomeQuadro.setBounds(379, 20, 361, 19);
			jLabelNomeQuadro.setText("");
			jLabelNomeQuadro.setFont(
				new java.awt.Font("Dialog", java.awt.Font.BOLD, 14));
			jLabelNomeQuadro.setHorizontalAlignment(
				javax.swing.SwingConstants.RIGHT);
		}
		return jLabelNomeQuadro;
	}
	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel1() {
		if (jPanel1 == null) {
			jPanel1 = new javax.swing.JPanel();
			jPanel1.setLayout(null);
			jPanel1.setLayout(FullScreenLayoutManager.getInstance());
			jPanel1.add(getJScrollPane(), null);
			jPanel1.add(getJTextFieldTotale(), null);
			jPanel1.add(getJLabel4(), null);
			jPanel1.add(getJTextFieldMetriCubi(), null);
			jPanel1.add(getJTextFieldCodAccisa(), null);
			jPanel1.add(getJComboBoxTipologiaEstrazione(), null);
			jPanel1.add(getJButtonElimina(), null);
			jPanel1.add(getJButtonModifica(), null);
			jPanel1.add(getJButtonInserisci(), null);

			jPanel1.add(getJLabel1(), null);
			jPanel1.add(getJLabel2(), null);
			jPanel1.add(getJLabel5(), null);
			jPanel1.setBounds(25, 53, 741, 382);
			jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Quantit", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
			jPanel1.setBackground(java.awt.Color.lightGray);
		}
		return jPanel1;
	}
	/**
	 * This method initializes jTable
	 * 
	 * @return javax.swing.JTable
	 */
	private javax.swing.JTable getJTable() {
		if (jTable == null) {
			jTable = new javax.swing.JTable();
			jTable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
			jTable.getSelectionModel().setSelectionMode(
				ListSelectionModel.SINGLE_SELECTION);
			jTable.getSelectionModel().addListSelectionListener(this);
		}
		return jTable;
	}
	/**
	 * This method initializes jScrollPane
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private javax.swing.JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new javax.swing.JScrollPane();
			jScrollPane.setBounds(13, 31, 712, 234);
			jScrollPane.setViewportView(getJTable());
		}
		return jScrollPane;
	}
	/**
	 * This method initializes jTextFieldTotale
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldTotale() {
		if (jTextFieldTotale == null) {
			jTextFieldTotale = new javax.swing.JTextField();
			jTextFieldTotale.setBounds(527, 268, 201, 21);
			jTextFieldTotale.setDocument(new BigIntegerDocument(MetanoEstrattoVenduto.dimMetriCubi));
		}
		return jTextFieldTotale;
	}
	/**
	 * This method initializes jLabel4
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel4() {
		if (jLabel4 == null) {
			jLabel4 = new javax.swing.JLabel();
			jLabel4.setBounds(326, 268,201, 21);
			jLabel4.setText("Totale");
			jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
			jLabel4.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabel4;
	}
	/**
	 * This method initializes jTextFieldMetriCubi
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldMetriCubi() {
		if (jTextFieldMetriCubi == null) {
			jTextFieldMetriCubi = new javax.swing.JTextField();
			jTextFieldMetriCubi.setBounds(527, 319, 201, 21);
			jTextFieldMetriCubi.setDocument(new BigIntegerDocument(MetanoEstrattoVenduto.dimMetriCubi));
			
			jTextFieldMetriCubi.addFocusListener(this);
		}
		return jTextFieldMetriCubi;
	}
	/**
	 * This method initializes jTextFieldCodAccisa
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldCodAccisa() {
		if (jTextFieldCodAccisa == null) {
			jTextFieldCodAccisa = new javax.swing.JTextField();
			jTextFieldCodAccisa.setBounds(326, 319, 201, 21);
			jTextFieldCodAccisa.setDocument(new StringDocument(MetanoEstrattoVenduto.dimCodiceAccisa));
			jTextFieldCodAccisa.addFocusListener(this);
		}
		return jTextFieldCodAccisa;
	}
	/**
	 * This method initializes jComboBoxTipologiaEstrazione
	 * 
	 * @return javax.swing.JComboBox
	 */
	private javax.swing.JComboBox getJComboBoxTipologiaEstrazione() {
		if (jComboBoxTipologiaEstrazione == null) {
			jComboBoxTipologiaEstrazione = new javax.swing.JComboBox();
			jComboBoxTipologiaEstrazione.setBounds(14, 319, 311, 21);
			jComboBoxTipologiaEstrazione.setSelectedIndex(-1);
		}
		return jComboBoxTipologiaEstrazione;
	}
	/**
	 * This method initializes jButtonElimina
	 * 
	 * @return javax.swing.JButton
	 */

	/**
	 * This method initializes jButtonElimina
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonElimina() {
		if (jButtonElimina == null) {
			jButtonElimina = new javax.swing.JButton();
			jButtonElimina.setBounds(644, 344, 83, 27);
			jButtonElimina.setText("Elimina");
			jButtonElimina.addActionListener(this);
		}
		return jButtonElimina;
	}
	/**
	 * This method initializes jButtonModifica
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonModifica() {
		if (jButtonModifica == null) {
			jButtonModifica = new javax.swing.JButton();
			jButtonModifica.setBounds(547, 344, 83, 27);
			jButtonModifica.setText("Modifica");
			jButtonModifica.addActionListener(this);
		}
		return jButtonModifica;
	}
	/**
	 * This method initializes jButtonInserisci
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonInserisci() {
		if (jButtonInserisci == null) {
			jButtonInserisci = new javax.swing.JButton();
			jButtonInserisci.setBounds(448, 344, 83, 27);
			jButtonInserisci.setText("Inserisci");
			jButtonInserisci.addActionListener(this);
		}
		return jButtonInserisci;
	}
	/**
	 * This method initializes jButtonConferma
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonConferma() {
		if (jButtonConferma == null) {
			jButtonConferma = new javax.swing.JButton();
			jButtonConferma.setBounds(24, 446, 91, 27);
			jButtonConferma.setText("Conferma");
			jButtonConferma.addActionListener(this);
		}
		return jButtonConferma;
	}
	/**
	 * This method initializes jButtonChiudi
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonChiudi() {
		if (jButtonChiudi == null) {
			jButtonChiudi = new javax.swing.JButton();
			jButtonChiudi.setBounds(123, 446, 91, 27);
			jButtonChiudi.setText("Chiudi");
			jButtonChiudi.addActionListener(this);
		}
		return jButtonChiudi;
	}
	
			
		private int validateExitText() {
			int retvalue = JOptionPane.NO_OPTION;
			if(flagModifica==true) {
				retvalue = JOptionPane.showConfirmDialog(this, "Le modifiche effettutate verranno perse. Vuoi salvare le modifiche?", "", JOptionPane.YES_NO_CANCEL_OPTION);
			}
			return retvalue;
		}			
	/**
	 * This method initializes jLabel1
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel1() {
		if (jLabel1 == null) {
			jLabel1 = new javax.swing.JLabel();
			jLabel1.setBounds(14, 300, 311, 19);
			jLabel1.setText("Tipologia di vendita");
			jLabel1.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
			jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}
		return jLabel1;
	}
	/**
	 * This method initializes jLabel2
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel2() {
		if (jLabel2 == null) {
			jLabel2 = new javax.swing.JLabel();
			jLabel2.setBounds(326, 300, 201, 19);
			jLabel2.setText("Codice accisa destinatario");
			jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}
		return jLabel2;
	}
	/**
	 * This method initializes jLabel5
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel5() {
		if (jLabel5 == null) {
			jLabel5 = new javax.swing.JLabel();
			jLabel5.setBounds(527, 300, 201, 19);
			jLabel5.setText("Metri cubi");
			jLabel5.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}
		return jLabel5;
	}

	class ComuneComboCellRenderer extends DefaultListCellRenderer {

		public Component getListCellRendererComponent(
			JList list,
			Object value,
			int index,
			boolean isSelected,
			boolean cellHasFocus) {

			if (value instanceof TipoComune) {
				value = ((TipoComune) value).toDefaultStyleString();
			}

			return super.getListCellRendererComponent(
				list,
				value,
				index,
				isSelected,
				cellHasFocus);
		}

	}

	private boolean validaCodiceAccisa() {
		boolean isOk = true;
		AbstractTipo tipologiaEstrazione = (AbstractTipo)jComboBoxTipologiaEstrazione.getSelectedItem();
		String codiceAccisa = StringUtil.nullify(getJTextFieldCodAccisa().getText());
		
		if(quadro.getTipiRecord().equals(Quadro.QUADRO_B) && tipologiaEstrazione.getCodice().equalsIgnoreCase("B")) {
		} else {
			if(codiceAccisa == null) {
				JOptionPane.showMessageDialog(
					this,
					"Il codice accisa per la tipologia di estrazione selezionata  obbigatorio",
					"Attenzione",
					JOptionPane.WARNING_MESSAGE);

				isOk = false;
			}
		}
		if(isOk) {
			if(codiceAccisa != null && !Validator.isCodiceDittaForMetano(codiceAccisa)) {
				JOptionPane.showMessageDialog(
					this,
					"Il codice accisa non  valido",
					"Attenzione",
					JOptionPane.WARNING_MESSAGE);

				isOk = false;
			}
		}
		
		return isOk;
	}

} //  @jve:visual-info  decl-index=0 visual-constraint="13,16"
