/*
 * Created on 28-set-06
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 * 
 */
package it.finanze.dogane.accise.metano.ui;


/**
 * @author Fiorello
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
import it.finanze.dogane.accise.combo.TipoFasciaClimatica;
import it.finanze.dogane.accise.combo.TipoMese;
import it.finanze.dogane.accise.combo.TipoProvincia;
import it.finanze.dogane.accise.metano.model.Frontespizio;
import it.finanze.dogane.accise.metano.model.MetanoFatturatoImpiegato;
import it.finanze.dogane.accise.metano.model.ProspettoConsumo;
import it.finanze.dogane.accise.metano.ui.quadri.Parametri;
import it.finanze.dogane.accise.metano.ui.quadri.Quadro;
import it.finanze.dogane.accise.metano.ui.tablemodel.MetanoFatturatoImpiegatoTM;
import it.finanze.dogane.accise.model.Prospect;
import it.finanze.dogane.accise.pdf.PdfBuilder;
import it.finanze.dogane.accise.pdf.PdfPrintable;
import it.finanze.dogane.accise.ui.FullScreenLayoutManager;
import it.finanze.dogane.accise.ui.RealDim;
import it.finanze.dogane.accise.ui.TableUtil;
import it.finanze.dogane.accise.ui.quadri.GestoreQuadro;
import it.finanze.dogane.accise.ui.quadri.dialog.QuadroDialog;
import it.finanze.dogane.accise.ui.validation.BigIntegerDocument;
import it.finanze.dogane.accise.ui.validation.SignedBigIntegerDocument;
import it.finanze.dogane.accise.util.StringUtil;

import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.math.BigInteger;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

public class MetanoFatturatoImpiegatoDialog
	extends JDialog
	implements ActionListener, ListSelectionListener, QuadroDialog, PdfPrintable {
	private javax.swing.JPanel jContentPane = null;

	private javax.swing.JPanel jPanel = null;
	private javax.swing.JLabel jLabelNomeQuadro = null;
	private javax.swing.JLabel jLabelTitoloQuadro = null;
	private javax.swing.JLabel jLabelProvincia = null;
	private javax.swing.JLabel jLabelMese = null;
	private javax.swing.JLabel jLabelCampo3 = null;
	private javax.swing.JTextField jTextFieldQuantita = null;
	private javax.swing.JButton jButtonElimina = null;
	private javax.swing.JButton jButtonImposta = null;
	private javax.swing.JScrollPane jScrollPane = null;
	private javax.swing.JTable jTable = null;
	private javax.swing.JButton jButtonConferma = null;
	private javax.swing.JButton jButtonChiudi = null;

	private ProspettoConsumo prospettoConsumo = null;
	private Quadro quadro = null;
	private TipoMese tipoMese = null;
	private TipoProvincia tipoProvincia = null;
	private TipoFasciaClimatica fasciaClimatica = null;
	private BigInteger totale = BigInteger.valueOf(0);

    private boolean flagModifica=false;
	private javax.swing.JLabel jLabel = null;
	private javax.swing.JTextField jTextFieldNumUtenze = null;
	private javax.swing.JLabel jLabel1 = null;
	/**
	 * This is the default constructor
	 */
	public MetanoFatturatoImpiegatoDialog(
		Frame frame,
		String description,
		String secondDescription) {
		super(frame, "Prospetto mensile del metano fatturato o impiegato per fascie climatiche", true);
		initialize();

		jLabelNomeQuadro.setText(description);
		jLabelTitoloQuadro.setText(secondDescription);
		// default button
		this.getRootPane().setDefaultButton(getJButtonImposta());
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		//this.setSize(800, 600);
		this.setSize(RealDim.getAbsoluteXValue(800), RealDim.getAbsoluteYValue(600));
		this.setContentPane(getJContentPane());
		this.setLocation(0, 0);
		this.setResizable(false);
		this.setModal(true);
		this.setDefaultCloseOperation(
			javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
	}

	public void prepareValues(Prospect prospect, GestoreQuadro gestoreQuadro) {

		prospettoConsumo = (ProspettoConsumo) prospect;
		Frontespizio frontespizio = prospettoConsumo.getFrontespizio();

		this.quadro = (Quadro) gestoreQuadro;
		List lista = prospettoConsumo.getListaQuadro(quadro.getTipiRecord());

		Parametri parametriSelezionati = (Parametri) quadro.getParameter();
		tipoProvincia = parametriSelezionati.getProvincia();
		tipoMese = parametriSelezionati.getMese();
		if (parametriSelezionati.getFasciaClimatica()!=null) {
			fasciaClimatica = parametriSelezionati.getFasciaClimatica();
		}
		boolean isAnnuale = false;
		lista =	Quadro.getListaRecordParametrizzato(lista,parametriSelezionati,quadro);
		
		/** MODIFICA 13-11-2007 **/			
		if (lista.size()==0 && (tipoMese.getCodice().trim().equals("0")||tipoMese.getCodice().trim().equals("00"))) { // Modifica annullata 17/01/2008 if ((tipoMese.getCodice().trim().equals("0")||tipoMese.getCodice().trim().equals("00"))){//lista.size()==0 &&
			// se il mese selezionato  annuale e non esiste tale record sul file
			// devo calcolare l'annuale per la pronvincia specificata
			lista = calcoloAnnuale();
			isAnnuale= true;
		}
		
		if (!tipoMese.getCodice().trim().equals("0") && !tipoMese.getCodice().trim().equals("00")) {
			getJLabelMese().setText("Mese di " + tipoMese.getDescrizione());
		} else {
			getJLabelMese().setText("Annuale");
			jTextFieldNumUtenze.setVisible(true);
			jLabel.setVisible(true);
			jLabel1.setVisible(true);
		}
		
		if (isAnnuale){
						if(quadro.getLettera().equals("E")){
						super.setTitle("Prospetto annuale del gas naturale fatturato o impiegato");
						}else if (quadro.getLettera().equals("F")){
						super.setTitle("Prospetto annuale del gas naturale fatturato o impiegato");
							}else if (quadro.getLettera().equals("G")){
					super.setTitle("Prospetto annuale del gas naturale fatturato o impiegato");
						}				
				}		
	
		boolean quadroCondition=Quadro.QUADRO_F.equals(quadro.getTipiRecord());
		if (quadroCondition && fasciaClimatica!=null && fasciaClimatica.getCodice()!=null)
			getJLabelProvincia().setText("Provincia di " + tipoProvincia.getDescrizione() + " - Fascia climatica: " + fasciaClimatica.getCodice().trim());
		else {
			getJLabelProvincia().setText("Provincia di " + tipoProvincia.getDescrizione());
		}

		MetanoFatturatoImpiegatoTM model = new MetanoFatturatoImpiegatoTM(lista,quadro.getTipiRecord(),tipoMese.getDescrizione());
		jTable.setModel(model);
		TableUtil.redimTable(jTable, jScrollPane);
	}

	private List calcoloAnnuale() {
		List annualeList = new LinkedList();
		List listAll = prospettoConsumo.getListaQuadro(quadro.getTipiRecord());
		BigInteger mese = BigInteger.valueOf(0);
		// inizializzo la lista annuale con tutti i record identificativi di un solo mese...
		// inizializzo la lista dei totali
		int[] identifiers = null;
		if(quadro.getTipiRecord().equals(Quadro.QUADRO_F)) {
			identifiers = MetanoFatturatoImpiegatoTM.QUADRO_F_IDENTIFIERS; 
		} else if(quadro.getTipiRecord().equals(Quadro.QUADRO_G)) {
			identifiers = MetanoFatturatoImpiegatoTM.QUADRO_G_IDENTIFIERS; 
		}
		for(int y=0; y<identifiers.length; y++) {
			MetanoFatturatoImpiegato record = MetanoFatturatoImpiegato.getNewObject(prospettoConsumo);
			record.setProgIdRigo(BigInteger.valueOf(identifiers[y]));
			record.setMese(new BigInteger("0"));
			record.setTipoRecord(BigInteger.valueOf(quadro.getTipiRecord()[0]));				
			if (fasciaClimatica!=null)record.setFasciaClimatica(fasciaClimatica.getCodice());
			record.setProvincia(tipoProvincia.getCodice());
			record.setLetteraIdQuadro(quadro.getLettera());
			annualeList.add(record);
		}
		// ora devo calcolare i totali per ogni record e sommarli a quella della lista annuale
		Iterator itAnnuale = annualeList.iterator();
		while (itAnnuale.hasNext()) {
			MetanoFatturatoImpiegato recordAnnuale =(MetanoFatturatoImpiegato) itAnnuale.next();
			String annualeProvincia = StringUtil.denullify( StringUtil.trim(recordAnnuale.getProvincia()) );
			String annualeFascia =  StringUtil.denullify( StringUtil.trim(recordAnnuale.getFasciaClimatica()) );
			Iterator itAll = listAll.iterator();
			while (itAll.hasNext()) {
				MetanoFatturatoImpiegato recordGenerico =(MetanoFatturatoImpiegato) itAll.next();
				if (recordGenerico.getProgIdRigo().equals(recordAnnuale.getProgIdRigo())) {
					String genericaProvincia = StringUtil.denullify( StringUtil.trim(recordGenerico.getProvincia()) );
					String genericaFascia =  StringUtil.denullify( StringUtil.trim(recordGenerico.getFasciaClimatica()) );
					if(annualeProvincia.equals(genericaProvincia) && annualeFascia.equals(genericaFascia)) {
						recordAnnuale.setQuantita(recordAnnuale.getQuantita().add(recordGenerico.getQuantita()));
						recordAnnuale.setNumUtenze(recordAnnuale.getNumUtenze().add(recordGenerico.getNumUtenze()));
					}
				}
			}
		}
		return annualeList;
	}

	public void plot(PdfBuilder pdfBuilder) {
		pdfBuilder.startCommandBlock();
		pdfBuilder.writeCenteredLabel(this.getTitle(), 14);
		pdfBuilder.moveYPen(44);
		//SALVATORE
		pdfBuilder.endCommandBlock();
		pdfBuilder.startDefineTableHeader();		
		//
		
		
		pdfBuilder.setXPen(PdfBuilder.MARGINE);
		pdfBuilder.writeLeftLabel(jLabelProvincia.getText(), 12);
		pdfBuilder.moveYPen(-14);
		pdfBuilder.writeRightLabel(jLabelMese.getText(), 12);
	
		pdfBuilder.moveYPen(10);
		pdfBuilder.writeLeftLabel(jLabelNomeQuadro.getText(), 12);
		pdfBuilder.moveYPen(-14);
		pdfBuilder.writeRightLabel(jLabelTitoloQuadro.getText(), 12);
		pdfBuilder.moveYPen(10);
		//SALVATORE
		//pdfBuilder.endCommandBlock();
		pdfBuilder.endDefineTableHeader();		
		//

		pdfBuilder.writeTable(this, jTable, jScrollPane);
		pdfBuilder.moveYPen(20);
	}

	public void valueChanged(ListSelectionEvent event) {
		if (event.getSource() == jTable.getSelectionModel()) {
			loadFieldsForEditing();
		}
		if (!this.getJTextFieldNumUtenze().isVisible()) {
			this.getJTextFieldQuantita().grabFocus();
			this.getJTextFieldQuantita().selectAll();
		}
		else {
			this.getJTextFieldNumUtenze().grabFocus();
			this.getJTextFieldNumUtenze().selectAll();
		}
	}

	/**************************************************************************************
	 * INIZIO GESTIONE EVENTI
	 **************************************************************************************/

	public void actionPerformed(ActionEvent event) {
		if (event.getSource() == jButtonChiudi) {
			doClose();
		} else if (event.getSource() == jButtonConferma) {
			doConfirm();
		} else if (event.getSource() == jButtonElimina) {
			doDelete();
		} else if (event.getSource() == jButtonImposta) {
			doInsert();
		}
	}

	private void doClose() {
		int val = validateExitText();
			if(val == JOptionPane.YES_OPTION) {
				doConfirm();
			} else if(val == JOptionPane.NO_OPTION) {
				this.setVisible(false);
			} else if(val == JOptionPane.CANCEL_OPTION) {
			}
	}
	private void doConfirm() {
		MetanoFatturatoImpiegatoTM model = (MetanoFatturatoImpiegatoTM) jTable.getModel();
		List listaQuadroXParametri = model.getRecords();
		List listaQuadroCompleta =
			prospettoConsumo.getListaQuadro(quadro.getTipiRecord());
		
		/** MODIFICA 24-10-2007 **/
		if(listaQuadroXParametri.size() >0) {
			quadro.setEmpty(false);
		}
		else
			quadro.setEmpty(true);
		// Elimino i vecchi record con il mese e provincia in modifica
		Iterator it = listaQuadroCompleta.iterator();
		while (it.hasNext()) {
			MetanoFatturatoImpiegato record = (MetanoFatturatoImpiegato) it.next();
			if (record.getProvincia().equals(tipoProvincia.getCodice())
				&& record.getMese().toString().equals(tipoMese.getCodice())) {
					
					if(fasciaClimatica != null) {
						String current = fasciaClimatica.getCodice();
						String fasciaRec = record.getFasciaClimatica();
						if(fasciaRec != null && current != null && current.equals(fasciaRec)) {
							it.remove();
						}
					} else {
						if(StringUtil.nullify(record.getFasciaClimatica()) == null) {
							it.remove();
						}
					}
			}
		}

		// Aggiungo i nuovi record per il mese in modifica
		listaQuadroCompleta.addAll(listaQuadroXParametri);

		// Imposto tutto sul modello! Finally!!!!!
		prospettoConsumo.setListaQuadro(
			listaQuadroCompleta,
			quadro.getTipiRecord());
		this.setVisible(false);
	}
	private void doUpdate() {
		MetanoFatturatoImpiegatoTM model = (MetanoFatturatoImpiegatoTM) jTable.getModel();
		int selectedRow = jTable.getSelectedRow();
		if (selectedRow != -1) {
			MetanoFatturatoImpiegato record = (MetanoFatturatoImpiegato) model.getRecord(selectedRow);
			if (record == null) {
				doInsert();
			} else {
				loadRecordFromUI(record);
				model.fireTableRowsUpdated(selectedRow, selectedRow);
				jTable.getSelectionModel().setSelectionInterval(
					selectedRow,
					selectedRow);
					flagModifica=true;
			}
		}else {
		JOptionPane.showMessageDialog(
						this,
						"Selezionare un elemento dalla lista",
						"Attenzione",
						JOptionPane.WARNING_MESSAGE);
	}

	}

	private void updateTot() {

		MetanoFatturatoImpiegatoTM model =(MetanoFatturatoImpiegatoTM) jTable.getModel();
		Iterator it = model.getRecords().iterator();
		BigInteger totale = BigInteger.valueOf(0);
		while (it.hasNext()) {
			MetanoFatturatoImpiegato record =(MetanoFatturatoImpiegato) it.next();
			totale = totale.add(record.getQuantita());
		}

		jTextFieldQuantita.setText(String.valueOf(totale));

	}

	private void doInsert() {

		MetanoFatturatoImpiegatoTM model =(MetanoFatturatoImpiegatoTM) jTable.getModel();
		int selectedRow = jTable.getSelectedRow();
		if (selectedRow != -1) {
			MetanoFatturatoImpiegato record =(MetanoFatturatoImpiegato) model.getRecord(selectedRow);
			if (record != null) {
				doUpdate();
			} else {
				record = MetanoFatturatoImpiegato.getNewObject(prospettoConsumo);
				record.setTipoRecord(
					BigInteger.valueOf(quadro.getTipiRecord()[0]));
				record.setProvincia(tipoProvincia.getCodice());
				record.setLetteraIdQuadro(quadro.getLettera());
				record.setMese(new BigInteger(tipoMese.getCodice()));
				record.setNumUtenze(BigInteger.valueOf(00000000));
				loadRecordFromUI(record);
				model.setRecord(selectedRow, record);
 				flagModifica=true;
				jTable.getSelectionModel().setSelectionInterval(
					selectedRow,
					selectedRow);
			}
		}else {
		JOptionPane.showMessageDialog(
						this,
						"Selezionare un elemento dalla lista",
						"Attenzione",
						JOptionPane.WARNING_MESSAGE);
	}

	}

	private void loadRecordFromUI(MetanoFatturatoImpiegato record) {
		String str = null;

		try {
			str = jTextFieldQuantita.getText();
			BigInteger d = new BigInteger(str);
			record.setQuantita(d);
			record.setProvincia(tipoProvincia.getCodice());
			record.setMese(new BigInteger(tipoMese.getCodice()));
			if (fasciaClimatica!=null && fasciaClimatica.getCodice()!=null) record.setFasciaClimatica(fasciaClimatica.getCodice());
		} catch (NumberFormatException e) {
			record.setQuantita(BigInteger.valueOf(0));
		}try {
			str = jTextFieldNumUtenze.getText();
			BigInteger d = new BigInteger(str);
			record.setNumUtenze(d);
		} catch (NumberFormatException e) {
		record.setNumUtenze(BigInteger.valueOf(0));
		}
	}

	/**
	 * 
	 */
	private void doDelete() {
		MetanoFatturatoImpiegatoTM model =(MetanoFatturatoImpiegatoTM) jTable.getModel();
		int selectedRow = jTable.getSelectedRow();
		if (selectedRow != -1) {
			model.removeRecord(selectedRow);
			clearFieldsForEditing();
			jTable.getSelectionModel().setSelectionInterval(
				selectedRow,
				selectedRow);
				flagModifica=true;
		}else {
		JOptionPane.showMessageDialog(
						this,
						"Selezionare un elemento dalla lista",
						"Attenzione",
						JOptionPane.WARNING_MESSAGE);
	}

	}

	private void loadFieldsForEditing() {
		MetanoFatturatoImpiegatoTM model =(MetanoFatturatoImpiegatoTM) jTable.getModel();
		int selectedRow = jTable.getSelectedRow();
		if (selectedRow == -1) {
		} else {
			MetanoFatturatoImpiegato record =(MetanoFatturatoImpiegato) model.getRecord(
					selectedRow);
			if (record == null && selectedRow != 11) {
				clearFieldsForEditing();
			} else {
				if (selectedRow == 11) {
					updateTot();
				} else {
					jTextFieldQuantita.setText(String.valueOf(record.getQuantita()));
					jTextFieldNumUtenze.setText(String.valueOf(record.getNumUtenze()));
				}
			}
		}
	}

	private void clearFieldsForEditing() {
		jTextFieldQuantita.setText(null);
		jTextFieldNumUtenze.setText(null);

	}

	/**************************************************************************************
	 * FINE GESTIONE EVENTI
	 **************************************************************************************/

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(null);
			jContentPane.setLayout(FullScreenLayoutManager.getInstance());
			jContentPane.add(getJPanel(), null);
			jContentPane.add(getJLabelNomeQuadro(), null);
			jContentPane.add(getJLabelTitoloQuadro(), null);
			jContentPane.add(getJLabelProvincia(), null);
			jContentPane.add(getJLabelMese(), null);
			jContentPane.add(getJButtonConferma(), null);
			jContentPane.add(getJButtonChiudi(), null);
		}
		return jContentPane;
	}
	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel() {
		if (jPanel == null) {
			jPanel = new javax.swing.JPanel();
			jPanel.setLayout(null);
			jPanel.setLayout(FullScreenLayoutManager.getInstance());
			jPanel.add(getJLabelCampo3(), null);
			jPanel.add(getJTextFieldQuantita(), null);
			jPanel.add(getJButtonElimina(), null);
			jPanel.add(getJButtonImposta(), null);
			jPanel.add(getJScrollPane(), null);
			jPanel.add(getJLabel(), null);
			jPanel.add(getJTextFieldNumUtenze(), null);
			jPanel.add(getJLabel1(), null);
			jPanel.setBounds(20, 60, 760, 451);
			//			jPanel.setBounds(RealDim.getAbsoluteXValue(20), RealDim.getAbsoluteYValue(132), RealDim.getAbsoluteXValue(755), RealDim.getAbsoluteYValue(289));
			jPanel.setBackground(java.awt.Color.lightGray);
			jPanel.setBorder(
				javax.swing.BorderFactory.createLineBorder(
					java.awt.Color.black,
					1));
		}
		return jPanel;
	}
	/**
	 * This method initializes jLabelNomeQuadro
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelNomeQuadro() {
		if (jLabelNomeQuadro == null) {
			jLabelNomeQuadro = new javax.swing.JLabel();
			jLabelNomeQuadro.setBounds(20, 40, 186, 19);
			//			jLabelNomeQuadro.setBounds(RealDim.getAbsoluteXValue(23), RealDim.getAbsoluteYValue(102), RealDim.getAbsoluteXValue(186), RealDim.getAbsoluteYValue(19));
			jLabelNomeQuadro.setText("");
			jLabelNomeQuadro.setHorizontalAlignment(
				javax.swing.SwingConstants.LEFT);
			jLabelNomeQuadro.setFont(
				new java.awt.Font("Dialog", java.awt.Font.BOLD, 18));
		}
		return jLabelNomeQuadro;
	}
	/**
	 * This method initializes jLabelTitoloQuadro
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelTitoloQuadro() {
		if (jLabelTitoloQuadro == null) {
			jLabelTitoloQuadro = new javax.swing.JLabel();
			jLabelTitoloQuadro.setBounds(240, 40, 542, 19);
			//			jLabelTitoloQuadro.setBounds(RealDim.getAbsoluteXValue(245), RealDim.getAbsoluteYValue(102), RealDim.getAbsoluteXValue(528), RealDim.getAbsoluteYValue(18));
			jLabelTitoloQuadro.setText("");
			jLabelTitoloQuadro.setHorizontalAlignment(
				javax.swing.SwingConstants.RIGHT);
		}
		return jLabelTitoloQuadro;
	}
	/**
	 * This method initializes jLabelProvincia
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelProvincia() {
		if (jLabelProvincia == null) {
			jLabelProvincia = new javax.swing.JLabel();
			jLabelProvincia.setBounds(20, 20, 420, 19);
			//			jLabelProvincia.setBounds(RealDim.getAbsoluteXValue(22), RealDim.getAbsoluteYValue(78), RealDim.getAbsoluteXValue(410), RealDim.getAbsoluteYValue(18));
			jLabelProvincia.setText("");
			jLabelProvincia.setHorizontalAlignment(
				javax.swing.SwingConstants.LEFT);
		}
		return jLabelProvincia;
	}
	/**
	 * This method initializes jLabelMese
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelMese() {
		if (jLabelMese == null) {
			jLabelMese = new javax.swing.JLabel();
			jLabelMese.setBounds(440, 20, 341, 19);
			//			jLabelMese.setBounds(RealDim.getAbsoluteXValue(449), RealDim.getAbsoluteYValue(78), RealDim.getAbsoluteXValue(324), RealDim.getAbsoluteYValue(19));
			jLabelMese.setText("");
			jLabelMese.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
		}
		return jLabelMese;
	}
	/**
	 * This method initializes jLabelCampo3
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelCampo3() {
		if (jLabelCampo3 == null) {
			jLabelCampo3 = new javax.swing.JLabel();
			jLabelCampo3.setBounds(593, 360, 157, 19);
			//			jLabelCampo3.setBounds(RealDim.getAbsoluteXValue(602), RealDim.getAbsoluteYValue(13), RealDim.getAbsoluteXValue(134), RealDim.getAbsoluteYValue(20));
			jLabelCampo3.setText("Quantit metri cubi");
			jLabelCampo3.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabelCampo3.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabelCampo3;
	}
	/**
	 * This method initializes jTextFieldQuantita
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldQuantita() {
		if (jTextFieldQuantita == null) {
			jTextFieldQuantita = new javax.swing.JTextField();
			jTextFieldQuantita.setBounds(593, 383, 157, 21);
			//			jTextFieldQuantita.setBounds(RealDim.getAbsoluteXValue(600), RealDim.getAbsoluteYValue(197), RealDim.getAbsoluteXValue(140), RealDim.getAbsoluteYValue(19));
			jTextFieldQuantita.setDocument(new SignedBigIntegerDocument(MetanoFatturatoImpiegato.getDimQuantita()));
		}
		return jTextFieldQuantita;
	}
	/**
	 * This method initializes jButtonElimina
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonElimina() {
		if (jButtonElimina == null) {
			jButtonElimina = new javax.swing.JButton();
			jButtonElimina.setBounds(654, 410, 93, 27);
			//			jButtonElimina.setBounds(RealDim.getAbsoluteXValue(603), RealDim.getAbsoluteYValue(238), RealDim.getAbsoluteXValue(93), RealDim.getAbsoluteYValue(24));
			jButtonElimina.setText("Elimina");

			jButtonElimina.addActionListener(this);
		}
		return jButtonElimina;
	}
	/**
	 * This method initializes jButtonImposta
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonImposta() {
		if (jButtonImposta == null) {
			jButtonImposta = new javax.swing.JButton();
			jButtonImposta.setBounds(557, 410, 93, 27);
			//			jButtonImposta.setBounds(RealDim.getAbsoluteXValue(393), RealDim.getAbsoluteYValue(238), RealDim.getAbsoluteXValue(93), RealDim.getAbsoluteYValue(24));
			jButtonImposta.setText("Imposta");

			jButtonImposta.addActionListener(this);
		}
		return jButtonImposta;
	}
	/**
	 * This method initializes jTable
	 * 
	 * @return javax.swing.JTable
	 */
	private javax.swing.JTable getJTable() {
		if (jTable == null) {
			jTable = new javax.swing.JTable();
			jTable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
			jTable.setSelectionMode(
				javax.swing.ListSelectionModel.SINGLE_SELECTION);

			jTable.getSelectionModel().setSelectionMode(
				ListSelectionModel.SINGLE_SELECTION);

			jTable.getSelectionModel().addListSelectionListener(this);
		}
		return jTable;
	}
	/**
	 * This method initializes jScrollPane
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private javax.swing.JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new javax.swing.JScrollPane();
			jScrollPane.setBounds(8, 6, 744, 332);
			//			jScrollPane.setBounds(RealDim.getAbsoluteXValue(7), RealDim.getAbsoluteYValue(39), RealDim.getAbsoluteXValue(732), RealDim.getAbsoluteYValue(156));
			jScrollPane.setViewportView(getJTable());
		}
		return jScrollPane;
	}
	/**
	 * This method initializes jButtonConferma
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonConferma() {
		if (jButtonConferma == null) {
			jButtonConferma = new javax.swing.JButton();
			jButtonConferma.setBounds(40, 520, 100, 27);
			//			jButtonConferma.setBounds(RealDim.getAbsoluteXValue(25), RealDim.getAbsoluteYValue(447), RealDim.getAbsoluteXValue(100), RealDim.getAbsoluteYValue(27));
			jButtonConferma.setText("Conferma");
			jButtonConferma.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);

			jButtonConferma.addActionListener(this);
		}
		return jButtonConferma;
	}
	/**
	 * This method initializes jButtonChiudi
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonChiudi() {
		if (jButtonChiudi == null) {
			jButtonChiudi = new javax.swing.JButton();
			jButtonChiudi.setBounds(160, 520, 100, 27);
			//			jButtonChiudi.setBounds(RealDim.getAbsoluteXValue(142), RealDim.getAbsoluteYValue(448), RealDim.getAbsoluteXValue(100), RealDim.getAbsoluteYValue(27));
			jButtonChiudi.setText("Chiudi");
			jButtonChiudi.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);

			jButtonChiudi.addActionListener(this);
		}
		return jButtonChiudi;
	}

	/**
	 * This method initializes jLabel
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel() {
		if(jLabel == null) {
			jLabel = new javax.swing.JLabel();
			jLabel.setBounds(431, 340, 151, 19);
			jLabel.setText("Numero Utenze");
			jLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			jLabel.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
			jLabel.setVisible(false);
		}
		return jLabel;
	}
	/**
	 * This method initializes jTextFieldNumUtenze
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldNumUtenze() {
		if(jTextFieldNumUtenze == null) {
			jTextFieldNumUtenze = new javax.swing.JTextField();
			jTextFieldNumUtenze.setBounds(431, 383, 151, 19);
			jTextFieldNumUtenze.setVisible(false);
			
		}
		return jTextFieldNumUtenze;
	}
	/**
	 * This method initializes jLabel1
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel1() {
		if(jLabel1 == null) {
			jLabel1 = new javax.swing.JLabel();
			jLabel1.setBounds(431, 360, 151, 19);
			jLabel1.setText("al 1 gennaio");
			jLabel1.setVisible(false);
		}
		return jLabel1;
	}
	private int validateExitText() {
			int retvalue = JOptionPane.NO_OPTION;
			if(flagModifica==true) {
				retvalue = JOptionPane.showConfirmDialog(this, "Le modifiche effettutate verranno perse. Vuoi salvare le modifiche?", "", JOptionPane.YES_NO_CANCEL_OPTION);
			}
			return retvalue;
		}	
		
			
}
