package it.finanze.dogane.accise.metano.ui; 

import it.finanze.dogane.accise.ui.validation.Validator;
import it.finanze.dogane.accise.combo.AbstractTipo;
import it.finanze.dogane.accise.combo.ComboDataSource;
import it.finanze.dogane.accise.combo.ComboUtil;
import it.finanze.dogane.accise.combo.TipoCapitolo; 
import it.finanze.dogane.accise.combo.TipoFasciaClimatica;
import it.finanze.dogane.accise.combo.TipoMese;
import it.finanze.dogane.accise.combo.TipoProvincia;
import it.finanze.dogane.accise.metano.model.Frontespizio;
import it.finanze.dogane.accise.metano.model.MetanoRecord;
import it.finanze.dogane.accise.metano.model.ProspettoConsumo;
import it.finanze.dogane.accise.metano.pdf.PdfProspectWriter;
import it.finanze.dogane.accise.metano.ui.quadri.Parametri;
import it.finanze.dogane.accise.metano.ui.quadri.Quadro;
import it.finanze.dogane.accise.ui.RealDim;
import it.finanze.dogane.accise.ui.actions.AboutAction;
import it.finanze.dogane.accise.ui.actions.BaseAbstractAction;
import it.finanze.dogane.accise.ui.actions.ExitAction;
import it.finanze.dogane.accise.ui.actions.InterchangeAction;
import it.finanze.dogane.accise.ui.actions.NewAction;
import it.finanze.dogane.accise.ui.actions.OpenAction;
import it.finanze.dogane.accise.ui.actions.SendAction;
import it.finanze.dogane.accise.ui.laf.LAFManager;
import it.finanze.dogane.accise.ui.quadri.QuadroListCellRenderer;
import it.finanze.dogane.accise.ui.validation.BigIntegerDocument;
import it.finanze.dogane.accise.ui.validation.StringDocument;
import it.finanze.dogane.accise.util.StringUtil;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.math.BigInteger;
import java.util.Calendar;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Locale;
import java.util.StringTokenizer;

import javax.swing.ButtonGroup;
import javax.swing.DefaultListModel;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

public class MetanoFrame extends JFrame implements ActionListener, ListSelectionListener, MouseListener{

	protected javax.swing.JPanel mainPanel = null;

	protected javax.swing.JMenuBar mainMenuBar = null;

	protected javax.swing.JMenu fileMenu = null;
	protected javax.swing.JMenu helpMenu = null;

	protected NewAction newAction = null;
	protected OpenAction openAction = null;
	protected SendAction sendAction = null;
	protected ExitAction exitAction = null;
	protected AboutAction aboutAction = null;
	private boolean sendActionMode=false;
   

	protected javax.swing.JPanel workPanel = null;
	protected javax.swing.JToolBar jToolBar = null;

	private InterchangeAction interchangeAction = null;
	private javax.swing.JTextField txtCodiceAccisa1 = null;
	private javax.swing.JPanel jPanel = null;
	private javax.swing.JLabel labelCodiceAccisa = null;
	private javax.swing.JTextField jTextCodiceAccisa = null;
	private javax.swing.JLabel jLabel = null;
	private javax.swing.JTextField jTextAnno = null;
	private JCheckBox ckDepositoAutorizzato = null;
	private JCheckBox ckAltroSoggettoSenzaImpianto = null;
	private javax.swing.JPanel jPanel1 = null;
	private javax.swing.JLabel jLabel1 = null;
	private javax.swing.JTabbedPane jTabbedPane = null;
	private javax.swing.JLabel labelDenominazione = null;
	private javax.swing.JTextField jTextFieldDichiarante = null;
	private javax.swing.JLabel lableProvincia = null;
	private javax.swing.JComboBox jComboBoxProvinciaDic = null;
	private javax.swing.JLabel labelComune = null;
	private javax.swing.JComboBox jComboBoxComuneDic = null;
	private javax.swing.JLabel labelIndirizzo = null;
	private javax.swing.JTextField jTextIndirizzoDic = null;
	private javax.swing.JPanel jPanel2 = null;
	private javax.swing.JLabel jLabel3 = null;
	private javax.swing.JTabbedPane jTabbedPane1 = null;
	private javax.swing.JLabel labelProvincia1 = null;
	private javax.swing.JComboBox jComboBoxProvinciaUffAmm = null;
	private javax.swing.JLabel labelComune1 = null;
	private javax.swing.JComboBox jComboBoxComuneUffAmm = null;
	private javax.swing.JLabel labelIndirizzo1 = null;
	private javax.swing.JTextField jTextFieldIndirizzoUffAmm = null;
	private javax.swing.JPanel jPanel3 = null;
	private javax.swing.JButton jButtonSalva = null;
	private javax.swing.JButton jButtonSalvaAs = null;
	private javax.swing.JButton jButtonStampa = null;
	private javax.swing.JButton jButtonChiudi = null;
	private javax.swing.JPanel jPanel4 = null;
	private javax.swing.JLabel jLabel2 = null;
	private javax.swing.JList jListListaQuadri = null;
	private javax.swing.JList jListDettaglioQuadri = null;
	private javax.swing.JMenu InterchMenu = null;
	private javax.swing.JPanel startupPanel = null;
	private javax.swing.JLabel JLabelIcon = null;
	private ButtonGroup buttonGroup = new ButtonGroup();
	private String tipoOperazione="";
	
	//SALVATORE
	private javax.swing.JScrollPane scroll = null;
	//
		
	private javax.swing.JTextField jTextFieldSpecificaQuadro = null;
	private javax.swing.JScrollPane jScrollPane = null;
	
	private ProspettoConsumo prospettoConsumo = new ProspettoConsumo();
	/** 
	 * Main method
	 */
	public static void main(String[] args) {

		
		MetanoFrame frame = new MetanoFrame();
		//frame.pack();
		frame.setVisible(true);
	}

	/**
	 * This is the default constructor
	 */
	public MetanoFrame() {
		super();
		initialize();
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.initActions();
		
		this.setSize(
			RealDim.getAbsoluteXValue(800),
			RealDim.getAbsoluteYValue(600));
//		this.setSize(
//			800,
//			600);

		this.setContentPane(getMainPanel());
		this.setJMenuBar(getMainMenuBar());
		this.setResizable(false);
		this.setTitle("Gas Naturale");
		setStartupPanel();
//		setWorkPanel();
	}

	private void setStartupPanel() {
		mainPanel = new javax.swing.JPanel();
		mainPanel.setLayout(new java.awt.BorderLayout());
		mainPanel.add(getJToolBar(), java.awt.BorderLayout.NORTH);
		mainPanel.add(getStartupPanel(), java.awt.BorderLayout.CENTER);
		this.setContentPane(mainPanel);
	}

	private void setWorkPanel() {
		mainPanel = new javax.swing.JPanel();
		mainPanel.setLayout(new java.awt.BorderLayout());
		mainPanel.add(getJToolBar(), java.awt.BorderLayout.NORTH);
		mainPanel.add(getWorkPanel(), java.awt.BorderLayout.CENTER);
		this.setContentPane(mainPanel);
	}

	// This method should be called before creating the UI 
	// to create all the Actions
	private void initActions() {

		newAction = new NewAction();
		registerAction(newAction);

		openAction = new OpenAction();
		registerAction(openAction);

		sendAction = new SendAction();
		registerAction(sendAction);

		exitAction = new ExitAction();
		registerAction(exitAction);

		aboutAction =
			new AboutAction("Dichiarazione di Consumo di Gas naturale per l'anno d'imposta 2007", "Versione 5.0 - Dicembre 2007");
		registerAction(aboutAction);

		interchangeAction = new InterchangeAction("", "");
		registerAction(interchangeAction);
	}

	private void initQuadri() {
		
		

		DefaultListModel model = new DefaultListModel();
		jListListaQuadri.setModel(model);
		jListListaQuadri.setCellRenderer(new QuadroListCellRenderer());
		Quadro etichetta = null;

		
		etichetta = new Quadro(Quadro.QUADRO_A);
		etichetta.setDescription("Quadro A");
		etichetta.setSecondDescription("Gas naturale introdotto");
		etichetta.setComplex(true);
		etichetta.setEmpty(true);
		model.addElement(etichetta);

		etichetta = new Quadro(Quadro.QUADRO_B);
		etichetta.setDescription("Quadro B");
		etichetta.setSecondDescription("Gas naturale estratto");
		etichetta.setComplex(true);
		etichetta.setEmpty(true);
		model.addElement(etichetta);

		etichetta = new Quadro(Quadro.QUADRO_C);
		etichetta.setDescription("Quadro C");
		etichetta.setSecondDescription(
			"Gas naturale acquistato");
		etichetta.setComplex(true);
		etichetta.setEmpty(true);
		model.addElement(etichetta);

		etichetta = new Quadro(Quadro.QUADRO_D);
		etichetta.setDescription("Quadro D");
		etichetta.setSecondDescription(
			"Gas naturale Venduto");
		etichetta.setComplex(true);
		etichetta.setEmpty(true);
		model.addElement(etichetta);

		etichetta = new Quadro(Quadro.QUADRO_E);
		etichetta.setDescription("Quadro E");
		etichetta.setSecondDescription(
			"Gas naturale fatturato o impiegato senza pagamento accisa");
		etichetta.setComplex(true);
		etichetta.setEmpty(true);
		model.addElement(etichetta);

		etichetta = new Quadro(Quadro.QUADRO_F);
		etichetta.setDescription("Quadro F");
		etichetta.setSecondDescription(
			"Gas naturale fatturato o impiegato per fasce climatiche");
		etichetta.setComplex(true);
		etichetta.setEmpty(true);
		model.addElement(etichetta);

		etichetta = new Quadro(Quadro.QUADRO_G);
		etichetta.setDescription("Quadro G");
		etichetta.setSecondDescription("Totale Gas naturale fatturato o impiegato");
		etichetta.setComplex(true);
		etichetta.setEmpty(true);
		model.addElement(etichetta);

		etichetta = new Quadro(Quadro.QUADRO_H);
		etichetta.setDescription("Quadro H");
		etichetta.setSecondDescription("Rettifiche di fatturazione");
		etichetta.setComplex(true);
		etichetta.setEmpty(true);
		model.addElement(etichetta);

		etichetta = new Quadro(Quadro.QUADRO_I);
		etichetta.setDescription("Quadro I");
		etichetta.setSecondDescription("Liquidazione dell'accisa");
		etichetta.setComplex(true);
		etichetta.setEmpty(true);
		model.addElement(etichetta);

		etichetta = new Quadro(Quadro.QUADRO_L);
		etichetta.setDescription("Quadro L");
		etichetta.setSecondDescription("Riepilogo e saldo dell'accisa");
		etichetta.setComplex(true);
		etichetta.setEmpty(true);
		model.addElement(etichetta);

		etichetta = new Quadro(Quadro.QUADRO_M);
		etichetta.setDescription("Quadro M");
		etichetta.setSecondDescription(
			"Liquidazione dell'addizionale regionale");
		etichetta.setComplex(true);
		etichetta.setEmpty(true);
		model.addElement(etichetta);

		etichetta = new Quadro(Quadro.QUADRO_N);
		etichetta.setDescription("Quadro N");
		etichetta.setSecondDescription(
			"Riepilogo e saldo dell'addizionale regionale");
		etichetta.setComplex(true);
		etichetta.setEmpty(true);
		model.addElement(etichetta);

		etichetta = new Quadro(Quadro.QUADRO_O);
		etichetta.setDescription("Quadro O");
		etichetta.setSecondDescription(
			"Liquidazione dell'imposta regionale sostitutiva");
		etichetta.setComplex(true);
		etichetta.setEmpty(true);
		model.addElement(etichetta);

		etichetta = new Quadro(Quadro.QUADRO_P);
		etichetta.setDescription("Quadro P");
		etichetta.setSecondDescription(
			"Riepilogo e saldo dell'imposta regionale sostitutiva");
		etichetta.setComplex(true);
		etichetta.setEmpty(true);
		model.addElement(etichetta);

		etichetta = new Quadro(Quadro.ALLEGATO);
		etichetta.setDescription("Allegato");
		etichetta.setSecondDescription("Elenco clienti agevolati");
		etichetta.setComplex(true);
		etichetta.setEmpty(true);
		model.addElement(etichetta);

		
		DefaultListModel modelDettaglio = new DefaultListModel();
		getJListDettaglioQuadri().setModel(modelDettaglio);
	}

	/**
	 * 
	 */

	private void setQuadri(ProspettoConsumo prospettoConsumo) {
		DefaultListModel model = (DefaultListModel) jListListaQuadri.getModel();

		Enumeration enumeration = model.elements();
		while (enumeration.hasMoreElements()) {
			Quadro quadro = (Quadro) enumeration.nextElement();
			quadro.setProspect(prospettoConsumo);
		}
	}

	private void registerAction(BaseAbstractAction action) {
		action.addActionListener(this);
	}

	public synchronized void setTitle(String title) {
		if (StringUtil.nullify(title) == null) {
			super.setTitle("Gas naturale");
		} else if (!title.trim().equals("Gas naturale")) { //MODIFICA 12-11-2007 PRIMA "Metano"
			super.setTitle("Gas naturale");
		} else {
			super.setTitle("Gas naturale - " + title);
		}
	}

	/*************************************************************************
	 * INIZIO GESTIONE EVENTI
	 *************************************************************************/
	public void actionPerformed(ActionEvent event) {
		String a = "";
		try {
			if (aboutAction
				.getActionCommand()
				.equals(event.getActionCommand())) {
				GestoreEventi.showHelp(this, aboutAction);
			} else if (
				openAction.getActionCommand().equals(
					event.getActionCommand())) {
				doOpen();
				
			} else if (
				newAction.getActionCommand().equals(
					event.getActionCommand())) {
				prospettoConsumo = new ProspettoConsumo();
				setWorkPanel();
				clearUI();
			} else if (sendAction.getActionCommand().equals(event.getActionCommand())) {
				sendFile();
			} else if (interchangeAction.getActionCommand().equals(event.getActionCommand())) {
				doOpenInterchageSession();
			} else if (
				exitAction.getActionCommand().equals(
					event.getActionCommand())) {
				GestoreEventi.exitApplication();
			} else if (event.getSource() == jButtonChiudi) {
				prospettoConsumo = new ProspettoConsumo();
				clearUI();
				setStartupPanel();
			} else if (event.getSource() == jButtonSalva) {
				doSave();
			} else if (event.getSource() == jButtonSalvaAs) {
				doSaveAs();
			} else if (event.getSource() == jButtonStampa) {
				doPrint();
			} else if (event.getSource() == jComboBoxProvinciaDic) {
				updateComboDic();
			} else if (event.getSource() == jComboBoxProvinciaUffAmm) {
				updateComboUffAm();
			}
		} catch (Exception e) {
			e.printStackTrace();
			JOptionPane.showMessageDialog(
				this,
				"Errore durante l'operazione richiesta: \n" + e.getMessage(),
				"Errore",
				JOptionPane.ERROR_MESSAGE);
		}
	}

	/**
	 * 
	 */
	private boolean validaFrontespizio() {
		Frontespizio frontespizio = prospettoConsumo.getFrontespizio();
		boolean isOk = true;
		if ((getJTextCodiceAccisa().getText().equals(""))
			|| (getJTextFieldDichiarante().getText().equals(""))
			|| (getJTextIndirizzoDic().getText().equals(""))
			|| ((!ckDepositoAutorizzato.isSelected())
				&& (!ckAltroSoggettoSenzaImpianto.isSelected()))
			|| (getJTextAnno().getText().equals(""))
			|| (jTextFieldIndirizzoUffAmm.getText().equals(""))) {

			JOptionPane.showMessageDialog(
				this,
				"Tutti i campi sono obbligatori",
				"Attenzione",
				JOptionPane.WARNING_MESSAGE);
			isOk = false;
		}
		if(isOk) {
			if(!Validator.isCodiceDittaForMetano(getJTextCodiceAccisa().getText())) {
				JOptionPane.showMessageDialog(
					this,
					"Il codice ditta non  valido",
					"Attenzione",
					JOptionPane.WARNING_MESSAGE);
				isOk = false;
			}
		}
		if(isOk) {
			/** MODIFICA PER TEST 24-10-2007 RIPRISTINARE **/
			if(!getJTextAnno().getText().equals("2007") && !getJTextAnno().getText().equals("2006") ) {
				/** FINE MODIFICA **/
				JOptionPane.showMessageDialog(
					this,
					"Si possono salvare solo prospetti relativi al 2007",
					"Attenzione",
					JOptionPane.WARNING_MESSAGE);
				isOk = false;
			}
		}
		if(isOk) {
			if(	jComboBoxComuneDic.getSelectedIndex() == -1 ||
				jComboBoxComuneUffAmm.getSelectedIndex() == -1 ||
				jComboBoxProvinciaDic.getSelectedIndex() == -1 ||
				jComboBoxProvinciaUffAmm.getSelectedIndex() == -1) {
					JOptionPane.showMessageDialog(
						this,
						"Si deve impostare correttamente la provincia e il comune",
						"Attenzione",
						JOptionPane.WARNING_MESSAGE);
					isOk = false;
				}
		}

		return isOk;
	}

	public void valueChanged(ListSelectionEvent event) {
		try {
			if (event.getSource() == jListListaQuadri) {
				updateListaQuadri();
				showDescription();
			} else if (event.getSource() == jListDettaglioQuadri) {
			}
		} catch (Exception e) {
			e.printStackTrace();
			JOptionPane.showMessageDialog(
				this,
				"Errore durante l'operazione richiesta: \n" + e.getMessage(),
				"Errore",
				JOptionPane.ERROR_MESSAGE);
		}
	}

	public void mouseClicked(MouseEvent event) {
		try {
			Frontespizio frontespizio = prospettoConsumo.getFrontespizio();

			if (event.getSource() == jListListaQuadri) {

				if (event.getClickCount() == 2) {
					loadModelFromUI(prospettoConsumo);
					if (StringUtil.nullify(frontespizio.getCodiceAccisa())
						== null) {
						JOptionPane.showMessageDialog(
							this,
							"Tutti i campi sono obbligatori");
					} else {
						mostraQuadro();
					}
				}
			} else if (event.getSource() == jListDettaglioQuadri) {
				if (event.getClickCount() == 2) { // DOPPIO CLICK
					mostraQuadroComplesso();
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
			JOptionPane.showMessageDialog(
				this,
				"Errore durante l'operazione richiesta: \n" + e.getMessage(),
				"Errore",
				JOptionPane.ERROR_MESSAGE);
		}
	}

	/**
	 * 
	 */
	private void mostraQuadro() {
		Quadro quadro = (Quadro) jListListaQuadri.getSelectedValue();
		if (quadro != null) {
			quadro.setProspect(prospettoConsumo);
			if (quadro.isComplex()) {
				quadro.showIntermediateDialog(this);
				updateListaQuadri();
			} else {
				quadro.showDialog(this);
			}
		}

	}

	private void mostraQuadroComplesso() {
		Quadro quadro = (Quadro) jListListaQuadri.getSelectedValue();
		Parametri parametri = (Parametri)jListDettaglioQuadri.getSelectedValue();

		if (quadro != null && parametri != null) {
			quadro.setProspect(prospettoConsumo, parametri);
			quadro.showDialog(this);
			updateListaQuadri();
		}
	}

	private void updateListaQuadri() {
		Quadro quadro = (Quadro) jListListaQuadri.getSelectedValue();
		if (quadro != null) {
			DefaultListModel model = new DefaultListModel();
			jListDettaglioQuadri.setModel(model);
			if (quadro.isComplex()) {
				List sottoQuadri = quadro.getSottoQuadri();//Restituisce i sottoquadri in base alla provincia scelta
				
				if (sottoQuadri != null && sottoQuadri.size() > 0) {
								
					Iterator it = sottoQuadri.iterator();
							
					while (it.hasNext()) {
						model.addElement(it.next());
					}
				}
				
				
				
			}
		}
	}
	private void showDescription() {
		Quadro quadro = (Quadro) jListListaQuadri.getSelectedValue();
		if (quadro != null) {
			getJTextFieldSpecificaQuadro().setText(
				quadro.getSecondDescription());
		}
	}

	private void loadModelFromUI(ProspettoConsumo prospettoConsumo) {
		Frontespizio frontespizio = prospettoConsumo.getFrontespizio();
			
		
	 
			frontespizio.setCodiceAccisa(this.jTextCodiceAccisa.getText());
			try {
				frontespizio.setAnnoDichiarazione(new BigInteger(this.jTextAnno.getText()));
			}
			catch(NumberFormatException e) {
				frontespizio.setAnnoDichiarazione(BigInteger.valueOf(0));
			}
			frontespizio.setDenominazioneDitta(jTextFieldDichiarante.getText());
			frontespizio.setIndirizzoDepositoFiscale(this.jTextIndirizzoDic.getText());
			frontespizio.setIndirizzoSedeUfficioAmm(this.jTextFieldIndirizzoUffAmm.getText());
		    
			if(ckDepositoAutorizzato.isSelected()){
			   frontespizio.setTipologiaDichiarante("S");
			}else if(ckAltroSoggettoSenzaImpianto.isSelected()){
			   frontespizio.setTipologiaDichiarante("A");
			}
			AbstractTipo provinciaSede=(AbstractTipo)this.jComboBoxProvinciaDic.getSelectedItem();
			if(provinciaSede != null) {		 
				frontespizio.setProvinciaDepositoFiscale(provinciaSede.getCodice());
			}
		
			AbstractTipo comuneSede=(AbstractTipo)this.jComboBoxComuneDic.getSelectedItem();
			if(comuneSede != null) {		 
				frontespizio.setComuneSedeDepositoFiscale(comuneSede.getDescrizione());
			}
		
			AbstractTipo provinciaSedeAmministrativa=(AbstractTipo)this.jComboBoxProvinciaUffAmm.getSelectedItem();
			if(provinciaSedeAmministrativa != null) {		 
				frontespizio.setProvinciaSedeUfficioAmm(provinciaSedeAmministrativa.getCodice());
			}
		
			AbstractTipo comuneSedeAmministrativa=(AbstractTipo)this.jComboBoxComuneUffAmm.getSelectedItem();		
			if(comuneSedeAmministrativa != null) {		 
				frontespizio.setComuneSedeUfficioAmm(comuneSedeAmministrativa.getDescrizione());
			}
	}

	public void mousePressed(MouseEvent event) {

	}

	public void mouseReleased(MouseEvent event) {

	}

	public void mouseEntered(MouseEvent event) {

	}

	public void mouseExited(MouseEvent arg0) {
	}


	
	private void updateComboDic() {
		AbstractTipo tipo = (AbstractTipo)jComboBoxProvinciaDic.getSelectedItem();
			if(tipo == null) {
				tipo = (AbstractTipo)jComboBoxProvinciaDic.getItemAt(0);
			}
			ComboUtil.setValues(jComboBoxComuneDic, ComboDataSource.getInstance().getComuni(tipo.getCodice()));

	}
	
	private void updateComboUffAm() {
			AbstractTipo tipo = (AbstractTipo)jComboBoxProvinciaUffAmm.getSelectedItem();
			if(tipo == null) {
				tipo = (AbstractTipo)jComboBoxProvinciaUffAmm.getItemAt(0);
			}
			ComboUtil.setValues(jComboBoxComuneUffAmm, ComboDataSource.getInstance().getComuni(tipo.getCodice()));
		}
	private void doSave() {
		
		if(validaFrontespizio()){
			loadModelFromUI(prospettoConsumo);
			GestoreEventi.saveProspect(this, prospettoConsumo);
		}
		

	}

	private void doSaveAs() {
		
		if(validaFrontespizio()){
		boolean saved = false;
		loadModelFromUI(prospettoConsumo);
		saved = GestoreEventi.saveAsProspect(this, prospettoConsumo);
		if (saved) {
			this.setTitle(prospettoConsumo.getResourceAccess().getFileName());
		}
	}
	}
	private void doSaveAs(String fileName) {
		boolean saved = false;
		saved = GestoreEventi.saveAsProspect(this, prospettoConsumo,fileName);
		if (saved) {
			this.setTitle(prospettoConsumo.getResourceAccess().getFileName());
		}
	}

	private void doPrint() {
		if(validaFrontespizio()){
			loadModelFromUI(prospettoConsumo);
			new PdfProspectWriter().print(jListListaQuadri, jListDettaglioQuadri, this, prospettoConsumo);
		}
	}

	/**
	 * 
	 */
	private void clearUI() {
		this.setTitle("");
		  
		jTextCodiceAccisa.setText(null);
		jTextFieldDichiarante.setText(null);
		jTextIndirizzoDic.setText(null);
		jTextFieldIndirizzoUffAmm.setText(null);
		jTextAnno.setText("2007");
		ckDepositoAutorizzato.setSelected(false);
		ckAltroSoggettoSenzaImpianto.setSelected(false); 
	
		jComboBoxComuneUffAmm.removeActionListener(this);
		jComboBoxComuneDic.removeActionListener(this);
		jComboBoxProvinciaDic.removeActionListener(this);
		jComboBoxProvinciaUffAmm.removeActionListener(this);

		ComboUtil.setValues(jComboBoxProvinciaDic,	ComboDataSource.getInstance().getProvince());
		String codiceProvincia =((TipoProvincia) jComboBoxProvinciaDic.getSelectedItem()).getCodice();
		ComboUtil.setValues(jComboBoxComuneDic,ComboDataSource.getInstance().getComuni(codiceProvincia));

		ComboUtil.setValues(jComboBoxProvinciaUffAmm,ComboDataSource.getInstance().getProvince());
		codiceProvincia =((TipoProvincia) jComboBoxProvinciaUffAmm.getSelectedItem()).getCodice();
		ComboUtil.setValues(jComboBoxComuneUffAmm,ComboDataSource.getInstance().getComuni(codiceProvincia));

		jComboBoxComuneUffAmm.setSelectedIndex(-1);
		jComboBoxComuneDic.setSelectedIndex(-1);
		jComboBoxProvinciaDic.setSelectedIndex(-1);
		jComboBoxProvinciaUffAmm.setSelectedIndex(-1);

		jComboBoxComuneUffAmm.addActionListener(this);
		jComboBoxComuneDic.addActionListener(this);
		jComboBoxProvinciaDic.addActionListener(this);
		jComboBoxProvinciaUffAmm.addActionListener(this);

		initQuadri();

	}

	/**
	 * 
	 */
	private void doOpen() {
		
		ProspettoConsumo prospettoAperto = GestoreEventi.openProspect(this);
		if (prospettoAperto != null) {
			prospettoConsumo = prospettoAperto;
			setWorkPanel();
			loadUIFromModel(prospettoConsumo);
		}

	}
	private void sendFile() {
		setSendActionMode(true);

		ProspettoConsumo prospettoAperto = GestoreEventi.openProspect(this);
		if (prospettoAperto != null) {
			prospettoConsumo = prospettoAperto;

			doSaveAs(prospettoConsumo.getFrontespizio().getCodiceAccisa() +"_"+prospettoConsumo.getFrontespizio().getAnnoDichiarazione()+".dic");
		}
	}

	private void loadUIFromModel(ProspettoConsumo prospettoConsumo) {

		this.setTitle(prospettoConsumo.getResourceAccess().getFileName());		
		Frontespizio frontespizio = prospettoConsumo.getFrontespizio();		
		jTextCodiceAccisa.setText(frontespizio.getCodiceAccisa());
		jTextAnno.setText("" + frontespizio.getAnnoDichiarazione());		
		jTextFieldDichiarante.setText(frontespizio.getDenominazioneDitta());
		jTextIndirizzoDic.setText(frontespizio.getIndirizzoDepositoFiscale());
		jTextFieldIndirizzoUffAmm.setText(frontespizio.getIndirizzoSedeUfficioAmm());
		if(frontespizio.getTipologiaDichiarante().equals("S")){		
			ckDepositoAutorizzato.setSelected(true);
		}else if(frontespizio.getTipologiaDichiarante().equals("A")){
			ckAltroSoggettoSenzaImpianto.setSelected(true);
		}
		
		jComboBoxComuneDic.removeActionListener(this);
		jComboBoxComuneUffAmm.removeActionListener(this);
		jComboBoxProvinciaDic.removeActionListener(this);
		jComboBoxProvinciaUffAmm.removeActionListener(this);
        
        
		ComboUtil.setValues(jComboBoxProvinciaDic, ComboDataSource.getInstance().getProvince());
		jComboBoxProvinciaDic.setSelectedItem(ComboDataSource.getInstance().getProvincia(frontespizio.getProvinciaDepositoFiscale()));
		
		ComboUtil.setValues(jComboBoxComuneDic, ComboDataSource.getInstance().getComuni(frontespizio.getProvinciaDepositoFiscale()));
		jComboBoxComuneDic.setSelectedItem(ComboDataSource.getInstance().getComunePerDescrizione(frontespizio.getProvinciaDepositoFiscale(),frontespizio.getComuneSedeDepositoFiscale()));
		
		
		ComboUtil.setValues(jComboBoxProvinciaUffAmm, ComboDataSource.getInstance().getProvince());
		jComboBoxProvinciaUffAmm.setSelectedItem(ComboDataSource.getInstance().getProvincia(frontespizio.getProvinciaSedeUfficioAmm()));
		
		
		ComboUtil.setValues(jComboBoxComuneUffAmm, ComboDataSource.getInstance().getComuni(frontespizio.getProvinciaSedeUfficioAmm()));
		jComboBoxComuneUffAmm.setSelectedItem(ComboDataSource.getInstance().getComunePerDescrizione(frontespizio.getProvinciaSedeUfficioAmm(),frontespizio.getComuneSedeUfficioAmm()));
		
		setQuadri(prospettoConsumo);
		updateListaQuadri();	

		validate();
		
		jComboBoxComuneDic.addActionListener(this);
		jComboBoxComuneUffAmm.addActionListener(this);
		jComboBoxProvinciaDic.addActionListener(this);
		jComboBoxProvinciaUffAmm.addActionListener(this);
		

	}
	
	

	/*************************************************************************
	 * FINE GESTIONE EVENTI
	 *************************************************************************/
	
	
	private List getComuni(String string) {
			return null;
		}

		/**
		 * @param string
		 * @return
		 */
		private List getProvincia(String string) {
			return null;
		}

		/**
		 * @param string
		 * @param string2
		 * @return
		 */
		private List getProvincia(String string, String string2) {

			return null;
		}

	/**
	 * This method initializes mainPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	protected javax.swing.JPanel getMainPanel() {
		if (mainPanel == null) {
			mainPanel = new javax.swing.JPanel();
			mainPanel.setLayout(new java.awt.BorderLayout());
			mainPanel.add(getWorkPanel(), java.awt.BorderLayout.CENTER);
			mainPanel.add(getJToolBar(), java.awt.BorderLayout.NORTH);
			
		}
		return mainPanel;
	}

	/**
	 * This method initializes mainMenuBar
	 * 
	 * @return javax.swing.JMenuBar
	 */
	protected javax.swing.JMenuBar getMainMenuBar() {
		if (mainMenuBar == null) {
			mainMenuBar = new javax.swing.JMenuBar();
			mainMenuBar.add(getFileMenu());
			mainMenuBar.add(getInterchange());
			LAFManager.getInstance().initLookMenu(mainMenuBar, this);
			mainMenuBar.add(getHelpMenu());
		}
		return mainMenuBar;
	}
	/**
	 * This method initializes fileMenu
	 * 
	 * @return javax.swing.JMenu
	 */
	protected javax.swing.JMenu getFileMenu() {
		if (fileMenu == null) {
			fileMenu = new javax.swing.JMenu();
			fileMenu.setText("Dichiarazione");
			fileMenu.setMnemonic(java.awt.event.KeyEvent.VK_F);

			JMenuItem menuItem;
			menuItem = fileMenu.add(newAction);
			menuItem = fileMenu.add(openAction);
			fileMenu.addSeparator();
			//menuItem = fileMenu.add(sendAction);
			//fileMenu.addSeparator();
			menuItem = fileMenu.add(exitAction);
		}
		return fileMenu;
	}
	/**
	 * This method initializes helpMenu
	 * 
	 * @return javax.swing.JMenu
	 */
	protected javax.swing.JMenu getHelpMenu() {
		if (helpMenu == null) {
			helpMenu = new javax.swing.JMenu();

			helpMenu.setText("?");
			//helpMenu.setText("Aiuto");
			JMenuItem menuItem;
			menuItem = helpMenu.add(aboutAction);
		}
		return helpMenu;
	}
	protected javax.swing.JMenu getInterchange() {
		
			if(InterchMenu == null) {
				InterchMenu = new javax.swing.JMenu();
				InterchMenu.setText("Interchange");
				InterchMenu.setMnemonic(java.awt.event.KeyEvent.VK_F);
				JMenuItem menuItem;
				menuItem = InterchMenu.add(interchangeAction);
			}
	 return InterchMenu;
		}


	/**
	 * This method initializes workPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	protected javax.swing.JPanel getWorkPanel() {
		if (workPanel == null) {
			workPanel = new javax.swing.JPanel();
			workPanel.setLayout(null);
			
			workPanel.add(getJPanel(), null);
			workPanel.add(getJPanel1(), null);
			workPanel.add(getJPanel2(), null);
			workPanel.add(getJPanel3(), null);
			workPanel.add(getJPanel4(), null);
		}
		return workPanel;
	}

	/**
	 * This method initializes jToolBar
	 * 
	 * @return javax.swing.JToolBar
	 */
	protected javax.swing.JToolBar getJToolBar() {
		if (jToolBar == null) {
			jToolBar = new javax.swing.JToolBar();

			jToolBar.add(newAction);
			jToolBar.add(openAction);
			jToolBar.addSeparator();
			//jToolBar.add(sendAction);
			jToolBar.addSeparator();
			jToolBar.add(exitAction);
		}
		return jToolBar;
	} /**
																 * This method initializes jTextAnno
																 * 
																 * @return javax.swing.JTextField
																 */
	private javax.swing.JTextField getJTextCodiceAccisa() {
		if (jTextCodiceAccisa == null) {
			jTextCodiceAccisa = new javax.swing.JTextField();
			//jTextCodiceAccisa.setBounds(165, 20, 138, 20);
			jTextCodiceAccisa.setBounds(RealDim.getAbsoluteXValue(165),RealDim.getAbsoluteYValue(20),RealDim.getAbsoluteXValue(138),RealDim.getAbsoluteYValue(20));
			jTextCodiceAccisa.setDocument(new StringDocument(Frontespizio.dimCodiceAccisa));
		}
		return jTextCodiceAccisa;
	}
	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel() {
		if (jPanel == null) {
			jPanel = new javax.swing.JPanel();
			jPanel.setLayout(null);
			jPanel.add(getLabelDenominazione(), null);
			jPanel.add(getJTextCodiceAccisa(), null);
			jPanel.add(getTxtCodiceAccisa1(), null);
			jPanel.add(getJLabel(), null);
			jPanel.add(getJTextAnno(), null);
			jPanel.add(getCkDepositoAutorizzato(), null);
			jPanel.add(getCkAltroSoggettoSenzaImpianto(), null);
			//jPanel.setBounds(12, 50, 770, 56);
			jPanel.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.black,1));
			jPanel.setBackground(java.awt.Color.lightGray);
			jPanel.setBounds(RealDim.getAbsoluteXValue(12),RealDim.getAbsoluteYValue(50),RealDim.getAbsoluteXValue(770),RealDim.getAbsoluteYValue(56));
		}
		return jPanel;
	}
	/**
	 * This method initializes jLabel
	 * 
	 * @return javax.swing.JLabel
	 */
	/*private javax.swing.JLabel getJLabel() {
		if (labelCodiceAccisa == null) {
			labelCodiceAccisa = new javax.swing.JLabel();
			labelCodiceAccisa.setText("Codice"); 
			labelCodiceAccisa.setBounds(RealDim.getAbsoluteXValue(42),RealDim.getAbsoluteYValue(20),RealDim.getAbsoluteXValue(50),RealDim.getAbsoluteYValue(18));
			labelCodiceAccisa.set
		}*/
		
		// MODIFICA
		private javax.swing.JLabel getJLabel() {
			if (labelCodiceAccisa == null) {
				labelCodiceAccisa = new javax.swing.JLabel();
			//jLabel.setBounds(333, 22, 32, 15);
			labelCodiceAccisa.setText("Codice Accisa/Ditta:");
			labelCodiceAccisa.setBounds(RealDim.getAbsoluteXValue(25),RealDim.getAbsoluteYValue(22),RealDim.getAbsoluteXValue(100),RealDim.getAbsoluteYValue(15));
		}
		
		return labelCodiceAccisa;
	}
	/**
	 * This method initializes jTextFieldIndirizzoUffAmm
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getTxtCodiceAccisa1() {
		if (txtCodiceAccisa1 == null) {
			txtCodiceAccisa1 = new javax.swing.JTextField();
			//txtCodiceAccisa1.setBounds(131, 20, 30, 19);
			txtCodiceAccisa1.setText("IT00");
			txtCodiceAccisa1.setEnabled(true);
			txtCodiceAccisa1.setEditable(false);
			 
			txtCodiceAccisa1.setBounds(RealDim.getAbsoluteXValue(131),RealDim.getAbsoluteYValue(20),RealDim.getAbsoluteXValue(30),RealDim.getAbsoluteYValue(19));
			//txtCodiceAccisa1.setDocument(new StringDocument(Frontespizio.dimCodiceAccisa));
		}
		return txtCodiceAccisa1;
	}
	/**
	 * This method initializes jLabel
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getLabelDenominazione() {
		if (jLabel == null) {
			jLabel = new javax.swing.JLabel();
			//jLabel.setBounds(333, 22, 32, 15);
			jLabel.setText("Anno:");
			jLabel.setBounds(RealDim.getAbsoluteXValue(333),RealDim.getAbsoluteYValue(22),RealDim.getAbsoluteXValue(32),RealDim.getAbsoluteYValue(15));
		}
		return jLabel;
	}
	/**
	 * This method initializes jTextAnno
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextAnno() {
		if (jTextAnno == null) {
			jTextAnno = new javax.swing.JTextField();
			//jTextAnno.setBounds(368, 20, 37, 19);
			Calendar c = Calendar.getInstance(Locale.ITALY);
			jTextAnno.setText(String.valueOf(c.get(Calendar.YEAR)));
			jTextAnno.setEditable(true);
			jTextAnno.setBounds(RealDim.getAbsoluteXValue(368),RealDim.getAbsoluteYValue(20),RealDim.getAbsoluteXValue(37),RealDim.getAbsoluteYValue(19));
			jTextAnno.setDocument(new BigIntegerDocument(Frontespizio.dimAnnoDichiarazione));
		}
		return jTextAnno;
	}
	/**
	 * This method initializes ckDepositoAutorizzato
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private javax.swing.JCheckBox getCkDepositoAutorizzato() {
		if (ckDepositoAutorizzato == null) {
			ckDepositoAutorizzato = new javax.swing.JCheckBox();
			//ckDepositoAutorizzato.setBounds(475, 8, 205, 21);
			ckDepositoAutorizzato.setText("Soggetto obbligato");
						
			ckDepositoAutorizzato.setBounds(RealDim.getAbsoluteXValue(475),RealDim.getAbsoluteYValue(8),RealDim.getAbsoluteXValue(205),RealDim.getAbsoluteYValue(21));
			buttonGroup.add(ckDepositoAutorizzato);
		}
		return ckDepositoAutorizzato;
	}
	/**
	 * This method initializes ckAltroSoggettoSenzaImpianto
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private javax.swing.JCheckBox getCkAltroSoggettoSenzaImpianto() {
		if (ckAltroSoggettoSenzaImpianto == null) {
			ckAltroSoggettoSenzaImpianto = new javax.swing.JCheckBox();
			//ckAltroSoggettoSenzaImpianto.setBounds(475, 33, 205, 21);
						
			ckAltroSoggettoSenzaImpianto.setText("Altro soggetto");	
		
			ckAltroSoggettoSenzaImpianto.setBounds(RealDim.getAbsoluteXValue(475),RealDim.getAbsoluteYValue(33),RealDim.getAbsoluteXValue(205),RealDim.getAbsoluteYValue(21));	
			
			buttonGroup.add(ckAltroSoggettoSenzaImpianto);
		}
		return ckAltroSoggettoSenzaImpianto;
	}
	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel1() {
		if (jPanel1 == null) {
			jPanel1 = new javax.swing.JPanel();
			jPanel1.setLayout(null);
			
			
			jPanel1.add(getJLabel22(), null);
			jPanel1.add(getJTextFieldDichiarante(), null);
			jPanel1.add(getLableProvincia(), null);
			jPanel1.add(getJComboBoxProvinciaDic(), null);
			jPanel1.add(getJComboBoxComuneDic(), null);
			jPanel1.add(getLabelComune(), null);
			jPanel1.add(getLabelIndirizzo(), null);
			jPanel1.add(getJTextIndirizzoDic(), null);
			//jPanel1.setBounds(12, 112, 770, 115);
			jPanel1.setBackground(java.awt.Color.lightGray);
			jPanel1.setBorder(
				javax.swing.BorderFactory.createLineBorder(
					java.awt.Color.black,
					1));
			jPanel1.setBounds(RealDim.getAbsoluteXValue(12),RealDim.getAbsoluteYValue(112),RealDim.getAbsoluteXValue(770),RealDim.getAbsoluteYValue(115));
			jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Dichiarante", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
		}
		return jPanel1;
	}
	
	private javax.swing.JLabel getJLabel22() {
		if (labelDenominazione == null) {
			labelDenominazione = new javax.swing.JLabel();
			//labelDenominazione.setBounds(44, 27, 90, 14);
			labelDenominazione.setText("Denominazione:");
			labelDenominazione.setBounds(RealDim.getAbsoluteXValue(44),RealDim.getAbsoluteYValue(27),RealDim.getAbsoluteXValue(90),RealDim.getAbsoluteYValue(14));
		}
		return labelDenominazione;
	}
	/**
	 * This method initializes jTextFieldDichiarante
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldDichiarante() {
		if (jTextFieldDichiarante == null) {
			jTextFieldDichiarante = new javax.swing.JTextField();
			//jTextFieldDichiarante.setBounds(140, 25, 544, 19);
			jTextFieldDichiarante.setBounds(RealDim.getAbsoluteXValue(140),RealDim.getAbsoluteYValue(25),RealDim.getAbsoluteXValue(544),RealDim.getAbsoluteYValue(19));
			jTextFieldDichiarante.setDocument(new StringDocument(Frontespizio.dimDenominazioneDitta));
		}
		return jTextFieldDichiarante;
	}
	/**
	 * This method initializes lableProvincia
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getLableProvincia() {
		if (lableProvincia == null) {
			lableProvincia = new javax.swing.JLabel();
			//lableProvincia.setBounds(44, 53, 60, 16);
			lableProvincia.setText("Provincia:");
			lableProvincia.setBounds(RealDim.getAbsoluteXValue(44),RealDim.getAbsoluteYValue(53),RealDim.getAbsoluteXValue(60),RealDim.getAbsoluteYValue(16));
		}
		return lableProvincia;
	}
	/**
	 * This method initializes jComboBoxProvinciaDic
	 * 
	 * @return javax.swing.JComboBox
	 */
	private javax.swing.JComboBox getJComboBoxProvinciaDic() {
		if (jComboBoxProvinciaDic == null) {
			jComboBoxProvinciaDic = new javax.swing.JComboBox();
			//jComboBoxProvinciaDic.setBounds(140, 52, 130, 20);
			jComboBoxProvinciaDic.setBounds(RealDim.getAbsoluteXValue(140),RealDim.getAbsoluteYValue(52),RealDim.getAbsoluteXValue(130),RealDim.getAbsoluteYValue(20));
		}
		return jComboBoxProvinciaDic;
	}
	/**
	 * This method initializes labelComune
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getLabelComune() {
		if (labelComune == null) {
			labelComune = new javax.swing.JLabel();
			//labelComune.setBounds(333, 53, 53, 16);
			labelComune.setText("Comune:");
			labelComune.setBounds(RealDim.getAbsoluteXValue(333),RealDim.getAbsoluteYValue(53),RealDim.getAbsoluteXValue(53),RealDim.getAbsoluteYValue(16));
		}
		return labelComune;
	}
	/**
	 * This method initializes jComboBoxComuneDic
	 * 
	 * @return javax.swing.JComboBox
	 */
	private javax.swing.JComboBox getJComboBoxComuneDic() {
		if (jComboBoxComuneDic == null) {
			jComboBoxComuneDic = new javax.swing.JComboBox();
			//jComboBoxComuneDic.setBounds(394, 52, 289, 20);
			jComboBoxComuneDic.setBounds(RealDim.getAbsoluteXValue(394),RealDim.getAbsoluteYValue(52),RealDim.getAbsoluteXValue(289),RealDim.getAbsoluteYValue(20));
		}
		return jComboBoxComuneDic;
	}
	/**
	 * This method initializes labelIndirizzo
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getLabelIndirizzo() {
		if (labelIndirizzo == null) {
			labelIndirizzo = new javax.swing.JLabel();
			//labelIndirizzo.setBounds(45, 86, 60, 10);
			labelIndirizzo.setText("Indirizzo;");
			labelIndirizzo.setBounds(RealDim.getAbsoluteXValue(45),RealDim.getAbsoluteYValue(86),RealDim.getAbsoluteXValue(60),RealDim.getAbsoluteYValue(10));
		}
		return labelIndirizzo;
	}
	/**
	 * This method initializes jTextIndirizzoDic
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextIndirizzoDic() {
		if (jTextIndirizzoDic == null) {
			jTextIndirizzoDic = new javax.swing.JTextField();
			//jTextIndirizzoDic.setBounds(140, 82, 544, 19);
			jTextIndirizzoDic.setBounds(RealDim.getAbsoluteXValue(140),RealDim.getAbsoluteYValue(82),RealDim.getAbsoluteXValue(544),RealDim.getAbsoluteYValue(19));
			jTextIndirizzoDic.setDocument(new StringDocument(Frontespizio.dimIndirizzoDepositoFiscale));
		}
		return jTextIndirizzoDic;
	}
	/**
	 * This method initializes jPanel2
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel2() {
		if (jPanel2 == null) {
			jPanel2 = new javax.swing.JPanel();
			jPanel2.setLayout(null);
		
		
			jPanel2.add(getLabelProvincia1(), null);
			jPanel2.add(getJComboBoxProvinciaUffAmm(), null);
			jPanel2.add(getLabelComune1(), null);
			jPanel2.add(getJComboBoxComuneUffAmm(), null);
			jPanel2.add(getLabelIndirizzo1(), null);
			jPanel2.add(getJTextField12(), null);
			//jPanel2.setBounds(12, 233, 770, 87);
			jPanel2.setBackground(java.awt.Color.lightGray);
			jPanel2.setBorder(
				javax.swing.BorderFactory.createLineBorder(
					java.awt.Color.black,
					1));
			jPanel2.setBounds(RealDim.getAbsoluteXValue(12),RealDim.getAbsoluteYValue(233),RealDim.getAbsoluteXValue(770),RealDim.getAbsoluteYValue(87));
			jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Ufficio Amministrativo", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));		
		}
		return jPanel2;
	}
	
	
	/**
	 * This method initializes labelProvincia1
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getLabelProvincia1() {
		if (labelProvincia1 == null) {
			labelProvincia1 = new javax.swing.JLabel();
			//labelProvincia1.setBounds(44, 27, 85, 14);
			labelProvincia1.setText("Provincia:");
			labelProvincia1.setBounds(RealDim.getAbsoluteXValue(44),RealDim.getAbsoluteYValue(27),RealDim.getAbsoluteXValue(85),RealDim.getAbsoluteYValue(14));
		}
		return labelProvincia1;
	}
	/**
	 * This method initializes jComboBoxProvinciaUffAmm
	 * 
	 * @return javax.swing.JComboBox
	 */
	private javax.swing.JComboBox getJComboBoxProvinciaUffAmm() {
		if (jComboBoxProvinciaUffAmm == null) {
			jComboBoxProvinciaUffAmm = new javax.swing.JComboBox();
			//jComboBoxProvinciaUffAmm.setBounds(140, 24, 130, 20);
			jComboBoxProvinciaUffAmm.setBounds(RealDim.getAbsoluteXValue(140),RealDim.getAbsoluteYValue(24),RealDim.getAbsoluteXValue(130),RealDim.getAbsoluteYValue(20));
		}
		return jComboBoxProvinciaUffAmm;
	}
	/**
	 * This method initializes labelComune1
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getLabelComune1() {
		if (labelComune1 == null) {
			labelComune1 = new javax.swing.JLabel();
			//labelComune1.setBounds(333, 24, 53, 16);
			labelComune1.setText("Comune:");
			labelComune1.setBounds(RealDim.getAbsoluteXValue(333),RealDim.getAbsoluteYValue(24),RealDim.getAbsoluteXValue(53),RealDim.getAbsoluteYValue(16));
		}
		return labelComune1;
	}
	/**
	 * This method initializes jComboBoxComuneUffAmm
	 * 
	 * @return javax.swing.JComboBox
	 */
	private javax.swing.JComboBox getJComboBoxComuneUffAmm() {
		if (jComboBoxComuneUffAmm == null) {
			jComboBoxComuneUffAmm = new javax.swing.JComboBox();
			//jComboBoxComuneUffAmm.setBounds(394, 24, 292, 20);
			jComboBoxComuneUffAmm.setBounds(RealDim.getAbsoluteXValue(394),RealDim.getAbsoluteYValue(24),RealDim.getAbsoluteXValue(292),RealDim.getAbsoluteYValue(20));
			
		}
		return jComboBoxComuneUffAmm;
	}
	/**
	 * This method initializes labelIndirizzo1
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getLabelIndirizzo1() {
		if (labelIndirizzo1 == null) {
			labelIndirizzo1 = new javax.swing.JLabel();
			//labelIndirizzo1.setBounds(44, 56, 66, 17);
			labelIndirizzo1.setText("Indirizzo:");
			labelIndirizzo1.setBounds(RealDim.getAbsoluteXValue(44),RealDim.getAbsoluteYValue(56),RealDim.getAbsoluteXValue(66),RealDim.getAbsoluteYValue(17));
		}
		return labelIndirizzo1;
	}
	/**
	 * This method initializes jTextFieldIndirizzoUffAmm
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextField12() {
		if (jTextFieldIndirizzoUffAmm == null) {
			jTextFieldIndirizzoUffAmm = new javax.swing.JTextField();
			//jTextFieldIndirizzoUffAmm.setBounds(140, 55, 544, 19);
			jTextFieldIndirizzoUffAmm.setBounds(RealDim.getAbsoluteXValue(140),RealDim.getAbsoluteYValue(55),RealDim.getAbsoluteXValue(544),RealDim.getAbsoluteYValue(19));
			jTextFieldIndirizzoUffAmm.setDocument(new StringDocument(Frontespizio.dimIndirizzoSedeUfficioAmm));
		}
		
		return jTextFieldIndirizzoUffAmm;
	}
	/**
	 * This method initializes jPanel3
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel3() {
		if (jPanel3 == null) {
			jPanel3 = new javax.swing.JPanel();
			jPanel3.setLayout(null);
			jPanel3.add(getJButtonSalva(), null);
			jPanel3.add(getJButtonSalvaAs(), null);
			jPanel3.add(getJButtonStampa(), null);
			jPanel3.add(getJButtonChiudi(), null);
			//jPanel3.setBounds(12, 327, 309, 138);
			jPanel3.setBounds(RealDim.getAbsoluteXValue(12),RealDim.getAbsoluteYValue(327),RealDim.getAbsoluteXValue(309),RealDim.getAbsoluteYValue(138));
		}
		return jPanel3;
	}
	/**
	 * This method initializes jButtonSalva
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonSalva() {
		if (jButtonSalva == null) {
			jButtonSalva = new javax.swing.JButton();
			//jButtonSalva.setBounds(14, 14, 127, 28);
			jButtonSalva.setText("Salva");
			jButtonSalva.addActionListener(this);
			jButtonSalva.setBounds(RealDim.getAbsoluteXValue(14),RealDim.getAbsoluteYValue(14),RealDim.getAbsoluteXValue(127),RealDim.getAbsoluteYValue(28));
		}
		return jButtonSalva;
	}
	/**
	 * This method initializes jButtonSalvaAs
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonSalvaAs() {
		if (jButtonSalvaAs == null) {
			jButtonSalvaAs = new javax.swing.JButton();
			//jButtonSalvaAs.setBounds(151, 14, 127, 28);
			jButtonSalvaAs.setText("Salva con nome");
			jButtonSalvaAs.addActionListener(this);
			jButtonSalvaAs.setBounds(RealDim.getAbsoluteXValue(151),RealDim.getAbsoluteYValue(14),RealDim.getAbsoluteXValue(127),RealDim.getAbsoluteYValue(28));
		}
		return jButtonSalvaAs;
	}
	/**
	 * This method initializes jButtonStampa
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonStampa() {
		if (jButtonStampa == null) {
			jButtonStampa = new javax.swing.JButton();
			//jButtonStampa.setBounds(14, 83, 127, 28);
			jButtonStampa.setText("Stampa");
			jButtonStampa.setBounds(RealDim.getAbsoluteXValue(14),RealDim.getAbsoluteYValue(83),RealDim.getAbsoluteXValue(127),RealDim.getAbsoluteYValue(28));
			
			jButtonStampa.addActionListener(this);
		}
		return jButtonStampa;
	}
	/**
	 * This method initializes jButtonChiudi
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonChiudi() {
		if (jButtonChiudi == null) {
			jButtonChiudi = new javax.swing.JButton();
			//jButtonChiudi.setBounds(151, 83, 127, 28);
			jButtonChiudi.setText("Chiudi");
			jButtonChiudi.addActionListener(this);
			jButtonChiudi.setBounds(RealDim.getAbsoluteXValue(151),RealDim.getAbsoluteYValue(83),RealDim.getAbsoluteXValue(127),RealDim.getAbsoluteYValue(28));

		}
		return jButtonChiudi;
	}
	/**
	 * This method initializes jPanel4
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel4() {
		if (jPanel4 == null) {
			jPanel4 = new javax.swing.JPanel();
			jPanel4.setLayout(null);
			jPanel4.add(getJScrollPane(), null);
			jPanel4.add(getJTextFieldSpecificaQuadro(), null);
			//jPanel4.add(getListDettagliQuadro(), null);
			
			jPanel4.add(getJListDettaglioQuadri(), null);
			//SALVATORE
			jPanel4.add(getJScrollPane2(), null);
			//
			//jPanel4.add(getListQuadroScelto(), null);
			jPanel4.add(getJLabel2(), null);
			//jPanel4.setBounds(333, 326, 448, 174);
			
			jPanel4.setBackground(java.awt.Color.lightGray);
			jPanel4.setBorder(
				javax.swing.BorderFactory.createLineBorder(
					java.awt.Color.black,
					1));
			jPanel4.setBounds(RealDim.getAbsoluteXValue(333),RealDim.getAbsoluteYValue(326),RealDim.getAbsoluteXValue(448),RealDim.getAbsoluteYValue(174));
		}
		return jPanel4;
	}
	/**
	 * This method initializes jLabel2
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel2() {
		if (jLabel2 == null) {
			jLabel2 = new javax.swing.JLabel();
			//jLabel2.setBounds(11, 3, 110, 15);
			jLabel2.setText("Quadri nel dettaglio");
			jLabel2.setBounds(RealDim.getAbsoluteXValue(6),RealDim.getAbsoluteYValue(1),RealDim.getAbsoluteXValue(110),RealDim.getAbsoluteYValue(15));
		}
		return jLabel2;
	}
	/**
	 * This method initializes jListListaQuadri
	 * 
	 * @return javax.swing.JList
	 */
	private javax.swing.JList getJListListaQuadri() {
		if(jListListaQuadri == null) {
			jListListaQuadri = new javax.swing.JList();
			jListListaQuadri.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.black,1));
			jListListaQuadri.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
			jListListaQuadri.setBounds(RealDim.getAbsoluteXValue(90), RealDim.getAbsoluteYValue(420), RealDim.getAbsoluteXValue(888), RealDim.getAbsoluteYValue(50));
			initQuadri();
			jListListaQuadri.addListSelectionListener(this);
			jListListaQuadri.addMouseListener(this);
		
			
		}
		return jListListaQuadri;
	}
	/**
	 * This method initializes listDettagliQuadro
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JList getJListDettaglioQuadri() {
		if(jListDettaglioQuadri == null) {
			jListDettaglioQuadri = new javax.swing.JList();
			jListDettaglioQuadri.setBounds(183, 20, 260, 124);
			jListDettaglioQuadri.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.black,1));

			jListDettaglioQuadri.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
			jListDettaglioQuadri.addMouseListener(this);
		
		}
		return jListDettaglioQuadri;
	}
	/**
	/**
	 * This method initializes listQuadroScelto
	 * 
	 * @return javax.swing.JList
	 */

	/**
	 * This method initializes jTextFieldSpecificaQuadro
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldSpecificaQuadro() {
		if (jTextFieldSpecificaQuadro == null) {
			jTextFieldSpecificaQuadro = new javax.swing.JTextField();
			//jTextFieldSpecificaQuadro.setBounds(15, 150, 429, 19);
			jTextFieldSpecificaQuadro.setEditable(false);			
			jTextFieldSpecificaQuadro.setBounds(RealDim.getAbsoluteXValue(6),RealDim.getAbsoluteYValue(150),RealDim.getAbsoluteXValue(429),RealDim.getAbsoluteYValue(19));
			
			
		}
		return jTextFieldSpecificaQuadro;
	}
	/**
	 * This method initializes jScrollPane
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private javax.swing.JScrollPane getJScrollPane() {
		if(jScrollPane == null) {
			jScrollPane = new javax.swing.JScrollPane();
			jScrollPane.setViewportView(getJListListaQuadri());
			jScrollPane.setBounds(10, 18, 164, 128);
		/** MODIFICA 31-10-2007
			labelCodiceAccisa.setBounds(RealDim.getAbsoluteXValue(0),RealDim.getAbsoluteYValue(20),RealDim.getAbsoluteXValue(85),RealDim.getAbsoluteYValue(18));
			FINE MODIFICA **/
		}
		return jScrollPane;
	}
	
	/**
	 * This method initializes jScrollPane
	 * 
	 * @return javax.swing.JScrollPane
	 */
	//SALVATORE
	private javax.swing.JScrollPane getJScrollPane2() {
		if(scroll == null) {
			scroll = new javax.swing.JScrollPane();
			scroll.setViewportView(jListDettaglioQuadri);
			scroll.setBounds(183, 20, 260, 124);
		}
		return scroll;
	}
	//

	private javax.swing.JPanel getStartupPanel() {
			if(startupPanel == null) {
				startupPanel = new javax.swing.JPanel();
				startupPanel.setLayout(new java.awt.BorderLayout());
				startupPanel.add(getJLabelIcon(), java.awt.BorderLayout.CENTER);
				
			}
			return startupPanel;
		}
		/**
		 * This method initializes JLabelIcon
		 * 
		 * @return javax.swing.JLabel
		 */
		private javax.swing.JLabel getJLabelIcon() {
			if(JLabelIcon == null) {
				JLabelIcon = new javax.swing.JLabel();
				JLabelIcon.setText("");
				JLabelIcon.setIcon(new javax.swing.ImageIcon(getClass().getResource("/it/finanze/dogane/accise/ui/icons/Repub.jpg")));
				JLabelIcon.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
				JLabelIcon.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
			}
			return JLabelIcon;
		}
		
	/**
	 * @return
	 */
	public boolean isSendActionMode() {
		return sendActionMode;
	}

	/**
	 * @param b
	 */
	public void setSendActionMode(boolean b) {
		sendActionMode = b;
	}

	private void doOpenInterchageSession() {
		MetanoInterchangeDialog dialogInterchange= new MetanoInterchangeDialog(this);
		dialogInterchange.setVisible(true);
	}

}
