/*
 * Created on 11-ott-06
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package it.finanze.dogane.accise.metano.ui;

import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import it.finanze.dogane.accise.metano.model.MetanoInterchange;
import it.finanze.dogane.accise.metano.model.ProspettoConsumo;
import it.finanze.dogane.accise.metano.model.ProspettoInterchange;
import it.finanze.dogane.accise.ui.InterchangeDialog;

/**
 * @author Fiorello
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class MetanoInterchangeDialog
	extends InterchangeDialog
	implements ActionListener {

	private MetanoInterchange model = null;
	private ProspettoConsumo prospetto = null;

	/**
	 * This is the default constructor
	 */
	public MetanoInterchangeDialog(Frame frame) {
		super(frame, "Creazione dei file per l'Interchange", true);
		model = new MetanoInterchange();
		addListnerS();
		init();

	}

	private void addListnerS() {
		getJTextFieldUtenteAbilitato()
			.addKeyListener(new java.awt.event.KeyAdapter() {
			public void keyReleased(java.awt.event.KeyEvent e) {
				elaboraNomeFlusso();
			}
		});
		getJTextFieldGGInterchange()
			.addKeyListener(new java.awt.event.KeyAdapter() {
			public void keyReleased(java.awt.event.KeyEvent e) {
				elaboraNomeFlusso();
			}
		});
		getJTextFieldMMInterchange()
			.addKeyListener(new java.awt.event.KeyAdapter() {
			public void keyReleased(java.awt.event.KeyEvent e) {
				elaboraNomeFlusso();
			}
		});
		getJTextFieldProgInterchange()
			.addKeyListener(new java.awt.event.KeyAdapter() {
			public void keyReleased(java.awt.event.KeyEvent e) {
				elaboraNomeFlusso();
			}
		});

	}
	private void init() {
		prospetto = new ProspettoConsumo();
		model = new MetanoInterchange();

		// inizializzo i TXTFIELD
		loadUIFromModel(model);
		// calcolo il nome del file
		elaboraNomeFlusso();

	}

	private void doAddFile() {
		ProspettoConsumo prospettoAperto = GestoreEventi.openProspect(this);
		if (prospettoAperto != null) {
			prospetto = prospettoAperto;
			// aggiorno il text field della directory
			this.getJTextFieldFileInterchange().setText(
				prospetto.getResourceAccess().getFileName());
			//aggiorno il model
			model.setFileNameInterchange(
				prospetto.getResourceAccess().getFileName());
		}
		elaboraNomeFlusso();
	}

	private void doConfirm() {
		boolean isOk = checkParametri();
		if (isOk) {
			doSaveAsInterchange();
		}
	}

	private void doSaveAsInterchange() {
		loadModelFromUI(model);
		ProspettoInterchange prospettoInter =
			new ProspettoInterchange(prospetto);
		prospettoInter.setInterchangeRecordTestata(model);

		boolean saved = false;
		saved = GestoreEventi.saveProspectInterchange(this, prospettoInter);
		if (saved) {
			// this.setTitle(prospetto.getResourceAccess().getFileName());
		}
	}

	protected void elaboraNomeFlusso() {
		// aggiorno il model
		loadModelFromUI(model);
		String nome = ".";
		String estensione = ".c";
		// carico il modello con dati dalla GUI
		nome =
			model.getCodiceUtenteAbilitato()
				+ getMese(model.getMeseInoltro())
				+ getGiorno(model.getGiornoInoltro());
		estensione = estensione + model.getProgressivoInterchange();
		//aggiorno il modello
		model.setNomeFlusso((nome + estensione).toUpperCase());
		getJTextFieldNomeFlusso().setText(model.getNomeFlusso());
	}

	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	/////////     GESTIONE EVENTI                     /////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	public void actionPerformed(ActionEvent event) {
		if (event.getSource() == getJButtonChiudi()) {
			doClose();
		} else if (event.getSource() == getJButtonCreaInterchange()) {
			doConfirm();
		} else if (event.getSource() == getJButtonEliminaFile()) {
			getJTextFieldFileInterchange().setText("");
			model.setFileNameInterchange("");
			prospetto = null;
		} else if (event.getSource() == getJButtonAddFile()) {
			doAddFile();
		}
	}
}