package it.finanze.dogane.accise.metano.ui;

import it.finanze.dogane.accise.combo.TipoCapitolo;
import it.finanze.dogane.accise.combo.TipoFasciaClimatica;
import it.finanze.dogane.accise.combo.TipoMese;
import it.finanze.dogane.accise.combo.TipoProvincia;
import it.finanze.dogane.accise.metano.model.ProspettoConsumo;
import it.finanze.dogane.accise.metano.ui.quadri.Parametri;
import it.finanze.dogane.accise.ui.FullScreenLayoutManager;
import it.finanze.dogane.accise.ui.RealDim;
import it.finanze.dogane.accise.ui.quadri.dialog.IntermediateDialog;
import it.finanze.dogane.accise.util.StringUtil;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.List;

import javax.swing.JDialog;
import javax.swing.JOptionPane;

public class MetanoIntermediateDialog
	extends JDialog
	implements ActionListener, IntermediateDialog {
	private javax.swing.JPanel jContentPane = null;

	private javax.swing.JLabel jLabelProvincia = null;
	private javax.swing.JComboBox jComboBoxProvincia = null;
	private javax.swing.JButton jButtonConferma = null;
	private javax.swing.JButton jButtonAnnulla = null;

	private int actionRequested = 0;

	private javax.swing.JLabel jLabel1 = null;
	private javax.swing.JComboBox jComboBoxCapitolo = null;
	private javax.swing.JLabel jLabelMese = null;
	private javax.swing.JComboBox jComboBoxMese = null;
	private javax.swing.JLabel jLabelFasciaClimatica = null;
	private javax.swing.JTextField jTextFieldFasciaClimatica = null;

	List province = null;
	List mesi = null;
	List capitoli = null;
	boolean fasciaClimatica = false;

	/**
	 * This is the default constructor
	 */
	public MetanoIntermediateDialog() {

		super();
		initialize();
	}

	private void initialize() {
//		this.setSize(615, 230);
		this.setSize(RealDim.getAbsoluteXValue(615), RealDim.getAbsoluteYValue(230));

		int xDim = RealDim.getAbsoluteXDim();
		int yDim = RealDim.getAbsoluteYDim();
		int width = getSize().width;
		int height = getSize().height;

		this.setLocation((xDim - width) / 2, (yDim - height) / 2);

		this.setContentPane(getJContentPane());
		this.setResizable(false);
		this.setModal(true);
		this.setDefaultCloseOperation(
			javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
	}

	public Parametri getSelectedValue() {
		Parametri retvalue = new Parametri();
		
		retvalue.setProvincia((TipoProvincia)getJComboBoxProvincia().getSelectedItem());
		retvalue.setCapitolo((TipoCapitolo)getJComboBoxCapitolo().getSelectedItem());
		retvalue.setMese((TipoMese)getJComboBoxMese().getSelectedItem());
		
		TipoFasciaClimatica fasciaClimatica = new TipoFasciaClimatica();
		
		String codiceFascia = getJTextFieldFasciaClimatica().getText();
		
		codiceFascia = StringUtil.nullify(codiceFascia);
		fasciaClimatica.setCodice(codiceFascia);
		retvalue.setFasciaClimatica(fasciaClimatica);
		
		
		return retvalue;
	}

	public int getActionRequested() {
		return actionRequested;

	}

	/**************************************************************************************
	 * INIZIO GESTIONE EVENTI
	 **************************************************************************************/
	public void actionPerformed(ActionEvent event) {
		if (event.getSource() == jButtonConferma) {
			
			doConfirm();
			
			
		} else if (event.getSource() == jButtonAnnulla) {
			doCancel();
		}
	}

	/**
	 * 
	 */
	private void doConfirm() {
		if(validateValues()) {
			actionRequested = ACTION_CONFIRM;
			this.setVisible(false);
		}
	}

	/**
	 * 
	 */
	private void doCancel() {
		actionRequested = ACTION_CANCEL;
		this.setVisible(false);
	}

	private boolean validateValues() {
		boolean isOk = true;
		
		
		if(jComboBoxProvincia.getSelectedIndex() == -1 && jComboBoxProvincia.isEnabled()) {
			JOptionPane.showMessageDialog(this, "E' Necessario impostare la provincia", "Attenzione", JOptionPane.WARNING_MESSAGE);
			isOk = false;
		}
		
		if(isOk) {
			if(jComboBoxCapitolo.getSelectedIndex() == -1 && jComboBoxCapitolo.isEnabled()) {
				JOptionPane.showMessageDialog(this, "E' Necessario impostare il capitolo", "Attenzione", JOptionPane.WARNING_MESSAGE);
				isOk = false;
			}
		}
		
		if(isOk) {
			if(jTextFieldFasciaClimatica.getText().length() > 3) {
				JOptionPane.showMessageDialog(this, "La fascia climatica deve avere lunghezza massima di 3 caratteri", "Attenzione", JOptionPane.WARNING_MESSAGE);
				isOk = false;
			}
		}

		if(isOk) {
			if(jComboBoxMese.getSelectedIndex() == -1 && jComboBoxMese.isEnabled()) {
				JOptionPane.showMessageDialog(this, "E' Necessario impostare il mese", "Attenzione", JOptionPane.WARNING_MESSAGE);
				isOk = false;
			}
		}
			
		return isOk;
	}

	/**************************************************************************************
	 * FINE GESTIONE EVENTI
	 **************************************************************************************/

	/**
		 * This method initializes jContentPane
		 * 
		 * @return javax.swing.JPanel
		 */
	private javax.swing.JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(null);
			jContentPane.setLayout(FullScreenLayoutManager.getInstance());
			jContentPane.add(getJLabelProvincia(), null);
			jContentPane.add(getJComboBoxProvincia(), null);
			jContentPane.add(getJButtonConferma(), null);
			jContentPane.add(getJButtonAnnulla(), null);
			jContentPane.add(getJLabel1(), null);
			jContentPane.add(getJComboBoxCapitolo(), null);
			jContentPane.add(getJLabelMese(), null);
			jContentPane.add(getJComboBoxMese(), null);
			jContentPane.add(getJLabelFasciaClimatica(), null);
			jContentPane.add(getJTextFieldFasciaClimatica(), null);
		}
		return jContentPane;
	}
	/**
	 * This method initializes jLabelProvincia
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelProvincia() {
		if (jLabelProvincia == null) {
			jLabelProvincia = new javax.swing.JLabel();
			jLabelProvincia.setBounds(0, 20, 114, 23);
			jLabelProvincia.setText("Provincia");
			jLabelProvincia.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabelProvincia.setHorizontalTextPosition(
				javax.swing.SwingConstants.RIGHT);
		}
		return jLabelProvincia;
	}
	/**
	 * This method initializes jComboBoxProvincia
	 * 
	 * @return javax.swing.JComboBox
	 */
	private javax.swing.JComboBox getJComboBoxProvincia() {
		if (jComboBoxProvincia == null) {
			jComboBoxProvincia = new javax.swing.JComboBox();
			jComboBoxProvincia.setBounds(120, 20, 371, 24);
			jComboBoxProvincia.setEnabled(false);

		}
		return jComboBoxProvincia;
	}
	/**
	 * This method initializes jButtonConferma
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonConferma() {
		if (jButtonConferma == null) {
			jButtonConferma = new javax.swing.JButton();
			jButtonConferma.setBounds(500, 20, 96, 23);
			jButtonConferma.setText("Conferma");
			jButtonConferma.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);

			jButtonConferma.addActionListener(this);
		}
		return jButtonConferma;
	}
	/**
	 * This method initializes jButtonAnnulla
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonAnnulla() {
		if (jButtonAnnulla == null) {
			jButtonAnnulla = new javax.swing.JButton();
			jButtonAnnulla.setBounds(500, 60, 96, 23);
			jButtonAnnulla.setText("Annulla");
			jButtonAnnulla.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);

			jButtonAnnulla.addActionListener(this);
		}
		return jButtonAnnulla;
	}

	/**
	 * This method initializes jLabel1
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel1() {
		if (jLabel1 == null) {
			jLabel1 = new javax.swing.JLabel();
			jLabel1.setBounds(0, 62, 114, 23);
			jLabel1.setText("Capitolo");
			jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}
		return jLabel1;
	}
	/**
	 * This method initializes jComboBoxCapitolo
	 * 
	 * @return javax.swing.JComboBox
	 */
	private javax.swing.JComboBox getJComboBoxCapitolo() {
		if (jComboBoxCapitolo == null) {
			jComboBoxCapitolo = new javax.swing.JComboBox();
			jComboBoxCapitolo.setBounds(120, 62, 371, 24);
			jComboBoxCapitolo.setEnabled(false);
			jComboBoxCapitolo.setSelectedIndex(-1);
		}
		return jComboBoxCapitolo;
	}
	/**
	 * This method initializes jLabelMese
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelMese() {
		if (jLabelMese == null) {
			jLabelMese = new javax.swing.JLabel();
			jLabelMese.setBounds(0, 104, 114, 23);
			jLabelMese.setText("Mese");
			jLabelMese.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabelMese;
	}
	/**
	 * This method initializes jComboBoxMese
	 * 
	 * @return javax.swing.JComboBox
	 */
	private javax.swing.JComboBox getJComboBoxMese() {
		if (jComboBoxMese == null) {
			jComboBoxMese = new javax.swing.JComboBox();
			jComboBoxMese.setBounds(120, 104, 371, 24);
			jComboBoxMese.setEnabled(false);
			jComboBoxMese.setSelectedIndex(-1);
		}
		return jComboBoxMese;
	}
	/**
	 * This method initializes jLabelFasciaClimatica
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelFasciaClimatica() {
		if (jLabelFasciaClimatica == null) {
			jLabelFasciaClimatica = new javax.swing.JLabel();
			jLabelFasciaClimatica.setBounds(0, 146, 114, 23);
			jLabelFasciaClimatica.setText("Fascia climatica");
			jLabelFasciaClimatica.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabelFasciaClimatica;
	}
	/**
	 * This method initializes jTextFieldFasciaClimatica
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldFasciaClimatica() {
		if (jTextFieldFasciaClimatica == null) {
			jTextFieldFasciaClimatica = new javax.swing.JTextField();
			jTextFieldFasciaClimatica.setBounds(120, 146, 143, 24);
			jTextFieldFasciaClimatica.setEnabled(false);
			jTextFieldFasciaClimatica.setEditable(false);
		}
		return jTextFieldFasciaClimatica;
	}
	/**
	 * @return
	 */
	public List getCapitoli() {
		return capitoli;
	}

	/**
	 * @return
	 */
	public List getMesi() {
		return mesi;
	}

	/**
	 * @return
	 */
	public List getProvince() {
		return province;
	}

	/**
	 * @param list
	 */
	public void setCapitoli(List list) {
		capitoli = list;
		if (capitoli != null) {
			Iterator it = capitoli.iterator();
			while (it.hasNext()) {
				getJComboBoxCapitolo().addItem(it.next());
			}
			jComboBoxCapitolo.setEnabled(true);
			jComboBoxCapitolo.setSelectedIndex(-1);
		}
	}

	/**
	 * @param list
	 */
	public void setMesi(List list) {
		this.mesi = list;
		if (mesi != null) {
			Iterator it = mesi.iterator();
			while (it.hasNext()) {
				getJComboBoxMese().addItem(it.next());
			}
			jComboBoxMese.setEnabled(true);
			jComboBoxMese.setSelectedIndex(-1);
		}
	}

	/**
	 * @param list
	 */
	public void setProvince(List list) {
		province = list;
		if (province != null) {
			Iterator it = province.iterator();
			while (it.hasNext()) {
				getJComboBoxProvincia().addItem(it.next());
			}
			jComboBoxProvincia.setEnabled(true);
			jComboBoxProvincia.setSelectedIndex(-1);
		}
	}

	/**
	 * @return
	 */
	public boolean isFasciaClimatica() {
		return fasciaClimatica;
	}

	/**
	 * @param b
	 */
	public void setFasciaClimatica(boolean b) {
		fasciaClimatica = b;
		if (isFasciaClimatica()) {
			jTextFieldFasciaClimatica.setEnabled(true);
			jTextFieldFasciaClimatica.setEditable(true);
		}
	}

} //  @jve:visual-info  decl-index=0 visual-constraint="10,10"
