package it.finanze.dogane.accise.metano.ui;


import it.finanze.dogane.accise.combo.TipoComune;
import it.finanze.dogane.accise.combo.TipoMese;
import it.finanze.dogane.accise.combo.TipoProvincia;
import it.finanze.dogane.accise.metano.model.Frontespizio;
import it.finanze.dogane.accise.metano.model.MetanoIntrodottoInDepositiFiscali;
import it.finanze.dogane.accise.metano.model.ProspettoConsumo;
import it.finanze.dogane.accise.metano.ui.quadri.Parametri;
import it.finanze.dogane.accise.metano.ui.quadri.Quadro;
import it.finanze.dogane.accise.metano.ui.tablemodel.MetanoIntrodottoInDepositiFiscaliPuntiImmissioneTM;
import it.finanze.dogane.accise.metano.ui.tablemodel.MetanoIntrodottoInDepositiFiscaliTM;
import it.finanze.dogane.accise.model.Prospect;
import it.finanze.dogane.accise.pdf.PdfBuilder;
import it.finanze.dogane.accise.pdf.PdfPrintable;
import it.finanze.dogane.accise.ui.FullScreenLayoutManager;
import it.finanze.dogane.accise.ui.RealDim;
import it.finanze.dogane.accise.ui.TableUtil;
import it.finanze.dogane.accise.ui.quadri.GestoreQuadro;
import it.finanze.dogane.accise.ui.quadri.dialog.IntermediateDialog;
import it.finanze.dogane.accise.ui.quadri.dialog.QuadroDialog;
import it.finanze.dogane.accise.ui.validation.BigIntegerDocument;
import it.finanze.dogane.accise.ui.validation.StringDocument;
import it.finanze.dogane.accise.ui.validation.Validator;
import it.finanze.dogane.accise.util.StringUtil;

import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.math.BigInteger;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;


public class MetanoIntrodottoInDepositiFiscaliDialog extends JDialog implements ActionListener, ListSelectionListener, QuadroDialog, FocusListener, PdfPrintable {

	private javax.swing.JPanel jContentPane = null;

	private javax.swing.JPanel jPanelIntestazione = null;
	private javax.swing.JLabel jLabelMese = null;
	private javax.swing.JLabel jLabelNomeQuadro = null;
	private javax.swing.JLabel jLabelTitoloQuadro = null;
	private javax.swing.JPanel jPanelPuntiImmissione = null;
	private javax.swing.JButton jButtonNuovoPI = null;
	private javax.swing.JButton jButtonEliminaPI = null;
	private javax.swing.JPanel jPanelQuantita = null;
	private javax.swing.JTextField jTextFieldMetanoProprio = null;
	private javax.swing.JTextField jTextFieldAltreFonti = null;
	private javax.swing.JTextField jTextFieldCodAccisaNaz = null;
	private javax.swing.JTextField jTextFieldMetanoNaz = null;
	private javax.swing.JTextField jTextFieldCodAccisaUE = null;
	private javax.swing.JTextField jTextFieldMetanoUE = null;
	private javax.swing.JTextField jTextFieldMetanoExtraUE = null;
	private javax.swing.JTextField jTextFieldTotale = null;
	private javax.swing.JButton jButtonElimina = null;
	private javax.swing.JButton jButtonModifica = null;
	private javax.swing.JButton jButtonInserisci = null;
	private javax.swing.JPanel jPanelTotali = null;
	private javax.swing.JTextField jTextFieldTotMetanoProprio = null;
	private javax.swing.JTextField jTextFieldTotAltreFonti = null;
	private javax.swing.JTextField jTextFieldTotMetanoNaz = null;
	private javax.swing.JTextField jTextFieldTotMetanoUE = null;
	private javax.swing.JTextField jTextFieldTotMetanoExtraUE = null;
	private javax.swing.JTextField jTextFieldTotTotale = null;
	private javax.swing.JButton jButtonConferma = null;
	private javax.swing.JButton jButtonChiudi = null;
	private javax.swing.JLabel jLabel7 = null;
	private javax.swing.JLabel jLabel8 = null;
	private javax.swing.JLabel jLabel9 = null;
	private ProspettoConsumo prospettoConsumo = null;
	private Quadro quadro = null;	
	private TipoMese tipoMese = null;
	private javax.swing.JLabel jLabel = null;
	private javax.swing.JLabel jLabel4 = null;
	private javax.swing.JLabel jLabel5 = null;
	private javax.swing.JLabel jLabel10 = null;
	private javax.swing.JLabel jLabel11 = null;
	private javax.swing.JLabel jLabel12 = null;
	private javax.swing.JLabel jLabel13 = null;
	private javax.swing.JLabel jLabel14 = null;
	private javax.swing.JLabel jLabel15 = null;
	private javax.swing.JLabel jLabel16 = null;
	private javax.swing.JScrollPane jScrollPane1 = null;
	private javax.swing.JTable jTableDettaglio = null;
	private javax.swing.JScrollPane jScrollPane = null;
	private javax.swing.JTable jTablePuntiDiImmissione = null;
	private boolean flagModifica = false;
	private MetanoIntrodottoInDepositiFiscali totaleRecord = null;
	private javax.swing.JLabel jLabel6 = null;

	private javax.swing.JButton jButtonModificaPI = null;
	/**
	 * This is the default constructor
	 */
	public MetanoIntrodottoInDepositiFiscaliDialog(Frame frame, String description, String secondDescription) {
		super(frame, "Prospetto mensile del gas naturale movimentato", true);
		getJLabelTitoloQuadro().setText(description);
		getJLabelNomeQuadro().setText(secondDescription);
		initialize();
	
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		// this.setSize(800, 600);
		this.setSize(RealDim.getAbsoluteXValue(800), RealDim.getAbsoluteYValue(600));
		this.setContentPane(getJContentPane());
		this.setLocation(0, 0);
		this.setResizable(false);
		this.setModal(true);
		this.setDefaultCloseOperation(
			javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
			
			
		getJTextFieldAltreFonti().addFocusListener(this);
		getJTextFieldCodAccisaNaz().addFocusListener(this);
		getJTextFieldCodAccisaUE().addFocusListener(this);
		getJTextFieldMetanoExtraUE().addFocusListener(this);
		getJTextFieldMetanoNaz().addFocusListener(this);
		getJTextFieldMetanoProprio().addFocusListener(this);
		getJTextFieldMetanoUE().addFocusListener(this);
	}
	
	public void prepareValues(Prospect prospect, GestoreQuadro gestoreQuadro) {

		prospettoConsumo = (ProspettoConsumo) prospect;
		Frontespizio frontespizio = prospettoConsumo.getFrontespizio();

		this.quadro = (Quadro) gestoreQuadro;
		List lista = prospettoConsumo.getListaQuadro(quadro.getTipiRecord());

		tipoMese = ((Parametri)quadro.getParameter()).getMese();

		boolean isAnnuale = false;
		if(Integer.parseInt(tipoMese.getCodice()) == 0) { // Annuale!
			getJLabelMese().setText("Prospetto Annuale");
			isAnnuale = true;
			super.setTitle("Prospetto annuale del gas naturale movimentato");
		} else {
			getJLabelMese().setText("Mese di " + tipoMese.getDescrizione());
		}
		int mese = Integer.parseInt(tipoMese.getCodice());
		List listaXMese = Quadro.getListaRecordPerMese(lista, mese);
		
	    preparaTotale(listaXMese, isAnnuale);

		if(listaXMese.size() == 0) { // Allora devo inizializzare in modo strano....
			
			MetanoIntrodottoInDepositiFiscaliPuntiImmissioneTM modelPuntiImmissione = new MetanoIntrodottoInDepositiFiscaliPuntiImmissioneTM(lista, tipoMese);
			jTablePuntiDiImmissione.setModel(modelPuntiImmissione);
			TableUtil.redimTable(jTablePuntiDiImmissione, jScrollPane);	

			MetanoIntrodottoInDepositiFiscaliTM model = new MetanoIntrodottoInDepositiFiscaliTM();
			jTableDettaglio.setModel(model);
			TableUtil.redimTable(jTableDettaglio, jScrollPane);		    
			
		} else {
			MetanoIntrodottoInDepositiFiscaliPuntiImmissioneTM modelPuntiImmissione = new MetanoIntrodottoInDepositiFiscaliPuntiImmissioneTM(listaXMese, null);
			jTablePuntiDiImmissione.setModel(modelPuntiImmissione);
			TableUtil.redimTable(jTablePuntiDiImmissione, jScrollPane);	

			MetanoIntrodottoInDepositiFiscaliTM model = new MetanoIntrodottoInDepositiFiscaliTM();
			jTableDettaglio.setModel(model);
			TableUtil.redimTable(jTableDettaglio, jScrollPane);		    
		}
		
	}
		
	private void preparaTotale(List list, boolean isAnnuale) {
		if (list != null) {
			Iterator it = list.iterator();
			boolean found = false;
			while (it.hasNext() && !found) {
				MetanoIntrodottoInDepositiFiscali record =(MetanoIntrodottoInDepositiFiscali) it.next();

				if (record.getTipoRigo().equals(BigInteger.valueOf(9)) && record.getProgPuntoImmissione().equals(BigInteger.valueOf(999))) {
					totaleRecord = record;
					found = true;
					it.remove();
				}
			}
			if(!found) {
				totaleRecord = MetanoIntrodottoInDepositiFiscali.getNewObject(prospettoConsumo);
				totaleRecord.setTipoRigo(BigInteger.valueOf(9));
				totaleRecord.setTipoRecord(BigInteger.valueOf(quadro.getTipiRecord()[0]));
				totaleRecord.setProgPuntoImmissione(BigInteger.valueOf(999));
				totaleRecord.setMese(new BigInteger(tipoMese.getCodice()));
				
				if(isAnnuale) {
					preparaTotaleAnnuale();
				}
			}
			
			jTextFieldTotAltreFonti.setText(totaleRecord.getMetanoAltreFonti().toString());
			jTextFieldTotMetanoExtraUE.setText(totaleRecord.getMetanoFornitoreExtraUE().toString());
			jTextFieldTotMetanoNaz.setText(totaleRecord.getMetanoFornitoreNazionale().toString());
			jTextFieldTotMetanoProprio.setText(totaleRecord.getMetanoPropriPozzi().toString());
			jTextFieldTotMetanoUE.setText(totaleRecord.getMetanoFornitoreUE().toString());
			jTextFieldTotTotale.setText(totaleRecord.getTotale().toString());
		}
	}

	private void preparaTotaleAnnuale() {
		List list = prospettoConsumo.getListaQuadro(quadro.getTipiRecord());
		Iterator it = list.iterator();
		while (it.hasNext()) {
			MetanoIntrodottoInDepositiFiscali record =(MetanoIntrodottoInDepositiFiscali) it.next();

			if (record.getTipoRigo().equals(BigInteger.valueOf(9)) && record.getProgPuntoImmissione().equals(BigInteger.valueOf(999))) {
				// Si tratta di un totale ==> nulla da fare
			} else {
				// Devo sommare i valori
				totaleRecord.setMetanoAltreFonti(totaleRecord.getMetanoAltreFonti().add(record.getMetanoAltreFonti()));
				totaleRecord.setMetanoFornitoreExtraUE(totaleRecord.getMetanoFornitoreExtraUE().add(record.getMetanoFornitoreExtraUE()));
				totaleRecord.setMetanoFornitoreNazionale(totaleRecord.getMetanoFornitoreNazionale().add(record.getMetanoFornitoreNazionale()));
				totaleRecord.setMetanoFornitoreUE(totaleRecord.getMetanoFornitoreUE().add(record.getMetanoFornitoreUE()));
				totaleRecord.setMetanoPropriPozzi(totaleRecord.getMetanoPropriPozzi().add(record.getMetanoPropriPozzi()));
				
				totaleRecord.setTotale(totaleRecord.getMetanoAltreFonti());
				totaleRecord.setTotale(totaleRecord.getTotale().add(totaleRecord.getMetanoFornitoreExtraUE()));
				totaleRecord.setTotale(totaleRecord.getTotale().add(totaleRecord.getMetanoFornitoreNazionale()));
				totaleRecord.setTotale(totaleRecord.getTotale().add(totaleRecord.getMetanoFornitoreUE()));
				totaleRecord.setTotale(totaleRecord.getTotale().add(totaleRecord.getMetanoPropriPozzi()));
			}
		}
		
	}

	public void plot(PdfBuilder pdfBuilder) {
		pdfBuilder.startCommandBlock();
		pdfBuilder.writeCenteredLabel(this.getTitle(), 14);
		pdfBuilder.moveYPen(50);

		pdfBuilder.endCommandBlock();

		
		int rowcount = jTablePuntiDiImmissione.getRowCount();
		for(int i = 0; i < rowcount; i++) {
			jTablePuntiDiImmissione.getSelectionModel().setSelectionInterval(i, i);
			MetanoIntrodottoInDepositiFiscaliPuntiImmissioneTM model = (MetanoIntrodottoInDepositiFiscaliPuntiImmissioneTM)jTablePuntiDiImmissione.getModel();
			MetanoIntrodottoInDepositiFiscali punto = model.getPunto(i);
			
			//SALVATORE
			pdfBuilder.startDefineTableHeader();		
			//
			
			if(i == 0) { // Solo la prima volta!
				pdfBuilder.moveXPen(50);
				pdfBuilder.writeRightLabel(jLabelMese.getText(), 12);
				pdfBuilder.moveYPen(10);
				pdfBuilder.setXPen(PdfBuilder.MARGINE);
				pdfBuilder.writeLeftLabel(jLabelTitoloQuadro.getText(), 12);
				pdfBuilder.moveYPen(-14);
				pdfBuilder.writeRightLabel(jLabelNomeQuadro.getText(), 12);
				pdfBuilder.moveYPen(20);
			}

			pdfBuilder.writeCenteredLabel("Punto di Immissione: " + punto.getComunePuntoImmissione() + "     Provincia: " + punto.getProvinciaPuntoImmissione() + "     Indirizzo:  " + punto.getIndirizzoPuntoImmissione(), 10);
			pdfBuilder.moveYPen(1);

			//SALVATORE
			pdfBuilder.endDefineTableHeader();		
			//

			pdfBuilder.writeTable(this, jTableDettaglio, jScrollPane);
			pdfBuilder.moveYPen(20);
		}

		pdfBuilder.startCommandBlock();

		pdfBuilder.moveXPen(230);
		pdfBuilder.writeLeftLabel("Totali", 10);
		pdfBuilder.moveXPen(20);
		float y = pdfBuilder.getYPen();
		pdfBuilder.writeLeftLabel("Di propriet: ", 10);
		pdfBuilder.writeLeftLabel("Proveniente da Altre Fonti: ", 10);
		pdfBuilder.writeLeftLabel("Proveniente da Fornitori Nazionali: ", 10);
		pdfBuilder.writeLeftLabel("Proveniente da Fornitori UE: ", 10);
		pdfBuilder.writeLeftLabel("Proveniente da Fornitori Extra UE: ", 10);
		pdfBuilder.writeLeftLabel("Totale: ", 10);
		pdfBuilder.setXPen(PdfBuilder.MARGINE);

		float y2 = pdfBuilder.getYPen();
		// Mi rimetto all'inizio e comincio a scrivere i valori
		pdfBuilder.moveYPen(y - y2); // All'interno di un blocco non si pu utilizzare una setYPen		
		pdfBuilder.writeRightLabel(totaleRecord.getMetanoPropriPozzi().toString(), 10);
		pdfBuilder.writeRightLabel(totaleRecord.getMetanoAltreFonti().toString(), 10);
		pdfBuilder.writeRightLabel(totaleRecord.getMetanoFornitoreNazionale().toString(), 10);
		pdfBuilder.writeRightLabel(totaleRecord.getMetanoFornitoreUE().toString(), 10);
		pdfBuilder.writeRightLabel(totaleRecord.getMetanoFornitoreExtraUE().toString(), 10);
		pdfBuilder.writeRightLabel(totaleRecord.getTotale().toString(), 10);

		pdfBuilder.endCommandBlock();
		pdfBuilder.moveYPen(20);
	}
	
	/*************************************************************************
	 * INIZIO GESTIONE EVENTI
	 *************************************************************************/
	 
	public void actionPerformed(ActionEvent event) {

		try {
			if (event.getSource() == jButtonChiudi) {
				doClose();
			} else if (event.getSource() == jButtonConferma) {
				doConfirm();
			} else if (event.getSource() == jButtonElimina) {
				doDelete();
			} else if (event.getSource() == jButtonInserisci) {
				doInsert();
			} else if (event.getSource() == jButtonModifica) {
				doUpdate();
			} else if (event.getSource() == jButtonNuovoPI) {
				doNewPI();
			} else if (event.getSource() == jButtonModificaPI) {
				doUpdatePI();
			} else if (event.getSource() == jButtonEliminaPI) {
				doDeletePI();
			}
		}
		catch(Exception e) {
			e.printStackTrace();
			JOptionPane.showMessageDialog(this, e.getMessage(), "Errore", JOptionPane.WARNING_MESSAGE);
		}
	}

	public void valueChanged(ListSelectionEvent event) {
		try {
			if (event.getSource() == jTableDettaglio.getSelectionModel()) {
				loadUIFromRecord();
			}
			if (event.getSource() == jTablePuntiDiImmissione.getSelectionModel()) {
				mostraQuantita();
			}
		}
		catch(Exception e) {
			e.printStackTrace();
			JOptionPane.showMessageDialog(this, e.getMessage(), "Errore sulla lista", JOptionPane.WARNING_MESSAGE);
		}
	}

	public void focusGained(FocusEvent event) {}

	public void focusLost(FocusEvent event) {
		if(
				event.getSource()==getJTextFieldAltreFonti() ||
				event.getSource()==getJTextFieldCodAccisaNaz() ||
				event.getSource()==getJTextFieldCodAccisaUE() ||
				event.getSource()==getJTextFieldMetanoExtraUE() ||
				event.getSource()==getJTextFieldMetanoNaz() ||
				event.getSource()==getJTextFieldMetanoProprio() ||
				event.getSource()==getJTextFieldMetanoUE()
			){
			updateRecordTot();
		}
	}

	private void doNewPI() {
		PuntiDiImmissioneIntermediateDialog puntiDiImmissioneIntermediateDialog = new PuntiDiImmissioneIntermediateDialog();			  
		puntiDiImmissioneIntermediateDialog.setVisible(true);

		if(puntiDiImmissioneIntermediateDialog.getActionRequested() == IntermediateDialog.ACTION_CONFIRM) {
			MetanoIntrodottoInDepositiFiscaliPuntiImmissioneTM model = (MetanoIntrodottoInDepositiFiscaliPuntiImmissioneTM)jTablePuntiDiImmissione.getModel();	
			MetanoIntrodottoInDepositiFiscali record = MetanoIntrodottoInDepositiFiscali.getNewObject(prospettoConsumo);
			record.setTipoRigo(BigInteger.valueOf(0));
			record.setMese(new BigInteger(tipoMese.getCodice()));

		
			TipoProvincia tipoProvincia = puntiDiImmissioneIntermediateDialog.getSelectedProvincia();
			TipoComune tipoComune = puntiDiImmissioneIntermediateDialog.getSelectedComune();
			String indirizzo = puntiDiImmissioneIntermediateDialog.getSelectedIndirizzo();
		
			record.setProvinciaPuntoImmissione(tipoProvincia.getCodice());
			record.setComunePuntoImmissione(tipoComune.getDescrizione());
			record.setIndirizzoPuntoImmissione(indirizzo);
		
			model.insertPunto(record);
			jTablePuntiDiImmissione.getSelectionModel().setSelectionInterval(model.getRowCount() - 1, model.getRowCount() - 1);		
			flagModifica=true;
		}
	}
 
	private void doDeletePI() {
		int selectedRow = jTablePuntiDiImmissione.getSelectedRow();
		if(selectedRow != -1) {
			MetanoIntrodottoInDepositiFiscaliPuntiImmissioneTM model = (MetanoIntrodottoInDepositiFiscaliPuntiImmissioneTM)jTablePuntiDiImmissione.getModel();
			MetanoIntrodottoInDepositiFiscali pi = model.getPunto(selectedRow);
			model.removePunto(selectedRow);
			updateTot();	
			flagModifica=true;
			
		}
	}

	private void doUpdatePI() {
		int selectedRow = jTablePuntiDiImmissione.getSelectedRow();
		if(selectedRow != -1) {
			MetanoIntrodottoInDepositiFiscaliPuntiImmissioneTM model = (MetanoIntrodottoInDepositiFiscaliPuntiImmissioneTM)jTablePuntiDiImmissione.getModel();	
			MetanoIntrodottoInDepositiFiscali punto = model.getPunto(selectedRow);
			
			PuntiDiImmissioneIntermediateDialog puntiDiImmissioneIntermediateDialog = new PuntiDiImmissioneIntermediateDialog(punto.getProvinciaPuntoImmissione(), punto.getComunePuntoImmissione(), punto.getIndirizzoPuntoImmissione());			  
			puntiDiImmissioneIntermediateDialog.setVisible(true);

			if(puntiDiImmissioneIntermediateDialog.getActionRequested() == IntermediateDialog.ACTION_CONFIRM) {
		
				TipoProvincia tipoProvincia = puntiDiImmissioneIntermediateDialog.getSelectedProvincia();
				TipoComune tipoComune = puntiDiImmissioneIntermediateDialog.getSelectedComune();
				String indirizzo = puntiDiImmissioneIntermediateDialog.getSelectedIndirizzo();
		
				punto.setProvinciaPuntoImmissione(tipoProvincia.getCodice());
				punto.setComunePuntoImmissione(tipoComune.getDescrizione());
				punto.setIndirizzoPuntoImmissione(indirizzo);
				
				model.fireTableRowsUpdated(selectedRow, selectedRow);
				flagModifica = true;
			}
		} else {
		JOptionPane.showMessageDialog(
						this,
						"Selezionare un elemento dalla lista",
						"Attenzione",
						JOptionPane.WARNING_MESSAGE);
	}
	}

	private void doInsert() {
		if(validateInsert()) {
		
			MetanoIntrodottoInDepositiFiscali record = null;
			
			int rowCount = jTableDettaglio.getRowCount();
			if(rowCount == 0) { // Inserimento da modello vuoto...
				MetanoIntrodottoInDepositiFiscaliPuntiImmissioneTM modelPI = (MetanoIntrodottoInDepositiFiscaliPuntiImmissioneTM)jTablePuntiDiImmissione.getModel();
				int selectedRow = jTablePuntiDiImmissione.getSelectedRow();
				if(selectedRow != -1) {
					record = modelPI.getPunto(selectedRow);
					loadRecordFromUI(record);
					List list = new LinkedList();
					list.add(record);
					modelPI.setListForPunto(selectedRow, list);
					updateTot();
					mostraQuantita();
					// doUpdate();
					flagModifica = true;
					clearFields();
					jTableDettaglio.clearSelection();
					showHideFields(1);
				} else {
					JOptionPane.showMessageDialog(
									this,
									"Per inserire dei dati  necessario selezionare un punto di immissione",
									"Attenzione",
									JOptionPane.WARNING_MESSAGE);
				}
			} else {
				record = MetanoIntrodottoInDepositiFiscali.getNewObject(prospettoConsumo);
				loadRecordFromUIRistretto(record);
				record.setTipoRigo(BigInteger.valueOf(1));
				record.setMese(new BigInteger(tipoMese.getCodice()));
				record.setTipoRecord(BigInteger.valueOf(quadro.getTipiRecord()[0]));
				MetanoIntrodottoInDepositiFiscaliTM model = (MetanoIntrodottoInDepositiFiscaliTM)jTableDettaglio.getModel();
				model.insertRecord(record);
				updateTot();
				flagModifica = true;
				clearFields();
				jTableDettaglio.clearSelection();
				showHideFields(1);
			}
		}
	}
	private void doDelete() {
		MetanoIntrodottoInDepositiFiscaliTM model = (MetanoIntrodottoInDepositiFiscaliTM)jTableDettaglio.getModel();
		int selectedRow = jTableDettaglio.getSelectedRow();
		if(selectedRow == 0) {
			JOptionPane.showMessageDialog(this, "Non si pu eliminare il punto di Immissione da qui.", "Operazione non consentita", JOptionPane.WARNING_MESSAGE);
		} else if(selectedRow > 0) {
			model.removeRecord(selectedRow);
			updateTot();
			flagModifica=true;
		}
	}

	private void doUpdate() {
		if(validateUpdate()) {
			MetanoIntrodottoInDepositiFiscaliTM model = (MetanoIntrodottoInDepositiFiscaliTM)jTableDettaglio.getModel();
			MetanoIntrodottoInDepositiFiscaliPuntiImmissioneTM piModel = (MetanoIntrodottoInDepositiFiscaliPuntiImmissioneTM)jTablePuntiDiImmissione.getModel();
			int selectedRow = jTableDettaglio.getSelectedRow();
			if(selectedRow != -1) {
				MetanoIntrodottoInDepositiFiscali record = model.getRecord(selectedRow);
			
				if(record == null) {
					throw new RuntimeException("Operazione non valida");
				}
				if(selectedRow == 0) { // Prima riga
					loadRecordFromUI(record);
				} else {
					loadRecordFromUIRistretto(record);
				}
		
				model.setRecord(selectedRow, record);
				updateTot();
				flagModifica = true;
//				piModel.setListForPunto(selectedRow, model.getRecords()); // Gestione punti vuoti....
			}else {
				JOptionPane.showMessageDialog(
								this,
								"Selezionare un elemento dalla lista",
								"Attenzione",
								JOptionPane.WARNING_MESSAGE);
			}
		}
	}
	
	
	private void updateRecordTot() {
		BigInteger sum = BigInteger.ZERO;
		BigInteger i =  BigInteger.ZERO;
		String valore = null;

		valore = StringUtil.nullify(jTextFieldAltreFonti.getText()); 
		try {
			i = new BigInteger(valore);
		}
		catch(Exception e) {
			i =  BigInteger.ZERO;
		}
		sum = sum.add(i);

		valore = StringUtil.nullify(jTextFieldMetanoExtraUE.getText()); 
		try {
			i = new BigInteger(valore);
		}
		catch(Exception e) {
			i =  BigInteger.ZERO;
		}
		sum = sum.add(i);

		valore = StringUtil.nullify(jTextFieldMetanoNaz.getText()); 
		try {
			i = new BigInteger(valore);
		}
		catch(Exception e) {
			i =  BigInteger.ZERO;
		}
		sum = sum.add(i);

		valore = StringUtil.nullify(jTextFieldMetanoProprio.getText()); 
		try {
			i = new BigInteger(valore);
		}
		catch(Exception e) {
			i =  BigInteger.ZERO;
		}
		sum = sum.add(i);

		valore = StringUtil.nullify(jTextFieldMetanoUE.getText()); 
		try {
			i = new BigInteger(valore);
		}
		catch(Exception e) {
			i =  BigInteger.ZERO;
		}
		sum = sum.add(i);

		jTextFieldTotale.setText(sum.toString());
		
	}
	
	private void updateTot() {
		totaleRecord.setTotale(BigInteger.ZERO);
		totaleRecord.setMetanoAltreFonti(BigInteger.ZERO);
		totaleRecord.setMetanoFornitoreExtraUE(BigInteger.ZERO);
		totaleRecord.setMetanoFornitoreNazionale(BigInteger.ZERO);
		totaleRecord.setMetanoFornitoreUE(BigInteger.ZERO);
		totaleRecord.setMetanoPropriPozzi(BigInteger.ZERO);

		MetanoIntrodottoInDepositiFiscaliPuntiImmissioneTM modelPI = (MetanoIntrodottoInDepositiFiscaliPuntiImmissioneTM)jTablePuntiDiImmissione.getModel();
		int rowCount = modelPI.getRowCount();
		for(int i=0; i < rowCount; i++) {
			List lista = modelPI.getListForPunto(i);
			if(lista != null && lista.size() > 0) {
				Iterator it = lista.iterator();
				while(it.hasNext()) {
					MetanoIntrodottoInDepositiFiscali item = (MetanoIntrodottoInDepositiFiscali)it.next();

					totaleRecord.setTotale(totaleRecord.getTotale().add(item.getTotale()));
					totaleRecord.setMetanoAltreFonti(totaleRecord.getMetanoAltreFonti().add(item.getMetanoAltreFonti()));
					totaleRecord.setMetanoFornitoreExtraUE(totaleRecord.getMetanoFornitoreExtraUE().add(item.getMetanoFornitoreExtraUE()));
					totaleRecord.setMetanoFornitoreNazionale(totaleRecord.getMetanoFornitoreNazionale().add(item.getMetanoFornitoreNazionale()));
					totaleRecord.setMetanoFornitoreUE(totaleRecord.getMetanoFornitoreUE().add(item.getMetanoFornitoreUE()));
					totaleRecord.setMetanoPropriPozzi(totaleRecord.getMetanoPropriPozzi().add(item.getMetanoPropriPozzi()));
				}
			}
		}
		
		loadUIFromRecordTotale();
	}
	

	private void doClose() {
		int val = validateExitText();
			if(val == JOptionPane.YES_OPTION) {
				doConfirm();
			} else if(val == JOptionPane.NO_OPTION) {
				this.setVisible(false);
			} else if(val == JOptionPane.CANCEL_OPTION) {
			}
	}

	private void doConfirm() {
		MetanoIntrodottoInDepositiFiscaliPuntiImmissioneTM model = (MetanoIntrodottoInDepositiFiscaliPuntiImmissioneTM)jTablePuntiDiImmissione.getModel();
		List nuovaLista = model.getListaRecords();
		
		if(nuovaLista.size() >0) {
			quadro.setEmpty(false);
		}
		else
			quadro.setEmpty(true);
		
		if(nuovaLista == null) {
			nuovaLista = new LinkedList();
		}
		if(nuovaLista.size() > 0) {
			loadRecordTotaleFromUI();
			nuovaLista.add(totaleRecord);

		}

		List listaQuadroCompleta = prospettoConsumo.getListaQuadro(quadro.getTipiRecord());
		// Elimino i vecchi record con il mese in modifica
		Iterator it = listaQuadroCompleta.iterator();
		while(it.hasNext()) {
			MetanoIntrodottoInDepositiFiscali record = (MetanoIntrodottoInDepositiFiscali)it.next();
			if(record.getMese().equals(new BigInteger(tipoMese.getCodice()))) {
				it.remove();
			}
		}

		// Aggiungo i nuovi record per il mese in modifica
		listaQuadroCompleta.addAll(nuovaLista);
		
		// Imposto tutto sul modello! Finally!!!!!
		prospettoConsumo.setListaQuadro(listaQuadroCompleta, quadro.getTipiRecord());
		
		this.setVisible(false);
	}

	private void loadUIFromRecordTotale() {
		jTextFieldTotTotale.setText(totaleRecord.getTotale().toString());		
		jTextFieldTotAltreFonti.setText(totaleRecord.getMetanoAltreFonti().toString());
		jTextFieldTotMetanoExtraUE.setText(totaleRecord.getMetanoFornitoreExtraUE().toString());			
		jTextFieldTotMetanoNaz.setText(totaleRecord.getMetanoFornitoreNazionale().toString());
		jTextFieldTotMetanoUE.setText(totaleRecord.getMetanoFornitoreUE().toString());
		jTextFieldTotMetanoProprio.setText(totaleRecord.getMetanoPropriPozzi().toString());
	}

	private void loadRecordTotaleFromUI() {
		String stringTotale = StringUtil.nullify(jTextFieldTotAltreFonti.getText()); 
		if(stringTotale != null) {
			try {
				BigInteger i = new BigInteger(stringTotale);
				totaleRecord.setMetanoAltreFonti(i);
			}
			catch(NumberFormatException e) {
				totaleRecord.setMetanoAltreFonti(BigInteger.valueOf(0));
			}
		}
		
		stringTotale = StringUtil.nullify(jTextFieldTotMetanoExtraUE.getText()); 
		if(stringTotale != null) {
			try {
				BigInteger i = new BigInteger(stringTotale);
				totaleRecord.setMetanoFornitoreExtraUE(i);
			}
			catch(NumberFormatException e) {
				totaleRecord.setMetanoFornitoreExtraUE(BigInteger.valueOf(0));
			}
		}

		stringTotale = StringUtil.nullify(jTextFieldTotMetanoNaz.getText()); 
		if(stringTotale != null) {
			try {
				BigInteger i = new BigInteger(stringTotale);
				totaleRecord.setMetanoFornitoreNazionale(i);
			}
			catch(NumberFormatException e) {
				totaleRecord.setMetanoFornitoreNazionale(BigInteger.valueOf(0));
			}
		}
		
		stringTotale = StringUtil.nullify(jTextFieldTotMetanoProprio.getText()); 
		if(stringTotale != null) {
			try {
				BigInteger i = new BigInteger(stringTotale);
				totaleRecord.setMetanoPropriPozzi(i);
			}
			catch(NumberFormatException e) {
				totaleRecord.setMetanoPropriPozzi(BigInteger.valueOf(0));
			}
		}
		
		stringTotale = StringUtil.nullify(jTextFieldTotMetanoUE.getText()); 
		if(stringTotale != null) {
			try {
				BigInteger i = new BigInteger(stringTotale);
				totaleRecord.setMetanoFornitoreUE(i);
			}
			catch(NumberFormatException e) {
				totaleRecord.setMetanoFornitoreUE(BigInteger.valueOf(0));
			}
		}

		stringTotale = StringUtil.nullify(jTextFieldTotTotale.getText());
		if(stringTotale != null) {
			try {
				BigInteger i = new BigInteger(stringTotale);
				totaleRecord.setTotale(i);
			}
			catch(NumberFormatException e) {
				totaleRecord.setTotale(BigInteger.valueOf(0));
			}
		}
	}

	private void mostraQuantita(){
		MetanoIntrodottoInDepositiFiscaliPuntiImmissioneTM model = (MetanoIntrodottoInDepositiFiscaliPuntiImmissioneTM)jTablePuntiDiImmissione.getModel();
		int selectedRow = jTablePuntiDiImmissione.getSelectedRow();
		if(selectedRow != -1) {
			List listaRecord = model.getListForPunto(selectedRow);
			if(listaRecord == null || listaRecord.size() == 0) { // Nel caso il modello sia vuoto....
				MetanoIntrodottoInDepositiFiscaliTM modelQuantita = new MetanoIntrodottoInDepositiFiscaliTM();
				jTableDettaglio.setModel(modelQuantita);
				TableUtil.redimTable(jTableDettaglio, jScrollPane);
				//loadUIFromRecord(model.getPunto(selectedRow));
				clearFields();
				
				jButtonElimina.setEnabled(false);
				jButtonModifica.setEnabled(false);
			} else {
				MetanoIntrodottoInDepositiFiscaliTM modelQuantita = new MetanoIntrodottoInDepositiFiscaliTM(listaRecord);
				jTableDettaglio.setModel(modelQuantita);
				TableUtil.redimTable(jTableDettaglio, jScrollPane);
		
				jTableDettaglio.getSelectionModel().setSelectionInterval(0,0);
				loadUIFromRecord();

				jButtonElimina.setEnabled(true);
				jButtonModifica.setEnabled(true);
			}

		} else {
			MetanoIntrodottoInDepositiFiscaliTM modelQuantita = new MetanoIntrodottoInDepositiFiscaliTM();
			jTableDettaglio.setModel(modelQuantita);
			TableUtil.redimTable(jTableDettaglio, jScrollPane);
			clearFields();
		}
	}

	private void loadUIFromRecord(MetanoIntrodottoInDepositiFiscali record) {
		if(record.getMetanoPropriPozzi().equals(BigInteger.valueOf(0))){
			jTextFieldMetanoProprio.setText("");
		}else{
			
			jTextFieldMetanoProprio.setText(String.valueOf(record.getMetanoPropriPozzi()));
		}
		if(record.getMetanoAltreFonti().equals(BigInteger.valueOf(0))){
			jTextFieldAltreFonti.setText("");
		}else{
			jTextFieldAltreFonti.setText(String.valueOf(record.getMetanoAltreFonti()));
		}

		jTextFieldCodAccisaNaz.setText(record.getCodiceAccisaFornitoreNazionale());

		if(record.getMetanoFornitoreNazionale().equals(BigInteger.valueOf(0)))	{
			jTextFieldMetanoNaz.setText("");
		}else{
			jTextFieldMetanoNaz.setText(String.valueOf(record.getMetanoFornitoreNazionale()));
		}

		jTextFieldCodAccisaUE.setText(record.getCodiceAccisaFornitoreUE());

		if(record.getMetanoFornitoreUE().equals(BigInteger.valueOf(0))){
			jTextFieldMetanoUE.setText("");
				
		}else{
			jTextFieldMetanoUE.setText(String.valueOf(record.getMetanoFornitoreUE()));
		}
		if(record.getMetanoFornitoreExtraUE().equals(BigInteger.valueOf(0))){
			jTextFieldMetanoExtraUE.setText("");
				
		}else{
			jTextFieldMetanoExtraUE.setText(String.valueOf(record.getMetanoFornitoreExtraUE()));
		}
		if(record.getTotale().equals(BigInteger.valueOf(0))){
			
			jTextFieldTotale.setText("");
		}else{
			jTextFieldTotale.setText(String.valueOf(record.getTotale()));
		}
		showHideFields(0);
	}
	
	private void loadUIFromRecord() {
		MetanoIntrodottoInDepositiFiscaliTM model =(MetanoIntrodottoInDepositiFiscaliTM) jTableDettaglio.getModel();

		int selectedRow = jTableDettaglio.getSelectedRow();
		int numOfElems = model.getRowCount();
		if (selectedRow == -1 || numOfElems < 1) {
			clearFields();
		} else {
			MetanoIntrodottoInDepositiFiscali record =(MetanoIntrodottoInDepositiFiscali) model.getRecord(selectedRow);
			loadUIFromRecord(record);
			showHideFields(selectedRow);
		}
	}

	/**
	 * @param record
	 */
	private void loadRecordFromUI(MetanoIntrodottoInDepositiFiscali record) {
		
		
		String value = null;
		BigInteger intValue = null;
		
		try {
			value = jTextFieldMetanoProprio.getText();
			intValue = new BigInteger(value);			
		}
		catch(NumberFormatException e) {
			intValue = BigInteger.ZERO;			
		}
		record.setMetanoPropriPozzi(intValue);
		
		try {
			value = jTextFieldAltreFonti.getText();
			intValue = new BigInteger(value);			
		}
		catch(NumberFormatException e) {
			intValue = BigInteger.ZERO;			
		}
		record.setMetanoAltreFonti(intValue);
		
		try {
			value = jTextFieldMetanoExtraUE.getText();
			intValue = new BigInteger(value);			
		}
		catch(NumberFormatException e) {
			intValue = BigInteger.ZERO;			
		}
		record.setMetanoFornitoreExtraUE(intValue);
		
		try {
			value = jTextFieldTotale.getText();
			intValue = new BigInteger(value);			
		}
		catch(NumberFormatException e) {
			intValue = BigInteger.ZERO;			
		}
		record.setTotale(intValue);
		
		loadRecordFromUIRistretto(record);
	}

	private void loadRecordFromUIRistretto(MetanoIntrodottoInDepositiFiscali record) {
		String value = null;
		BigInteger intValue = null;

		try {
			value = jTextFieldMetanoNaz.getText();
			intValue = new BigInteger(value);			
		}
		catch(NumberFormatException e) {
			intValue = BigInteger.ZERO;			
		}
		record.setMetanoFornitoreNazionale(intValue);
		
		try {
			value = jTextFieldMetanoUE.getText();
			intValue = new BigInteger(value);			
		}
		catch(NumberFormatException e) {
			intValue = BigInteger.ZERO;			
		}
		record.setMetanoFornitoreUE(intValue);
		
		value = jTextFieldCodAccisaNaz.getText();
		record.setCodiceAccisaFornitoreNazionale(value);
		
		value = jTextFieldCodAccisaUE.getText();
		record.setCodiceAccisaFornitoreUE(value);
	}

	
	private void clearFields() {
		jTextFieldMetanoProprio.setText("");
		jTextFieldAltreFonti.setText("");
		jTextFieldCodAccisaNaz.setText("");
		jTextFieldMetanoNaz.setText("");
		jTextFieldCodAccisaUE.setText("");
		jTextFieldMetanoUE.setText("");
		jTextFieldMetanoExtraUE.setText("");
		jTextFieldTotale.setText("");
		
		showHideFields(0);
	}

	private void showHideFields(int selectedRow) {
		if (selectedRow == 0) {
			jTextFieldMetanoProprio.setVisible(true);
			jTextFieldAltreFonti.setVisible(true);
			jTextFieldMetanoExtraUE.setVisible(true);
			jTextFieldTotale.setVisible(true);
			
			// jButtonInserisci.setEnabled(false);
				
		} else {
			jTextFieldMetanoProprio.setVisible(false);
			jTextFieldAltreFonti.setVisible(false);					
			jTextFieldMetanoExtraUE.setVisible(false);
			jTextFieldTotale.setVisible(false);

			// jButtonInserisci.setEnabled(true);
		}
	}

	private boolean validateUpdate() {
		return validateInsert();
	}

	private boolean validateInsert() {
		boolean isOk=true;
		
//		if(true)return true;
		
		String codice = StringUtil.nullify(jTextFieldCodAccisaNaz.getText());
		String valore = null;
		if(codice != null) {
			isOk = validateCodAccisaNaz();
			//SALVATORE
			isOk = true;
			//
		}
		if(isOk) {
			valore = StringUtil.nullify(jTextFieldMetanoNaz.getText());
			if(codice == null ^ valore == null) {
				JOptionPane.showMessageDialog(
					this,
					"Il codice accisa nazionale ed i consumi relativi devono essere entrambi presenti o assenti",
					"Attenzione",
					JOptionPane.WARNING_MESSAGE);
				isOk = false;
			}
		}
		if(isOk) {
			isOk = compareAccisaDic();
		}
		if(isOk) {
			codice = StringUtil.nullify(jTextFieldCodAccisaUE.getText());
			if(codice != null) {
				isOk=true;
				// isOk = validateCodAccisaUE();
			}
		}
		if(isOk) {
			valore = StringUtil.nullify(jTextFieldMetanoUE.getText());
			if(codice == null ^ valore == null) {
				JOptionPane.showMessageDialog(
					this,
					"Il codice accisa UE ed i consumi relativi devono essere entrambi presenti o assenti",
					"Attenzione",
					JOptionPane.WARNING_MESSAGE);
				isOk = false;
			}
		}
		
		return isOk;
	}


	private boolean validateCodAccisaUE() {
		boolean isOk=true;
		int valore = jTextFieldCodAccisaUE.getText().length();
		if(valore<20){
		
			JOptionPane.showMessageDialog(
				this,
				"Il codice accisa UE deve essere 20 caratteri",
				"Attenzione",
				JOptionPane.WARNING_MESSAGE);
			isOk=false;
		}
		return isOk;
	}

	private boolean compareAccisaDic() {
		boolean isOk=true;
		Frontespizio frontespizio = prospettoConsumo.getFrontespizio();
		if (frontespizio.getCodiceAccisa().equals(jTextFieldCodAccisaNaz.getText())){
			JOptionPane.showMessageDialog(
					this,
					"I codici accisa deve essere diverso da quello corrente",
					"Attenzione",
					JOptionPane.WARNING_MESSAGE);  
			isOk=false;
		}
		return isOk;
	}

	private boolean validateCodAccisaNaz() {
		boolean isOk=true;
		String codice = jTextFieldCodAccisaNaz.getText();
		int valore = codice.length();
		if(valore<9){
			JOptionPane.showMessageDialog(
				this,
				"Il codice accisa Nazionale deve essere 9 caratteri\n",
				"Attenzione",
				JOptionPane.WARNING_MESSAGE);
			isOk=false;
		}
		if(isOk) {
			if(!Validator.isCodiceDittaForMetano(codice)) {
				JOptionPane.showMessageDialog(
					this,
					"Il codice accisa non  valido",
					"Attenzione",
					JOptionPane.WARNING_MESSAGE);
				isOk=false;
			}
		}
		
		return isOk;
	}
		
	/*************************************************************************
	 * FINE GESTIONE EVENTI
	 *************************************************************************/

	
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(null);
			jContentPane.setLayout(FullScreenLayoutManager.getInstance());
			jContentPane.add(getJPanelIntestazione(), null);
			jContentPane.add(getJPanelPuntiImmissione(), null);
			jContentPane.add(getJPanelQuantita(), null);
			jContentPane.add(getJPanelTotali(), null);
			jContentPane.add(getJButtonConferma(), null);
			jContentPane.add(getJButtonChiudi(), null);
			jContentPane.setBackground(java.awt.Color.lightGray);
		}
		return jContentPane;
	}
	/**;
	 * This method initializes jPanelIntestazione
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanelIntestazione() {
		if(jPanelIntestazione == null) {
			jPanelIntestazione = new javax.swing.JPanel();
			jPanelIntestazione.setLayout(FullScreenLayoutManager.getInstance());
			jPanelIntestazione.setLayout(null);
			jPanelIntestazione.add(getJLabelMese(), null);
			jPanelIntestazione.add(getJLabelNomeQuadro(), null);
			jPanelIntestazione.add(getJLabelTitoloQuadro(), null);
			jPanelIntestazione.setBounds(0, 2, 793, 49);
			jPanelIntestazione.setBackground(java.awt.Color.lightGray);
			jPanelIntestazione.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.black,0));
		}
		return jPanelIntestazione;
	}
	/**
	 * This method initializes jLabelMese
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelMese() {
		if(jLabelMese == null) {
			jLabelMese = new javax.swing.JLabel();
			jLabelMese.setBounds(544, 4, 246, 20);
			jLabelMese.setText("");
			jLabelMese.setBackground(java.awt.Color.lightGray);
			jLabelMese.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
		}
		return jLabelMese;
	}
	/**
	 * This method initializes jLabelNomeQuadro
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelNomeQuadro() {
		if(jLabelNomeQuadro == null) {
			jLabelNomeQuadro = new javax.swing.JLabel();
			jLabelNomeQuadro.setBounds(544, 23, 248, 24);
			jLabelNomeQuadro.setText("");
			jLabelNomeQuadro.setBackground(java.awt.Color.lightGray);
			jLabelNomeQuadro.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
			jLabelNomeQuadro.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
		}
		return jLabelNomeQuadro;
	}
	/**
	 * This method initializes jLabelTitoloQuadro
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelTitoloQuadro() {
		if(jLabelTitoloQuadro == null) {
			jLabelTitoloQuadro = new javax.swing.JLabel();
			jLabelTitoloQuadro.setBounds(0, 29, 126, 19);
			jLabelTitoloQuadro.setText("");
			jLabelTitoloQuadro.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
			jLabelTitoloQuadro.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 18));
		}
		return jLabelTitoloQuadro;
	}
	/**
	 * This method initializes jPanelPuntiImmissione
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanelPuntiImmissione() {
		if(jPanelPuntiImmissione == null) {
			jPanelPuntiImmissione = new javax.swing.JPanel();
			jPanelPuntiImmissione.setLayout(null);
			jPanelPuntiImmissione.setLayout(FullScreenLayoutManager.getInstance());
			jPanelPuntiImmissione.add(getJButtonNuovoPI(), null);
			jPanelPuntiImmissione.add(getJButtonEliminaPI(), null);
			jPanelPuntiImmissione.add(getJButtonModificaPI(), null);
			jPanelPuntiImmissione.add(getJScrollPane(), null);
			jPanelPuntiImmissione.setBounds(1, 51, 791, 121);
			jPanelPuntiImmissione.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Punti di Immissione", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
		}
		return jPanelPuntiImmissione;
	}
	/**
	 * This method initializes jButtonNuovoPI
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonNuovoPI() {
		if(jButtonNuovoPI == null) {
			jButtonNuovoPI = new javax.swing.JButton();
			jButtonNuovoPI.setBounds(656, 21, 83, 27);
			jButtonNuovoPI.setText("Nuovo");
			jButtonNuovoPI.addActionListener(this);
		}
		return jButtonNuovoPI;
	}
	/**
	 * This method initializes jButtonEliminaPI
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonEliminaPI() {
		if(jButtonEliminaPI == null) {
			jButtonEliminaPI = new javax.swing.JButton();
			jButtonEliminaPI.setBounds(656, 51, 83, 27);
			jButtonEliminaPI.setText("Elimina");
			
			jButtonEliminaPI.addActionListener(this);
		}
		return jButtonEliminaPI;
	}
	/**
	 * This method initializes jPanelQuantita
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanelQuantita() {
		if(jPanelQuantita == null) {
			jPanelQuantita = new javax.swing.JPanel();
			jPanelQuantita.setLayout(null);
			jPanelQuantita.setLayout(FullScreenLayoutManager.getInstance());
			jPanelQuantita.add(getJTextFieldMetanoProprio(), null);
			jPanelQuantita.add(getJTextFieldAltreFonti(), null);
			jPanelQuantita.add(getJTextFieldCodAccisaNaz(), null);
			jPanelQuantita.add(getJTextFieldMetanoNaz(), null);
			jPanelQuantita.add(getJTextFieldCodAccisaUE(), null);
			jPanelQuantita.add(getJTextFieldMetanoUE(), null);
			jPanelQuantita.add(getJTextFieldMetanoExtraUE(), null);
			jPanelQuantita.add(getJTextFieldTotale(), null);
			jPanelQuantita.add(getJButtonElimina(), null);
			jPanelQuantita.add(getJButtonModifica(), null);
			jPanelQuantita.add(getJButtonInserisci(), null);
			jPanelQuantita.add(getJLabel7(), null);
			jPanelQuantita.add(getJLabel8(), null);
			jPanelQuantita.add(getJLabel9(), null);
			jPanelQuantita.add(getJLabel(), null);
			jPanelQuantita.add(getJLabel4(), null);
			jPanelQuantita.add(getJLabel5(), null);
			jPanelQuantita.add(getJLabel10(), null);
			jPanelQuantita.add(getJLabel11(), null);
			jPanelQuantita.add(getJLabel12(), null);
			jPanelQuantita.add(getJLabel13(), null);
			jPanelQuantita.add(getJLabel14(), null);
			jPanelQuantita.add(getJLabel15(), null);
			jPanelQuantita.add(getJLabel16(), null);
			jPanelQuantita.add(getJScrollPane1(), null);
			jPanelQuantita.add(getJLabel6(), null);
			jPanelQuantita.setBounds(1, 174, 791, 302);
			jPanelQuantita.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Quantit", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
		}
		return jPanelQuantita;
	}
	/**
	 * This method initializes jTextFieldMetanoProprio
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldMetanoProprio() {
		if(jTextFieldMetanoProprio == null) {
			jTextFieldMetanoProprio = new javax.swing.JTextField();
			jTextFieldMetanoProprio.setBounds(new java.awt.Rectangle(3,242,98,19));

			jTextFieldMetanoProprio.setDocument(new BigIntegerDocument(MetanoIntrodottoInDepositiFiscali.dimMetanoPropriPozzi));
		}
		return jTextFieldMetanoProprio;
	}
	/**
	 * This method initializes jTextFieldAltreFonti
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldAltreFonti() {
		if(jTextFieldAltreFonti == null) {
			jTextFieldAltreFonti = new javax.swing.JTextField();
			jTextFieldAltreFonti.setBounds(100, 242, 97, 19);

			jTextFieldAltreFonti.setDocument(new BigIntegerDocument(MetanoIntrodottoInDepositiFiscali.dimMetanoPropriPozzi));
		}
		return jTextFieldAltreFonti;
	}
	/**
	 * This method initializes jTextFieldCodAccisaNaz
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldCodAccisaNaz() {
		if(jTextFieldCodAccisaNaz == null) {
			jTextFieldCodAccisaNaz = new javax.swing.JTextField();
			jTextFieldCodAccisaNaz.setBounds(197, 242, 96, 19);
			// jTextFieldCodAccisaNaz.addFocusListener(this);
		
			jTextFieldCodAccisaNaz.setDocument(new StringDocument(MetanoIntrodottoInDepositiFiscali.dimCodiceAccisaFornitoreNazionale));
		}
		return jTextFieldCodAccisaNaz;
	}
	/**
	 * This method initializes jTextFieldMatanoNaz
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldMetanoNaz() {
		if(jTextFieldMetanoNaz == null) {
			jTextFieldMetanoNaz = new javax.swing.JTextField();
			jTextFieldMetanoNaz.setBounds(293, 242, 98, 19);

			jTextFieldMetanoNaz.setDocument(new BigIntegerDocument(MetanoIntrodottoInDepositiFiscali.dimMetanoFornitoreNazionale));
		}
		return jTextFieldMetanoNaz;
	}
	/**
	 * This method initializes jTextFieldCodAccisaUE
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldCodAccisaUE() {
		if(jTextFieldCodAccisaUE == null) {
			jTextFieldCodAccisaUE = new javax.swing.JTextField();
			jTextFieldCodAccisaUE.setBounds(390, 242, 97, 19);
            jTextFieldCodAccisaUE.setDocument(new StringDocument(MetanoIntrodottoInDepositiFiscali.dimCodiceAccisaFornitoreUE));
			// jTextFieldCodAccisaUE.addFocusListener(this);
		}
		return jTextFieldCodAccisaUE;
	}
	/**
	 * This method initializes jTextFieldMetanoUE
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldMetanoUE() {
		if(jTextFieldMetanoUE == null) {
			jTextFieldMetanoUE = new javax.swing.JTextField();
			jTextFieldMetanoUE.setBounds(487, 242, 97, 19);

			jTextFieldMetanoUE.setDocument(new BigIntegerDocument(MetanoIntrodottoInDepositiFiscali.dimMetanoFornitoreUE));
		}
		return jTextFieldMetanoUE;
	}
	/**
	 * This method initializes jTextFieldMetanoExtraUE
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldMetanoExtraUE() {
		if(jTextFieldMetanoExtraUE == null) {
			jTextFieldMetanoExtraUE = new javax.swing.JTextField();
			jTextFieldMetanoExtraUE.setBounds(584, 242, 97, 19);

			jTextFieldMetanoExtraUE.setDocument(new BigIntegerDocument(MetanoIntrodottoInDepositiFiscali.dimMetanoFornitoreExtraUE));
		}
		return jTextFieldMetanoExtraUE;
	}
	/**
	 * This method initializes jTextFieldTotale
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldTotale() {
		if(jTextFieldTotale == null) {
			jTextFieldTotale = new javax.swing.JTextField();
			jTextFieldTotale.setBounds(681, 242, 98, 19);

			jTextFieldTotale.setDocument(new BigIntegerDocument(MetanoIntrodottoInDepositiFiscali.dimTotale));
		}
		return jTextFieldTotale;
	}
	/**
	 * This method initializes jButtonElimina
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonElimina() {
		if(jButtonElimina == null) {
			jButtonElimina = new javax.swing.JButton();
			jButtonElimina.setBounds(694, 267, 83, 27);
			jButtonElimina.setText("Elimina");
			
			jButtonElimina.addActionListener(this);
			jButtonElimina.setEnabled(false);
		}
		return jButtonElimina;
	}
	/**
	 * This method initializes jButtonModifica
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonModifica() {
		if(jButtonModifica == null) {
			jButtonModifica = new javax.swing.JButton();
			jButtonModifica.setBounds(607, 267, 83, 27);
			jButtonModifica.setText("Modifica");

			jButtonModifica.addActionListener(this);
			jButtonModifica.setEnabled(false);
		}
		return jButtonModifica;
	}
	/**
	 * This method initializes jButtonInserisci
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonInserisci() {
		if(jButtonInserisci == null) {
			jButtonInserisci = new javax.swing.JButton();
			jButtonInserisci.setBounds(520, 267, 83, 27);
			jButtonInserisci.setText("Inserisci");
			
			jButtonInserisci.addActionListener(this);
			// jButtonInserisci.setEnabled(false);
		}
		return jButtonInserisci;
	}
	/**
	 * This method initializes jPanelTotali
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanelTotali() {
		if(jPanelTotali == null) {
			jPanelTotali = new javax.swing.JPanel();
			jPanelTotali.setLayout(null);
			jPanelTotali.setLayout(FullScreenLayoutManager.getInstance());
			jPanelTotali.add(getJTextFieldTotMetanoProprio(), null);
			jPanelTotali.add(getJTextFieldTotAltreFonti(), null);
			jPanelTotali.add(getJTextFieldTotMetanoNaz(), null);
			jPanelTotali.add(getJTextFieldTotMetanoUE(), null);
			jPanelTotali.add(getJTextFieldTotMetanoExtraUE(), null);
			jPanelTotali.add(getJTextFieldTotTotale(), null);
			jPanelTotali.setBounds(2, 477, 792, 45);
			jPanelTotali.setBackground(java.awt.Color.lightGray);
			jPanelTotali.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Totali", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
		}
		return jPanelTotali;
	}
	/**
	 * This method initializes jTextFieldTotMetanoProprio
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldTotMetanoProprio() {
		if(jTextFieldTotMetanoProprio == null) {
			jTextFieldTotMetanoProprio = new javax.swing.JTextField();
			jTextFieldTotMetanoProprio.setBounds(3, 17, 98, 19);
			
			jTextFieldTotMetanoProprio.setDocument(new BigIntegerDocument(MetanoIntrodottoInDepositiFiscali.dimMetanoPropriPozzi));
		}
		return jTextFieldTotMetanoProprio;
	}
	/**
	 * This method initializes jTextFieldTotAltreFonti
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldTotAltreFonti() {
		if(jTextFieldTotAltreFonti == null) {
			jTextFieldTotAltreFonti = new javax.swing.JTextField();
			jTextFieldTotAltreFonti.setBounds(100, 17, 97, 19);

			jTextFieldTotAltreFonti.setDocument(new BigIntegerDocument(MetanoIntrodottoInDepositiFiscali.dimMetanoAltreFonti));

		}
		return jTextFieldTotAltreFonti;
	}
	/**
	 * This method initializes jTextFieldTotMetanoNaz
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldTotMetanoNaz() {
		if(jTextFieldTotMetanoNaz == null) {
			jTextFieldTotMetanoNaz = new javax.swing.JTextField();
			jTextFieldTotMetanoNaz.setBounds(293, 17, 98, 19);

			jTextFieldTotMetanoNaz.setDocument(new BigIntegerDocument(MetanoIntrodottoInDepositiFiscali.dimMetanoFornitoreNazionale));

		}
		return jTextFieldTotMetanoNaz;
	}
	/**
	 * This method initializes jTextFieldTotMetanoUE
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldTotMetanoUE() {
		if(jTextFieldTotMetanoUE == null) {
			jTextFieldTotMetanoUE = new javax.swing.JTextField();
			jTextFieldTotMetanoUE.setBounds(487, 17, 97, 19);

			jTextFieldTotMetanoUE.setDocument(new BigIntegerDocument(MetanoIntrodottoInDepositiFiscali.dimMetanoFornitoreUE));
		}
		return jTextFieldTotMetanoUE;
	}
	/**
	 * This method initializes jTextFieldTotMetanoExtraUE
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldTotMetanoExtraUE() {
		if(jTextFieldTotMetanoExtraUE == null) {
			jTextFieldTotMetanoExtraUE = new javax.swing.JTextField();
			jTextFieldTotMetanoExtraUE.setBounds(584, 17, 97, 19);

			jTextFieldTotMetanoExtraUE.setDocument(new BigIntegerDocument(MetanoIntrodottoInDepositiFiscali.dimMetanoFornitoreExtraUE));
		}
		return jTextFieldTotMetanoExtraUE;
	}
	/**
	 * This method initializes jTextFieldTotTotale
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldTotTotale() {
		if(jTextFieldTotTotale == null) {
			jTextFieldTotTotale = new javax.swing.JTextField();
			jTextFieldTotTotale.setBounds(681, 17, 98, 19);

			jTextFieldTotTotale.setDocument(new BigIntegerDocument(MetanoIntrodottoInDepositiFiscali.dimTotale));
		}
		return jTextFieldTotTotale;
	}
	/**
	 * This method initializes jButtonConferma
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonConferma() {
		if(jButtonConferma == null) {
			jButtonConferma = new javax.swing.JButton();
			jButtonConferma.setBounds(7, 526, 90, 26);
			jButtonConferma.setText("Conferma");

			jButtonConferma.addActionListener(this);
		}
		return jButtonConferma;
	}
	/**
	 * This method initializes jButtonChiudi
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonChiudi() {
		if(jButtonChiudi == null) {
			jButtonChiudi = new javax.swing.JButton();
			jButtonChiudi.setBounds(105, 526, 90, 26);
			jButtonChiudi.setText("Chiudi");
			jButtonChiudi.addActionListener(this);
		}
		return jButtonChiudi;
	}
	/**
	 * This method initializes jLabel7
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel7() {
		if(jLabel7 == null) {
			jLabel7 = new javax.swing.JLabel();
			jLabel7.setBounds(197, 203, 192, 18);
			jLabel7.setText("NAZIONALI");
			jLabel7.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			jLabel7.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1));
		}
		return jLabel7;
	}
	/**
	 * This method initializes jLabel8
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel8() {
		if(jLabel8 == null) {
			jLabel8 = new javax.swing.JLabel();
			jLabel8.setBounds(390, 203, 193, 18);
			jLabel8.setText("UE");
			jLabel8.setVerticalAlignment(javax.swing.SwingConstants.TOP);
			jLabel8.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			jLabel8.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1));
		}
		return jLabel8;
	}
	/**
	 * This method initializes jLabel9
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel9() {
		if(jLabel9 == null) {
			jLabel9 = new javax.swing.JLabel();
			jLabel9.setBounds(584, 203, 96, 18);
			jLabel9.setText("EXTRA UE");
			jLabel9.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1));
			jLabel9.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			jLabel9.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
		}
		return jLabel9;
	}
	
	private javax.swing.JLabel getJLabel() {
		if(jLabel == null) {
			jLabel = new javax.swing.JLabel();
			jLabel.setBounds(2, 216, 98, 10);
			jLabel.setText("Proveniente");
			jLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}
		return jLabel;
	}
	/**
	 * This method initializes jLabel4
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel4() {
		if(jLabel4 == null) {
			jLabel4 = new javax.swing.JLabel();
			jLabel4.setBounds(2, 230, 98, 10);
			jLabel4.setText("da propri pozzi");
			jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}
		return jLabel4;
	}
	/**
	 * This method initializes jLabel5
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel5() {
		if(jLabel5 == null) {
			jLabel5 = new javax.swing.JLabel();
			jLabel5.setBounds(101, 216, 97, 10);
			jLabel5.setText("Proveniente");
			jLabel5.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}
		return jLabel5;
	}
	/**
	 * This method initializes jLabel10
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel10() {
		if(jLabel10 == null) {
			jLabel10 = new javax.swing.JLabel();
			jLabel10.setBounds(101, 230, 97, 10);
			jLabel10.setText("da altre fonti");
			jLabel10.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}
		return jLabel10;
	}
	/**
	 * This method initializes jLabel11
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel11() {
		if(jLabel11 == null) {
			jLabel11 = new javax.swing.JLabel();
			jLabel11.setBounds(197, 182, 483, 20);
			jLabel11.setText("PROVENIENTE DA ALTRI FORNITORI");
			jLabel11.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			jLabel11.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1));
		}
		return jLabel11;
	}
	/**
	 * This method initializes jLabel12
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel12() {
		if(jLabel12 == null) {
			jLabel12 = new javax.swing.JLabel();
			jLabel12.setBounds(197, 230, 96, 10);
			jLabel12.setText("Codice accisa/ditta");
			jLabel12.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}
		return jLabel12;
	}
	/**
	 * This method initializes jLabel13
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel13() {
		if(jLabel13 == null) {
			jLabel13 = new javax.swing.JLabel();
			jLabel13.setBounds(293, 230, 98, 10);
			jLabel13.setText("Metri cubi");
			jLabel13.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}
		return jLabel13;
	}
	/**
	 * This method initializes jLabel14
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel14() {
		if(jLabel14 == null) {
			jLabel14 = new javax.swing.JLabel();
			jLabel14.setBounds(390, 230, 97, 10);
			jLabel14.setText("Codice accisa/ditta");
			jLabel14.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}
		return jLabel14;
	}
	/**
	 * This method initializes jLabel15
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel15() {
		if(jLabel15 == null) {
			jLabel15 = new javax.swing.JLabel();
			jLabel15.setBounds(487, 230, 97, 10);
			jLabel15.setText("Metri cubi");
			jLabel15.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}
		return jLabel15;
	}
	/**
	 * This method initializes jLabel16
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel16() {
		if(jLabel16 == null) {
			jLabel16 = new javax.swing.JLabel();
			jLabel16.setBounds(584, 230, 97, 10);
			jLabel16.setText("Metri cubi");
			jLabel16.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}
		return jLabel16;
	}
	
	
			
	private int validateExitText() {
			int retvalue = JOptionPane.NO_OPTION;
			if(flagModifica==true) {
				retvalue = JOptionPane.showConfirmDialog(this, "Le modifiche effettutate verranno perse. Vuoi salvare le modifiche?", "", JOptionPane.YES_NO_CANCEL_OPTION);
			}
			return retvalue;
		}			
	

	/**
	 * This method initializes jTableDettaglio
	 * 
	 * @return javax.swing.JTable
	 */
	private javax.swing.JTable getJTableDettaglio() {
		if(jTableDettaglio == null) {
			jTableDettaglio = new javax.swing.JTable();
			jTableDettaglio.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
			jTableDettaglio.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
			jTableDettaglio.getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			jTableDettaglio.getSelectionModel().addListSelectionListener(this);
		}
		return jTableDettaglio;
	}
	/**
	 * This method initializes jScrollPane1
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private javax.swing.JScrollPane getJScrollPane1() {
		if(jScrollPane1 == null) {
			jScrollPane1 = new javax.swing.JScrollPane();
			jScrollPane1.setBounds(7, 17, 777, 158);
			jScrollPane1.setViewportView(getJTableDettaglio());
		}
		return jScrollPane1;
	}
	/**
	 * This method initializes jTablePuntiDiImmissione
	 * 
	 * @return javax.swing.JTable
	 */
	private javax.swing.JTable getJTablePuntiDiImmissione() {
		if(jTablePuntiDiImmissione == null) {
			jTablePuntiDiImmissione = new javax.swing.JTable();
			jTablePuntiDiImmissione.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
			jTablePuntiDiImmissione.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
			jTablePuntiDiImmissione.getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			jTablePuntiDiImmissione.getSelectionModel().addListSelectionListener(this);
		}
		return jTablePuntiDiImmissione;
	}
	/**
	 * This method initializes jScrollPane
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private javax.swing.JScrollPane getJScrollPane() {
		if(jScrollPane == null) {
			jScrollPane = new javax.swing.JScrollPane();
			jScrollPane.setBounds(6, 20, 637, 92);
			jScrollPane.setViewportView(getJTablePuntiDiImmissione());
		}
		return jScrollPane;
	}
	/* (non-Javadoc)
	 * @see java.awt.event.MouseListener#mouseClicked(java.awt.event.MouseEvent)
	

	/**
	 * This method initializes jLabel6
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel6() {
		if(jLabel6 == null) {
			jLabel6 = new javax.swing.JLabel();
			jLabel6.setBounds(681, 230, 98, 10);
			jLabel6.setText("TOTALE");
			jLabel6.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}
		return jLabel6;
	}
	/**
	 * This method initializes jButtonModificaPI
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonModificaPI() {
		if(jButtonModificaPI == null) {
			jButtonModificaPI = new javax.swing.JButton();
			jButtonModificaPI.setBounds(656, 81, 83, 27);
			jButtonModificaPI.setText("Modifica");
			
			jButtonModificaPI.addActionListener(this);
		}
		return jButtonModificaPI;
	}


}  //  @jve:visual-info  decl-index=0 visual-constraint="108,25"
