/*
 * Created on 20-set-06
 * 
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package it.finanze.dogane.accise.metano.ui;

import it.finanze.dogane.accise.combo.AbstractTipo;
import it.finanze.dogane.accise.combo.TipoCapitolo;
import it.finanze.dogane.accise.combo.TipoFasciaClimatica;
import it.finanze.dogane.accise.combo.TipoMese;
import it.finanze.dogane.accise.combo.TipoProvincia;

import it.finanze.dogane.accise.metano.model.Frontespizio;
import it.finanze.dogane.accise.metano.model.MetanoLiquidazioneImposte;
import it.finanze.dogane.accise.metano.model.ProspettoConsumo;
import it.finanze.dogane.accise.metano.ui.quadri.Parametri;
import it.finanze.dogane.accise.metano.ui.quadri.Quadro;
import it
	.finanze
	.dogane
	.accise
	.metano
	.ui
	.tablemodel
	.MetanoLiquidazioneImposteTM;
import it.finanze.dogane.accise.model.Prospect;
import it.finanze.dogane.accise.pdf.DataFirmaPiePagina;
import it.finanze.dogane.accise.pdf.PdfBuilder;
import it.finanze.dogane.accise.pdf.PdfPrintable;
import it.finanze.dogane.accise.ui.TableUtil;
import it.finanze.dogane.accise.ui.quadri.GestoreQuadro;
import it.finanze.dogane.accise.ui.quadri.dialog.LiquidazioneImposteDialog;
import it.finanze.dogane.accise.ui.validation.BigDecimalDocument;
import it.finanze.dogane.accise.ui.validation.BigIntegerDocument;
import it.finanze.dogane.accise.ui.validation.SignedBigDecimalDocument;
import it.finanze.dogane.accise.ui.validation.SignedBigIntegerDocument;
import it.finanze.dogane.accise.util.StringUtil;

import java.awt.Component;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.event.ListSelectionEvent;

/**
 * @author Fiorello
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class MetanoLiquidazioneImposteDialog
	extends LiquidazioneImposteDialog implements PdfPrintable {
		

	private ProspettoConsumo prospettoConsumo = null;
	private Quadro quadro = null;
	private TipoCapitolo tipoCapitolo = null;
	private TipoProvincia tipoProvincia = null;
	private TipoMese tipoMese = null;
	private TipoFasciaClimatica fasciaClimatica = null;
	private BigDecimal totale= new BigDecimal(0);
	private boolean flagModifica=false;
	/**
	 * This is the default constructor
	 */
	public MetanoLiquidazioneImposteDialog(
		Frame frame,
		String description,
		String secondDescription) {
		super(
			frame,
			"Prospetto di liquidazione dell'accisa",
			true,
			description,
			secondDescription);
			initialize();
			getJTextFieldAliquota().setDocument(new BigDecimalDocument(MetanoLiquidazioneImposte.DIM_ALIQUOTA_IMPOSTA_INTERE,MetanoLiquidazioneImposte.DIM_ALIQUOTA_IMPOSTA_DECIMALI));
			getJTextFieldImpostaEuro().setDocument(new SignedBigDecimalDocument(MetanoLiquidazioneImposte.DIM_IMPOSTA_EURO_INTERE,MetanoLiquidazioneImposte.DIM_IMPOSTA_EURO_DECIMALI));
			getJTextFieldConsumi().setDocument(new SignedBigIntegerDocument(MetanoLiquidazioneImposte.DIM_CONSUMI));
	}

	public void prepareValues(Prospect prospect, GestoreQuadro gestoreQuadro) {
		prospettoConsumo = (ProspettoConsumo) prospect;
		this.quadro = (Quadro) gestoreQuadro;
		
		String letteraQuadro= quadro.getLettera().trim();
		List listaQuadroCompleta = prospettoConsumo.getListaQuadro(quadro.getTipiRecord());
	
		if (letteraQuadro.equals("I")){
			getJComboBoxAliquota().setVisible(true);
			getJTextFieldAliquota().setVisible(false);
			Component editor = getJComboBoxAliquota().getEditor().getEditorComponent();
			if(editor instanceof JTextField) {
				JTextField txtFld = (JTextField)editor;
				txtFld.setDocument(new BigDecimalDocument(MetanoLiquidazioneImposte.DIM_ALIQUOTA_IMPOSTA_INTERE, MetanoLiquidazioneImposte.DIM_ALIQUOTA_IMPOSTA_DECIMALI));
			}
		} else {
			getJComboBoxAliquota().setVisible(false);
			getJTextFieldAliquota().setVisible(true);
		}

		List lista = prospettoConsumo.getListaQuadro(quadro.getTipiRecord());
		Parametri parametriSelezionati = (Parametri) quadro.getParameter();
		tipoProvincia = parametriSelezionati.getProvincia();
		tipoCapitolo = parametriSelezionati.getCapitolo();
		tipoMese = parametriSelezionati.getMese();
		fasciaClimatica = parametriSelezionati.getFasciaClimatica();
		
		lista = Quadro.getListaRecordParametrizzato(lista, parametriSelezionati, quadro);
	
		MetanoLiquidazioneImposteTM model =
			new MetanoLiquidazioneImposteTM(
				lista,
				quadro.getTipiRecord(),
				tipoCapitolo);
		getJTable().setModel(model);

		//getJTable().getSelectionModel().setSelectionInterval(0, 0);
		TableUtil.redimTable(getJTable(), getJScrollPane());
		
		if (tipoCapitolo != null) {
			getJLabelCapitolo().setText(tipoCapitolo.getDescrizione());
		}
		if (tipoProvincia != null) {
			getJLabel2().setText("Provincia di: "+tipoProvincia.getDescrizioneEstesa());
		}
		if (fasciaClimatica!=null && fasciaClimatica.getCodice()!=null) {
			getJLabel2().setText("Provincia di: "+tipoProvincia.getDescrizioneEstesa()+" - Fascia climatica:"+fasciaClimatica.getCodice());
		}
		
		/** MODIFICA 05-11-2007 **/
		if (letteraQuadro.equals("M")) {
		
			MetanoLiquidazioneImposte recordRettifica = (MetanoLiquidazioneImposte) model.getRecord(model.getRowCount()-2);
			
			
			Iterator it = listaQuadroCompleta.iterator();
			
			while(it.hasNext()) {
				MetanoLiquidazioneImposte rProvv = (MetanoLiquidazioneImposte) it.next();
				
			if(recordRettifica==null && rProvv.getProvincia().equals(tipoProvincia.getCodice())) {
				
				if (rProvv.getProgressivoIdentificativo().intValue()==7) {
					
				recordRettifica = MetanoLiquidazioneImposte.getNewObject(prospettoConsumo);
				recordRettifica.setImpostaEuro(rProvv.getImpostaEuro());
				recordRettifica.setTipoRecord(BigInteger.valueOf(quadro.getTipiRecord()[0]));
			
				if(tipoCapitolo != null) {
					recordRettifica.setCapitoliImputazioneImposta(new BigInteger(tipoCapitolo.getCapitolo()));
				}
				if(tipoProvincia != null) {
					recordRettifica.setProvincia(tipoProvincia.getCodice());
				}
				if(fasciaClimatica != null) {
					recordRettifica.setFasciaClimatica(fasciaClimatica.getCodice());
				}
					
					//loadRecordFromUI(recordRettifica);
					model.setRecord(6, recordRettifica);
					showHideFields(recordRettifica); 
					getJTable().getSelectionModel().setSelectionInterval(
						model.getRowCount()-2,
						model.getRowCount()-2);
					flagModifica = true;

			
					}
				}	
				
				MetanoLiquidazioneImposte recordTotale = (MetanoLiquidazioneImposte) model.getRecord(model.getRowCount()-1);
				if(recordTotale==null && rProvv.getProvincia().equals(tipoProvincia.getCodice())) {
				
				if (rProvv.getProgressivoIdentificativo().intValue()==8) {
					
					recordTotale = MetanoLiquidazioneImposte.getNewObject(prospettoConsumo);
					recordTotale.setImpostaEuro(rProvv.getImpostaEuro());
					recordTotale.setTipoRecord(BigInteger.valueOf(quadro.getTipiRecord()[0]));
			
				if(tipoCapitolo != null) {
					recordTotale.setCapitoliImputazioneImposta(new BigInteger(tipoCapitolo.getCapitolo()));
				}
				if(tipoProvincia != null) {
					recordTotale.setProvincia(tipoProvincia.getCodice());
				}
				if(fasciaClimatica != null) {
					recordTotale.setFasciaClimatica(fasciaClimatica.getCodice());
				}
					//loadRecordFromUI(recordTotale);
					model.setRecord(model.getRowCount()-1, recordTotale);
					showHideFields(recordTotale); 
					getJTable().getSelectionModel().setSelectionInterval(
						model.getRowCount()-1,
						model.getRowCount()-1);
					flagModifica = true;

			
					}
				}									
			
				
			}
		}
		/**FINE MODIFICA **/
			
		
		
		initAliquota(-1);
		getJComboBoxAliquota().setSelectedIndex(-1);
		
		
		getJLabelCampo1().setText("Consumi mc");
		getJLabelCampo2().setText("Aliq. Euro/mc");
		
		
	}
	
	private void initAliquota(int selectedRow) {
		getJComboBoxAliquota().removeAllItems();
		BigDecimal aliquota = BigDecimal.valueOf(0);
		MetanoLiquidazioneImposteTM model = (MetanoLiquidazioneImposteTM) jTable.getModel();

		if(selectedRow != -1) {
			MetanoLiquidazioneImposte record = model.getRecord(selectedRow);
			int progressivoIdentificativo = model.getProgressivoForRowIndex(selectedRow);
			if(record != null) {
				progressivoIdentificativo = record.getProgressivoIdentificativo().intValue();
			}
			if(quadro.getTipiRecord().equals(Quadro.QUADRO_I)) {
				if(tipoCapitolo.getCodice().equals("1412")) {
					if(progressivoIdentificativo == 1) {
						getJComboBoxAliquota().addItem("0.00291");
					}
				} else if(tipoCapitolo.getCodice().equals("1421")) {
					if(progressivoIdentificativo == 4) {
						getJComboBoxAliquota().addItem("0.012498");
					} else if(progressivoIdentificativo == 5) {
						getJComboBoxAliquota().addItem("0.03865");
					} else if(progressivoIdentificativo == 6) {
						getJComboBoxAliquota().addItem("0.0463");
					} else if(progressivoIdentificativo == 7) {
						getJComboBoxAliquota().addItem("0.17320");
					} else if(progressivoIdentificativo == 8) {
						getJComboBoxAliquota().addItem("0.0386516");
					} else if(progressivoIdentificativo == 9) {
						getJComboBoxAliquota().addItem("0.0386516");
					} else if(progressivoIdentificativo == 10) {
						getJComboBoxAliquota().addItem("0.1242182");
					} else if(progressivoIdentificativo == 11) {
						getJComboBoxAliquota().addItem("0.0004493");
					} else if(progressivoIdentificativo == 12) {
						getJComboBoxAliquota().addItem("0.0001348");
					}
				}
			}
		}

		if(aliquota.floatValue() == 0) {
			getJTextFieldAliquota().setText("");
		} else {
			getJTextFieldAliquota().setText(aliquota.toString());
		}
		
	}
	

	public void setTotale(BigDecimal tot){
		totale=tot;
	}
	public BigDecimal getTotale(){
		return totale;
	}
	public void plot(PdfBuilder pdfBuilder) {
		pdfBuilder.startCommandBlock();
		
		pdfBuilder.writeCenteredLabel(this.getTitle(), 14);
		pdfBuilder.moveYPen(50);
		
		//SALVATORE
		pdfBuilder.endCommandBlock();
		pdfBuilder.startDefineTableHeader();		
		//
		pdfBuilder.setXPen(PdfBuilder.MARGINE);
		pdfBuilder.writeLeftLabel(getJLabel2().getText(), 12);
		pdfBuilder.moveYPen(-14);
		pdfBuilder.writeRightLabel(getJLabelCapitolo().getText(), 12);
		pdfBuilder.moveYPen(10);
		pdfBuilder.writeLeftLabel(jLabelNomeQuadro.getText(), 12);
		pdfBuilder.moveYPen(-14);
		pdfBuilder.writeRightLabel(jLabelTitoloQuadro.getText(), 12);
		pdfBuilder.moveYPen(10);

		//SALVATORE
		//pdfBuilder.endCommandBlock();
		pdfBuilder.endDefineTableHeader();		
		//
		
		pdfBuilder.writeTable(this, jTable, jScrollPane);
		
		pdfBuilder.setPageEndWriterInterface(new DataFirmaPiePagina());
		pdfBuilder.moveYPen(20);
	}

	/**************************************************************************************
	 * INIZIO GESTIONE EVENTI
	 **************************************************************************************/
	public void actionPerformed(ActionEvent event) {
		if (event.getSource() == getJButtonChiudi()) {
			this.doClose();
		} else if (event.getSource() == getJButtonConferma()) {
			this.doConfirm();
		} else if (event.getSource() == getJButtonElimina()) {
			this.doDelete();
		} else if (event.getSource() == getJButtonImposta()) {
			this.doUpdate();
		} else if (event.getSource() == getJButtonInserisci()) {
			this.doInsertSon();
		}
	}

	public void valueChanged(ListSelectionEvent event) {
		if (event.getSource() == getJTable().getSelectionModel()) {
			loadFieldsForEditing();
		}
		if (this.getJTextFieldConsumi().isEnabled()) {
			this.getJTextFieldConsumi().grabFocus();
			this.getJTextFieldConsumi().selectAll();
		}
		else {
			this.getJTextFieldImpostaEuro().grabFocus();
			this.getJTextFieldImpostaEuro().selectAll();
		}
	}

	
	protected void doClose() {
		int val = validateExitText();
		if(val == JOptionPane.YES_OPTION) {
			doConfirm();
		} else if(val == JOptionPane.NO_OPTION) {
			super.setVisible(false);
		} else if(val == JOptionPane.CANCEL_OPTION) {
		}
	}

	private void doConfirm() {
		MetanoLiquidazioneImposteTM model =	(MetanoLiquidazioneImposteTM) getJTable().getModel();
		List listaQuadroXCapitolo = model.getRecords();
		List listaQuadroCompleta = prospettoConsumo.getListaQuadro(quadro.getTipiRecord());
		
		/** MODIFICA 24-10-2007 **/
		if(listaQuadroXCapitolo.size() >0) {
			quadro.setEmpty(false);
		}
		else
			quadro.setEmpty(true);
			
		BigDecimal impostaRettifica = BigDecimal.valueOf(0);
		BigDecimal impostaTotale = BigDecimal.valueOf(0);
		if(quadro.getLettera().equals("M") && model.getRecord(model.getRowCount()-2) !=null) {
			impostaRettifica = model.getRecord(model.getRowCount()-2).getImpostaEuro();
			
		}
		
		if(quadro.getLettera().equals("M") && model.getRecord(model.getRowCount()-1) !=null) {
			impostaTotale = model.getRecord(model.getRowCount()-1).getImpostaEuro();
		}
		
		/** FINE MODIFICA **/
		
		// Elimino i vecchi record 
		Iterator it = listaQuadroCompleta.iterator();
		String provincia = "";
		if(tipoProvincia!=null) {
			provincia = StringUtil.denullify(tipoProvincia.getCodice());
		}
		String fascia = "";
		if(this.fasciaClimatica!=null) {
			fascia = StringUtil.denullify(fasciaClimatica.getCodice());
		}
		String capitolo = "";
		if(tipoCapitolo!=null) {
			capitolo = StringUtil.denullify(tipoCapitolo.getCodice());
		}
		String mese = "";
		if (this.tipoMese!=null) {
			mese = StringUtil.denullify(tipoMese.getCodice());
		}
		if(capitolo.equals("")) {
			capitolo = "0";		
		}
		if(mese.equals("")) {
			mese = "0";		
		}
		
		
		
		/** MODIFICA 24-10-2007 **/
		while (it.hasNext()) {
			MetanoLiquidazioneImposte record = (MetanoLiquidazioneImposte) it.next();
			String recProvincia = StringUtil.denullify(record.getProvincia());
			String recCapitolo = StringUtil.denullify(String.valueOf(record.getCapitoliImputazioneImposta()));
			String recFascia = StringUtil.denullify(record.getFasciaClimatica());
			String recMese = StringUtil.denullify(String.valueOf(record.getMese()));

			if(recProvincia.equals(provincia) && recCapitolo.equals(capitolo) && recFascia.equals(fascia) && recMese.equals(mese)) {
				it.remove();
			}
			
			if(recProvincia.equals(provincia) && recMese.equals(mese) && quadro.getLettera().equals("M") 
				&& (record.getProgressivoIdentificativo().toString().equals("7") ||	record.getProgressivoIdentificativo().toString().equals("8"))) {
			
				if(record.getProgressivoIdentificativo().toString().equals("7")) {				
					record.setImpostaEuro(impostaRettifica);
				}
				
				if(record.getProgressivoIdentificativo().toString().equals("8")) {				
					record.setImpostaEuro(impostaTotale);
				}
			
				
			}
			
	}
			
		
		// Aggiungo i nuovi record per il mese in modifica
		listaQuadroCompleta.addAll(listaQuadroXCapitolo);
		
		// Imposto tutto sul modello! Finally!!!!!
		prospettoConsumo.setListaQuadro(listaQuadroCompleta,quadro.getTipiRecord());

		this.setVisible(false);
	}
	
	
	/**
	 * 
	 */
	private void doUpdate() {
		MetanoLiquidazioneImposteTM model =
			(MetanoLiquidazioneImposteTM) getJTable().getModel();
		int selectedRow = getJTable().getSelectedRow();
																			
		if (selectedRow != -1) {
			MetanoLiquidazioneImposte record =
				(MetanoLiquidazioneImposte) model.getRecord(selectedRow);
							
				
			if (record == null) {
				doInsert();
			} else {
				loadRecordFromUI(record);
				showHideFields(record);
				flagModifica = true;
				model.fireTableRowsUpdated(selectedRow, selectedRow);
				getJTable().getSelectionModel().setSelectionInterval(
					selectedRow,
					selectedRow);
			}
		}
	}

	/** MODIFICA 25-10-2007 **/
	private void updateTotale(int selectedRow) {

				MetanoLiquidazioneImposteTM model =
						(MetanoLiquidazioneImposteTM) jTable.getModel();
				Iterator it = model.getRecords().iterator();
		
		
		List listaQuadroXCapitolo = model.getRecords();
		List listaQuadroCompleta = prospettoConsumo.getListaQuadro(quadro.getTipiRecord());
				
		Iterator is = listaQuadroCompleta.iterator();
		
		String provincia = "";
		if(tipoProvincia!=null) {
			provincia = StringUtil.denullify(tipoProvincia.getCodice());
		}
		String fascia = "";
		if(this.fasciaClimatica!=null) {
			fascia = StringUtil.denullify(fasciaClimatica.getCodice());
		}
		String capitolo = "";
		if(tipoCapitolo!=null) {
			capitolo = StringUtil.denullify(tipoCapitolo.getCodice());
		}
		String mese = "";
		if (this.tipoMese!=null) {
			mese = StringUtil.denullify(tipoMese.getCodice());
		}
		if(capitolo.equals("")) {
			capitolo = "0";		
		}
		if(mese.equals("")) {
			mese = "0";		
		}					
				
		BigDecimal totaleProvincia = BigDecimal.valueOf(0);
		BigDecimal totaleFascia = BigDecimal.valueOf(0);
		BigDecimal totale = BigDecimal.valueOf(0);
		
		while (is.hasNext()) {
				MetanoLiquidazioneImposte record = (MetanoLiquidazioneImposte) is.next();
				String recProvincia = StringUtil.denullify(record.getProvincia());
				String recCapitolo = StringUtil.denullify(String.valueOf(record.getCapitoliImputazioneImposta()));
				String recFascia = StringUtil.denullify(record.getFasciaClimatica());
				String recMese = StringUtil.denullify(String.valueOf(record.getMese()));
				
				
				if(recProvincia.equals(provincia) && recMese.equals(mese) && !recFascia.equals(fascia.trim()) && !recFascia.equals("")  && quadro.getLettera().equals("M") &&
					record.getProgressivoIdentificativo().intValue() < 7) {
						totaleProvincia = totaleProvincia.add(record.getImpostaEuro());
				}
			
							
				
				
		}		
		
				
				while (it.hasNext()) {
					MetanoLiquidazioneImposte record =
						(MetanoLiquidazioneImposte) it.next();
					if(record.getProgressivoIdentificativo().intValue() < 8) {
						totaleFascia = totaleFascia.add(record.getImpostaEuro());
										
					}
					 totale = totaleFascia.add(totaleProvincia);
					
				}
						
				int progressivo = model.getProgressivoForRowIndex(selectedRow);
		
				if(progressivo == 8) {
					getJTextFieldImpostaEuro().setText(totale.toString());
								
				}
			
			
			}
	
	
	/**
	 * 
	 */
	private void doInsert() {
		MetanoLiquidazioneImposteTM model =
			(MetanoLiquidazioneImposteTM) getJTable().getModel();
			
				
		int selectedRow = getJTable().getSelectedRow();
		if (selectedRow != -1) {
			MetanoLiquidazioneImposte record =
				(MetanoLiquidazioneImposte) model.getRecord(selectedRow);
			if (record != null) {
				doUpdate();
			} else {
				record = MetanoLiquidazioneImposte.getNewObject(prospettoConsumo);
				record.setTipoRecord(BigInteger.valueOf(quadro.getTipiRecord()[0]));
				if(tipoCapitolo != null) {
					record.setCapitoliImputazioneImposta(new BigInteger(tipoCapitolo.getCapitolo()));
				}
				if(tipoProvincia != null) {
					record.setProvincia(tipoProvincia.getCodice());
				}
				
				try {	
					loadRecordFromUI(record);
					model.setRecord(selectedRow, record);
					showHideFields(record); 
					getJTable().getSelectionModel().setSelectionInterval(
						selectedRow,
						selectedRow);
					flagModifica = true;
		
				}
				catch(Exception e) {
					JOptionPane.showMessageDialog(this, e.getMessage(), "Errore", JOptionPane.ERROR_MESSAGE);
				}	
			}
		} else {
			JOptionPane.showMessageDialog(
						this,
						"Selezionare un elemento dalla lista",
						"Attenzione",
						JOptionPane.WARNING_MESSAGE);
		}
	}

	private void doInsertSon() {
		MetanoLiquidazioneImposteTM model =
			(MetanoLiquidazioneImposteTM) getJTable().getModel();
		int selectedRow = getJTable().getSelectedRow();
		if (selectedRow != -1) {
			MetanoLiquidazioneImposte record =
				(MetanoLiquidazioneImposte) model.getRecord(selectedRow);

			MetanoLiquidazioneImposte son = MetanoLiquidazioneImposte.getNewObject(prospettoConsumo); 
			son.setTipoRecord(BigInteger.valueOf(quadro.getTipiRecord()[0]));
			if(tipoCapitolo != null) {
				son.setCapitoliImputazioneImposta(new BigInteger(tipoCapitolo.getCapitolo()));
			}
			if(tipoProvincia != null) {
				son.setProvincia(tipoProvincia.getCodice());
			}
			son.setProgressivoIdentificativo(record.getProgressivoIdentificativo());
			son.setTipoRigo();

			try {	
				loadRecordFromUI(son);
				son.setImpostaEuro(BigDecimal.valueOf(0));
				model.insertSonRecord(son);
				showHideFields(record);
				getJTable().getSelectionModel().setSelectionInterval(
					selectedRow,
					selectedRow);
				flagModifica = true;		
				}
			catch(Exception e) {
				e.printStackTrace();
				JOptionPane.showMessageDialog(this, e.getMessage(), "Errore", JOptionPane.ERROR_MESSAGE);
			}	
		}
		
	}

	/**
	 * 
	 */
	private void doDelete() {
		MetanoLiquidazioneImposteTM model =
			(MetanoLiquidazioneImposteTM) getJTable().getModel();
		int selectedRow = getJTable().getSelectedRow();
		if (selectedRow != -1) {
			if(model.isRemovable(selectedRow)) {
				model.removeRecord(selectedRow);
				showHideFields(null);
				clearFieldsForEditing();
				getJTable().getSelectionModel().setSelectionInterval(
					selectedRow,
					selectedRow);
				loadFieldsForEditing();
			} else {
				JOptionPane.showMessageDialog(this, "Non  possibile cancellare questa riga. Possibili cause: ci sono altre righe associate a questa.", "Attenzione", JOptionPane.WARNING_MESSAGE);
			}
		} else {
			JOptionPane.showMessageDialog(
							this,
							"Selezionare un elemento dalla lista",
							"Attenzione",
							JOptionPane.WARNING_MESSAGE);
		}
	}

	private void loadFieldsForEditing() {
		MetanoLiquidazioneImposteTM model =
			(MetanoLiquidazioneImposteTM) getJTable().getModel();
		String letteraQuadro= quadro.getLettera().trim();
		String capitoloQuadro = "";
		if(tipoCapitolo != null){
			capitoloQuadro = tipoCapitolo.getCapitolo().trim();
		}
		int selectedRow = getJTable().getSelectedRow();
		initAliquota(selectedRow);

		if (selectedRow == -1) {
		} else {
			MetanoLiquidazioneImposte record =
				(MetanoLiquidazioneImposte) model.getRecord(selectedRow);
			if (record == null) {
				showHideFields(null);
				clearFieldsForEditing();
				if(letteraQuadro.equals("M") && selectedRow== model.getRowCount()-1)
					updateTotale(selectedRow);
				if(letteraQuadro.equals("I") && selectedRow == model.getRowCount()-1) {
					if(capitoloQuadro.equals("1412"))
						updateTotI1412();
					else 
						updateTotI1421();
				}
				if(letteraQuadro.equals("O") && selectedRow == model.getRowCount()-1) 
					updateTotO();
				
			} else {
				showHideFields(record);
				if(letteraQuadro.equals("M") && record.getProgressivoIdentificativo().intValue() == 8 ) {
					updateTotale(selectedRow);
				}
				if(letteraQuadro.equals("O") && selectedRow == model.getRowCount()-1) 
					updateTotO();
					
				if (letteraQuadro.equals("I")&& selectedRow == model.getRowCount()-1 ){
					if(capitoloQuadro.equals("1412"))
						updateTotI1412();
					else if(capitoloQuadro.equals("1421"))
						updateTotI1421();
						
					getJComboBoxAliquota().setSelectedItem(record.getAliquotaImposta().toString());
				} else {
					getJTextFieldAliquota().setText(String.valueOf(record.getAliquotaImposta()));
				}
				if(letteraQuadro.equals("M") && record.getProgressivoIdentificativo().intValue() < 8)
				getJTextFieldImpostaEuro().setText(String.valueOf(record.getImpostaEuro())); 
				getJTextFieldConsumi().setText(String.valueOf(record.getConsumi()));
			}
		}
		if (selectedRow < model.getRowCount() - 1 - 1) {
			getJTextFieldConsumi().setEnabled(true);
			if (letteraQuadro.equals("I")){
			   getJComboBoxAliquota().setEnabled(true);
			   getJTextFieldAliquota().setVisible(false);
			} else {
				getJComboBoxAliquota().setVisible(false);
				getJTextFieldAliquota().setEnabled(true);
			}
		} else {
			getJTextFieldConsumi().setText("");
			getJTextFieldConsumi().setEnabled(false);

			if (letteraQuadro.equals("I")){
				getJComboBoxAliquota().setSelectedItem(" ");
			} else {
				getJTextFieldAliquota().setText("");
				getJTextFieldAliquota().setEnabled(false);
			}
			getJComboBoxAliquota().setEnabled(false);
		}
	}
	
	/**
		 * 
		 */
		private void updateTotO() {
		
		
			MetanoLiquidazioneImposteTM model =
				(MetanoLiquidazioneImposteTM) jTable.getModel();
			Iterator it = model.getRecords().iterator();
			BigDecimal totale = BigDecimal.valueOf(0);
		
			while (it.hasNext()) {
				MetanoLiquidazioneImposte record =
					(MetanoLiquidazioneImposte) it.next();
				if(record.getProgressivoIdentificativo().intValue() < 9) {
					totale = totale.add(record.getImpostaEuro());
				
				}
			}
		
			getJTextFieldImpostaEuro().setText(String.valueOf(totale));
		}
		
	/**
	 * 
	 */
	private void updateTotI1421() {
		
		
		MetanoLiquidazioneImposteTM model =
			(MetanoLiquidazioneImposteTM) jTable.getModel();
		Iterator it = model.getRecords().iterator();
		BigDecimal totale = BigDecimal.valueOf(0);
		
		while (it.hasNext()) {
			MetanoLiquidazioneImposte record =
				(MetanoLiquidazioneImposte) it.next();
			if(record.getProgressivoIdentificativo().intValue() < 15) {
				totale = totale.add(record.getImpostaEuro());
				
			}
		}
		
		getJTextFieldImpostaEuro().setText(String.valueOf(totale));
	}

	/**
	 * @param 
	 */
	private void updateTotI1412() {
		
		MetanoLiquidazioneImposteTM model =
			(MetanoLiquidazioneImposteTM) jTable.getModel();
		Iterator it = model.getRecords().iterator();
		BigDecimal totale = BigDecimal.valueOf(0);
		
		while (it.hasNext()) {
			MetanoLiquidazioneImposte record =
				(MetanoLiquidazioneImposte) it.next();
			if(record.getProgressivoIdentificativo().intValue() < 3) {
				totale = totale.add(record.getImpostaEuro());
				
			}
		}

		getJTextFieldImpostaEuro().setText(String.valueOf(totale));
		
	}
	

	private void showHideFields(MetanoLiquidazioneImposte record) {
		if(record != null && record.getTipoRigo().equals(BigInteger.ZERO)) {
			if(record.getProgressivoRecordRigo().compareTo(BigInteger.ZERO) == 0) {
				getJButtonInserisci().setVisible(true);
				getJButtonImposta().setText("Modifica");
				getJTextFieldImpostaEuro().setVisible(true);
			} else {
				getJButtonInserisci().setVisible(false);
				getJButtonImposta().setText("Imposta");
				getJTextFieldImpostaEuro().setVisible(false);
			}
		} else {
			getJButtonInserisci().setVisible(false);
			getJButtonImposta().setText("Imposta");
			getJTextFieldImpostaEuro().setVisible(true);
		}
	}

	private void loadRecordFromUI(MetanoLiquidazioneImposte record) {
		String letteraQuadro= quadro.getLettera().trim();
						
		String str = null;
		try {
			if (letteraQuadro.equals("I")){
				str = (String)getJComboBoxAliquota().getSelectedItem();
			} else {
				str = (String)getJTextFieldAliquota().getText();
			}
			if (str!=null && !str.trim().equals("")) {
				record.setAliquotaImposta(new BigDecimal(str));
			} else {
				record.setAliquotaImposta(BigDecimal.valueOf(0));
			}
		} catch (NumberFormatException e) {
			record.setAliquotaImposta(BigDecimal.valueOf(0));
		}

		try {
			str = getJTextFieldImpostaEuro().getText();
			if (!str.trim().equals("")) {
				record.setImpostaEuro(new BigDecimal(str));
			//	updateTotale(new BigDecimal(str));
			} 
		} catch (NumberFormatException e) {
			record.setImpostaEuro(BigDecimal.valueOf(0));
		}
		
		try {
			str = getJTextFieldConsumi().getText();
			record.setConsumi(new BigInteger(str));
		} catch (NumberFormatException e) {
			record.setConsumi(BigInteger.valueOf(0));
		}
		if (this.tipoProvincia!=null)
			record.setProvincia(this.tipoProvincia.getCodice());
		if (this.fasciaClimatica!=null)
			record.setFasciaClimatica(this.fasciaClimatica.getCodice());
		if (this.tipoCapitolo!=null)
			record.setCapitoliImputazioneImposta(new BigInteger(this.tipoCapitolo.getCodice().trim()));
		if (this.tipoMese!=null)
			record.setMese(new BigInteger(this.tipoMese.getCodice()));
	}

	private int validateExitText() {
		int retvalue = JOptionPane.NO_OPTION;
		if(flagModifica==true) {
			retvalue = JOptionPane.showConfirmDialog(this, "Le modifiche effettutate verranno perse. Vuoi salvare le modifiche?", "", JOptionPane.YES_NO_CANCEL_OPTION);
		}
		return retvalue;
	}		
			
		
}
