package it.finanze.dogane.accise.metano.ui;

import it.finanze.dogane.accise.combo.TipoProvincia;
import it.finanze.dogane.accise.metano.model.MetanoRettificheFatturazione;
import it.finanze.dogane.accise.metano.model.ProspettoConsumo;
import it.finanze.dogane.accise.metano.ui.quadri.Parametri;
import it.finanze.dogane.accise.metano.ui.quadri.Quadro;
import it.finanze.dogane.accise.metano.ui.tablemodel.MetanoRettificheFatturazioneTM;
import it.finanze.dogane.accise.model.AbstractRecord;
import it.finanze.dogane.accise.model.Prospect;
import it.finanze.dogane.accise.pdf.PdfBuilder;
import it.finanze.dogane.accise.pdf.PdfPrintable;
import it.finanze.dogane.accise.ui.FullScreenLayoutManager;
import it.finanze.dogane.accise.ui.RealDim;
import it.finanze.dogane.accise.ui.TableUtil;
import it.finanze.dogane.accise.ui.quadri.GestoreQuadro;
import it.finanze.dogane.accise.ui.quadri.dialog.QuadroDialog;
import it.finanze.dogane.accise.ui.validation.BigDecimalDocument;
import it.finanze.dogane.accise.ui.validation.BigIntegerDocument;
import it.finanze.dogane.accise.ui.validation.SignedBigDecimalDocument;
import it.finanze.dogane.accise.util.StringUtil;

import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Iterator;
import java.util.List;

import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;


public class MetanoRettificheFatturazioneDialog extends JDialog
	implements ActionListener, ListSelectionListener, QuadroDialog, PdfPrintable {
	private javax.swing.JPanel jContentPane = null;

	private javax.swing.JPanel jPanel = null;
	private javax.swing.JLabel jLabelNomeQuadro = null;
	private javax.swing.JLabel jLblProvincia = null;
	private javax.swing.JLabel jLabelTitoloQuadro = null;
	private javax.swing.JPanel jPanel1 = null;
	private javax.swing.JLabel jLblUbicazione = null;
	private javax.swing.JLabel jLblQuantita = null;
	private javax.swing.JLabel jLblAliquota = null;
	private javax.swing.JLabel jLblImporto = null;
	private javax.swing.JLabel jLblTotale = null;
	private javax.swing.JComboBox jCbUbicazione = null;
	private javax.swing.JComboBox jCbSegno = null;
	private javax.swing.JTextField jTxtImporto = null;
	private javax.swing.JTextField jTxtAliquota = null;
	private javax.swing.JTextField jTxtQuantita = null;
	private javax.swing.JButton jBtElimina = null;
	private javax.swing.JButton jBtImposta = null;
	private javax.swing.JButton jBtConferma = null;
	private javax.swing.JButton jBtChiudi = null;
	private javax.swing.JScrollPane jScrollPane = null;
	private javax.swing.JTable jTable = null;
	private javax.swing.JTextField jTxtTotale = null;
	private javax.swing.JLabel jLblTotale1 = null;
	private javax.swing.JLabel jLblSegno = null;

	private ProspettoConsumo prospettoConsumo = null;
	private Quadro quadro = null;
	private TipoProvincia tipoProvincia = null;
	private boolean flagModifica=false;
	
	//public static final String DEBITO="+";
	//public static final String CREDITO="-";
	private String lblUbicazioni[] = {"C","M"};
	private String lblSegno[] = {"DEBITO","CREDITO"};
	public static final int[] identifiers = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 };

	private javax.swing.JButton jButtonInserisci = null;
	/**
	 * This is the default constructor
	 */
	public MetanoRettificheFatturazioneDialog(Frame frame,String description,String secondDescription) {
		super(frame, "Metano Rettifiche Fatturazione ", true);
		initialize();
		getJLabelNomeQuadro().setText(description);
		getJLabelTitoloQuadro().setText(secondDescription);
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(800, 600);
		this.setSize(RealDim.getAbsoluteXValue(800), RealDim.getAbsoluteYValue(600));
		this.setContentPane(getJContentPane());
		this.setLocation(0, 0);
		this.setResizable(false);
		this.setModal(true);
		jTable.clearSelection();
		this.setDefaultCloseOperation(
			javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
	}

	public void prepareValues(Prospect prospect, GestoreQuadro gestoreQuadro) {
		prospettoConsumo = (ProspettoConsumo) prospect;
		this.quadro = (Quadro) gestoreQuadro;

		List lista = prospettoConsumo.getListaQuadro(quadro.getTipiRecord());

		Parametri parametriSelezionati = (Parametri) quadro.getParameter();
		tipoProvincia = parametriSelezionati.getProvincia();

		getJLblProvincia().setText("Provincia di: "+tipoProvincia.getDescrizione());

		lista = Quadro.getListaRecordParametrizzato(lista, parametriSelezionati, quadro);

		MetanoRettificheFatturazioneTM model = new MetanoRettificheFatturazioneTM(lista);
		jTable.setModel(model);
		jTable.getSelectionModel().setSelectionInterval(0, 0);
		TableUtil.redimTable(jTable, jScrollPane);
	}

	public void plot(PdfBuilder pdfBuilder) {
		pdfBuilder.startCommandBlock();
		pdfBuilder.writeCenteredLabel(this.getTitle(), 14);
		pdfBuilder.moveYPen(50);
		
		//SALVATORE
		pdfBuilder.endCommandBlock();
		pdfBuilder.startDefineTableHeader();		
		//

		pdfBuilder.setXPen(PdfBuilder.MARGINE);
		pdfBuilder.writeLeftLabel(jLblProvincia.getText(), 12);
		pdfBuilder.moveYPen(10);
		pdfBuilder.writeLeftLabel(jLabelNomeQuadro.getText(), 12);
		pdfBuilder.moveYPen(-14);
		pdfBuilder.writeRightLabel(jLabelTitoloQuadro.getText(), 12);
		pdfBuilder.moveYPen(10);
		//SALVATORE
		//pdfBuilder.endCommandBlock();
		pdfBuilder.endDefineTableHeader();		
		//

		
		pdfBuilder.writeTable(this, jTable, jScrollPane);
		pdfBuilder.moveYPen(10);

//		pdfBuilder.startCommandBlock();
//		pdfBuilder.moveXPen(230);
//		pdfBuilder.writeLeftLabel("Totali", 10);
//		pdfBuilder.moveXPen(20);
//		float y = pdfBuilder.getYPen();
//		pdfBuilder.writeLeftLabel("importo accisa per combustione: ", 10);
//		pdfBuilder.writeLeftLabel("importo addizionale regionale: ", 10);
//		pdfBuilder.writeLeftLabel("importo imposta regionale sostitutiva: ", 10);
//		pdfBuilder.setXPen(PdfBuilder.MARGINE);
//
//		float y2 = pdfBuilder.getYPen();
//		// Mi rimetto all'inizio e comincio a scrivere i valori
//		pdfBuilder.moveYPen(y - y2); // All'interno di un blocco non si pu utilizzare una setYPen		
//		pdfBuilder.writeRightLabel(totaleRecord.getMetanoPropriPozzi().toString(), 10);
//		pdfBuilder.writeRightLabel(totaleRecord.getMetanoFornitoreExtraUE().toString(), 10);
//		pdfBuilder.writeRightLabel(.getText(), 10);
//		pdfBuilder.endCommandBlock();
	}
	
	public void actionPerformed(ActionEvent event) {
		try {
			if (event.getSource() == jBtChiudi) {
				doClose();
			} else if (event.getSource() == jBtConferma) {
				doConfirm();
			} else if (event.getSource() == jBtElimina) {
				doDelete();
			} else if (event.getSource() == jBtImposta) {
				doUpdate();
			} else if (event.getSource() == getJButtonInserisci()) {
				this.doInsertSon();
			}
		}
		catch(Exception e) {
			e.printStackTrace();
			JOptionPane.showMessageDialog(this, e.getMessage(), "Attenzione", JOptionPane.WARNING_MESSAGE);
		}
	}

	private int validateExitText() {
		int retvalue = JOptionPane.NO_OPTION;
		if(flagModifica==true) {
			retvalue = JOptionPane.showConfirmDialog(this, "Le modifiche effettutate verranno perse. Vuoi salvare le modifiche?", "", JOptionPane.YES_NO_CANCEL_OPTION);
		}
		return retvalue;
	}		

	private void doClose() {
			int val = validateExitText();
			if(val == JOptionPane.YES_OPTION) {
				doConfirm();
			} else if(val == JOptionPane.NO_OPTION) {
				this.setVisible(false);
			} else if(val == JOptionPane.CANCEL_OPTION) {
			}
		}
	private void doConfirm() {
		MetanoRettificheFatturazioneTM model =(MetanoRettificheFatturazioneTM) jTable.getModel();
		List listaQuadroXParametri = model.getRecords();//contiene quello nuovo
		List listaQuadroXParametriTotali = model.getRecordsTotali();//contiene quello nuovo
		
		if(listaQuadroXParametri.size() > 0 || listaQuadroXParametriTotali.size()>0 )
			quadro.setEmpty(false);
		else
			quadro.setEmpty(true);

		List listaQuadroCompleta =prospettoConsumo.getListaQuadro(quadro.getTipiRecord());

		// Elimino i vecchi record con la provincia in modifica
		Iterator it = listaQuadroCompleta.iterator();
		while (it.hasNext()) {
			MetanoRettificheFatturazione record =	(MetanoRettificheFatturazione) it.next();	
			if (record.getProvincia().equals(tipoProvincia.getCodice())) {
				it.remove();
			}
		}

		// Aggiungo il nuovo record a quello precedente
		listaQuadroCompleta.addAll(listaQuadroXParametri);
		// Aggiungo i nuovi record relativi ai totali
		listaQuadroCompleta.addAll(listaQuadroXParametriTotali);

		// Imposto tutto sul modello! Finally!!!!!
		prospettoConsumo.setListaQuadro(listaQuadroCompleta,quadro.getTipiRecord());
		this.setVisible(false);
	}

	private void doInsert() throws CloneNotSupportedException {
//		if (this.jCbSegno.isEnabled() && this.jCbSegno.getSelectedIndex()==0) {
//			JOptionPane.showMessageDialog(this, "Specificare il segno.", "Attenzione!", JOptionPane.ERROR_MESSAGE);
//			return;
//		}
		
		MetanoRettificheFatturazioneTM model = (MetanoRettificheFatturazioneTM) jTable.getModel();
		int selectedRow = jTable.getSelectedRow();
		if (selectedRow != -1) {
			MetanoRettificheFatturazione record = (MetanoRettificheFatturazione) model.getRecord(selectedRow);
			MetanoRettificheFatturazione recordTotale = (MetanoRettificheFatturazione) model.getRecordTotale(selectedRow);
			if (record != null || recordTotale != null) {
				doUpdate();
			} else {
				record = MetanoRettificheFatturazione.getNewObject(prospettoConsumo);
				recordTotale = MetanoRettificheFatturazione.getNewObject(prospettoConsumo);
				record.setTipoRecord(BigInteger.valueOf(quadro.getTipiRecord()[0]));
				record.setProgRecordUso(BigInteger.ONE);
				recordTotale.setTipoRecord(BigInteger.valueOf(quadro.getTipiRecord()[0]));
				recordTotale.setProgRecordUso(BigInteger.valueOf(999));
				loadRecordFromUI(record, recordTotale, selectedRow);
				model.setRecord(selectedRow, record);
				model.setRecordTotale(selectedRow, recordTotale);
				showHideFields(record);
				jTable.getSelectionModel().setSelectionInterval(selectedRow,selectedRow);
				flagModifica = true;
			}
		}else {
		JOptionPane.showMessageDialog(
						this,
						"Selezionare un elemento dalla lista",
						"Attenzione",
						JOptionPane.WARNING_MESSAGE);
	}
	}

	private void doInsertSon() {
		MetanoRettificheFatturazioneTM model =
			(MetanoRettificheFatturazioneTM) getJTable().getModel();
		int selectedRow = getJTable().getSelectedRow();
		if (selectedRow != -1) {
			MetanoRettificheFatturazione record =
				(MetanoRettificheFatturazione) model.getRecord(selectedRow);

			MetanoRettificheFatturazione son = MetanoRettificheFatturazione.getNewObject(prospettoConsumo); 
			son.setTipoRecord(BigInteger.valueOf(quadro.getTipiRecord()[0]));
			son.setProgIdentificativoUso(record.getProgIdentificativoUso());

			try {	
				loadRecordFromUI(son, new MetanoRettificheFatturazione(), selectedRow);
//				son.setImportoEuro(BigDecimal.valueOf(0));
				model.insertSonRecord(son);
				showHideFields(record);
				getJTable().getSelectionModel().setSelectionInterval(
					selectedRow,
					selectedRow);
				flagModifica = true;		
				}
			catch(Exception e) {
				e.printStackTrace();
				JOptionPane.showMessageDialog(this, e.getMessage(), "Errore", JOptionPane.ERROR_MESSAGE);
			}	
		}
		
	}


	private void doUpdate() throws CloneNotSupportedException {
		MetanoRettificheFatturazioneTM model = (MetanoRettificheFatturazioneTM) jTable.getModel();
		int selectedRow = jTable.getSelectedRow();
		if (selectedRow != -1) {
			MetanoRettificheFatturazione record = (MetanoRettificheFatturazione) model.getRecord(selectedRow);
			MetanoRettificheFatturazione recordTotale = (MetanoRettificheFatturazione) model.getRecordTotale(selectedRow);
			if (record == null && recordTotale == null) { 
				doInsert();
			} else {
				
				MetanoRettificheFatturazione recordTotaleNuovo = null;
				if(recordTotale != null) { 
					recordTotaleNuovo = (MetanoRettificheFatturazione)recordTotale.clone(); 
				}
				loadRecordFromUI(record, recordTotaleNuovo, selectedRow);
				model.setRecord(selectedRow, record);
				model.setRecordTotale(selectedRow, recordTotaleNuovo);

				if(recordTotaleNuovo == null) {
					model.calcolaTotale(record.getProgIdentificativoUso());
				}
				jTable.getSelectionModel().setSelectionInterval(
					selectedRow,
					selectedRow);
					flagModifica=true;
			}
		}

	}
	
	/** AGGIUNTO MODIFICA 25-10-2007 **/
	private void updateTot(int selectedRow) {

			MetanoRettificheFatturazioneTM model =
				(MetanoRettificheFatturazioneTM) jTable.getModel();
			Iterator it = model.getRecords().iterator();
			Iterator itTotali = model.getRecordsTotali().iterator();
			BigDecimal totaleQuantita = BigDecimal.valueOf(0);
			BigDecimal totaleAliquota = BigDecimal.valueOf(0);
			BigDecimal totaleImporto = BigDecimal.valueOf(0);
			BigDecimal totale = BigDecimal.valueOf(0);
			
			while (it.hasNext()) {
				MetanoRettificheFatturazione record =
					(MetanoRettificheFatturazione) it.next();
				if(record.getProgIdentificativoUso().intValue() < 8) {
					totaleQuantita = totaleQuantita.add(record.getImportoEuro());
					totaleAliquota = totaleAliquota.add(record.getImportoEuro());
					totaleImporto = totaleImporto.add(record.getImportoEuro());
				
				}
				
			}
			
			while (itTotali.hasNext()) {
				MetanoRettificheFatturazione record =
					(MetanoRettificheFatturazione) itTotali.next();
				if(record.getProgIdentificativoUso().intValue() < 8) {
					totale = totale.add(record.getImportoEuro());
					
				}
				
					
			}
			int progressivo = model.getProgressivoForRowIndex(selectedRow);
		
			if(progressivo == 8) {
				jTxtAliquota.setText(totaleAliquota.toString());
				jTxtQuantita.setText(totaleQuantita.toString());
				jTxtImporto.setText(totaleImporto.toString());
				jTxtTotale.setText (totale.toString());
								
			}
			
			
		}
	/** FINE MODIFICA **/
	
	public void valueChanged(ListSelectionEvent event) {
		if (event.getSource() == jTable.getSelectionModel()) {
			loadFieldsForEditing();
		}
	}

	private void doDelete() {
		MetanoRettificheFatturazioneTM model = (MetanoRettificheFatturazioneTM) jTable.getModel();
		int selectedRow = jTable.getSelectedRow();
		if (selectedRow != -1) {
			model.removeRecord(selectedRow);
			clearFieldsForEditing(selectedRow);
			jTable.getSelectionModel().setSelectionInterval(
				selectedRow,
				selectedRow);
			flagModifica = true;
			}else {
		JOptionPane.showMessageDialog(
						this,
						"Selezionare un elemento dalla lista",
						"Attenzione",
						JOptionPane.WARNING_MESSAGE);
	}
	}

	private void loadFieldsForEditing() {
		MetanoRettificheFatturazioneTM model = (MetanoRettificheFatturazioneTM) jTable.getModel();
		int selectedRow = jTable.getSelectedRow();
		
		if (selectedRow == -1) {
		} 
		else {
			MetanoRettificheFatturazione record = (MetanoRettificheFatturazione) model.getRecord(selectedRow);
			MetanoRettificheFatturazione recordTotale = (MetanoRettificheFatturazione) model.getRecordTotale(selectedRow);
			showHideFields(record);
			if (record == null && recordTotale == null) { 
				clearFieldsForEditing(selectedRow);
				updateTot(selectedRow);
								
			} else {
							
				clearFieldsForEditing(selectedRow);
				
				if(recordTotale != null) {
				
				if (recordTotale.getProgIdentificativoUso().intValue() == 8) {
				    updateTot(selectedRow);
					}
				
				else  				
					jTxtTotale.setText(recordTotale.getImportoEuro().toString());
				}

				if(record != null) {
					jCbUbicazione.setSelectedItem(record.getLocUtenzeCivili().trim());					
					
					if (record.getImportoEuro().compareTo(BigDecimal.valueOf(0)) > 0) {
						this.jCbSegno.setSelectedItem(lblSegno[0]);					
					} else {
						this.jCbSegno.setSelectedItem(lblSegno[1]);					
					}
					
					
//					jTxtAliquota.setText(record.getAliquotaImposta().toString());
//					jTxtImporto.setText(record.getImportoEuro().abs().toString());
//					jTxtQuantita.setText(record.getQuantita().toString());
				
				
				}
			}
		}
	}

	private void showHideFields(MetanoRettificheFatturazione record) {
		if(record != null && record.getProgRecordUso().equals(BigInteger.ONE)) {
			getJButtonInserisci().setVisible(true);
			getJBtImposta().setText("Modifica");
		} else {
			getJButtonInserisci().setVisible(false);
			getJBtImposta().setText("Imposta");
		}
	}

	/**
	 * @param selectedRow
	 */
	private void enableJTxField(int selectedRow) {
		MetanoRettificheFatturazioneTM model = (MetanoRettificheFatturazioneTM)jTable.getModel();
		int progressivo = 0;
		MetanoRettificheFatturazione record = model.getRecord(selectedRow);
		if(record == null) {
			record = model.getRecordTotale(selectedRow);
			if(record == null) {
				progressivo = model.getProgressivoForRowIndex(selectedRow);
			} else {
				progressivo = record.getProgIdentificativoUso().intValue();
			}
		} else {
			progressivo = record.getProgIdentificativoUso().intValue();
		}
		if (progressivo==8 || progressivo==10 || progressivo==11)
		{
			this.jTxtAliquota.setEnabled(false);
			this.jTxtImporto.setEnabled(false);
			this.jTxtQuantita.setEnabled(false);
			this.jTxtTotale.setEnabled(true);
						
			
		} else {
			
			this.jTxtAliquota.setEnabled(true);
			this.jTxtImporto.setEnabled(true);
			this.jTxtQuantita.setEnabled(true);
			this.jTxtTotale.setEnabled(true);
			
					
		}
	}

	private void enableJCbUbicazioni(int selectedRow) {
		MetanoRettificheFatturazioneTM model = (MetanoRettificheFatturazioneTM)jTable.getModel();
		int progressivo = 0;
		MetanoRettificheFatturazione record = model.getRecord(selectedRow);
		if(record == null) {
			record = model.getRecordTotale(selectedRow);
			if(record == null) {
				progressivo = model.getProgressivoForRowIndex(selectedRow);
			} else {
				progressivo = record.getProgIdentificativoUso().intValue();
			}
		} else {
			progressivo = record.getProgIdentificativoUso().intValue();
		}
		if (progressivo==2 || progressivo==3 || progressivo==4)
		{
			this.jCbUbicazione.setEnabled(true);
			this.jCbUbicazione.setVisible(true);
		} else {
			this.jCbUbicazione.setEnabled(false);
			this.jCbUbicazione.setVisible(false);
		}
		// this.jCbUbicazione.setSelectedIndex(0);					
	}

	private void enableJCbSegno(int selectedRow) {
		MetanoRettificheFatturazioneTM model = (MetanoRettificheFatturazioneTM)jTable.getModel();
		int progressivo = 0;
		MetanoRettificheFatturazione record = model.getRecord(selectedRow);
		if(record == null) {
			record = model.getRecordTotale(selectedRow);
			if(record == null) {
				progressivo = model.getProgressivoForRowIndex(selectedRow);
			} else {
				progressivo = record.getProgIdentificativoUso().intValue();
			}
		} else {
			progressivo = record.getProgIdentificativoUso().intValue();
		}
		if (progressivo==8 || progressivo==10 || progressivo==11  )
		{
			this.jCbSegno.setEnabled(false);
			this.jCbSegno.setVisible(false);
		} else {
			this.jCbSegno.setEnabled(true);
			this.jCbSegno.setVisible(true);
		}
		// this.jCbSegno.setSelectedIndex(0);					
	}

	private void clearFieldsForEditing(int selectedRow) {
		this.jTxtImporto.setText("");
		this.jTxtAliquota.setText("");
		this.jTxtQuantita.setText("");
		this.jCbSegno.setSelectedIndex(0);
		this.jTxtTotale.setText("");
		this.enableJCbUbicazioni(selectedRow);					
		this.enableJCbSegno(selectedRow);		
		this.enableJTxField(selectedRow);		
	}

	private void loadRecordFromUI(MetanoRettificheFatturazione record,MetanoRettificheFatturazione recordTotale,int selectedRow) {
		String str = null;
		try {
			if(record != null) {
				/////////////////////////////////////////////////////////////////
				//////////    attributi per i record di dettaglio    ////////////
				/////////////////////////////////////////////////////////////////
				// carico il record dalla UI (by fiorello)
				if (record.getProvincia()==null || record.getProvincia().equals(""))
					record.setProvincia(tipoProvincia.getCodice());
//				if (record.getProgIdentificativoUso()==null || record.getProgIdentificativoUso()==BigInteger.valueOf(0)){
//					record.setProgIdentificativoUso(BigInteger.valueOf(identifiers[selectedRow]));
//				}
//				if (record.getProgRecordUso()==null || record.getProgRecordUso()==BigInteger.valueOf(0)){
//					BigInteger idRecord=BigInteger.valueOf(0);
//					record.setProgRecordUso(idRecord.add(BigInteger.ONE));
//				}
				if (record.getLetteraIdentificativa()==null || record.getLetteraIdentificativa().trim().equals("")){
					record.setLetteraIdentificativa(quadro.getLettera());
				}
				
				/** MODIFICA REPLY 29-10-2007 **/
				//if (jTxtQuantita.isEnabled()) {
					record.setQuantita(new BigInteger(getValue(jTxtQuantita)));
			//	}

			//	if (jTxtAliquota.isEnabled()) {
					record.setAliquotaImposta(new BigDecimal(getValue(jTxtAliquota)));
			//	}
			
			//	if (jTxtImporto.isEnabled()) {
					record.setImportoEuro(new BigDecimal(getValue(jTxtImporto)));
			//	}
				/** FINE MODIFICA **/
				
				if (jCbUbicazione.isEnabled())
					record.setLocUtenzeCivili((String)jCbUbicazione.getSelectedItem());
				if (jCbSegno.isEnabled()) {
					String segno=(String)jCbSegno.getSelectedItem();
									
					if (segno.equals("DEBITO") ){// && record.getSegno().equals(AbstractRecord.PLUS)) {
						record.setImportoEuro(record.getImportoEuro()); 
					} else if(segno.equals("CREDITO")){// && record.getSegno().equals(AbstractRecord.MINUS)) {
						record.setImportoEuro(record.getImportoEuro().negate()); 
					}
				}
			}

			/////////////////////////////////////////////////////////////////
			//////////    attributi per i totali     ////////////////////////
			/////////////////////////////////////////////////////////////////
			if(recordTotale != null) {
				BigDecimal totale = null;
				if (jTxtTotale.isEnabled()) {
					totale=new BigDecimal(this.getValue(jTxtTotale));
					
					String segno = "";
					
					if (jCbSegno.isEnabled()) 
						segno=(String)jCbSegno.getSelectedItem();
			
					if(segno.equals("CREDITO")) {
						recordTotale.setImportoEuro(totale.negate());	
					}else 
						recordTotale.setImportoEuro(totale);
					
					if(StringUtil.nullify(jTxtTotale.getText()) == null) {
						recordTotale.setImportoEuro(null);
					}
				}

				recordTotale.setProgRecordUso(BigInteger.valueOf(999));
				if (recordTotale.getProvincia()==null || recordTotale.getProvincia().equals(""))
					recordTotale.setProvincia(tipoProvincia.getCodice());
//				if (recordTotale.getProgIdentificativoUso()==null || recordTotale.getProgIdentificativoUso()==BigInteger.valueOf(0))
//					recordTotale.setProgIdentificativoUso(BigInteger.valueOf(identifiers[selectedRow]));
				if (recordTotale.getLetteraIdentificativa()==null || recordTotale.getLetteraIdentificativa().trim().equals(""))
					recordTotale.setLetteraIdentificativa(quadro.getLettera());
			}

		} catch (NumberFormatException e) {
			record.setImportoEuro(BigDecimal.valueOf(0));
		}
	}


	private String getValue(JTextField jTxtField) {
		String strFielValue="0";
		if (!jTxtField.getText().trim().equals(""))
			strFielValue=jTxtField.getText();
		return strFielValue;
	}

	/**
	 * 
	 */
	protected void aggiornaImportoFromUI() {
		// Aggiorna il text field dell'importo
		BigDecimal aliquota = new BigDecimal(getValue(jTxtAliquota));
		BigDecimal quantita = new BigDecimal(getValue(jTxtQuantita));
		BigDecimal importo = aliquota.multiply(quantita);
		importo = importo.setScale(2,BigDecimal.ROUND_HALF_UP);
		
		BigDecimal massimo = new BigDecimal("999999999999.99"); // Attualmente  il massimo previsto dal tracciato record
		if(importo.compareTo(massimo) > 0) {
			JOptionPane.showMessageDialog(this, "L'importo calcolato automaticamente eccede dal valore massimo impostabile (12 cifre). Importo: " + importo, "Attenzione", JOptionPane.WARNING_MESSAGE);
		}

		this.jTxtImporto.setText(importo.toString());
		// if (this.jCbSegno.getSelectedIndex()==0) this.jCbSegno.setSelectedIndex(1);
	}


	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(null);
			jContentPane.setLayout(FullScreenLayoutManager.getInstance());
			jContentPane.add(getJPanel(), null);
			jContentPane.add(getJPanel1(), null);
			jContentPane.add(getJBtConferma(), null);
			jContentPane.add(getJBtChiudi(), null);
		}
		return jContentPane;
	}
	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel() {
		if(jPanel == null) {
			jPanel = new javax.swing.JPanel();
			jPanel.setLayout(null);
			jPanel.setLayout(FullScreenLayoutManager.getInstance());
			jPanel.add(getJLabelNomeQuadro(), null);
			jPanel.add(getJLblProvincia(), null);
			jPanel.add(getJLabelTitoloQuadro(), null);
			jPanel.setBounds(25, 5, 741, 54);
			jPanel.setBackground(java.awt.Color.lightGray);
			jPanel.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.black,1));
		}
		return jPanel;
	}
	
	
	/**
	 * This method initializes jLabelNomeQuadro
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelNomeQuadro() {
		if(jLabelNomeQuadro == null) {
			jLabelNomeQuadro = new javax.swing.JLabel();
			jLabelNomeQuadro.setBounds(5, 34, 134, 19);
			jLabelNomeQuadro.setText("QUADRO H");
			jLabelNomeQuadro.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 14));
		}
		return jLabelNomeQuadro;
	}
	/**
	 * This method initializes jLblProvincia
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLblProvincia() {
		if(jLblProvincia == null) {
			jLblProvincia = new javax.swing.JLabel();
			jLblProvincia.setBounds(5, 4, 154, 19);
			jLblProvincia.setText("PROVINCIA DI ");
		}
		return jLblProvincia;
	}
	/**
	 * This method initializes jLabelTitoloQuadro
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelTitoloQuadro() {
		if(jLabelTitoloQuadro == null) {
			jLabelTitoloQuadro = new javax.swing.JLabel();
			jLabelTitoloQuadro.setBounds(480, 33, 258, 19);
			jLabelTitoloQuadro.setText("RETTIFICHE FATTURAZIONE");
			jLabelTitoloQuadro.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 18));
		}
		return jLabelTitoloQuadro;
	}
	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel1() {
		if(jPanel1 == null) {
			jPanel1 = new javax.swing.JPanel();
			jPanel1.setLayout(null);
			jPanel1.setLayout(FullScreenLayoutManager.getInstance());
			jPanel1.add(getJLblUbicazione(), null);
			
			jPanel1.add(getJLblQuantita(), null);
			jPanel1.add(getJLblAliquota(), null);
			jPanel1.add(getJLblImporto(), null);
			jPanel1.add(getJLblTotale(), null);
			jPanel1.add(getJCbUbicazione(), null);
			jPanel1.add(getJCbSegno(), null);
			jPanel1.add(getJTxtImporto(), null);
			jPanel1.add(getJTxtAliquota(), null);
			jPanel1.add(getJTxtQuantita(), null);
			jPanel1.add(getJBtElimina(), null);
			jPanel1.add(getJBtImposta(), null);
			jPanel1.add(getJScrollPane(), null);
			jPanel1.add(getJTxtTotale(), null);
			jPanel1.add(getJLblTotale1(), null);
			jPanel1.add(getJLblSegno(), null);
			jPanel1.add(getJButtonInserisci(), null);
			jPanel1.setBounds(25, 65, 741, 390);
			jPanel1.setBackground(java.awt.Color.lightGray);
			jPanel1.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,1));
		}
		return jPanel1;
	}
	/**
	 * This method initializes jLblUbicazione
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLblUbicazione() {
		if(jLblUbicazione == null) {
			jLblUbicazione = new javax.swing.JLabel();
			jLblUbicazione.setSize(80, 19);
			jLblUbicazione.setText("Ubicazione");
			jLblUbicazione.setLocation(204, 306);
			jLblUbicazione.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}
		return jLblUbicazione;
	}
	/**
	 * This method initializes jLblSegno
	 * 
	 * @return javax.swing.JLabel
	 */
	
	/**
	 * This method initializes jLblQuantita
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLblQuantita() {
		if(jLblQuantita == null) {
			jLblQuantita = new javax.swing.JLabel();
			jLblQuantita.setSize(78, 19);
			jLblQuantita.setText("Quantit");
			jLblQuantita.setLocation(372, 306);
			jLblQuantita.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}
		return jLblQuantita;
	}
	/**
	 * This method initializes jLblAliquota
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLblAliquota() {
		if(jLblAliquota == null) {
			jLblAliquota = new javax.swing.JLabel();
			jLblAliquota.setSize(78, 19);
			jLblAliquota.setText("Aliquota");
			jLblAliquota.setLocation(453, 306);
			jLblAliquota.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}
		return jLblAliquota;
	}
	/**
	 * This method initializes jLblImporto
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLblImporto() {
		if(jLblImporto == null) {
			jLblImporto = new javax.swing.JLabel();
			jLblImporto.setSize(81, 19);
			jLblImporto.setText("Importo");
			jLblImporto.setLocation(534, 306);
			jLblImporto.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}
		return jLblImporto;
	}
	/**
	 * This method initializes jLblTotale
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLblTotale() {
		if(jLblTotale == null) {
			jLblTotale = new javax.swing.JLabel();
			jLblTotale.setBounds(674, 15, 45, 19);
			jLblTotale.setText("Totale");
		}
		return jLblTotale;
	}
	/**
	 * This method initializes jCbUbicazione
	 * 
	 * @return javax.swing.JComboBox
	 */
	private javax.swing.JComboBox getJCbUbicazione() {
		if(jCbUbicazione == null) {
			//jCbUbicazione = new javax.swing.JComboBox();
			jCbUbicazione = new javax.swing.JComboBox(this.lblUbicazioni);
			jCbUbicazione.setSize(80, 21);
			jCbUbicazione.setLocation(204, 325);
		}
		return jCbUbicazione;
	}
	/**
	 * This method initializes jCbSegno
	 * 
	 * @return javax.swing.JComboBox
	 */
	private javax.swing.JComboBox getJCbSegno() {
		if(jCbSegno == null) {
			//jCbSegno = new javax.swing.JComboBox();
			jCbSegno = new javax.swing.JComboBox(lblSegno);
			jCbSegno.setSize(80, 21);
			jCbSegno.setSelectedIndex(0);
			jCbSegno.setLocation(288, 325);
		}
		return jCbSegno;
	}
	/**
	 * This method initializes jTxtImporto
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTxtImporto() {
		if(jTxtImporto == null) {
			jTxtImporto = new javax.swing.JTextField();
			jTxtImporto.setSize(81, 21);
			jTxtImporto.setLocation(534, 325);
			jTxtImporto.setDocument(new BigDecimalDocument(MetanoRettificheFatturazione.dimImportoEuroIntere,MetanoRettificheFatturazione.dimImportoEuroDecimale));
		}
		return jTxtImporto;
	}
	/**
	 * This method initializes jTxtAliquota
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTxtAliquota() {
		if(jTxtAliquota == null) {
			jTxtAliquota = new javax.swing.JTextField();
			jTxtAliquota.setSize(78, 21);
			jTxtAliquota.setLocation(453, 325);
			jTxtAliquota.addFocusListener(new java.awt.event.FocusAdapter() { 
				public void focusLost(java.awt.event.FocusEvent e) {    
					aggiornaImportoFromUI();
				}
			});
			jTxtAliquota.setDocument(new BigDecimalDocument(MetanoRettificheFatturazione.dimAliquotaImpostaIntere,MetanoRettificheFatturazione.dimAliquotaImpostaDecimale));
		}
		return jTxtAliquota;
	}

	/**
	 * This method initializes jTxtQuantita
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTxtQuantita() {
		if(jTxtQuantita == null) {
			jTxtQuantita = new javax.swing.JTextField();
			jTxtQuantita.setSize(78, 21);
			jTxtQuantita.setLocation(372, 325);
			jTxtQuantita.addFocusListener(new java.awt.event.FocusAdapter() { 
				public void focusLost(java.awt.event.FocusEvent e) {   
					aggiornaImportoFromUI();
				}
			});
			jTxtQuantita.setDocument(new BigIntegerDocument(MetanoRettificheFatturazione.dimQuantita));
		}
		return jTxtQuantita;
	}
	/**
	 * This method initializes jBtElimina
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJBtElimina() {
		if(jBtElimina == null) {
			jBtElimina = new javax.swing.JButton();
			jBtElimina.setSize(83, 27);
			jBtElimina.setText("Elimina");
			jBtElimina.setLocation(648, 355);
			jBtElimina.addActionListener(this);
		}
		return jBtElimina;
	}
	/**
	 * This method initializes jBtImposta
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJBtImposta() {
		if(jBtImposta == null) {
			jBtImposta = new javax.swing.JButton();
			jBtImposta.setBounds(557, 355, 83, 27);
			jBtImposta.setText("Imposta");
			jBtImposta.addActionListener(this);
		}
		return jBtImposta;
	}
	/**
	 * This method initializes jBtConferma
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJBtConferma() {
		if(jBtConferma == null) {
			jBtConferma = new javax.swing.JButton();
			jBtConferma.setBounds(26, 462, 97, 27);
			jBtConferma.setText("Conferma");
			jBtConferma.addActionListener(this);

		}
		return jBtConferma;
	}
	/**
	 * This method initializes jBtChiudi
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJBtChiudi() {
		if(jBtChiudi == null) {
			jBtChiudi = new javax.swing.JButton();
			jBtChiudi.setBounds(128, 462, 97, 27);
			jBtChiudi.setText("Chiudi");
			jBtChiudi.addActionListener(this);
		}
		return jBtChiudi;
	}
	/**
	 * This method initializes jTable
	 * 
	 * @return javax.swing.JTable
	 */
	private javax.swing.JTable getJTable() {
		if(jTable == null) {
			jTable = new javax.swing.JTable();
			jTable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
			jTable.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
			jTable.getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);			
			jTable.getSelectionModel().addListSelectionListener(this);
		}
		return jTable;
	}
	/**
	 * This method initializes jScrollPane
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private javax.swing.JScrollPane getJScrollPane() {
		if(jScrollPane == null) {
			jScrollPane = new javax.swing.JScrollPane();
			jScrollPane.setBounds(8, 33, 727, 271);
			jScrollPane.setViewportView(getJTable());
		}
		return jScrollPane;
	}

	/**
	 * This method initializes jTxtTotale
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTxtTotale() {
		if(jTxtTotale == null) {
			jTxtTotale = new javax.swing.JTextField();
			jTxtTotale.setSize(115, 21);
			jTxtTotale.setLocation(618, 325);
			jTxtTotale.setEnabled(true);
			jTxtTotale.setDocument(new SignedBigDecimalDocument(MetanoRettificheFatturazione.dimImportoEuroIntere,MetanoRettificheFatturazione.dimImportoEuroDecimale));
		}
		return jTxtTotale;
	}
	/**
	 * This method initializes jLblTotale1
	 * 
	 * @return javax.swing.JLabel
	 */
	
	private javax.swing.JLabel getJLblTotale1() {
		if(jLblTotale1 == null) {
			jLblTotale1 = new javax.swing.JLabel();
			jLblTotale1.setSize(115, 19);
			jLblTotale1.setText("Totale");
			jLblTotale1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
			jLblTotale1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			jLblTotale1.setLocation(618, 306);
		}
		return jLblTotale1;
	}
	
	/**
	 * This method initializes jLblSegno
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLblSegno() {
		if(jLblSegno == null) {
			jLblSegno = new javax.swing.JLabel();
			jLblSegno.setSize(80, 19);
			jLblSegno.setText("Segno");
			jLblSegno.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
			jLblSegno.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			jLblSegno.setLocation(288, 306);
		}
		return jLblSegno;
	}
		
	/**
	 * This method initializes jButtonInserisci
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonInserisci() {
		if(jButtonInserisci == null) {
			jButtonInserisci = new javax.swing.JButton();
			jButtonInserisci.setBounds(467, 355, 83, 27);
			jButtonInserisci.setText("Inserisci");
			jButtonInserisci.addActionListener(this);
		}
		return jButtonInserisci;
	}
}
