package it.finanze.dogane.accise.metano.ui;

import it.finanze.dogane.accise.combo.AbstractTipo;
import it.finanze.dogane.accise.combo.ComboDataSource;
import it.finanze.dogane.accise.combo.ComboUtil;
import it.finanze.dogane.accise.combo.TipoComune;
import it.finanze.dogane.accise.combo.TipoProvincia;
import it.finanze.dogane.accise.metano.model.MetanoIntrodottoInDepositiFiscali;
import it.finanze.dogane.accise.metano.model.ProspettoConsumo;
import it.finanze.dogane.accise.metano.ui.quadri.Quadro;
import it.finanze.dogane.accise.metano.ui.tablemodel.MetanoIntrodottoInDepositiFiscaliPuntiImmissioneTM;
import it.finanze.dogane.accise.ui.FullScreenLayoutManager;
import it.finanze.dogane.accise.ui.RealDim;
import it.finanze.dogane.accise.ui.quadri.dialog.IntermediateDialog;
import it.finanze.dogane.accise.ui.validation.StringDocument;
import it.finanze.dogane.accise.util.StringUtil;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import javax.swing.JDialog;
import javax.swing.JOptionPane;

public class PuntiDiImmissioneIntermediateDialog extends JDialog  implements ActionListener, IntermediateDialog {
	private javax.swing.JPanel jContentPane = null;

	private javax.swing.JLabel jLabelProvincia = null;
	private javax.swing.JComboBox jComboBoxProvincia = null;
	private javax.swing.JButton jButtonConferma = null;
	private javax.swing.JButton jButtonAnnulla = null;

	private int actionRequested = 0;
	
	private javax.swing.JLabel jLabel1 = null;
	private javax.swing.JComboBox jComboBoxComune = null;
	private javax.swing.JLabel jLabelMese = null;
	List province = null;
	List mesi  = null;
	List capitoli = null;
	
	private MetanoIntrodottoInDepositiFiscaliPuntiImmissioneTM modelPuntiImmissione = null;
	private MetanoIntrodottoInDepositiFiscali recordPuntiImmissione = null;
	private ProspettoConsumo prospettoConsumo = null;
	private Quadro quadro = null;
	
	
	

	private javax.swing.JTextField jTextFieldIndirizzo = null;
	/**
	 * This is the default constructor
	 */
	public PuntiDiImmissioneIntermediateDialog() {		
		super();
		initialize();
	}

	public PuntiDiImmissioneIntermediateDialog(String provincia, String comune, String indirizzo) {		
		super();
		initialize();
		
		TipoProvincia tipoProvincia = ComboDataSource.getInstance().getProvincia(provincia);
		TipoComune tipoComune = ComboDataSource.getInstance().getComunePerDescrizione(provincia, comune);
		
		jComboBoxProvincia.setSelectedItem(tipoProvincia);
		jComboBoxComune.setSelectedItem(tipoComune);
		jTextFieldIndirizzo.setText(indirizzo);
	}
	
	private void initialize() {
//		this.setSize(614, 200);
		this.setSize(RealDim.getAbsoluteXValue(614), RealDim.getAbsoluteYValue(200));
		int xDim = RealDim.getAbsoluteXDim();
		int yDim = RealDim.getAbsoluteYDim();
		int width = getSize().width;
		int height = getSize().height;
		
		this.setLocation((xDim-width)/2, (yDim-height)/2);

		this.setContentPane(getJContentPane());
		this.setResizable(false);			
		this.setModal(true);
	    initCombo();
		
		this.setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
			
	}
		
	public void initCombo(){  	
		ComboDataSource.getInstance().getProvince();
		ComboUtil.setValues(jComboBoxProvincia,ComboDataSource.getInstance().getProvince());
		String codiceProvincia =((TipoProvincia) jComboBoxProvincia.getSelectedItem()).getCodice();
		ComboUtil.setValues(jComboBoxComune,ComboDataSource.getInstance().getComuni(codiceProvincia));
	}
  
	public List getSelectedValue() {
		List parametriSelezionati = new LinkedList();				
		parametriSelezionati.add(getJComboBoxProvincia().getSelectedItem());	
		parametriSelezionati.add(getJComboBoxComune().getSelectedItem());
		parametriSelezionati.add(getJTextFieldIndirizzo().getText());	
		return parametriSelezionati ;
	}

	public TipoProvincia getSelectedProvincia() {
		return (TipoProvincia)getJComboBoxProvincia().getSelectedItem();
	}

	public TipoComune getSelectedComune() {
		return (TipoComune)getJComboBoxComune().getSelectedItem();
	}
	
	public String getSelectedIndirizzo() {
		return getJTextFieldIndirizzo().getText();
	}

	public int getActionRequested() {
		return actionRequested;
		
	}
	
/**************************************************************************************
 * INIZIO GESTIONE EVENTI
 **************************************************************************************/
	public void actionPerformed(ActionEvent event) {
		
		if(event.getSource() == jButtonConferma) {
			doConfirm();
		} else if(event.getSource() == jButtonAnnulla) {
			doCancel();
		}else if (event.getSource() == jComboBoxProvincia) {
		    updateCombo();
		}
	
	}

	
	private void doConfirm() {
		if(validateForm()) {
			actionRequested = ACTION_CONFIRM;
			this.setVisible(false);
		}
	}

	private void doCancel() {
		actionRequested = ACTION_CANCEL;
		this.setVisible(false);
	}

	private void updateCombo() {
		AbstractTipo tipo = (AbstractTipo)jComboBoxProvincia.getSelectedItem();
		if(tipo == null) {
			tipo = (AbstractTipo)jComboBoxProvincia.getItemAt(0);
		}
		ComboUtil.setValues(jComboBoxComune, ComboDataSource.getInstance().getComuni(tipo.getCodice()));
	}
	
	private boolean validateForm() {
		boolean isOk = true;
		
		String indirizzo = StringUtil.nullify(jTextFieldIndirizzo.getText());
		if(indirizzo == null) {
			JOptionPane.showMessageDialog(
							this,
							"Impostare l'indirizzo",
							"Attenzione",
							JOptionPane.WARNING_MESSAGE);
							
			isOk = false;
			
		}
		
		return isOk;
	}
/**************************************************************************************
 * FINE GESTIONE EVENTI
 **************************************************************************************/


/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(null);
			jContentPane.setLayout(FullScreenLayoutManager.getInstance());
			jContentPane.add(getJLabelProvincia(), null);
			jContentPane.add(getJComboBoxProvincia(), null);
			jContentPane.add(getJButtonConferma(), null);
			jContentPane.add(getJButtonAnnulla(), null);
			jContentPane.add(getJLabel1(), null);
			jContentPane.add(getJComboBoxComune(), null);
			jContentPane.add(getJLabelMese(), null);
			jContentPane.add(getJTextFieldIndirizzo(), null);
		}
		return jContentPane;
	}
	/**
	 * This method initializes jLabelProvincia
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelProvincia() {
		if(jLabelProvincia == null) {
			jLabelProvincia = new javax.swing.JLabel();
			jLabelProvincia.setBounds(0, 20, 114, 23);
			jLabelProvincia.setText("Provincia");
			jLabelProvincia.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			jLabelProvincia.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);
		}
		return jLabelProvincia;
	}
	/**
	 * This method initializes jComboBoxProvincia
	 * 
	 * @return javax.swing.JComboBox
	 */
	private javax.swing.JComboBox getJComboBoxProvincia() {
		if(jComboBoxProvincia == null) {
			jComboBoxProvincia = new javax.swing.JComboBox();
			jComboBoxProvincia.setBounds(120, 20, 371, 24);
			jComboBoxProvincia.setEnabled(true);
			jComboBoxProvincia.setEditable(false);
			jComboBoxProvincia.addActionListener(this);
			
		}
		return jComboBoxProvincia;
	}
	/**
	 * This method initializes jButtonConferma
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonConferma() {
		if(jButtonConferma == null) {
			jButtonConferma = new javax.swing.JButton();
			jButtonConferma.setBounds(500, 20, 96, 23);
			jButtonConferma.setText("Conferma");
			jButtonConferma.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
			
			jButtonConferma.addActionListener(this);
		}
		return jButtonConferma;
	}
	/**
	 * This method initializes jButtonAnnulla
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonAnnulla() {
		if(jButtonAnnulla == null) {
			jButtonAnnulla = new javax.swing.JButton();
			jButtonAnnulla.setBounds(500, 60, 96, 23);
			jButtonAnnulla.setText("Annulla");
			jButtonAnnulla.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

			jButtonAnnulla.addActionListener(this);
		}
		return jButtonAnnulla;
	}

	/**
	 * This method initializes jLabel1
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel1() {
		if(jLabel1 == null) {
			jLabel1 = new javax.swing.JLabel();
			jLabel1.setBounds(0, 62, 114, 23);
			jLabel1.setText("Comune");
			jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}
		return jLabel1;
	}
	/**
	 * This method initializes jComboBoxComune
	 * 
	 * @return javax.swing.JComboBox
	 */
	private javax.swing.JComboBox getJComboBoxComune() {
		if(jComboBoxComune == null) {
			jComboBoxComune = new javax.swing.JComboBox();
			jComboBoxComune.setBounds(120, 62, 371, 24);
			jComboBoxComune.setEnabled(true);
			jComboBoxComune.setSelectedIndex(-1);
		}
		return jComboBoxComune;
	}
	/**
	 * This method initializes jLabelMese
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelMese() {
		if(jLabelMese == null) {
			jLabelMese = new javax.swing.JLabel();
			jLabelMese.setBounds(0, 104, 114, 23);
			jLabelMese.setText("Indirizzo");
			jLabelMese.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		}
		return jLabelMese;
	}
	
	
	/**
	 * @return
	 */
	public List getCapitoli() {
		return capitoli;
	}

	/**
	 * @return
	 */
	public List getMesi() {
		return mesi;
	}

	/**
	 * @return
	 */
	public List getProvince() {
		return province;
	}

	/**
	 * @param list
	 */
	public void setCapitoli(List list) {
		capitoli = list;
		if(capitoli!=null){
		Iterator it = capitoli.iterator();
		 while(it.hasNext()) {
			getJComboBoxComune().addItem(it.next());			
		 }
	   jComboBoxComune.setEnabled(true)	;
	   jComboBoxComune.setSelectedIndex(-1);
		}
	}
	

	/**
	 * @param list
	 */
	public void setProvince(List list) {
		province = list;
		if(province!=null){
		Iterator it = province.iterator();
		  while(it.hasNext()) {
		   getJComboBoxProvincia().addItem(it.next());			
		  }
		jComboBoxProvincia.setEnabled(true)	;
		jComboBoxProvincia.setSelectedIndex(-1);
		}
	}
	

	

	/**
	 * This method initializes jTextFieldIndirizzo
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldIndirizzo() {
		if(jTextFieldIndirizzo == null) {
			jTextFieldIndirizzo = new javax.swing.JTextField();
			jTextFieldIndirizzo.setBounds(119, 103, 371, 24);
			
			jTextFieldIndirizzo.setDocument(new StringDocument(MetanoIntrodottoInDepositiFiscali.dimIndirizzoPuntoImmissione));
		}
		return jTextFieldIndirizzo;
	}
}  //  @jve:visual-info  decl-index=0 visual-constraint="10,10"
