package it.finanze.dogane.accise.metano.ui.quadri;

import it.finanze.dogane.accise.combo.TipoCapitolo;
import it.finanze.dogane.accise.combo.TipoFasciaClimatica;
import it.finanze.dogane.accise.combo.TipoMese;
import it.finanze.dogane.accise.combo.TipoProvincia;
import it.finanze.dogane.accise.util.StringUtil;

/**
 * Questa classe gestisce i parametri utilizzati per la visualizzazione dei quadri complessi 
 */
public class Parametri {
	private TipoProvincia provincia = null;
	private TipoCapitolo capitolo = null;
	private TipoMese mese = null;
	private TipoFasciaClimatica fasciaClimatica = null;
	
	/**
	 * @return
	 */
	public TipoCapitolo getCapitolo() {
		return capitolo;
	}

	/**
	 * @return
	 */
	public TipoMese getMese() {
		return mese;
	}

	/**
	 * @return
	 */
	public TipoProvincia getProvincia() {
		return provincia;
	}

	/**
	 * @param capitolo
	 */
	public void setCapitolo(TipoCapitolo capitolo) {
		this.capitolo = capitolo;
	}

	/**
	 * @param mese
	 */
	public void setMese(TipoMese mese) {
		this.mese = mese;
	}

	/**
	 * @param provincia
	 */
	public void setProvincia(TipoProvincia provincia) {
		this.provincia = provincia;
	}

	/**
	 * @return
	 */
	public TipoFasciaClimatica getFasciaClimatica() {
		return fasciaClimatica;
	}

	/**
	 * @param climatica
	 */
	public void setFasciaClimatica(TipoFasciaClimatica climatica) {
		fasciaClimatica = climatica;
	}

	public String toString() {
		String retvalue = "";
		if(provincia != null && StringUtil.nullify(provincia.getCodice()) != null) {
			retvalue += provincia.getCodice();
		}

		if(capitolo != null && StringUtil.nullify(capitolo.getDescrizione()) != null) {
			if(!retvalue.equals("")) {
				retvalue += " - ";
			}
			retvalue += capitolo.getDescrizione();
		}
		
		if(mese != null && StringUtil.nullify(mese.getDescrizione()) != null) {
			if(!retvalue.equals("")) {
				retvalue += " - ";
			}
			retvalue += mese.getDescrizione();
		}
		
		if(fasciaClimatica != null && StringUtil.nullify(fasciaClimatica.getCodice()) != null) {
			if(!retvalue.equals("")) {
				retvalue += " - ";
			}
			retvalue += "FAS. CLIM. " + fasciaClimatica.getCodice();
		}
		
		return retvalue;
	}

}
