package it.finanze.dogane.accise.metano.ui.quadri;

import java.util.Comparator;

public class ParametriComparator implements Comparator {

	public int compare(Object left, Object right) {
		
		Parametri leftP = (Parametri)left;
		Parametri rightP = (Parametri)right;
		
		int retvalue = 0;
		
		String stringLeft = null;
		String stringRight = null;
		
		if(leftP.getProvincia() != null) {
			stringLeft = leftP.getProvincia().getCodice();
		}

		if(rightP.getProvincia() != null) {
			stringRight = rightP.getProvincia().getCodice();
		}
		
		retvalue = getCompareValue(stringLeft, stringRight);
		
		if(retvalue == 0) {
			
			stringLeft = null;
			stringRight = null;

			if(leftP.getCapitolo() != null) {
				stringLeft = leftP.getCapitolo().getCodice();
			}

			if(rightP.getCapitolo() != null) {
				stringRight = rightP.getCapitolo().getCodice();
			}
		
			retvalue = getCompareValue(stringLeft, stringRight);
			
			if(retvalue == 0) {
				
				stringLeft = null;
				stringRight = null;

				if(leftP.getMese() != null) {
					stringLeft = leftP.getMese().getCodice();
					while(stringLeft != null && stringLeft.length() < 2) {
						stringLeft = "0" + stringLeft;
					}
				}

				if(rightP.getMese() != null) {
					stringRight = rightP.getMese().getCodice();
					while(stringRight != null && stringRight.length() < 2) {
						stringRight = "0" + stringRight;
					}
				}
		
				retvalue = getCompareValue(stringLeft, stringRight);

				if(retvalue == 0) {
					
					stringLeft = null;
					stringRight = null;

					if(leftP.getFasciaClimatica() != null) {
						stringLeft = leftP.getFasciaClimatica().getCodice();
					}

					if(rightP.getFasciaClimatica() != null) {
						stringRight = rightP.getFasciaClimatica().getCodice();
					}
		
					retvalue = getCompareValue(stringLeft, stringRight);

				}

			}
		}

		return retvalue;
	}


	private int getCompareValue(String left, String right) {
		if(left == null && right == null) {
			return 0;
		} else if (left == null && right != null){ // il null + minore di tutto il resto
			return -1;
		} else if (left != null && right == null){
			return 1;
		} else if (left != null && right != null){
			return left.compareTo(right);
		}
		
		return 0; // Qui non ci arrivo mai...
	}

	/** modificato da Fiorello il 12 ottobre 2006
	 	private int getCompareValue(String left, String right) {
			if(left == null && right == null) {
				return 0;
			} else if(left != null) {
				return left.compareTo(right);
			} else if(left == null) {
				return -1 * right.compareTo(left);
			}
			
			return 0; // Qui non ci arrivo mai...
		}
	 * */
}
