package it.finanze.dogane.accise.metano.ui.quadri;




import it.finanze.dogane.accise.combo.AbstractTipo;
import it.finanze.dogane.accise.combo.ComboDataSource;
import it.finanze.dogane.accise.combo.TipoCapitolo;
import it.finanze.dogane.accise.combo.TipoFasciaClimatica;
import it.finanze.dogane.accise.combo.TipoMese;
import it.finanze.dogane.accise.combo.TipoProvincia;
import it.finanze.dogane.accise.metano.model.DatiAddizionaleClientiAgevolati;
import it.finanze.dogane.accise.metano.model.MetanoAcquistatoDaSoggettiSenzaImpianti;
import it.finanze.dogane.accise.metano.model.MetanoEstrattoVenduto;
import it.finanze.dogane.accise.metano.model.MetanoFatturatoImpiegato;
import it.finanze.dogane.accise.metano.model.MetanoFatturatoImpiegatoSenzaPagAccisa;
import it.finanze.dogane.accise.metano.model.MetanoLiquidazioneImposte;
import it.finanze.dogane.accise.metano.model.MetanoRecord;
import it.finanze.dogane.accise.metano.model.MetanoRettificheFatturazione;
import it.finanze.dogane.accise.metano.model.MetanoRiepilogoSaldoImposte;
import it.finanze.dogane.accise.metano.model.ProspettoConsumo;
import it.finanze.dogane.accise.metano.ui.MetanoAcquistatoDaSoggettiSenzaImpiantiDialog;
import it.finanze.dogane.accise.metano.ui.MetanoClientiAgevolati;
import it.finanze.dogane.accise.metano.ui.MetanoEstrattoVendutoDialog;
import it.finanze.dogane.accise.metano.ui.MetanoFatturatoImpiegatoDialog;
import it.finanze.dogane.accise.metano.ui.MetanoFatturatoImpiegatoSenzaPagAccisaDialog;
import it.finanze.dogane.accise.metano.ui.MetanoIntermediateDialog;
import it.finanze.dogane.accise.metano.ui.MetanoIntrodottoInDepositiFiscaliDialog;
import it.finanze.dogane.accise.metano.ui.MetanoLiquidazioneImposteDialog;
import it.finanze.dogane.accise.metano.ui.MetanoRettificheFatturazioneDialog;
import it.finanze.dogane.accise.metano.ui.MetanoRiepilogoSaldoImposteDialog;
import it.finanze.dogane.accise.model.Prospect;
import it.finanze.dogane.accise.pdf.PdfBuilder;
import it.finanze.dogane.accise.pdf.PrintDriver;
import it.finanze.dogane.accise.ui.RealDim;
import it.finanze.dogane.accise.ui.quadri.DefaultEtichettaQuadro;
import it.finanze.dogane.accise.ui.quadri.GestoreQuadro;
import it.finanze.dogane.accise.ui.quadri.dialog.QuadroDialog;
import it.finanze.dogane.accise.util.StringUtil;

import java.awt.Component;
import java.awt.Frame;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.TreeSet;

import javax.swing.JDialog;
import javax.swing.JOptionPane;

public class Quadro extends DefaultEtichettaQuadro implements GestoreQuadro {

	
	public static final int[] QUADRO_A = { 10 };
	public static final int[] QUADRO_B = {15};
	public static final int[] QUADRO_C = { 11 };
	public static final int[] QUADRO_D = {16};
	public static final int[] QUADRO_E = { 20 };
	public static final int[] QUADRO_F = { 31 };
	public static final int[] QUADRO_G = { 32 };
	public static final int[] QUADRO_H = { 40 };
	public static final int[] QUADRO_I = { 50 };
	public static final int[] QUADRO_L = { 55 };
	public static final int[] QUADRO_M = { 60 };
	public static final int[] QUADRO_N = { 65 };
	public static final int[] QUADRO_O = { 70 };
	public static final int[] QUADRO_P = { 75 };
	public static final int[] ALLEGATO = { 80 };
	
	public static final String LETTERA_QUADRO_A = "A";
	public static final String LETTERA_QUADRO_B = "B";
	public static final String LETTERA_QUADRO_C = "C";
	public static final String LETTERA_QUADRO_D = "D";
	public static final String LETTERA_QUADRO_E = "E";
	public static final String LETTERA_QUADRO_F = "F";
	public static final String LETTERA_QUADRO_G = "G";
	public static final String LETTERA_QUADRO_H = "H";
	public static final String LETTERA_QUADRO_I = "I";
	public static final String LETTERA_QUADRO_L = "L";
	public static final String LETTERA_QUADRO_M = "M";
	public static final String LETTERA_QUADRO_N = "N";
	public static final String LETTERA_QUADRO_O = "O";
	public static final String LETTERA_QUADRO_P = "P";
	public static final String LETTERA_ALLEGATO = "ALLEGATO";
	ProspettoConsumo prospettoConsumo = null;
	Parametri parametriSelezionati = null;

	private int[] tipiRecord = null;
	private String lettera = null;
	

	public Quadro(int[] tipi) {
		if(tipi == null || tipi.length == 0) {
			throw new IllegalArgumentException("Si devono specificare i tipi.");
		}
		
		tipiRecord = tipi;
		lettera = getLetteraQuadro(tipi);
	}

	public void setProspect(Prospect prospect) {
		setProspect(prospect, null);
	}

	public static String getLetteraQuadro(int[] tipiRecord) {
		String retvalue = null;
		if(QUADRO_A.equals(tipiRecord)) {
			retvalue = LETTERA_QUADRO_A;
		} else if(QUADRO_B.equals(tipiRecord)) {
			retvalue = LETTERA_QUADRO_B;
		} else if(QUADRO_C.equals(tipiRecord)) {
			retvalue = LETTERA_QUADRO_C;
		} else if(QUADRO_D.equals(tipiRecord)) {
			retvalue = LETTERA_QUADRO_D;
		} else if(QUADRO_E.equals(tipiRecord)) {
			retvalue = LETTERA_QUADRO_E;
		} else if(QUADRO_F.equals(tipiRecord)) {
			retvalue = LETTERA_QUADRO_F;
		} else if(QUADRO_G.equals(tipiRecord)) {
			retvalue = LETTERA_QUADRO_G;
		} else if(QUADRO_H.equals(tipiRecord)) {
			retvalue = LETTERA_QUADRO_H;
		} else if(QUADRO_I.equals(tipiRecord)) {
			retvalue = LETTERA_QUADRO_I;
		} else if(QUADRO_L.equals(tipiRecord)) {
			retvalue = LETTERA_QUADRO_L;
		} else if(QUADRO_M.equals(tipiRecord)) {
			retvalue = LETTERA_QUADRO_M;
		} else if(QUADRO_N.equals(tipiRecord)) {
			retvalue = LETTERA_QUADRO_N;
		} else if(QUADRO_O.equals(tipiRecord)) {
			retvalue = LETTERA_QUADRO_O;
		} else if(QUADRO_P.equals(tipiRecord)) {
			retvalue = LETTERA_QUADRO_P;		
		}else if(ALLEGATO.equals(tipiRecord)) {
		retvalue = LETTERA_ALLEGATO;		
	}
		return retvalue;
	}

	/**
	 * Il parametro che si pu passare pu essere un TipoMese per i quadri complessi relativi
	 * o un TipoCapitoloArticolo per i quadri complessi relativi
	 */
	public void setProspect(Prospect prospect, Object parameter) {
		if(prospect instanceof ProspettoConsumo) {
			prospettoConsumo = (ProspettoConsumo)prospect;
			updateEmptyValue();
		} else {
			throw new IllegalArgumentException("Il prospetto deve essere di tipo: " + ProspettoConsumo.class.getName() + " e non di tipo: " + prospettoConsumo.getClass().getName());
		}
		
		if(parameter == null || parameter instanceof Parametri) {
			parametriSelezionati = (Parametri)parameter;
		} else {
			throw new IllegalArgumentException("Il parametro deve essere di tipo: " + Parametri.class.getName() + " e non di tipo: " + parameter.getClass().getName());
		}
	}

	public Object getParameter() {
		return parametriSelezionati;
	}

	private void updateEmptyValue() {
		List recordPerQuadro = prospettoConsumo.getListaQuadro(tipiRecord);
		if(recordPerQuadro.size() > 0) {
			setEmpty(false);
		} else {
			setEmpty(true);
		}
	}

	public void showDialog(Frame frame) {
		QuadroDialog quadroDialog = initDialog(frame);
		quadroDialog.prepareValues(prospettoConsumo, this);
		
		JDialog jDialog = (JDialog)quadroDialog;
		
		updateEmptyValue();
		
		jDialog.setVisible(true);
	}
	
	public void printDialog(Frame frame, PdfBuilder builder) {
		QuadroDialog quadroDialog = initDialog(frame);
		quadroDialog.prepareValues(prospettoConsumo, this);

		Component c = (Component)quadroDialog;
		PrintDriver.print(c, builder);
	}

	private QuadroDialog initDialog(Frame frame) {
		QuadroDialog quadroDialog = null;
		if(tipiRecord.equals(QUADRO_A)) {
			quadroDialog = new MetanoIntrodottoInDepositiFiscaliDialog(frame, getDescription(), getSecondDescription());
		} else if(tipiRecord.equals(QUADRO_B)) {
			quadroDialog = new MetanoEstrattoVendutoDialog(frame, getDescription(), getSecondDescription());
		} else if(tipiRecord.equals(QUADRO_C)) {
			quadroDialog = new MetanoAcquistatoDaSoggettiSenzaImpiantiDialog(frame, getDescription(), getSecondDescription());
		} else if(tipiRecord.equals(QUADRO_D)) {
			quadroDialog = new MetanoEstrattoVendutoDialog(frame, getDescription(), getSecondDescription());
		} else if(tipiRecord.equals(QUADRO_E)) {
			quadroDialog = new MetanoFatturatoImpiegatoSenzaPagAccisaDialog(frame, getDescription(), getSecondDescription());
		} else if(tipiRecord.equals(QUADRO_F)) {
			quadroDialog = new MetanoFatturatoImpiegatoDialog(frame, getDescription(), getSecondDescription());
		} else if(tipiRecord.equals(QUADRO_G)) {
			quadroDialog = new MetanoFatturatoImpiegatoDialog(frame, getDescription(), getSecondDescription());
		} else if(tipiRecord.equals(QUADRO_I)) {
			quadroDialog = new MetanoLiquidazioneImposteDialog(frame, getDescription(), getSecondDescription());
		} else if(tipiRecord.equals(QUADRO_M)) {
			quadroDialog = new MetanoLiquidazioneImposteDialog(frame, getDescription(), getSecondDescription());
		} else if(tipiRecord.equals(QUADRO_O)) {
			quadroDialog = new MetanoLiquidazioneImposteDialog(frame, getDescription(), getSecondDescription());
		} else if(tipiRecord.equals(QUADRO_L)) {
			quadroDialog = new MetanoRiepilogoSaldoImposteDialog(frame, getDescription(), getSecondDescription());
		} else if(tipiRecord.equals(QUADRO_N)) {
			quadroDialog = new MetanoRiepilogoSaldoImposteDialog(frame, getDescription(), getSecondDescription());
		} else if(tipiRecord.equals(QUADRO_P)) {
			quadroDialog = new MetanoRiepilogoSaldoImposteDialog(frame, getDescription(), getSecondDescription());
		} else if(tipiRecord.equals(QUADRO_H)) {
			quadroDialog = new MetanoRettificheFatturazioneDialog(frame, getDescription(), getSecondDescription());
		}else if(tipiRecord.equals(ALLEGATO)) {
		quadroDialog = new MetanoClientiAgevolati(frame, getDescription(), getSecondDescription());
	} 
		 
		
		
		else {
			throw new RuntimeException("Dialogo non previsto per questo quadro. " + Quadro.getLetteraQuadro(tipiRecord));
		}
		
		return quadroDialog;
	}		
		
		public void showIntermediateDialog(Frame frame) {
			String etichetta = null;
			List mesi = null;
			List capitoli = null;
			List province = null;
			boolean fasciaClimatica = false;
		
			if(tipiRecord.equals(QUADRO_A)||tipiRecord.equals(QUADRO_B)||tipiRecord.equals(QUADRO_C)||tipiRecord.equals(QUADRO_D)) {				
				mesi = ComboDataSource.getInstance().getMesi();
			} else if(tipiRecord.equals(QUADRO_E)||tipiRecord.equals(QUADRO_G)) {
				mesi = ComboDataSource.getInstance().getMesi();
				province = ComboDataSource.getInstance().getProvince();
			} else if(tipiRecord.equals(QUADRO_F)) {
				mesi = ComboDataSource.getInstance().getMesi();
				province = ComboDataSource.getInstance().getProvinceNoStatutoSpeciale();
				fasciaClimatica = true;
			} else if(tipiRecord.equals(QUADRO_H)) {
				province = ComboDataSource.getInstance().getProvince();				
			} else if(tipiRecord.equals(QUADRO_N)||tipiRecord.equals(QUADRO_O)||tipiRecord.equals(QUADRO_P)) {
				province = ComboDataSource.getInstance().getProvinceNoStatutoSpeciale();				
			} else if(tipiRecord.equals(QUADRO_I)|| tipiRecord.equals(QUADRO_L)) {
				province = ComboDataSource.getInstance().getProvince();
				capitoli = ComboDataSource.getInstance().getCapitoli(lettera);
			}else if(tipiRecord.equals(QUADRO_M)) {
				province = ComboDataSource.getInstance().getProvinceNoStatutoSpeciale();
				fasciaClimatica = true;
			}else if(tipiRecord.equals(ALLEGATO)){
				province = ComboDataSource.getInstance().getProvince();
				fasciaClimatica = false;
			}
		
		
	

		MetanoIntermediateDialog dialog = new MetanoIntermediateDialog();
		
		dialog.setMesi(mesi);
		dialog.setProvince(province);
		dialog.setCapitoli(capitoli);
		dialog.setFasciaClimatica(fasciaClimatica);
		
		
		dialog.setVisible(true);
		
		if(dialog.getActionRequested() == MetanoIntermediateDialog.ACTION_CONFIRM) {
			parametriSelezionati = (Parametri)dialog.getSelectedValue();
			
			// ... per il quadro f
			// Se per provincia si acquisisce un mese senza fascia climatica, tutti gli altri mesi 
			// per quella provincia non dovranno avere la fascia climatica obbligatoriamente e viceversa
			// se venisse acquisita.
			
			/** MODIFICA 06-11-2007 **/
			if(tipiRecord.equals(QUADRO_M) && getSottoQuadri().size()>0) {
				Parametri[] parametri = getListaPerProvince_Mesi_FascieClimatiche(prospettoConsumo.getListaQuadro(tipiRecord));	
				for(int i=0; i < parametri.length; i++) {
					Parametri parametro=(Parametri)parametri[i];
					TipoProvincia provinciaTmp=parametro.getProvincia();
					TipoMese meseTmp=parametro.getMese();
					TipoFasciaClimatica fasciaClimaticaTmp=parametro.getFasciaClimatica();
					if (provinciaTmp.equals(parametriSelezionati.getProvincia())){
						// se nella lista  gia' presente quella provincia, controllo se la fascia climatica  gi stata inserita
						// provincia = e fasciaClimatica nulla
						// provinicia = e fasciaClimatica =
						if (parametriSelezionati.getProvincia().getCodice().equals(provinciaTmp.getCodice())) {
							if ( (parametriSelezionati.getFasciaClimatica().getCodice() == null &&
							 	 fasciaClimaticaTmp.getCodice() != null) 
							 	 || (parametriSelezionati.getFasciaClimatica().getCodice() != null &&
									 fasciaClimaticaTmp.getCodice() == null) ) {
								
							   
								QuadroDialog quadroDialog = initDialog(frame);
								//quadroDialog.prepareValues(prospettoConsumo, this);
								JDialog jDialog = (JDialog)quadroDialog;
								JOptionPane.showMessageDialog(
												jDialog,
												"Per la provincia in questione sono gi presenti informazioni per le quali  stata specificata la fascia climatica.\n" +
												"Per una stessa provincia non  possibile inserire dati relativi a una specifica fascia e dati generici.",
												"Attenzione",
												JOptionPane.WARNING_MESSAGE);
												return;
							}
						}
					}
				}
			}
			/** FINE MODIFICA **/			
			if(tipiRecord.equals(QUADRO_F)) {
				Parametri[] parametri = getListaPerProvince_Mesi_FascieClimatiche(prospettoConsumo.getListaQuadro(tipiRecord));	
				for(int i=0; i < parametri.length; i++) {
					Parametri parametro=(Parametri)parametri[i];
					TipoProvincia provinciaTmp=parametro.getProvincia();
					TipoMese meseTmp=parametro.getMese();
					TipoFasciaClimatica fasciaClimaticaTmp=parametro.getFasciaClimatica();
					if (provinciaTmp.equals(parametriSelezionati.getProvincia())){
						// se nella lista  gia' presente quella provincia, controllo se la fascia climatica  gi stata inserita
						if (
						 (fasciaClimaticaTmp!=null && fasciaClimaticaTmp.getCodice()!=null && !fasciaClimaticaTmp.getCodice().trim().equals("") && (parametriSelezionati.getFasciaClimatica()==null || parametriSelezionati.getFasciaClimatica().getCodice()==null))
						|| ((fasciaClimaticaTmp==null || fasciaClimaticaTmp.getCodice()==null || fasciaClimaticaTmp.getCodice().trim().equals("")) && parametriSelezionati.getFasciaClimatica()!=null && parametriSelezionati.getFasciaClimatica().getCodice()!=null)	
						) { 
							QuadroDialog quadroDialog = initDialog(frame);
							//quadroDialog.prepareValues(prospettoConsumo, this);
							JDialog jDialog = (JDialog)quadroDialog;
							JOptionPane.showMessageDialog(
											jDialog,
											"Per la provincia in questione sono gi presenti informazioni per le quali  stata specificata la fascia climatica.\n" +
											"Per una stessa provincia non  possibile inserire dati relativi a una specifica fascia e dati generici.",
											"Attenzione",
											JOptionPane.WARNING_MESSAGE);
											return;
						}
					}
				}
			}
			showDialog(frame);
		}
	}

	/**
	 * Restituisce una lista di oggetti Parametri  o TipoMese e quindi inseribili in una Lista AWT
	 */
	public List getSottoQuadri() {
		
		if(prospettoConsumo == null) {
			return null;
		}
		
		if(!isComplex()) {
			return null;
		} else {
			List retlist = new LinkedList();			
			String valoriSelezionati = null;
			
			if(QUADRO_A.equals(tipiRecord) ||
				QUADRO_B.equals(tipiRecord) ||
				QUADRO_C.equals(tipiRecord) ||
				QUADRO_D.equals(tipiRecord)) { // Tipi Mese!
				int[] mesi = getListaMesi(prospettoConsumo.getListaQuadro(tipiRecord));
				for(int i=0; i < mesi.length; i++) {
					TipoMese tipoMese = ComboDataSource.getInstance().getMese(String.valueOf(mesi[i]));
					Parametri parametri = new Parametri();
					parametri.setMese(tipoMese);
					retlist.add(parametri);
				}
			} else if(QUADRO_H.equals(tipiRecord) ||
					QUADRO_N.equals(tipiRecord) ||
					QUADRO_O.equals(tipiRecord) ||
					QUADRO_P.equals(tipiRecord) ||
					ALLEGATO.equals(tipiRecord))	{
				
				//Questi sono i parametri relativi ai due dicversi quadri configurati in base alla provincia
				Parametri[] parametri = getListaPerProvince(prospettoConsumo.getListaQuadro(tipiRecord));	
				for(int i=0; i < parametri.length; i++) {
					retlist.add(parametri[i]);
				}

			} else if(QUADRO_E.equals(tipiRecord) ||
					QUADRO_G.equals(tipiRecord))	{
	
				Parametri[] parametri = getListaPerProvince_Mesi(prospettoConsumo.getListaQuadro(tipiRecord));	
				for(int i=0; i < parametri.length; i++) {
					retlist.add(parametri[i]);
				}

			} else if(QUADRO_F.equals(tipiRecord))	{

				Parametri[] parametri = getListaPerProvince_Mesi_FascieClimatiche(prospettoConsumo.getListaQuadro(tipiRecord));	
				for(int i=0; i < parametri.length; i++) {
					retlist.add(parametri[i]);
				}

			} else if(QUADRO_I.equals(tipiRecord) ||
						QUADRO_L.equals(tipiRecord))	{

				Parametri[] parametri = getListaPerProvince_Capitoli(prospettoConsumo.getListaQuadro(tipiRecord), getLettera());	
				for(int i=0; i < parametri.length; i++) {
					retlist.add(parametri[i]);
				}

			} 
			else if(QUADRO_M.equals(tipiRecord))	{
				Parametri[] parametri = getListaPerProvince_FascieClimatiche(prospettoConsumo.getListaQuadro(tipiRecord));
				for(int i=0; i < parametri.length; i++) {
					retlist.add(parametri[i]); 
				}
				
			} 
			return retlist;
		}
	}
	

	
	public int[] getTipiRecord() {
		return tipiRecord;
	}


	/**
	 * Restituisce un vettore contenente i codici dei mesi che sono presenti nei record passati in input.
	 * @param records
	 * @return
	 */
	public static int[] getListaMesi(List records) {
		// NB questo algoritmo ordina anche i mesi in modo crescente!
		boolean[] mesi = {false,false,false,false,false,false,false,false,false,false,false,false,false,false}; // 13 per gestire la non presenza!
		if(records!=null) {
			Iterator it = records.iterator();
			while(it.hasNext()) {
				MetanoRecord record = (MetanoRecord)it.next();
				mesi[record.getMese().intValue()] = true;
			}
		}
		short count = 0;
		for(short i=0; i < 13; i++) {
			if(mesi[i]) {
				count++;
			}
		}
		int[] retvalue = new int[count];
		count = 0;
		for(short i=0; i < 13; i++) {
			if(mesi[i]) {
				retvalue[count] = i;
				count++;
			}
		}
		return retvalue;
	}
	
	
	public static Parametri[] getListaPerProvince(List list) {
		Set set = new TreeSet(new ParametriComparator());

		Iterator it = list.iterator();
		TipoProvincia provincia = null;
		while(it.hasNext()) {
			Object obj = it.next();						
		
			if(
				obj instanceof MetanoRecord
			) {
				MetanoRecord item = (MetanoRecord)obj;
				provincia = new TipoProvincia();
				provincia = ComboDataSource.getInstance().getProvincia(item.getProvincia());
				
				Parametri parametri = new Parametri();
				parametri.setProvincia(provincia);
				set.add(parametri);
			} else {
				throw new RuntimeException("Nella lista  presente un record non supportato per questa operazione. " + obj.getClass().getName());
			}
		}
		Object[] objs = set.toArray();
		Parametri[] retvalue = new Parametri[objs.length];
		for(int i=0; i<objs.length; i++) {
			retvalue[i] = (Parametri)objs[i];
		}
		return retvalue;
	}

	/**
	 * @param list
	 * @return
	 */
	private Parametri[] getListaPerProvince_FascieClimatiche(List list) {
		Set set = new TreeSet(new ParametriComparator());

		Iterator it = list.iterator();
		TipoProvincia provincia = null;
		TipoFasciaClimatica fasciaClimatica = null;
		
		while(it.hasNext()) {
			Object obj = it.next();						
		
			if(obj instanceof MetanoLiquidazioneImposte ||
				obj instanceof MetanoFatturatoImpiegato) {
				MetanoRecord item = (MetanoRecord)obj;

				provincia = ComboDataSource.getInstance().getProvincia(item.getProvincia());

				fasciaClimatica = new TipoFasciaClimatica();
				if(obj instanceof MetanoLiquidazioneImposte) {
					fasciaClimatica.setCodice(((MetanoLiquidazioneImposte)item).getFasciaClimatica());
				} else if(obj instanceof MetanoFatturatoImpiegato) {
					fasciaClimatica.setCodice(((MetanoFatturatoImpiegato)item).getFasciaClimatica());
				}

				Parametri parametri = new Parametri();
				parametri.setProvincia(provincia);
				parametri.setFasciaClimatica(fasciaClimatica);
				set.add(parametri);
			} else {
				throw new RuntimeException("Nella lista  presente un record non supportato per questa operazione. " + obj.getClass().getName());
			}
		}

		Object[] objs = set.toArray();
		Parametri[] retvalue = new Parametri[objs.length];
		for(int i=0; i<objs.length; i++) {
			retvalue[i] = (Parametri)objs[i];
		}
		return retvalue;
	}

	/**
	 * @param list
	 * @return
	 */
	public static Parametri[] getListaPerProvince_Capitoli(List list, String letteraIdentificativa) {
		Set set = new TreeSet(new ParametriComparator());

		Iterator it = list.iterator();
		TipoProvincia provincia = null;
		TipoCapitolo capitolo = null;
		
		while(it.hasNext()) {
			Object obj = it.next();						
		
			if(obj instanceof MetanoLiquidazioneImposte ||obj instanceof MetanoRiepilogoSaldoImposte) {
				MetanoRecord item = (MetanoRecord)obj;

				provincia = ComboDataSource.getInstance().getProvincia(item.getProvincia().replace('-',' ').trim());
				capitolo = null;

				if(obj instanceof MetanoLiquidazioneImposte)
					capitolo = ComboDataSource.getInstance().getCapitolo(letteraIdentificativa,((MetanoLiquidazioneImposte)obj).getCapitoliImputazioneImposta().toString());
				else if(obj instanceof MetanoRiepilogoSaldoImposte)
					capitolo = ComboDataSource.getInstance().getCapitolo(letteraIdentificativa,((MetanoRiepilogoSaldoImposte)obj).getCapitoliImputazioneImposta().toString());

				Parametri parametri = new Parametri();
				parametri.setProvincia(provincia);
				parametri.setCapitolo(capitolo);
				set.add(parametri);
			} else {
				throw new RuntimeException("Nella lista  presente un record non supportato per questa operazione. " + obj.getClass().getName());
			}
		}
		Object[] objs = set.toArray();
		Parametri[] retvalue = new Parametri[objs.length];
		for(int i=0; i<objs.length; i++) {
			retvalue[i] = (Parametri)objs[i];
		}
		return retvalue;
	}

	public static Parametri[] getListaPerProvince_Mesi(List list) {
		Set set = new TreeSet(new ParametriComparator());

		Iterator it = list.iterator();
		TipoProvincia provincia = null;
		TipoMese mese = null;		
		while(it.hasNext()) {
			Object obj = it.next();						
		
			if(
				obj instanceof MetanoRecord
			) {
				MetanoRecord item = (MetanoRecord)obj;
				provincia = new TipoProvincia();
				provincia = ComboDataSource.getInstance().getProvincia(item.getProvincia());
				mese = new TipoMese();
				mese = ComboDataSource.getInstance().getMese(item.getMese().toString());
				
				Parametri parametri = new Parametri();
				parametri.setProvincia(provincia);
				parametri.setMese(mese);
				set.add(parametri);
			} else {
				throw new RuntimeException("Nella lista  presente un record non supportato per questa operazione. " + obj.getClass().getName());
			}
		}
		Object[] objs = set.toArray();
		Parametri[] retvalue = new Parametri[objs.length];
		for(int i=0; i<objs.length; i++) {
			retvalue[i] = (Parametri)objs[i];
		}
		return retvalue;
	}

	public static Parametri[] getListaPerProvince_Mesi_FascieClimatiche(List list) {
		Set set = new TreeSet(new ParametriComparator());

		Iterator it = list.iterator();
		TipoProvincia provincia = null;
		TipoMese mese = null;
		TipoFasciaClimatica fasciaClimatica = null;
		while(it.hasNext()) {
			Object obj = it.next();						
		
			if(
				obj instanceof MetanoFatturatoImpiegato ||
				obj instanceof MetanoLiquidazioneImposte
			) {
				MetanoRecord item = (MetanoRecord)obj;
				provincia = ComboDataSource.getInstance().getProvincia(item.getProvincia());
				mese = ComboDataSource.getInstance().getMese(item.getMese().toString());
				fasciaClimatica = new TipoFasciaClimatica();
				
				String codiceFasciaClimatica = null;
				if(obj instanceof MetanoFatturatoImpiegato) {
					codiceFasciaClimatica = ((MetanoFatturatoImpiegato)item).getFasciaClimatica();
				} else if(obj instanceof MetanoLiquidazioneImposte) {
					codiceFasciaClimatica = ((MetanoLiquidazioneImposte)item).getFasciaClimatica();
				} 
				
				fasciaClimatica.setCodice(codiceFasciaClimatica);
				
				Parametri parametri = new Parametri();
				parametri.setProvincia(provincia);
				parametri.setMese(mese);
				parametri.setFasciaClimatica(fasciaClimatica);
				set.add(parametri);
			} else {
				throw new RuntimeException("Nella lista  presente un record non supportato per questa operazione. " + obj.getClass().getName());
			}
		}
		Object[] objs = set.toArray();
		Parametri[] retvalue = new Parametri[objs.length];
		for(int i=0; i<objs.length; i++) {
			retvalue[i] = (Parametri)objs[i];
		}
		return retvalue;
	}

	/**
	 * Restituisce la lista dei record appartenenti a records che hanno il mese impostato a mese
	 * @param records
	 * @return
	 */
	public static List getListaRecordPerMese(List records, int mese) {
		List retlist = new LinkedList();
		
		Iterator it = records.iterator();
		while(it.hasNext()) {
			MetanoRecord record = (MetanoRecord)it.next();
			if(mese == record.getMese().intValue()) {
				retlist.add(record);
			}
		}
		return retlist;
	}

	/**
	 * @param list
	 * @return
	 */
	/**
	public static String[] getListaCapitoli(List list) {
		Set set = new TreeSet();
		Iterator it = list.iterator();
		while(it.hasNext()) {
			Object obj = it.next();
			String capitoloArticolo = null;
			
			if(obj instanceof MetanoLiquidazioneImposte) {
				MetanoLiquidazioneImposte item = (MetanoLiquidazioneImposte)obj;
				capitoloArticolo = item.getCodiceAccisa();

			//}// else if(obj instanceof MetanoRiepilogoSaldoImposte) {
			//	EnergiaRiepilogoSaldoImposte item = (EnergiaRiepilogoSaldoImposte)obj;
			//	capitoloArticolo = item.getCapitoloArticolo();
			} else {
				throw new RuntimeException("Nella lista  presente un record non supportato per questa operazione. " + obj.getClass().getName());
			}
			
			set.add(capitoloArticolo);
		}

		Object[] objs = set.toArray();
		String[] retvalue = new String[objs.length];
		for(int i=0; i<objs.length; i++) {
			retvalue[i] = (String)objs[i];
		}
		return retvalue;
	}
	**/
	/**
	 * Restituisce la lista dei record appartenenti a records che hanno il mese impostato a mese
	 * @param records
	 * @return
	 */
	/**
	public static List getListaRecordPerCapitolo(List records, String capitoloArticolo) {
		List retlist = new LinkedList();
		
		Iterator it = records.iterator();
		while(it.hasNext()) {
			Object obj = it.next();
			String capArt = null;
			
			if(obj instanceof MetanoLiquidazioneImposte) {
				MetanoLiquidazioneImposte item = (MetanoLiquidazioneImposte)obj;
				capArt = item.getCodiceAccisa();

			} else if(obj instanceof MetanoLiquidazioneImposte) {
				MetanoLiquidazioneImposte item = (MetanoLiquidazioneImposte)obj;
				capArt = item.getCodiceAccisa();
			} else {
				throw new RuntimeException("Nella lista  presente un record non supportato per questa operazione. " + obj.getClass().getName());
			}

			if(capArt.equals(capitoloArticolo)) {
				retlist.add(obj);
			}
		}
		return retlist;
	}
	**/
	/**
	 * @return
	 */
	public String getLettera() {
		return lettera;
	}

	public static List getListaRecordParametrizzato(List records, Parametri parametriSelezionati, Quadro quadro) {
		List retList = new LinkedList();
		TipoCapitolo tipoCapitolo = parametriSelezionati.getCapitolo();
		TipoProvincia tipoProvincia = parametriSelezionati.getProvincia();
		TipoMese tipoMese = parametriSelezionati.getMese();
		TipoFasciaClimatica fasciaClimatica = parametriSelezionati.getFasciaClimatica();
		
		if(tipoCapitolo == null) {
			tipoCapitolo = new TipoCapitolo();
		}
		if(tipoProvincia == null) {
			tipoProvincia = new TipoProvincia();
		}
		if(tipoMese == null) {
			tipoMese = new TipoMese();
		}
		if(fasciaClimatica == null) {
			fasciaClimatica = new TipoFasciaClimatica();
		}
		
		//BigInteger tipoRigo=null;
		
		Iterator it = records.iterator();
		while(it.hasNext()) {
			Object obj = it.next();
			String capitoloTmp = null;
			String provinciaTmp = null;
			String meseTmp = null;
			String fasciaClimaticaTmp = null;
			
			
			if(obj instanceof MetanoLiquidazioneImposte) {
				MetanoLiquidazioneImposte item = (MetanoLiquidazioneImposte)obj;
				capitoloTmp = String.valueOf(item.getCapitoliImputazioneImposta());
				provinciaTmp = item.getProvincia();
				meseTmp = String.valueOf(item.getMese());
				fasciaClimaticaTmp = StringUtil.trim(item.getFasciaClimatica());
				//tipoRigo = item.getTipoRigo();
			} else if(obj instanceof MetanoEstrattoVenduto) {
				MetanoEstrattoVenduto item = (MetanoEstrattoVenduto)obj;
				meseTmp = String.valueOf(item.getMese());
				//tipoRigo = item.getTipoRigo();
			}else if(obj instanceof MetanoAcquistatoDaSoggettiSenzaImpianti) {
				MetanoAcquistatoDaSoggettiSenzaImpianti item = (MetanoAcquistatoDaSoggettiSenzaImpianti)obj;
				meseTmp = String.valueOf(item.getMese());
				//tipoRigo = item.getTipoRigo();
			} else if(obj instanceof MetanoRiepilogoSaldoImposte) {
				MetanoRiepilogoSaldoImposte item = (MetanoRiepilogoSaldoImposte)obj;
				provinciaTmp = item.getProvincia();
				capitoloTmp = String.valueOf(item.getCapitoliImputazioneImposta());
			}else if(obj instanceof MetanoFatturatoImpiegatoSenzaPagAccisa) {
				MetanoFatturatoImpiegatoSenzaPagAccisa item = (MetanoFatturatoImpiegatoSenzaPagAccisa)obj;
				provinciaTmp = item.getProvincia();
				meseTmp = String.valueOf(item.getMese());
			}else if(obj instanceof MetanoRettificheFatturazione) {
				MetanoRettificheFatturazione item = (MetanoRettificheFatturazione)obj;
				provinciaTmp = item.getProvincia();
			}else if(obj instanceof MetanoFatturatoImpiegato) {
				MetanoFatturatoImpiegato item = (MetanoFatturatoImpiegato)obj;
				provinciaTmp = item.getProvincia();
				meseTmp = String.valueOf(item.getMese());
				fasciaClimaticaTmp = StringUtil.trim(item.getFasciaClimatica());
			}else if(obj instanceof DatiAddizionaleClientiAgevolati) {
			DatiAddizionaleClientiAgevolati item = (DatiAddizionaleClientiAgevolati)obj;
			provinciaTmp = item.getProvincia();
		}else {
				throw new RuntimeException("Nella lista  presente un record non supportato per questa operazione. " + obj.getClass().getName());
			}

			capitoloTmp = StringUtil.nullify(capitoloTmp);
			provinciaTmp = StringUtil.nullify(provinciaTmp);
			meseTmp = StringUtil.nullify(meseTmp);
			fasciaClimaticaTmp = StringUtil.nullify(fasciaClimaticaTmp);

			// capitolo e provincia
			if (quadro.getTipiRecord().equals(QUADRO_I)||quadro.getTipiRecord().equals(QUADRO_L)) {
				if((capitoloTmp!=null && capitoloTmp.equals(tipoCapitolo.getCodice().trim()))
					&& (provinciaTmp!=null && provinciaTmp.equals(StringUtil.trim(tipoProvincia.getCodice()))))
						retList.add(obj);
			// provincia e/o fascia climatica
			} else if (quadro.getTipiRecord().equals(QUADRO_M)){
				// se la fascia climatica non  specificata
				if((provinciaTmp!=null && provinciaTmp.equals(StringUtil.trim(tipoProvincia.getCodice())))
					&& (fasciaClimaticaTmp==null || fasciaClimaticaTmp.equals("")))
						retList.add(obj);
				// se la fascia climatica  specificata
				else if((provinciaTmp!=null && provinciaTmp.equals(StringUtil.trim(tipoProvincia.getCodice())))
						&& (fasciaClimaticaTmp!=null && !fasciaClimaticaTmp.equals("") && fasciaClimaticaTmp.equals(fasciaClimatica.getCodice())))
							retList.add(obj);
			// solo provincia
			} else if (quadro.getTipiRecord().equals(QUADRO_O)||quadro.getTipiRecord().equals(QUADRO_N)||quadro.getTipiRecord().equals(QUADRO_P)||quadro.getTipiRecord().equals(QUADRO_H)||quadro.getTipiRecord().equals(ALLEGATO)){
				if(provinciaTmp!=null && provinciaTmp.equals(StringUtil.trim(tipoProvincia.getCodice())))
					retList.add(obj);
			// solo mese
			} else if (quadro.getTipiRecord().equals(QUADRO_B) || quadro.getTipiRecord().equals(QUADRO_C) || quadro.getTipiRecord().equals(QUADRO_D)){
				//boolean isAnnuale=new BigInteger(tipoMese.getCodice()).equals(BigInteger.valueOf(0));
				if(meseTmp!=null && meseTmp.equals(StringUtil.trim(tipoMese.getCodice()))) {
				
					retList.add(obj);
				}
				//else if (isAnnuale){
				//else if (isAnnuale && tipoRigo!=null &&!tipoRigo.equals(BigInteger.valueOf(9))){
					//retList.add(obj);
			//	}
				
					
				/*
					boolean isAnnuale=new BigInteger(tipoMese.getCodice()).equals(BigInteger.valueOf(0));
					if(meseTmp!=null && !isAnnuale && meseTmp.equals(tipoMese.getCodice().trim())) {
						retList.add(obj);
					}
					else if (isAnnuale){
					//else if (isAnnuale && tipoRigo!=null &&!tipoRigo.equals(BigInteger.valueOf(9))){
						retList.add(obj);
					}
				*/				
			// provincia e mese
			//}else if (quadro.getTipiRecord().equals(QUADRO_E)||quadro.getTipiRecord().equals(QUADRO_G)){ if((provinciaTmp!=null && provinciaTmp.equals(tipoProvincia.getCodice().trim())) && meseTmp!=null && meseTmp.equals(tipoMese.getCodice().trim())) {
			}else if (quadro.getTipiRecord().equals(QUADRO_E)||quadro.getTipiRecord().equals(QUADRO_G)){
				if((provinciaTmp!=null && provinciaTmp.equals(tipoProvincia.getCodice().trim()))) {
					if(meseTmp!=null && meseTmp.equals(tipoMese.getCodice().trim())) {
						retList.add(obj);
					}
					/*
					boolean isAnnuale=new BigInteger(tipoMese.getCodice()).equals(BigInteger.valueOf(0));
					if(meseTmp!=null && !isAnnuale && meseTmp.equals(tipoMese.getCodice().trim())) {
						retList.add(obj);
					}
					else if (isAnnuale){
						retList.add(obj);
					}
					*/
				}

			// provincia e mese e/o fascia climatica
			}else if (quadro.getTipiRecord().equals(QUADRO_F)){
				// se la fascia climatica non  specificata

				//if((provinciaTmp!=null && provinciaTmp.equals(tipoProvincia.getCodice().trim())) && meseTmp!=null && meseTmp.equals(tipoMese.getCodice().trim()) && (fasciaClimaticaTmp==null || fasciaClimaticaTmp.equals("")))
				if((provinciaTmp!=null && provinciaTmp.equals(tipoProvincia.getCodice().trim())) 
					&& (fasciaClimaticaTmp==null || fasciaClimaticaTmp.equals(""))){
						if(meseTmp!=null && meseTmp.trim().equals(new BigInteger(tipoMese.getCodice()).toString())) {
							retList.add(obj);
						}
						/*
						boolean isAnnuale=new BigInteger(tipoMese.getCodice()).equals(BigInteger.valueOf(0));
						if(meseTmp!=null && !isAnnuale && meseTmp.equals(tipoMese.getCodice().trim())) {
							retList.add(obj);
						}
						else if (isAnnuale){
							retList.add(obj);
						}
						*/
				}
				// se la fascia climatica  specificata

				// if((provinciaTmp!=null && provinciaTmp.equals(tipoProvincia.getCodice().trim())) && meseTmp!=null && meseTmp.equals(tipoMese.getCodice().trim()) && (fasciaClimaticaTmp!=null && !fasciaClimaticaTmp.equals("") && fasciaClimaticaTmp.equals(fasciaClimatica.getCodice().trim()))){
				if((provinciaTmp!=null && provinciaTmp.equals(tipoProvincia.getCodice().trim())) 
					&& (fasciaClimaticaTmp!=null && !fasciaClimaticaTmp.equals("") && fasciaClimatica !=null && fasciaClimatica.getCodice() !=null && fasciaClimaticaTmp.equals(fasciaClimatica.getCodice().trim()))){
						if(meseTmp!=null && meseTmp.trim().equals(new BigInteger(tipoMese.getCodice()).toString())) {
							retList.add(obj);
						}
						/*
						boolean isAnnuale=new BigInteger(tipoMese.getCodice()).equals(BigInteger.valueOf(0));
						if(meseTmp!=null && !isAnnuale && meseTmp.equals(tipoMese.getCodice().trim())) {
							retList.add(obj);
						}
						else if (isAnnuale){
							retList.add(obj);
						}
						*/
				}
			}
		}
		return retList;
	}
}