package it.finanze.dogane.accise.metano.ui.tablemodel;

import it.finanze.dogane.accise.combo.ComboDataSource;
import it.finanze.dogane.accise.combo.TipoComune;
import it.finanze.dogane.accise.combo.TipoQuadro;
import it.finanze.dogane.accise.metano.model.DatiAddizionaleClientiAgevolati;
import it.finanze.dogane.accise.metano.model.DatiAddizionaleClientiAgevolati;
import it.finanze.dogane.accise.pdf.PrintableTableModel;

import java.math.BigInteger;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import javax.swing.table.AbstractTableModel;

//Tale classe rappresenta la parte superiore
public class MetanoClientiAgevolatiTM extends AbstractTableModel implements PrintableTableModel {
	
	private List listaRecord = null;
	
		private List listaRecordTotale = null;	  

	//Nella lista ci sono oggetti di tipo record ossia DatiAddizionaliClientiAgevolati
	public MetanoClientiAgevolatiTM(List lista) {
		listaRecord = lista;
		
		
		Iterator it = listaRecord.iterator();
		boolean found = false;
		while(it.hasNext() && !found) {
			DatiAddizionaleClientiAgevolati record = (DatiAddizionaleClientiAgevolati)it.next();
			
		}
	}

	public List getRecordsTotali() {
			List retlist = new LinkedList();
			Iterator it = listaRecordTotale.iterator();
			while (it.hasNext()) {
				Object obj = it.next();
				if (obj != null) {
					retlist.add(obj);
				}
			}
			return retlist;
		}
	/* (non Javadoc)
	 * @see javax.swing.table.TableModel#getValueAt(int, int)
	 */
	public Object getValueAt(int rowIndex, int columnIndex) {
		DatiAddizionaleClientiAgevolati record = (DatiAddizionaleClientiAgevolati)listaRecord.get(rowIndex);
		Object retvalue = null;
		
		if(columnIndex == 0) {
			retvalue = record.getCodiceIdentificativoCliente();
		}else if(columnIndex == 1) {
			retvalue = record.getTipologiaUtilizzo();
		}else if(columnIndex == 2) {
		retvalue = record.getApplicazioneAgevolazione();
		}else if(columnIndex == 3) {
		retvalue = record.getDataInizio();
		}else if(columnIndex == 4) {
		retvalue = record.getDataFine();
		}

		
		/*
			Object retvalue = null;
			if(columnIndex == 0) {
				TipoComune tipoComune = ComboDataSource.getInstance().getComune(record.getParteCodDitta(), record.getCodiceCatastale());
				if(tipoComune == null) {
					retvalue = record.getCodiceCatastale();
				} else {
					retvalue = tipoComune.toDefaultStyleString();
				}
			} else if(columnIndex == 1) {
				retvalue = record.getNumeroUtenze();
			} else if(columnIndex == 2) {
				retvalue = record.getConsumi();
			} else if(columnIndex == 3) {
				retvalue = record.getAliquotaDImposta();
			} else if(columnIndex == 4) {
				retvalue = record.getRettificaFatturazione();
			} */
		return retvalue;
	}
	
	/* (non Javadoc)
	 * @see javax.swing.table.TableModel#getColumnCount()
	 */
	public int getColumnCount() {
		return 5;
	}
	/* (non Javadoc)
	 * @see javax.swing.table.TableModel#getRowCount()
	 */
	public int getRowCount() {
		return listaRecord.size();
	}
	
	public String getColumnName(int columnIndex) {
		String retvalue = null;
		if(columnIndex == 0) {
			retvalue = "Codice identificativo cliente";
		} else if(columnIndex == 1) {
			retvalue = "Tipologia di utilizzo";
		} else if(columnIndex == 2) {
			retvalue = "Applicazione dell'agevolazione";
		} else if(columnIndex == 3) {
			retvalue = "Data inizio";
		} else if(columnIndex == 4) {
			retvalue = "Data fine";
		} 
		return retvalue;
	}

	public DatiAddizionaleClientiAgevolati getRecord(int selectedRow) {
		return (DatiAddizionaleClientiAgevolati) listaRecord.get(selectedRow);
	}

	public List getRecords() {
		return listaRecord;
	}

	public void insertRecord(DatiAddizionaleClientiAgevolati record) {
		// se il comune  gia' presente nella lista devo aggiungere questo record dopo l'ultima occorrenza di esso
		int index=0;
		int indexWhereInsertRecord=-1;
		Iterator it = this.getRecords().iterator();
		//Qui prendo quelli gi inseriti nel template
		while(it.hasNext()) {
			DatiAddizionaleClientiAgevolati recordTmp = (DatiAddizionaleClientiAgevolati)it.next();
			if(record.getCodiceCatastale().equals(recordTmp.getCodiceCatastale())){
				indexWhereInsertRecord=index+1;	
			}
			index++;
		}

		if (indexWhereInsertRecord==-1){
			//Aggiungo il record cio l'oggetto che rappresenta il record ad una lista		
			listaRecord.add(record);
		} else {
			listaRecord.add(indexWhereInsertRecord,record);
		}
		
		// Imposto il progressivo
		BigInteger progressivo = BigInteger.valueOf(-1);
		record.setProgessivoInternoComune(progressivo);
		it = this.getRecords().iterator();
		
		
		this.fireTableDataChanged();
	}

	public void removeRecord(int selectedRow) {
		// Aggiusto il progressivo
		DatiAddizionaleClientiAgevolati record = getRecord(selectedRow);
		BigInteger progressivo = record.getProgessivoInternoComune();
		Iterator it = this.getRecords().iterator();
		while(it.hasNext()) {
			DatiAddizionaleClientiAgevolati recordTmp = (DatiAddizionaleClientiAgevolati)it.next();
			if(record.getCodiceCatastale().equals(recordTmp.getCodiceCatastale())){
				if(recordTmp.getProgessivoInternoComune().compareTo(progressivo) > 0) {
					recordTmp.setProgessivoInternoComune(recordTmp.getProgessivoInternoComune().subtract(BigInteger.valueOf(1)));
				}
			}
		}
		
		listaRecord.remove(selectedRow);
		
		this.fireTableRowsDeleted(selectedRow, selectedRow);
	}
	

	public void setRecord(int selectedRow, DatiAddizionaleClientiAgevolati record) {
		listaRecord.set(selectedRow, record);

		this.fireTableRowsUpdated(selectedRow, selectedRow);
	}

	public PrintableTableModel split(int index, int offset) {
		List newListaRecord = new LinkedList();
		
		Iterator it = listaRecord.iterator();
		int i = 0;
		while(it.hasNext()) {
			Object obj = it.next();
			if(i>=index && i<=index+offset-1) {
				newListaRecord.add(obj);
			}
			i++;
		}
		
		return new MetanoClientiAgevolatiTM(newListaRecord);
	}

	public PrintableTableModel split(int index) {
		return split(index, listaRecord.size() - index);
	}

}
