package it.finanze.dogane.accise.metano.ui.tablemodel;

import it.finanze.dogane.accise.combo.ComboDataSource;
import it.finanze.dogane.accise.combo.TipoEstrazioneVendita;
import it.finanze.dogane.accise.metano.model.MetanoEstrattoVenduto;
import it.finanze.dogane.accise.pdf.PrintableTableModel;

import java.math.BigDecimal;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import javax.swing.table.AbstractTableModel;

public class MetanoEstrattoVendutoTM extends AbstractTableModel implements PrintableTableModel {
	
	private List listaRecord = null;
	private String letteraQuadro = null ;
	
	public MetanoEstrattoVendutoTM(List lista, String letteraQuadro)
	{
		listaRecord = lista;
		this.letteraQuadro = letteraQuadro;
	}
	public Object getValueAt(int rowIndex, int columnIndex) {
		
		MetanoEstrattoVenduto record = (MetanoEstrattoVenduto)listaRecord.get(rowIndex);
		
			Object retvalue = null;
		    if(columnIndex == 0) {
				TipoEstrazioneVendita tipoEstrazioneVendita = ComboDataSource.getInstance().getTipologiaEstrazioneVendita(letteraQuadro,record.getTipEstrazioneVendita());
				if(tipoEstrazioneVendita == null) {
					retvalue = record.getCodiceAcc();
				} else {
				    retvalue = tipoEstrazioneVendita.toDefaultStyleString();
				}	
			
			} else if(columnIndex == 1) {
				retvalue = record.getCodiceAcc();
			} else if(columnIndex == 2) {
				retvalue = new BigDecimal(record.getMetriCubi());
			} 
		return retvalue;
	}
	
	/* (non Javadoc)
	 * @see javax.swing.table.TableModel#getColumnCount()
	 */
	public int getColumnCount() {
		return 3;
	}
	/* (non Javadoc)
	 * @see javax.swing.table.TableModel#getRowCount()
	 */
	public int getRowCount() {
		return listaRecord.size();
	}
	
	public String getColumnName(int columnIndex) {
		
		String retvalue = null;
		if(columnIndex == 0) {
			if(letteraQuadro.equals("B")) {
				retvalue = "Tipologia estrazione";
			} else if(letteraQuadro.equals("D")) {
				retvalue = "Tipologia vendita";
			}
		} else if(columnIndex == 1) {
			if(letteraQuadro.equals("B")) {
				retvalue = "Codice accisa destinatario";
			} else if(letteraQuadro.equals("D")) {
				retvalue = "Codice identificativo acquirente/distributore";
			}
		} else if(columnIndex == 2) {
			retvalue = "Metri cubi";
		} 
		
		
		return retvalue;
	}

	public MetanoEstrattoVenduto getRecord(int selectedRow) {
		return (MetanoEstrattoVenduto) listaRecord.get(selectedRow);
	}

	public List getRecords() {
		return listaRecord;
	}

	public void insertRecord(MetanoEstrattoVenduto record) {
		listaRecord.add(record);
		
		this.fireTableRowsInserted(getRowCount() -1 , getRowCount() - 1);
	}

	public void removeRecord(int selectedRow) {
		listaRecord.remove(selectedRow);
		
		this.fireTableRowsDeleted(selectedRow, selectedRow);
	}
	

	public void setRecord(int selectedRow, MetanoEstrattoVenduto record) {
		listaRecord.add(selectedRow, record);
		listaRecord.remove(selectedRow);

		this.fireTableRowsUpdated(selectedRow, selectedRow);
	}

	public PrintableTableModel split(int index, int offset) {
		List newListaRecord = new LinkedList();
		
		Iterator it = listaRecord.iterator();
		int i = 0;
		while(it.hasNext()) {
			Object obj = it.next();
			if(i>=index && i<=index+offset-1) {
				newListaRecord.add(obj);
			}
			i++;
		}
		
		return new MetanoEstrattoVendutoTM(newListaRecord, letteraQuadro);
	}

	public PrintableTableModel split(int index) {
		return split(index, listaRecord.size() - index);
	}

}
