package it.finanze.dogane.accise.metano.ui.tablemodel;

import it.finanze.dogane.accise.metano.model.MetanoIntrodottoInDepositiFiscali;
import it.finanze.dogane.accise.pdf.PrintableTableModel;

import java.math.BigInteger;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import javax.swing.table.AbstractTableModel;

public class MetanoIntrodottoInDepositiFiscaliTM extends AbstractTableModel implements PrintableTableModel {

	
	private List listaRecord = new LinkedList();

	public MetanoIntrodottoInDepositiFiscaliTM() {

	}

	public MetanoIntrodottoInDepositiFiscaliTM(List lista) {
		listaRecord = lista;
		if(lista == null) {
			listaRecord = new LinkedList();
		}
	}

	public Object getValueAt(int rowIndex, int columnIndex) {
		Object retvalue = null;	
		
		MetanoIntrodottoInDepositiFiscali record =	(MetanoIntrodottoInDepositiFiscali) listaRecord.get(rowIndex);

		if (columnIndex == 0 && rowIndex == 0) {
			
			retvalue = record.getMetanoPropriPozzi();
		} else if (columnIndex == 1 && rowIndex == 0) {
			retvalue = record.getMetanoAltreFonti();
		} else if (columnIndex == 2) {
			retvalue = record.getCodiceAccisaFornitoreNazionale();
		} else if (columnIndex == 3) {
			retvalue = record.getMetanoFornitoreNazionale();
		} else if (columnIndex == 4) {
			retvalue = record.getCodiceAccisaFornitoreUE();					
		} else if (columnIndex == 5) {
			retvalue = record.getMetanoFornitoreUE();					
		} else if (columnIndex == 6 && rowIndex == 0) {
			retvalue = record.getMetanoFornitoreExtraUE();					
		} else if (columnIndex == 7 && rowIndex == 0) {
			retvalue = record.getTotale();					
		}
			
		return retvalue;

	}
		

	public int getColumnCount() {
		return 8;
	}

	public int getRowCount() {
		return listaRecord.size();
	}

	public String getColumnName(int columnIndex) {
		String retvalue = null;
		if (columnIndex == 0) {
			retvalue = "Propri pozzi mc";
		} else if (columnIndex == 1) {
			retvalue = "Altre fonti mc";
		} else if (columnIndex == 2) {
			retvalue = "Fornitori nazionali cod.";
		} else if (columnIndex == 3) {
			retvalue = "Fornitori nazionali mc";
		} else if (columnIndex == 4) {
			retvalue = "Fornitori U.E. cod.";
		} else if (columnIndex == 5) {
			retvalue = "Fornitori U.E. mc";
		} else if (columnIndex == 6) {
			retvalue = "Fornitori extra U.E. mc";
		} else if (columnIndex == 7) {
			retvalue = "Totale";
		}

		return retvalue;
	}

	public MetanoIntrodottoInDepositiFiscali getRecord(int selectedRow) {
		MetanoIntrodottoInDepositiFiscali retvalue = null;
		if(listaRecord == null || listaRecord.size() == 0) {
		} else {
			retvalue = (MetanoIntrodottoInDepositiFiscali) listaRecord.get(selectedRow);
		}
		return retvalue;
	}

	public List getRecords() {
		return listaRecord;
	}

	public void insertRecord(MetanoIntrodottoInDepositiFiscali record) {
		if (listaRecord.size() == 0) {
			// Qui per gestione vuoto
			record.setTipoRigo(BigInteger.valueOf(0));
		} else {
			MetanoIntrodottoInDepositiFiscali punto = (MetanoIntrodottoInDepositiFiscali)listaRecord.get(0);
			record.setTipoRigo(BigInteger.valueOf(1));
			record.setProgPuntoImmissione(punto.getProgPuntoImmissione());
		}

		listaRecord.add(record);

		updateFirstRecordTot();

		this.fireTableRowsInserted(getRowCount() - 1, getRowCount() - 1);
		this.fireTableDataChanged();
	}

	public void removeRecord(int selectedRow) {

		if (selectedRow == 0 && listaRecord.size() > 1) {
			// Non posso cancellare			
		} else {
			listaRecord.remove(selectedRow);
			updateFirstRecordTot();
			this.fireTableRowsDeleted(selectedRow, selectedRow);
			this.fireTableDataChanged();
		}
	}

	public void setRecord(
		int selectedRow,
		MetanoIntrodottoInDepositiFiscali record) {

		if (selectedRow == 0) {
			record.setTipoRigo(BigInteger.valueOf(0));
		} else {
			record.setTipoRigo(BigInteger.valueOf(1));
		}
		listaRecord.set(selectedRow, record);

		updateFirstRecordTot();

		this.fireTableDataChanged();
	}

	private void updateFirstRecordTot() {
		BigInteger totale = BigInteger.ZERO;
		if(listaRecord != null && listaRecord.size() > 0) {
			Iterator it = listaRecord.iterator();
			while(it.hasNext()) {
				MetanoIntrodottoInDepositiFiscali item = (MetanoIntrodottoInDepositiFiscali)it.next();

				totale = totale.add(item.getMetanoFornitoreExtraUE());
				totale = totale.add(item.getMetanoFornitoreNazionale());
				totale = totale.add(item.getMetanoFornitoreUE());
				totale = totale.add(item.getMetanoAltreFonti());
				totale = totale.add(item.getMetanoPropriPozzi());
			}
			
			MetanoIntrodottoInDepositiFiscali firstItem = (MetanoIntrodottoInDepositiFiscali)listaRecord.get(0);
			firstItem.setTotale(totale);
		}
	}

	public PrintableTableModel split(int index, int offset) {
		List newListaRecord = new LinkedList();
		
		Iterator it = listaRecord.iterator();
		int i = 0;
		while(it.hasNext()) {
			Object obj = it.next();
			if(i>=index && i<=index+offset-1) {
				newListaRecord.add(obj);
			}
			i++;
		}
		
		return new MetanoIntrodottoInDepositiFiscaliTM(newListaRecord);
	}

	public PrintableTableModel split(int index) {
		return split(index, listaRecord.size() - index);
	}

}
