/*
 * Created on 20-set-06
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package it.finanze.dogane.accise.metano.ui.tablemodel;


import it.finanze.dogane.accise.combo.TipoCapitolo;
import it.finanze.dogane.accise.metano.model.MetanoLiquidazioneImposte;
import it.finanze.dogane.accise.metano.ui.quadri.Quadro;
import it.finanze.dogane.accise.pdf.DefaultPrintableTableModel;
import it.finanze.dogane.accise.pdf.PrintableTableModel;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import javax.swing.table.AbstractTableModel;

public class MetanoLiquidazioneImposteTM extends AbstractTableModel implements PrintableTableModel {

	private List listaRecord = new LinkedList();

	public static final String[] QUADRO_I_DESCRIPTIONS_1412 =
		{
			"Autotrazione (G10)",
			"Rettifiche di fatturazione (H9)",
			"TOTALE CAPITOLO 1412"};

	public static final int[] QUADRO_I_IDENTIFIERS_1412 =
		{ 1, 2, 3};

	public static final String[] QUADRO_I_DESCRIPTIONS_1421 =
		{
			"Usi industriali (G1)",
			"Utenze Centro-Nord - Usi civili tariffa T1 (G2)",
			"Utenze Centro-Nord - Usi civili tariffa T2 fino a 250 mc/anno (G3)",
			"Utenze Centro-Nord - Usi civili tariffa T2 oltre 250 mc/anno e alt. usi civili (G4)",
			"Utenze Mezzogiorno - Usi civili tariffa T1 (G5)",
			"Utenze Mezzogiorno - Usi civili tariffa T2 fino a 250 mc/anno (G6)",
			"Utenze Mezzogiorno - Usi civili tariffa T2 oltre 250 mc/anno e alt. usi civili (G7)",
			"Produzione di energia elettrica (G8)",
			"Autoproduzione di energia elettrica (G9)",
			"Usi di cantiere, motori fissi e operaz. di campo coltivaz. idroc. dal 01/06/2007 (G11)",
			"Rettifiche di fatturazione (H8)",
			"TOTALE CAPITOLO 1421" };

	public static final int[] QUADRO_I_IDENTIFIERS_1421 =
		{ 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14 , 15};

	public static final String[] QUADRO_M_DESCRIPTIONS =
		{
			"Usi industriali (F1)",
			"Usi civili tariffa T1 (F2+F5)",
			"Usi civili tariffa T2 fino a 250 mc/anno (F3+F6)",
			"Usi civili tariffa T2 oltre 250 mc/anno e alt. usi civili (F4+F7)",
			"(F8)",
			"(F9)",
			"Rettifiche di fatturazione (H10)",
			"TOTALE ADDIZIONALE REGIONALE" };

	public static final int[] QUADRO_M_IDENTIFIERS =
		{ 1, 2, 3, 4, 5, 6, 7, 8};


	public static final String[] QUADRO_O_DESCRIPTIONS =
		{
			" Impieghi diversi da carburante per motori o combustibile per riscaldamento (E1)",
			" Prosciugamento e sistemazione terreni allagati in zone colpite da alluvione (E2)",
			" Sollevamento acque per agev. coltivaz. fondi rustici su terrreni bonificati(E3)",
			" Produzione di ossido di alluminio e di magnesio da acqua di mare (E4)",
			" Oli minerali iniettati in altiforni realizzazione di processi produttivi (E5)",
			" Forniture rel. dipl., org. int. ric., FF.AA. NATO, in accordo con esenz. IVA (E6)",
			" Forniture alle Forze Armate nazionali (E7)",
			" Rettifiche di fatturazione (H11)",
			"TOTALE IMPOSTA REGIONALE SOSTITUTIVA" };

	public static final int[] QUADRO_O_IDENTIFIERS =
		{ 1, 2, 3, 4, 5, 6, 7, 8, 9};

	private String[] descriptions = null;
	private int[] identifiers = null;

	public MetanoLiquidazioneImposteTM(
		List lista,
		int[] tipiRecord,
		TipoCapitolo tipoCapitolo) {
		
		if (Quadro.QUADRO_I.equals(tipiRecord)) {
			if (tipoCapitolo.getCodice().trim().equals("1412")) {
				descriptions = QUADRO_I_DESCRIPTIONS_1412;
				identifiers = QUADRO_I_IDENTIFIERS_1412;
			} else if (tipoCapitolo.getCodice().trim().equals("1421")) {
				descriptions = QUADRO_I_DESCRIPTIONS_1421;
				identifiers = QUADRO_I_IDENTIFIERS_1421;
			}
		}
		else if (Quadro.QUADRO_M.equals(tipiRecord)) {
			descriptions = QUADRO_M_DESCRIPTIONS;
			identifiers = QUADRO_M_IDENTIFIERS;
		}
		else if (Quadro.QUADRO_O.equals(tipiRecord)) {
			descriptions = QUADRO_O_DESCRIPTIONS;
			identifiers = QUADRO_O_IDENTIFIERS;
		}
		else {
			throw new IllegalArgumentException("Tipo record non consentito. (Quadri permessi I / M / O)");
		}

		for (int i = 0; i < descriptions.length; i++) {
			listaRecord.add(null);
			
		}

		Iterator it = lista.iterator();
		List listaFigli = new LinkedList();
		while (it.hasNext()) {
			MetanoLiquidazioneImposte record =(MetanoLiquidazioneImposte) it.next();
			if(record.getTipoRigo().equals(BigInteger.ZERO) && record.getProgressivoRecordRigo().compareTo(BigInteger.ZERO) > 0) {
				listaFigli.add(record);
			} else {
				int row = computeRow(record.getProgressivoIdentificativo().intValue());
				listaRecord.set(row, record);
			}
		}

		it = listaFigli.iterator();
		while(it.hasNext()) {
			MetanoLiquidazioneImposte son = (MetanoLiquidazioneImposte)it.next();
			insertSonRecord(son);
		}
	}

	public Object getValueAt(int rowIndex, int columnIndex) {
		MetanoLiquidazioneImposte record =
			(MetanoLiquidazioneImposte) listaRecord.get(rowIndex);
		Object retvalue = null;

		if (record == null) {

			int progressivo = getProgressivoForRowIndex(rowIndex);

			if (columnIndex == 0) {
				retvalue = BigInteger.valueOf(progressivo);
			} else if (columnIndex == 1) {
				retvalue = descriptions[findIdentifiersIndex(progressivo)];
			} else if (columnIndex == 2) {
				retvalue = "";
			} else if (columnIndex == 3) {
				retvalue = "";
			} else if (columnIndex == 4) {
				retvalue = "";
			}
		} else {
			if(columnIndex == 0) {
			   if(record.getProgressivoRecordRigo().compareTo(BigInteger.ZERO) > 0) {
				   retvalue = "";
			   } else {
				   retvalue = record.getProgressivoIdentificativo();
			   }
			} else if(columnIndex == 1) {
			   if(record.getProgressivoRecordRigo().compareTo(BigInteger.ZERO) > 0) {
				   retvalue = "";
			   } else {
				   retvalue = descriptions[findIdentifiersIndex(record.getProgressivoIdentificativo().intValue())];
			   }
			} else if (columnIndex == 2) {
				retvalue = record.getConsumi();
			} else if (columnIndex == 3) {
				retvalue = record.getAliquotaImposta();
			} else if (columnIndex == 4) {
				retvalue = record.getImpostaEuro();
			}
		}

		if(retvalue instanceof BigInteger) {
			BigInteger integer = (BigInteger)retvalue;
			if(BigInteger.ZERO.equals(integer)) {
				retvalue = "";
			}
		} else if(retvalue instanceof BigDecimal) {
			BigDecimal decimal = (BigDecimal)retvalue;
//			if(BigDecimal.ZERO.equals(decimal)) {
			if(decimal.floatValue() == 0) {
				retvalue = "";
			}
		}

		return retvalue;
	}

	public int getProgressivoForRowIndex(int rowIndex) {
		int retvalue = 0;
		if(rowIndex == 0) {
			retvalue = identifiers[0];
		} else {
			Object progressivoPrecedente = getValueAt(rowIndex - 1, 0);
			while(!(progressivoPrecedente instanceof BigInteger)) { // Fino a quando non trovo un numero
				rowIndex--;
				progressivoPrecedente = getValueAt(rowIndex - 1, 0);
			}
			int prgPrec = ((BigInteger)progressivoPrecedente).intValue(); 
			retvalue = identifiers[findIdentifiersIndex(prgPrec) + 1];
		}
		
		return retvalue;
	}

	private int findIdentifiersIndex(int progressivoIdentificativo) {
		int retvalue = 0;
		for(int i=0; i < identifiers.length; i++) {
			if(identifiers[i] == progressivoIdentificativo) {
				retvalue = i;
				break;
			}
		}
		return retvalue;
	}

	public int getColumnCount() {
		return 5;
	}

	public int getRowCount() {
		return listaRecord.size();
	}

	public String getColumnName(int columnIndex) {
		String retvalue = null;
		if (columnIndex == 0) {
			retvalue = "";
		} else if (columnIndex == 1) {
			retvalue = "";
		} else if (columnIndex == 2) {
			retvalue = "Consumi mc";
		} else if (columnIndex == 3) {
			retvalue = "Aliq. Euro/mc";
		} else if (columnIndex == 4) {
			retvalue = "Imposta Euro";
		}

		return retvalue;
	}

	public MetanoLiquidazioneImposte getRecord(int selectedRow) {
		return (MetanoLiquidazioneImposte) listaRecord.get(selectedRow);
	}

	public void setRecord(int selectedRow, MetanoLiquidazioneImposte record) {
		Object obj = getValueAt(selectedRow, 0);
		BigInteger progressivo = null; 
		if(obj instanceof BigInteger) {
			progressivo = (BigInteger)obj;
		}
		if(record != null) {
			if(progressivo != null) {
				record.setProgressivoIdentificativo(progressivo);
			}
			record.setTipoRigo();
		}
		listaRecord.set(selectedRow, record);
		this.fireTableRowsUpdated(selectedRow, selectedRow);
	}

	public void removeRecord(int selectedRow) {
		MetanoLiquidazioneImposte record = getRecord(selectedRow);
		if(!isRemovable(selectedRow)) {
			throw new RuntimeException("Non  possibile cancellare questo valore finch ci sono righe associate a quella selezionata");
		}
		
		if(record != null) {
			if(record.getTipoRigo().intValue() == 0 && record.getProgressivoRecordRigo().intValue() > 0) { // se sono figlio!
				listaRecord.remove(selectedRow);
				fireTableDataChanged();
			} else {
				setRecord(selectedRow, null);
			}
		} else {
			setRecord(selectedRow, null);
		}
	}

	public boolean isRemovable(int selectedRow) {
		boolean retvalue = true;
		MetanoLiquidazioneImposte record = getRecord(selectedRow);
		if(record != null) {
			if(record.getTipoRigo().intValue() == 0 && record.getProgressivoRecordRigo().intValue() > 0) { // se sono figlio!
				retvalue = true;
			} else {
				retvalue = true;
				// Controllo se ci sono figli
				if(selectedRow < getRowCount() - 1) {
					MetanoLiquidazioneImposte possibileFiglio = getRecord(selectedRow + 1);
					if(possibileFiglio != null && possibileFiglio.getProgressivoIdentificativo().equals(record.getProgressivoIdentificativo())) {
						retvalue = false;
					}
				}
			}
		} else {
			retvalue = true;
		}
		return retvalue;
	}

	public void insertSonRecord(MetanoLiquidazioneImposte son) {
		Iterator it = listaRecord.iterator();
		int counter = 0;
		boolean found = false;
		while(it.hasNext() && !found) {
			MetanoLiquidazioneImposte record = (MetanoLiquidazioneImposte)it.next();
			if(record != null && record.getProgressivoIdentificativo().equals(son.getProgressivoIdentificativo())) {
				if(it.hasNext()) {
					int counter2 = 0;
					while(it.hasNext() && !found) {
						MetanoLiquidazioneImposte record2 = (MetanoLiquidazioneImposte)it.next();
						if(record2 == null || !record.getProgressivoIdentificativo().equals(record2.getProgressivoIdentificativo())) {
							listaRecord.add(counter + counter2 + 1, son);
							son.setProgressivoRecordRigo(BigInteger.valueOf(counter2 + 1));
							found = true;
						}
						counter2++;
					}
					if(!found) {
						listaRecord.add(counter + counter2, son);
						son.setProgressivoRecordRigo(BigInteger.valueOf(counter2));
					}
				} else {
					listaRecord.add(counter + 1, son);
					son.setProgressivoRecordRigo(BigInteger.ONE);
					found = true;
				}
			}
			counter++;
		}
		
		fireTableDataChanged();
	}

	public List getRecords() {
		List retlist = new LinkedList();
		Iterator it = listaRecord.iterator();
		while (it.hasNext()) {
			Object obj = it.next();
			if (obj != null) {
				retlist.add(obj);
			}
		}
		return retlist;
	}

	private int computeRow(int identifier) {
		for (int i = 0; i < identifiers.length; i++) {
			if (identifier == identifiers[i]) {
				return i;
			}
		}
		return -1; // E quindi crasha!!!!!! 
	}
//	public int[] getIdentifiers(){
//			return identifiers;
//	}
//	public List getListaRecordFull(){
//		return listaRecord;
//	}

	public PrintableTableModel split(int index, int offset) {
		return DefaultPrintableTableModel.getSplitted(this, index, offset);
		//throw new UnsupportedOperationException();
	}

	public PrintableTableModel split(int index) {
		return split(index, listaRecord.size() - index);
	}

	public BigDecimal getImportoTotale() {
		BigDecimal somma = BigDecimal.valueOf(0);
		
		LinkedList listaSenzaTotale = new LinkedList(listaRecord);
		listaSenzaTotale.removeLast();
		Iterator it = listaSenzaTotale.iterator();
		while(it.hasNext()) {
			Object obj = it.next();
			if(obj != null) {
				MetanoLiquidazioneImposte record = (MetanoLiquidazioneImposte)obj;
				somma = somma.add(record.getImpostaEuro());
			}
		}
		
		return somma;
	}
}
