/*
 * Created on 26-set-06
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package it.finanze.dogane.accise.metano.ui.tablemodel;

import it.finanze.dogane.accise.metano.model.MetanoRettificheFatturazione;
import it.finanze.dogane.accise.model.AbstractRecord;
import it.finanze.dogane.accise.pdf.DefaultPrintableTableModel;
import it.finanze.dogane.accise.pdf.PrintableTableModel;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import javax.swing.table.AbstractTableModel;

/**
 * @author Fiorello
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class MetanoRettificheFatturazioneTM extends AbstractTableModel implements PrintableTableModel {

	public static final String[] descriptions =
		{
			"Accisa per combustione - Usi industriali",
			"Accisa per combustione - Usi civili tariffa T1",
			"Accisa per combustione - Usi civili tariffa T2 fino a 250 mc/anno",
			"Accisa per combustione - Usi civili tar. T2 oltre 250 mc/anno e altri usi",
			"Accisa per combustione - Produzione di energia elettrica",
			"Accisa per combustione - Autoproduzione di energia elettrica",
			"Usi di cantiere, motori fissi e operaz. di campo coltivaz. idroc. dal 01/06/2007",
			"Totale importo accisa per combustione",
			"Accisa per autotrazione",
			"Totale importo addizionale regionale",
			"Totale importo imposta regionale sostitutiva" };

	public static final int[] identifiers = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 ,11};


	private List listaRecord = null;
	private List listaRecordTotale = null;
	private String letteraQuadro = "";

	public MetanoRettificheFatturazioneTM(List lista) {
		listaRecord = new LinkedList();
		listaRecordTotale = new LinkedList();
//		listaRecord = new ArrayList();
//		listaRecordTotale = new ArrayList();

		for (int i = 0; i < descriptions.length; i++) {
			listaRecord.add(null);
			listaRecordTotale.add(null);
		}

		Iterator it = lista.iterator();
		List listaFigli = new LinkedList();
		while (it.hasNext()) {
			MetanoRettificheFatturazione record =(MetanoRettificheFatturazione) it.next();
			if(record.getProgRecordUso().equals(BigInteger.ONE) || record.getProgRecordUso().equals(BigInteger.valueOf(999))) {
				int row = computeRow(record.getProgIdentificativoUso().intValue());
				if(record.getProgRecordUso().equals(BigInteger.ONE)) {
					listaRecord.set(row, record);
				} else {
					listaRecordTotale.set(row, record);
				}
			} else {
				listaFigli.add(record);
			}
		}

		it = listaFigli.iterator();
		while(it.hasNext()) {
			MetanoRettificheFatturazione son = (MetanoRettificheFatturazione)it.next();
			insertSonRecord(son, false);
		}

	}

	private void insertSonRecord(MetanoRettificheFatturazione son, boolean updateTot) {
		Iterator it = listaRecord.iterator();
		int counter = 0;
		boolean found = false;
		while(it.hasNext() && !found) {
			MetanoRettificheFatturazione record = (MetanoRettificheFatturazione)it.next();
			if(record != null && record.getProgIdentificativoUso().equals(son.getProgIdentificativoUso())) {
				if(it.hasNext()) {
					int counter2 = 0;
					while(it.hasNext() && !found) {
						MetanoRettificheFatturazione record2 = (MetanoRettificheFatturazione)it.next();
						if(record2 == null || !record.getProgIdentificativoUso().equals(record2.getProgIdentificativoUso())) {
							listaRecord.add(counter + counter2 + 1, son);
							listaRecordTotale.add(counter + counter2 + 1, null);
							son.setProgRecordUso(BigInteger.valueOf(counter2 + 2));
							found = true;
						}
						counter2++;
					}
					if(!found) {
						listaRecord.add(counter + counter2, son);
						listaRecordTotale.add(counter + counter2, null);
						son.setProgRecordUso(BigInteger.valueOf(counter2 + 1));
					}
				} else {
					listaRecord.add(counter + 1, son);
					listaRecordTotale.add(counter + 1, null);
					son.setProgRecordUso(BigInteger.valueOf(2));
					found = true;
				}
			}
			counter++;
		}

		if(updateTot == true) {
			calcolaTotale(son.getProgIdentificativoUso());
		}

		fireTableDataChanged();
	}

	public void insertSonRecord(MetanoRettificheFatturazione son) {
		insertSonRecord(son, true);
	}


	public Object getValueAt(int rowIndex, int columnIndex) {
		MetanoRettificheFatturazione record = (MetanoRettificheFatturazione) listaRecord.get(rowIndex);
		MetanoRettificheFatturazione recordTotale = (MetanoRettificheFatturazione) listaRecordTotale.get(rowIndex);

		Object retvalue = null;

		if (record == null) {

			int progressivo = identifiers[0];
			if(recordTotale == null) {
				progressivo = getProgressivoForRowIndex(rowIndex); 
			} else {
				progressivo = recordTotale.getProgIdentificativoUso().intValue();
			}
			
			if (columnIndex == 0) {
				retvalue = BigInteger.valueOf(progressivo);
			} else if (columnIndex == 1) {
				retvalue = descriptions[findIdentifiersIndex(progressivo)];
			} else if (columnIndex == 2) {
				retvalue = "";
			} else if (columnIndex == 3) {
				retvalue = "";
			} else if (columnIndex == 4) {
				retvalue = "";
			} else if (columnIndex == 5) {
				retvalue = "";
			} else if (columnIndex == 6) {
				retvalue = "";
			}
		} else {
			if (columnIndex == 0) {
				if(record.getProgRecordUso().equals(BigInteger.ONE)) {
					retvalue = record.getProgIdentificativoUso();
				} else {
					retvalue = "";
				}
			} else if (columnIndex == 1) {
				if(record.getProgRecordUso().equals(BigInteger.ONE)) {
					retvalue = descriptions[findIdentifiersIndex(record.getProgIdentificativoUso().intValue())];
				} else {
					retvalue = "";
				}
			} else if (columnIndex == 2) {
				retvalue = record.getLocUtenzeCivili();
			} else if (columnIndex == 3) {
		
			
				String segno = record.getSegno();
				if (segno!=null && segno.equals(AbstractRecord.PLUS)) {
					retvalue="Debito";
				} else if (segno!=null && segno.equals(AbstractRecord.MINUS)) {
					retvalue="Credito";
				} else {
					retvalue = "";
				}
			} else if (columnIndex == 4) {
				retvalue = record.getQuantita();
			} else if (columnIndex == 5) {
				retvalue = record.getAliquotaImposta();
			} else if (columnIndex == 6) {
				retvalue= record.getImportoEuro().abs();
			}
		}

		if (recordTotale == null) {
			if (columnIndex == 7) {
			   retvalue = "";
			}
		} else {
			if (columnIndex == 7) {
				retvalue = recordTotale.getImportoEuro();
			}
		}

		if(retvalue instanceof BigInteger) {
			BigInteger integer = (BigInteger)retvalue;
			if(BigInteger.ZERO.equals(integer)) {
				retvalue = "";
			}
		} else if(retvalue instanceof BigDecimal) {
			BigDecimal decimal = (BigDecimal)retvalue;
//			if(BigDecimal.ZERO.equals(decimal)) {
			if(decimal.floatValue() == 0) {
				retvalue = "";
			}
		}

		return retvalue;
	}

	public int getProgressivoForRowIndex(int rowIndex) {
		// if (true) return 1;
		
		int retvalue = 0;
		if(rowIndex == 0) {
			retvalue = identifiers[0];
		} else {
			Object progressivoPrecedente = getValueAt(rowIndex - 1, 0);
			while(!(progressivoPrecedente instanceof BigInteger)) { // Fino a quando non trovo un numero
				rowIndex--;
				progressivoPrecedente = getValueAt(rowIndex - 1, 0);
			}
			int prgPrec = ((BigInteger)progressivoPrecedente).intValue(); 
			retvalue = identifiers[findIdentifiersIndex(prgPrec) + 1];
		}
		
		return retvalue;
	}

	private int findIdentifiersIndex(int progressivoIdentificativo) {
		int retvalue = 0;
		for(int i=0; i < identifiers.length; i++) {
			if(identifiers[i] == progressivoIdentificativo) {
				retvalue = i;
				break;
			}
		}
		return retvalue;
	}


	/* (non Javadoc)
	 * @see javax.swing.table.TableModel#getColumnCount()
	 */
	public int getColumnCount() {
		return 8;
	}
	/* (non Javadoc)
	 * @see javax.swing.table.TableModel#getRowCount()
	 */
	public int getRowCount() {
		return listaRecord.size();
	}

	public String getColumnName(int columnIndex) {

		String retvalue = null;
		if (columnIndex == 0) {
			retvalue = "";
		} else if (columnIndex == 1) {
			retvalue = "";
		} else if (columnIndex == 2) {
			retvalue = "Ubicazione";
		} else if (columnIndex == 3) {
			retvalue = "Segno";
		} else if (columnIndex == 4) {
			retvalue = "Quantit mc";
		} else if (columnIndex == 5) {
			retvalue = "Aliquota Euro/mc";
		} else if (columnIndex == 6) {
			retvalue = "Importo Euro";
		} else if (columnIndex == 7) {
			retvalue = "Totale euro";
		}

		return retvalue;
	}

	public MetanoRettificheFatturazione getRecord(int selectedRow) {
		return (MetanoRettificheFatturazione) listaRecord.get(selectedRow);
	}

	public MetanoRettificheFatturazione getRecordTotale(int selectedRow) {
		return (MetanoRettificheFatturazione) listaRecordTotale.get(selectedRow);
	}

	public void setRecord(int selectedRow, MetanoRettificheFatturazione record) {
		if(record != null) {
			Object obj = getValueAt(selectedRow, 0);
			BigInteger progressivo = null; 
			if(obj instanceof BigInteger) {
				progressivo = (BigInteger)obj;
			}
			if(record != null) {
				if(progressivo != null) {
					record.setProgIdentificativoUso(progressivo);
				}
				progressivo = record.getProgIdentificativoUso();
				// calcolaTotale(progressivo);
			}
			if(progressivo != null && progressivo.intValue() != 8 && progressivo.intValue() != 10 && progressivo.intValue() != 11) {
				listaRecord.set(selectedRow, record);
			} else {
				listaRecord.set(selectedRow, null);
			}
		} else {
			listaRecord.set(selectedRow, null);
		}
		this.fireTableDataChanged();
	}

	public void setRecordTotale(int selectedRow, MetanoRettificheFatturazione recordTotale) {
		if(recordTotale != null) {
			Object obj = getValueAt(selectedRow, 0);
			BigInteger progressivo = null; 
			if(obj instanceof BigInteger) {
				progressivo = (BigInteger)obj;
			}
			if(recordTotale != null) {
				if(progressivo != null) {
					recordTotale.setProgIdentificativoUso(progressivo);
				}
				progressivo = recordTotale.getProgIdentificativoUso();
			}
			MetanoRettificheFatturazione recordVecchio = (MetanoRettificheFatturazione)listaRecordTotale.get(selectedRow);
			listaRecordTotale.set(selectedRow, recordTotale);

			if(recordTotale.getImportoEuro() == null) {
				calcolaTotale(recordTotale);	
			/** MODIFICA 25-10-2007 **/
			} else if(progressivo != null && progressivo.intValue() != 8 && progressivo.intValue() != 10 && progressivo.intValue() != 11) {
				if(recordVecchio != null) {
					if(recordTotale.getImportoEuro().equals(recordVecchio.getImportoEuro())) {
						calcolaTotale(recordTotale);
					}
//				} else {
//					calcolaTotale(recordTotale);
				}
			}
		} else {
			listaRecordTotale.set(selectedRow, null);
		}

		this.fireTableDataChanged();
		/** FINE MODIFICA **/
	}

	/**
	 * @param recordTotale
	 */
	public void calcolaTotale(BigInteger progIdentificativoUso) {
		Iterator it = listaRecordTotale.iterator();
		while(it.hasNext()) {
			MetanoRettificheFatturazione recordTotale = (MetanoRettificheFatturazione)it.next();
			if(recordTotale != null && recordTotale.getProgIdentificativoUso().equals(progIdentificativoUso)) {
				calcolaTotale(recordTotale);
			}
		}
	}

	private void calcolaTotale(MetanoRettificheFatturazione recordTotale) {
		BigDecimal totale = BigDecimal.valueOf(0);
		Iterator it = listaRecord.iterator();
		while(it.hasNext()) {
			MetanoRettificheFatturazione record = (MetanoRettificheFatturazione)it.next();
			if(record != null && record.getProgIdentificativoUso().equals(recordTotale.getProgIdentificativoUso())) {
				BigDecimal importo = record.getImportoEuro();
				totale = totale.add(record.getImportoEuro());
			}
		}
		recordTotale.setImportoEuro(totale);
	}

	public void removeRecord(int selectedRow) {
		if(!isRemovable(selectedRow)) {
			throw new RuntimeException("Non  possibile cancellare questo valore finch ci sono righe associate a quella selezionata");
		}
		
		MetanoRettificheFatturazione record = getRecord(selectedRow);
		MetanoRettificheFatturazione recordTotale = getRecordTotale(selectedRow);
		if(record != null) {
			if(!(record.getProgRecordUso().equals(BigInteger.ONE) || record.getProgRecordUso().equals(BigInteger.valueOf(999)))) { // se sono figlio!
				listaRecord.remove(selectedRow);
				listaRecordTotale.remove(selectedRow);
				fireTableDataChanged();
			} else {
				setRecord(selectedRow, null);
				setRecordTotale(selectedRow, null);
			}
			calcolaTotale(record.getProgIdentificativoUso());
		} else {
			setRecord(selectedRow, null);
			setRecordTotale(selectedRow, null);
		}
	}

	public boolean isRemovable(int selectedRow) {
		boolean retvalue = true;
		MetanoRettificheFatturazione record = getRecord(selectedRow);
		if(record != null) {
			if(!(record.getProgRecordUso().equals(BigInteger.ONE) || record.getProgRecordUso().equals(BigInteger.valueOf(999)))) { // se sono figlio!
				retvalue = true;
			} else {
				retvalue = true;
				// Controllo se ci sono figli
				if(selectedRow < getRowCount() - 1) {
					MetanoRettificheFatturazione possibileFiglio = getRecord(selectedRow + 1);
					if(possibileFiglio != null && possibileFiglio.getProgIdentificativoUso().equals(record.getProgIdentificativoUso())) {
						retvalue = false;
					}
				}
			}
		} else {
			retvalue = true;
		}
		return retvalue;
	}

	public List getRecords() {
		List retlist = new LinkedList();
		Iterator it = listaRecord.iterator();
		while (it.hasNext()) {
			Object obj = it.next();
			if (obj != null) {
				retlist.add(obj);
			}
		}
		return retlist;
	}
	public List getRecordsTotali() {
		List retlist = new LinkedList();
		Iterator it = listaRecordTotale.iterator();
		while (it.hasNext()) {
			Object obj = it.next();
			if (obj != null) {
				retlist.add(obj);
			}
		}
		return retlist;
	}

	private int computeRow(int identifier) {
		for (int i = 0; i < identifiers.length; i++) {
			if (identifier == identifiers[i]) {
				return i;
			}
		}
		return -1; // E quindi crasha!!!!!! 
	}

	public PrintableTableModel split(int index, int offset) {
		return DefaultPrintableTableModel.getSplitted(this, index, offset);
		//throw new UnsupportedOperationException();
	}

	public PrintableTableModel split(int index) {
		return split(index, listaRecord.size() - index);
	}

}
