/*
 * Created on 22-set-06
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 * 
 */
package it.finanze.dogane.accise.metano.ui.tablemodel;

/**
 * @author Fiorello
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
import it.finanze.dogane.accise.combo.TipoCapitolo;
import it.finanze.dogane.accise.metano.model.MetanoRiepilogoSaldoImposte;
import it.finanze.dogane.accise.metano.ui.quadri.Quadro;
import it.finanze.dogane.accise.pdf.DefaultPrintableTableModel;
import it.finanze.dogane.accise.pdf.PrintableTableModel;

import java.math.BigInteger;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import javax.swing.table.AbstractTableModel;

public class MetanoRiepilogoSaldoImposteTM extends AbstractTableModel implements PrintableTableModel {

	private List listaRecord = new LinkedList();

	public static final String[] QUADRO_L_DESCRIPTIONS_1412 =
		{
			"ACCISA LIQUIDATA (rigo I3)",
			"RATEI D'ACCONTO DOVUTI",
			"CONGUAGLIO ACCISA A DEBITO",
			"CONGUAGLIO ACCISA A CREDITO" };

	public static final int[] QUADRO_L_IDENTIFIERS_1412 = { 1, 2, 3, 4 };

	public static final String[] QUADRO_L_DESCRIPTIONS_1421 =
		{
			"ACCISA LIQUIDATA (rigo I15)",
			"RATEI D'ACCONTO DOVUTI",
			"CONGUAGLIO ACCISA A DEBITO",
			"CONGUAGLIO ACCISA A CREDITO" };

	public static final int[] QUADRO_L_IDENTIFIERS_1421 = { 6, 7, 8, 9 };

	public static final String[] QUADRO_N_DESCRIPTIONS =
		{
			"ADDIZIONALE LIQUIDATA (rigo M8)",
			"RATEI D'ACCONTO DOVUTI",
			"CONGUAGLIO ADDIZIONALE A DEBITO",
			"CONGUAGLIO ADDIZIONALE A CREDITO" };

	public static final int[] QUADRO_N_IDENTIFIERS = { 1, 2, 3, 4 };

	public static final String[] QUADRO_P_DESCRIPTIONS =
		{
			"IMPOSTA LIQUIDATA (rigo O9)",
			"RATEI D'ACCONTO DOVUTI",
			"CONGUAGLIO IMPOSTA A DEBITO",
			"CONGUAGLIO IMPOSTA A CREDITO" };

	public static final int[] QUADRO_P_IDENTIFIERS = { 1, 2, 3, 4 };

	private String[] descriptions = null;
	private int[] identifiers = null;

	public MetanoRiepilogoSaldoImposteTM(
		List lista,
		int[] tipiRecord,
		TipoCapitolo tipoCapitolo) {

		if (Quadro.QUADRO_L.equals(tipiRecord)) {
			if (tipoCapitolo.getCodice().trim().equals("1412")) {
				descriptions = QUADRO_L_DESCRIPTIONS_1412;
				identifiers = QUADRO_L_IDENTIFIERS_1412;
			}
			else if (tipoCapitolo.getCodice().trim().equals("1421")) {
				descriptions = QUADRO_L_DESCRIPTIONS_1421;
				identifiers = QUADRO_L_IDENTIFIERS_1421;
			}
		} else if (Quadro.QUADRO_N.equals(tipiRecord)) {
				descriptions = QUADRO_N_DESCRIPTIONS;
				identifiers = QUADRO_N_IDENTIFIERS;

		} else if (Quadro.QUADRO_P.equals(tipiRecord)) {
			descriptions = QUADRO_P_DESCRIPTIONS;
			identifiers = QUADRO_P_IDENTIFIERS;
		} else {
			throw new IllegalArgumentException("Tipo record " + tipiRecord.toString().trim() + " non consentito. (Quadri permessi L,N,P)");
		}

		for (int i = 0; i < descriptions.length; i++) {
			listaRecord.add(null);
		}

		Iterator it = lista.iterator();
		while (it.hasNext()) {
			MetanoRiepilogoSaldoImposte record = (MetanoRiepilogoSaldoImposte) it.next();
			int row = computeRow(record.getProgressivoIdentificativo().intValue());
			if (row != -1) {
				listaRecord.set(row, record);
			}
		}
	}

	public Object getValueAt(int rowIndex, int columnIndex) {
		MetanoRiepilogoSaldoImposte record = (MetanoRiepilogoSaldoImposte) listaRecord.get(rowIndex);
		Object retvalue = null;

		if (record == null) {
			if (columnIndex == 0) {
				retvalue = new Integer(identifiers[rowIndex]);
			} else if (columnIndex == 1) {
				retvalue = descriptions[rowIndex];
			} else if (columnIndex == 2) {
				retvalue = "";
			} else if (columnIndex == 3) {
				retvalue = "";
			} else if (columnIndex == 4) {
				retvalue = "";
			}
		} else {
			if (columnIndex == 0) {
				retvalue = record.getProgressivoIdentificativo();
			} else if (columnIndex == 1) {
				retvalue = descriptions[rowIndex];
			} else if (columnIndex == 2) {
				retvalue = record.getImportoEuro();
			}
		}

		return retvalue;
	}

	public int getColumnCount() {
		return 3;
	}

	public int getRowCount() {
		return listaRecord.size();
	}

	public String getColumnName(int columnIndex) {
		String retvalue = null;
		if (columnIndex == 0) {
			retvalue = "";
		} else if (columnIndex == 1) {
			retvalue = "";
		} else if (columnIndex == 2) {
			retvalue = "Importo";
		}

		return retvalue;
	}

	public MetanoRiepilogoSaldoImposte getRecord(int selectedRow) {
		return (MetanoRiepilogoSaldoImposte) listaRecord.get(selectedRow);
	}

	public void setRecord(
		int selectedRow,
		MetanoRiepilogoSaldoImposte record) {
		listaRecord.set(selectedRow, record);
		if (record != null) {
			record.setProgressivoIdentificativo(BigInteger.valueOf(identifiers[selectedRow]));
		}

		this.fireTableRowsUpdated(selectedRow, selectedRow);
	}

	public void removeRecord(int selectedRow) {
		setRecord(selectedRow, null);
	}

	public List getRecords() {
		List retlist = new LinkedList();
		Iterator it = listaRecord.iterator();
		while (it.hasNext()) {
			Object obj = it.next();
			if (obj != null) {
				retlist.add(obj);
			}
		}
		return retlist;
	}

	private int computeRow(int identifier) {
		for (int i = 0; i < identifiers.length; i++) {
			if (identifier == identifiers[i]) {
				return i;
			}
		}
		return -1;
	}
	public PrintableTableModel split(int index, int offset) {
		return DefaultPrintableTableModel.getSplitted(this, index, offset);
		//throw new UnsupportedOperationException();
	}

	public PrintableTableModel split(int index) {
		return split(index, listaRecord.size() - index);
	}

}
